
# TYPO3 Static TSConfig Help
#--------------------------------------------------------


#
# Table structure for table "static_tsconfig_help"
#
DROP TABLE IF EXISTS static_tsconfig_help;
CREATE TABLE static_tsconfig_help (
  uid int(11) NOT NULL auto_increment,
  guide int(11) DEFAULT '0' NOT NULL,
  md5hash varchar(32) DEFAULT '' NOT NULL,
  description text NOT NULL,
  obj_string tinytext NOT NULL,
  appdata blob NOT NULL,
  title tinytext NOT NULL,
  PRIMARY KEY (uid),
  KEY guide (guide,md5hash)
);



#
# ==== Data extracted from CoreDocs/doc_core_api_4.0.0.t3x
#
INSERT INTO static_tsconfig_help VALUES ('1', '', '004ad0c011cac5a5fcbc294774cb0281', '', 'page:RTE', 'a:1:{s:4:"rows";a:2:{i:0;a:6:{s:8:"property";s:133:"default.[...]<br>config.[<i>tablename</i>].[<i>field</i>].[...]<br>config.[<i>tablename</i>].[<i>field</i>].types.[<i>type</i>].[...]";s:8:"datatype";s:12:"-&gt;RTEconf";s:11:"description";s:610:"&nbsp; This is a description of how you can customize in general and override for specific fields/types.<br>&nbsp;<br>&#039;RTE.default&#039; configures the RTE for all tables/fields/types<br>&nbsp;<br>&#039;RTE.config.[<i>tablename</i>].[<i>field</i>]&#039; configures a specific field. The values inherit the values from &#039;RTE.default&#039; in fact this is overriding values.<br>&nbsp;<br>&#039;RTE.config.[<i>tablename</i>].[<i>field</i>].types.[<i>type</i>]&#039; configures a specific field in case the &#039;type&#039;-value of the field matches <i>type</i>. Again this overrides the former settings.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:24:"[individual RTE options]";s:8:"datatype";s:1:"-";s:11:"description";s:469:"There are other options to set for the RTE toplevel object. These depends on the individual RTEs though! So there can be no further reference in this table to these properties.<br>Generally the &quot;rte&quot; (classic MSIE RTE) will set the standard for configuration options, so you can refer to the documentation for that RTE for more details. On the top level of the RTE object you will normally find that general collections of classes, styles etc. are configured.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('2', '', 'ccb0322c7d1f7b0e49e1c8b981aacd1e', '', 'page:->RTEconf', 'a:1:{s:4:"rows";a:3:{i:0;a:6:{s:8:"property";s:8:"disabled";s:8:"datatype";s:7:"boolean";s:11:"description";s:128:"If set, the editor is disabled.<br>This option is evaluated in t3lib_TCEforms where it determines if the RTE is rendered or not.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:4:"proc";s:8:"datatype";s:9:"-&gt;PROC";s:11:"description";s:442:"Customization of the server processing of the content - also called &#039;transformations&#039;. See table below.<br>The transformations are only initialized, if they are configured (&quot;rte_transform&quot; must be set for the field in the types-definition in TCA.)<br>The &quot;-&gt;PROC&quot; object is processed in &quot;t3lib_parsehtml_proc&quot; and is <i>independant</i> of the particular RTE used (like transformations generally is!)";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:24:"[individual RTE options]";s:8:"datatype";s:1:"-";s:11:"description";s:200:"Each RTE may use additional properties for the RTE. Typically such properties relates to the features of the RTE application. For instance you could configure which tool bar buttons are available etc.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('3', '', '11acbecfba402c242e0ad130ba3140d1', '', 'page:->PROC', 'a:1:{s:4:"rows";a:28:{i:0;a:6:{s:8:"property";s:12:"overruleMode";s:8:"datatype";s:28:"List of RTE transformations ";s:11:"description";s:171:"This can overrule the RTE transformation set from TCA.<br>&nbsp;<br>Notice, this is a <i>comma list</i> of transformation keys. (Not a &quot;dash-list&quot; like in $TCA).";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:8:"typolist";s:8:"datatype";s:7:"boolean";s:11:"description";s:290:"<i>(Applies for &quot;ts_transform&quot; only)</i><br>&nbsp;<br>This enables/disables the conversion between &lt;TYPOLIST&gt; and &lt;UL&gt; sections. Default (if unset) is that &quot;typolist&quot; is enabled.<br>&nbsp;<b><br>Example that disables &quot;typolist&quot;:</b><br>typolist = 0";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:8:"typohead";s:8:"datatype";s:7:"boolean";s:11:"description";s:230:"<i>(Applies for &quot;ts_transform&quot; only)</i><br>&nbsp;<br>This enables/disables the conversion between &lt;TYPOHEAD&gt; and &lt;Hx&gt; sections.<br>&nbsp;<b><br>Example that disables &quot;typohead&quot;:</b><br>typohead = 0";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:13:"preserveTags ";s:8:"datatype";s:12:"list of tags";s:11:"description";s:843:"(DEPRECATED)<br>&nbsp;<br>Here you may specify a list of tags - possibly user-defined pseudo tags - which you wish to preserve from being removed by the RTE. See the information about preservation in the description of transformations.<br>&nbsp;<b><br>Example:</b><br>In the default TypoScript configuration of content rendering the tags typotags &lt;LINK&gt;, &lt;TYPOLIST&gt; and &lt;TYPOHEAD&gt; are the most widely used. However the &lt;TYPOCODE&gt;-tag is also configured to let you define a section being formatted in monospace. Lets also imaging, you have defined a custom tag, &lt;MYTAG&gt;. In order to preserve these tag from removal by the RTE, you should configure like this.<br>&nbsp;<br>RTE.default.proc {<br>&nbsp;&nbsp;&nbsp;preserveTags = TYPOCODE, MYTAG<br>}<br>&nbsp;<br>Relates to the transformation &#039;ts_preserve&#039;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:21:"dontConvBRtoParagraph";s:8:"datatype";s:7:"boolean";s:11:"description";s:293:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function divideIntoLines))</i><br>&nbsp;<br>&nbsp;By default &lt;BR&gt; tags in the content are converted to paragraphs. Setting this value will <i>prevent</i> the convertion of &lt;BR&gt;-tags to new-lines (chr(10))";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:19:"internalizeFontTags";s:8:"datatype";s:7:"boolean";s:11:"description";s:544:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function divideIntoLines))</i><br>&nbsp;<br>This splits the content into font-tag chunks. <br>If there are any &lt;P&gt;/&lt;DIV&gt; sections inside of them, the font-tag is wrapped AROUND the content INSIDE of the P/DIV sections and the outer font-tag is removed.<br>This functions seems to be a good choice for pre-processing content if it has been pasted into the RTE from eg. star-office. <br>In that case the font-tags is normally on the OUTSIDE of the sections.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:16:"allowTagsOutside";s:8:"datatype";s:20:"commalist of strings";s:11:"description";s:286:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function divideIntoLines))</i><br>&nbsp;<br>&nbsp;Enter tags which are allowed outside of &lt;P&gt; and &lt;DIV&gt; sections when converted back to database.<br>Default is &quot;img&quot;<br>Example:<br>IMG,HR";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:20:"allowTagsInTypolists";s:8:"datatype";s:20:"commalist of strings";s:11:"description";s:213:"<i>(Applies for &quot;ts_transform&quot; only)</i><br>&nbsp;<br>Enter tags which are allowed inside of &lt;typolist&gt; tags when content is sent to the database.<br>Default is &quot;br,font,b,i,u,a,img,span&quot;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:9:"allowTags";s:8:"datatype";s:20:"commalist of strings";s:11:"description";s:344:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function getKeepTags))</i><br>&nbsp;<br>Tags to allow. Notice, this list is <i>added</i> to the default list, which you see here:<br>b,i,u,a,img,br,div,center,pre,font,hr,sub,sup,p,strong,em,li,ul,ol,blockquote,strike,span<br>If you wish to deny some tags, see below.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:8:"denyTags";s:8:"datatype";s:20:"commalist of strings";s:11:"description";s:150:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function getKeepTags))</i><br>&nbsp;<br>Tags from above list to disallow.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:31:"HTMLparser_rte<br>HTMLparser_db";s:8:"datatype";s:15:"-&gt;HTMLparser";s:11:"description";s:939:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function getKeepTags))</i><br>&nbsp;<br>This is additional options to the HTML-parser calls which strips of tags when the content is prepared for the RTE and DB respectively. You can configure additional rules, like which other tags to preserve, which attributes to preserve, which values are allowed as attributes of a certain tag etc.<br>&nbsp;.nestingGlobal for HTMLparser_db is set by default to &quot;b,i,u,a,center,font,sub,sup,strong,em,strike,span&quot; unless another value is set.<br>Also B/I tags are mapped to STRONG/EM tags in the RTE direction and vise versa.<br>This parsing is done on a per-line basis, so you cannot expect the paragraph tags (P or DIV) to be included.<b><br>&nbsp;</b><br>&nbsp;<b>Notice</b> the -&gt;HTMLparser options, &quot;keepNonMatchedTags&quot; and &quot;htmlSpecialChars&quot; is NOT observed. They are preset internally";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:24:"dontRemoveUnknownTags_db";s:8:"datatype";s:7:"boolean";s:11:"description";s:528:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function HTMLcleaner_db))</i><br>&nbsp;<br>Direction: To database<br>Default is to remove all unknown tags in the content going to the database. (See HTMLparser_db above for default tags). Generally this is a very usefull thing, because all kinds of bogus tags from pasted content like that from Word etc. will be removed to have clean content in the database.<br>However this disables that and allows all tags, that are not in the HTMLparser_db-list.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:14:"dontUndoHSC_db";s:8:"datatype";s:7:"boolean";s:11:"description";s:331:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function HTMLcleaner_db))</i><br>&nbsp;<br>Direction: To database<br>Default is to re-convert literals to characters (that is &amp;lt; to &lt;) outside of HTML-tags. This is disabled by this boolean. (HSC means HtmlSpecialChars - which is a PHP function)";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:26:"dontProtectUnknownTags_rte";s:8:"datatype";s:7:"boolean";s:11:"description";s:566:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function setDivTags))</i><br>&nbsp;<br>Direction: To RTE<br>&nbsp;Default is that tags unknown to HTMLparser_rte is &quot;protected&quot; when sent to the RTE. This means they are converted from eg &lt;MYTAG&gt; to &amp;lt;MYTAG&amp;gt;. This is normally very fine, because it can be edited plainly by the editor and when returned to the database the tag is (by default, disabled by .dontUndoHSC_db) converted back.<br>Setting this option will prevent unknown tags from becoming protected.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:11:"dontHSC_rte";s:8:"datatype";s:7:"boolean";s:11:"description";s:344:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function setDivTags))</i><br>&nbsp;<br>Direction: To RTE<br>Default is that all content outside of HTML-tags is passed through htmlspecialchars(). This will disable that. (opposite to .dontUndoHSC_db)<br>This option disables the default htmlspecialchars() conversion.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:21:"dontConvAmpInNBSP_rte";s:8:"datatype";s:7:"boolean";s:11:"description";s:295:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function setDivTags))</i><br>&nbsp;<br>Direction: To RTE<br>By default all &amp;nbsp; codes are NOT converted to &amp;amp;nbsp; which they naturally word (unless .dontHSC_rte is set). You can disable that by this flag.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:17:"allowedFontColors";s:8:"datatype";s:18:"list of HTMLcolors";s:11:"description";s:222:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function getKeepTags))</i><br>&nbsp;<br>Direction: To DB<br>If set, this is the only colors which will be allowed in font-tags! Case insensitive.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:14:"allowedClasses";s:8:"datatype";s:15:"list of strings";s:11:"description";s:640:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function getKeepTags))</i><br>&nbsp;<br>Direction: To DB<br>&nbsp;Allowed general classnames when content is stored in database. Could be a list matching the number of defined classes you have. Case-insensitive.<br>This might be a really good idea to do, because when pasting in content from MS word for instance there are a lot of &lt;SPAN&gt; and &lt;P&gt; tags which may have class-names in. So by setting a list of allowed classes, such foreign classnames are removed.<br>If a classname is not found in this list, the default is to remove the class-attribute.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:22:"skipAlign<br>skipClass";s:8:"datatype";s:7:"boolean";s:11:"description";s:368:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function divideIntoLines))</i><br>&nbsp;<br>If set, then the align and class attributes of &lt;P&gt;/&lt;DIV&gt; sections (respectively) will be ignored. Normally &lt;P&gt;/&lt;DIV&gt; tags are preserved if one or both of these attributes are present in the tag. Otherwise it&#039;s removed.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:15:"keepPDIVattribs";s:8:"datatype";s:32:"list of tag attributes (strings)";s:11:"description";s:287:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function divideIntoLines))</i><br>&nbsp;<br>&quot;align&quot; and &quot;class&quot; are the only attributes preserved for &lt;P&gt;/&lt;DIV&gt; tags. Here you can specify a list of other attributes to preserve.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:17:"remapParagraphTag";s:8:"datatype";s:16:"string / boolean";s:11:"description";s:532:"<i>(Applies for &quot;ts_transform&quot; and &quot;css_transform&quot; only (function divideIntoLines))</i><br>&nbsp;<br>When &lt;P&gt;/&lt;DIV&gt; sections are converted to be put into the database, the tag - P or DIV - is preserved. However setting this options to either P or DIV will force the section to be converted to the one or the other.<br>If the value is set true (1), then it works as a general disable-flag for the whole section-convertion stuff here and the result will be no tags preserved what so ever. Just removed.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:27:"useDIVasParagraphTagForRTE ";s:8:"datatype";s:6:"string";s:11:"description";s:284:"<i>(Applies for &quot;ts_transform&quot; only and &quot;css_transform&quot; (function TS_transform_rte))</i><br>&nbsp;<br>Use &lt;DIV&gt;-tags for sections when converting lines from database to RTE. Default is &lt;P&gt;. Applies only to lines which has NO tag wrapped around already.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:22;a:6:{s:8:"property";s:14:"preserveTables";s:8:"datatype";s:7:"boolean";s:11:"description";s:87:"<i>(Applies for &quot;ts_transform&quot;)</i><br>&nbsp;<br>If set, tables are preserved";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:23;a:6:{s:8:"property";s:20:"dontFetchExtPictures";s:8:"datatype";s:7:"boolean";s:11:"description";s:204:"<i>(Applies for &quot;ts_images&quot;)</i><br>&nbsp;<br>If set, images from external urls are not fetched for the page if content is pasted from external sources. Normally this process of copying is done.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:24;a:6:{s:8:"property";s:14:"plainImageMode";s:8:"datatype";s:14:"boolean/string";s:11:"description";s:1079:"<i>(Applies for &quot;ts_images&quot;)</i><br>&nbsp;<br>If set, all &quot;plain&quot; local images (those that are not magic images) will be cleaned up in some way.<br>If the value is just set, then the style attribute will be removed after detecting any special width/height CSS attributes (which is what the RTE will set if you scale the image manually) and the border attribute is set to zero.<br>You can also configure with special keywords. So setting &quot;plainImageMode&quot; to any of the value below will perform special processing:<br>&nbsp;<br>&quot;lockDimensions&quot; : This will read the real dimensions of the image file and force these values into the &lt;img&gt; tag. Thus this option will prevent any user applied scaling in the image!<br>&quot;lockRatio&quot; : This will allow users to scale the image but will automatically correct the height dimension so the aspect ratio from the original image file is preserved.<br>&quot;lockRatioWhenSmaller&quot; : Like &quot;lockRatio&quot;, but will not allow any scaling larger than the original size of the image.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:25;a:6:{s:8:"property";s:84:"exitHTMLparser_rte<br>exitHTMLparser_db<br>entryHTMLparser_rte<br>entryHTMLparser_db";s:8:"datatype";s:23:"boolean/-&gt;HTMLparser";s:11:"description";s:274:"<i>(Applies for all kinds of processing)</i><br>&nbsp;<br>Allows you to enable/disable the HTMLparser for the content before (entry) and after (exit) the content is processed with the predefined processors (eg. ts_images or ts_transform).<br>There is no default values set. ";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:26;a:6:{s:8:"property";s:22:"disableUnifyLineBreaks";s:8:"datatype";s:7:"boolean";s:11:"description";s:250:"<i>(Applies for all kinds of processing)</i><br>&nbsp;<br>When entering the processor all rn linebreaks are converted to n (13-10 to 10). When leaving the processor all n is reconverted to rn (10 to 13-10).<br>This options disables that processing...";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:27;a:6:{s:8:"property";s:43:"usertrans.[user-defined transformation key]";s:8:"datatype";s:1:"-";s:11:"description";s:110:"Custom option-space for userdefined transformations.<br>See example from section about custom transformations.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');

#
# ==== Data extracted from CoreDocs/doc_core_cgl_4.0.0.t3x
#

#
# ==== Data extracted from CoreDocs/doc_core_compclient_0.0.2.t3x
#

#
# ==== Data extracted from CoreDocs/doc_core_compserv_0.0.5.t3x
#

#
# ==== Data extracted from CoreDocs/doc_core_inside_4.0.0.t3x
#

#
# ==== Data extracted from CoreDocs/doc_core_services_0.2.0.t3x
#
INSERT INTO static_tsconfig_help VALUES ('4', '', 'd41d8cd98f00b204e9800998ecf8427e', '', '', 'a:1:{s:4:"rows";a:10:{i:0;a:6:{s:8:"property";s:5:"title";s:8:"datatype";s:6:"string";s:11:"description";s:25:"The title of the service.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:11:"description";s:8:"datatype";s:6:"string";s:11:"description";s:234:"The description. If it makes sense it should contain information about<br>- the quality of the service (if it&#039;s better or less good as normal)<br>- the OS dependency<br>- the dependency of external programs (perl, pdftotext, ...)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:7:"subtype";s:8:"datatype";s:19:"string / comma list";s:11:"description";s:162:"The subtype is not predefined. Its usage is defined by the API of the service type.<br>&nbsp;<b><br>Example:</b><br>&#039;subtype&#039; =&gt; &#039;jpg,tif&#039;,";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:9:"available";s:8:"datatype";s:7:"boolean";s:11:"description";s:700:"Defines if the service is available. Which means if available=FALSE the service will be ignored.<br>Of course it makes no sense to set this to FALSE, but it can be used to make a quick check if the service works on the system it installed:<br>&nbsp;<b><br>Examples:</b><br>&nbsp;&nbsp;&nbsp;// is the curl extension available we need<br>&#039;available&#039; =&gt; is_function(&#039;curl_exec&#039;),<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;// the code depends on PHP version 4.2.0<br>&#039;available&#039; =&gt; version_compare(phpversion(), &#039;4.2.0&#039; &#039;&gt;=&#039;),<br>Do only quick checks here. More strict checks can be done when the service is requested and the service class is initialized.";s:7:"default";s:4:"TRUE";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:8:"priority";s:8:"datatype";s:7:"integer";s:11:"description";s:660:"By which priority should the service be selected. Can be reconfigured by TYPO3_CONF_VARS.<br>&nbsp;<br>Use a value from 0 to 100. Higher values are reserved for reconfiguration by TYPO3_CONF_VARS. The default value is 50 which means that the service is well implemented and gives normal (good) results.<br>&nbsp;<br>If you have two solutions. A PHP only and one that depends on an external program, the PHP solution should have a priority of 50 and the other solution a less high priority. PHP only solutions should have a higher priority. But if the external solution gives better results you should set both to 50 and set the quality value to a higher value.";s:7:"default";s:10:"50 (0-100)";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:7:"quality";s:8:"datatype";s:15:"Integer / float";s:11:"description";s:519:"A service with higher quality by the same priority is preferred.<br>&nbsp;<br>The use of the quality range is defined by the service type. Integer and floats can be used. The default range is 0-100 and the default value for a normal (good) quality service is 50. <br>&nbsp;<br>A definition of the quality can be like this. A service type implements the detection of a language used in a text. One service can detect 67 languages another service only 25. It&#039;s a good idea to use these values for the quality values.";s:7:"default";s:10:"50 (0-100)";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:2:"os";s:8:"datatype";s:6:"string";s:11:"description";s:345:"Defines which operating system is needed to run this service.<br>&nbsp;<b><br>Examples:</b><br>&nbsp;&nbsp;&nbsp;// runs only on UNIX<br>&#039;os&#039; =&gt; &#039;UNIX&#039;,<br>&nbsp;&nbsp;&nbsp;// runs only on Windows<br>&#039;os&#039; =&gt; &#039;WIN&#039;,<br>&nbsp;&nbsp;&nbsp;// no special dependenvy<br>&#039;os&#039; =&gt; &#039;&#039;,";s:7:"default";s:12:"&quot;&quot;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:4:"exec";s:8:"datatype";s:19:"string / comma list";s:11:"description";s:306:"List of external programs which are needed to run the service. Absolute paths are allowed but not recommended, because the programs are searched automatically by t3lib_exec.<br>&nbsp;<b><br>Examples:</b><br>&#039;exec&#039; =&gt; &#039;perl&#039;,<br>&nbsp;<br>&#039;exec&#039; =&gt; &#039;pdftotext&#039;,";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:9:"classFile";s:8:"datatype";s:6:"string";s:11:"description";s:132:"Created by the kickstarter<br>&nbsp;<b><br>Example:</b><br>t3lib_extMgm::extPath($_EXTKEY).&#039;sv1/class.tx_myextkey_sv1.php&#039;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:9:"className";s:8:"datatype";s:6:"string";s:11:"description";s:96:"Created by the kickstarter<br>&nbsp;<b><br>Example:</b><br>&#039;class.tx_myextkey_sv1.php&#039;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');

#
# ==== Data extracted from CoreDocs/doc_core_ts_4.0.0.t3x
#

#
# ==== Data extracted from CoreDocs/doc_core_tsbyex_0.0.16.t3x
#

#
# ==== Data extracted from CoreDocs/doc_core_tsbyex_fr_0.0.1.t3x
#

#
# ==== Data extracted from CoreDocs/doc_core_tsconfig_4.0.0.t3x
#
INSERT INTO static_tsconfig_help VALUES ('5', '', '284eaff2c8b565d4257002d25e85e0ec', '', 'beuser', 'a:1:{s:4:"rows";a:9:{i:0;a:6:{s:8:"property";s:8:"admPanel";s:8:"datatype";s:13:"-&gt;ADMPANEL";s:11:"description";s:43:"Options regarding the front-end admin panel";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:7:"options";s:8:"datatype";s:12:"-&gt;OPTIONS";s:11:"description";s:29:"Options for the user, various";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:3:"mod";s:8:"datatype";s:38:"<i>(see -&gt;MOD of Page TSconfig)</i>";s:11:"description";s:91:"Overriding values for the backend modules<br>&nbsp;<b>Deprecated. </b>Use page.mod instead!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:32:"setup.defaults<br>setup.override";s:8:"datatype";s:10:"-&gt;SETUP";s:11:"description";s:481:"Default values and override values for the user settings known from the setup module.<br>&nbsp;<b><br>Notice:</b><br>There is a tricky aspect to these settings; If first you have set a value by setup.override and then removes it again you will experience that the value persists to exist. This is because it is saved in the backend users profile. Therefore, if you have once set a value, do <i>not</i> remove it again by rather set it blank if you want to disable the effect again!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:31:"TCAdefaults.[tablename].[field]";s:8:"datatype";s:6:"string";s:11:"description";s:746:"Sets default values for records. The order of default values when creating new records in the backend is this:<br>Value from $TCA<br>Value from User TSconfig (these settings)<br>Value from &quot;defVals&quot; GET vars (see alt_doc.php)<br>Value from previous record based on &#039;useColumnsForDefaultValues&#039;<br>&nbsp;<br>However the order for default values used by tcemain.php if a certain field is not granted access to for user will be:<br>Value from $TCA<br>Value from User TSconfig (these settings)<br>&nbsp;<br>So these values will be authoritative if the user has no access to the field anyway.<br>&nbsp;<b><br>Example:</b><br>This sets the default hidden flag for pages to &quot;clear&quot;<br>&nbsp;<br>TCAdefaults.pages.hidden = 0";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:4:"user";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:87:"This is for custom purposes. <br>Deprecated, use &quot;tx_*&quot; below from extensions";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:4:"auth";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:203:"Configuration for authentication services. Currently these are the options:<br>&nbsp;<b><br>auth.BE.redirectToURL</b><br>Specifies a URL to redirect to after login is performed in the backend login form.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:4:"page";s:8:"datatype";s:28:"all page TSconfig properties";s:11:"description";s:195:"You can override all page TSconfig properties by putting them into user<br>TSconfig and prefixing them with page.<br>&nbsp;<b><br>Example:</b><br>page.TCEMAIN.table.pages.disablePrependAtCopy = 1";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:37:"tx_[extension key with no underscore]";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:38:"This is reserved space for extensions.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('6', '', '7cd94e953cc449fe4c0856671acf229d', '', 'beuser:admPanel', 'a:1:{s:4:"rows";a:4:{i:0;a:6:{s:8:"property";s:6:"enable";s:8:"datatype";s:8:"[object]";s:11:"description";s:253:"Used to enable the various parts of the panel for users.<br>All values are 0/1 booleans.<b><br>&nbsp;</b><b><br>General:</b><br>.all: enables all modules<b><br>&nbsp;</b><b><br>Modules:</b><br>.preview<br>.cache<br>.publish<br>.edit<br>.tsdebug<br>.info";s:7:"default";s:57:"(For admin-users, all = 1 is default! Hardcoded in class)";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:4:"hide";s:8:"datatype";s:7:"boolean";s:11:"description";s:93:"If set, the panel will not display in the bottom of the page. This has only a visual effect. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:8:"override";s:8:"datatype";s:8:"[object]";s:11:"description";s:936:"Override all admin panel settings:<br>.[modulename].[propertyname]<br>&nbsp;<b><br>Note:</b><br>You have to activate a module first by setting<br>.modulename = 1<br>&nbsp;<b><br>Full reference:</b><br>To find out the name of a modulename/property, you can have a look at the HTML code of the admin panel and watch the names of the form elements. In this example, the module name is &quot;tsdebug&quot;, and the property is called &quot;displayTimes&quot;:<i><br>name=&quot;TSFE_ADMIN_PANEL[tsdebug_displayTimes]&quot;</i><br>&nbsp;<b><br>Most common options</b><br>.preview.showHiddenPages (boolean)<br>.preview.showHiddenRecords (boolean)<br>.preview.simulateDate (timestamp)<br>.preview.simulateUserGroup (integer)<br>&nbsp;<br>.cache.noCache (boolean)<br>.cache.clearCacheLevels (integer)<br>&nbsp;<br>.edit.displayFieldIcons (boolean)<br>.edit.displayIcons (boolean)<br>.edit.editFormsOnPage (boolean)<br>.edit.editNoPopup (boolean)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:11:"module.edit";s:8:"datatype";s:8:"[object]";s:11:"description";s:703:"&nbsp;<b>DEPRECATED</b>, use override.* instead (see above).<b><br>&nbsp;</b><br>&nbsp;<b>.forceDisplayIcons</b> (boolean):<i><br>Forces edit-panels to appear regardless of the selectorbox.</i><br>&nbsp;<b>.forceDisplayFieldIcons</b> (boolean):<i><br>Forces edit-icons to appear regardless of the selectorbox.</i><br>&nbsp;<b>.forceNoPopup</b> (boolean):<i><br>Forces edit-forms to open in same window - not pop up window.</i><i><br>&nbsp;</i><i><br>Example, that forces the display of the edit icons without displaying the admin-panel itself:</i><br>&nbsp;<br>admPanel {<br>&nbsp;&nbsp;&nbsp;enable.edit = 1<br>&nbsp;&nbsp;&nbsp;module.edit.forceDisplayFieldIcons = 1<br>&nbsp;&nbsp;&nbsp;hide = 1<br>}";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('7', '', '114e940842aa2d2d8a1efb37b1191103', '', 'beuser:options', 'a:1:{s:4:"rows";a:33:{i:0;a:6:{s:8:"property";s:20:"dontMountAdminMounts";s:8:"datatype";s:7:"boolean";s:11:"description";s:158:"This options prevents the root to be mounted for an admin user.<b><br>&nbsp;</b><br>&nbsp;<b>NOTE:</b> Only for admin-users. For other users it has no effect.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:10:"RTEkeyList";s:8:"datatype";s:18:"[list of keywords]";s:11:"description";s:291:"This is a list of the Rich Text Editor buttons the user may see displayed. The user will not see any buttons not listed here.<br>&nbsp;<br>Either enter a comma list of button keywords (see &quot;TYPO3 Core API / RTE section&quot;) or specify all with a wildcard &quot;*&quot; for everything.";s:7:"default";s:48:"*<br>(If value is not set at all, *, is default)";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:16:"clearCache.pages";s:8:"datatype";s:7:"boolean";s:11:"description";s:53:"This will allow a user to clear the whole page cache.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:14:"clearCache.all";s:8:"datatype";s:7:"boolean";s:11:"description";s:82:"This will allow a user to clear all cache (that is everything including templates)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:8:"lockToIP";s:8:"datatype";s:6:"string";s:11:"description";s:566:"List of IP-numbers with wildcards. <br>&nbsp;<br>&nbsp;<b>Note:</b> This option is enabled only if the TYPO3_CONF_VARS[BE][enabledBeUserIPLock] configuration is true.<b><br>&nbsp;</b><b><br>Examples:</b><br>192.168.*.* &nbsp;&nbsp;&nbsp;<br>- will allow all from 192.168-network<br>&nbsp;<br>192.168.*.*, 212.22.33.44 &nbsp;&nbsp;&nbsp;<br>- will allow all from 192.168-network plus all from REMOTE_ADDR 212.22.33.44<br>&nbsp;<br>192.168, 212.22.33.44 &nbsp;&nbsp;&nbsp;<br>- the same as the previous. Leaving out parts of the IP address is the same as wild cards...";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:13:"saveClipboard";s:8:"datatype";s:7:"boolean";s:11:"description";s:129:"If set, the clipboard content will be preserved for the next login. Normally the clipboard content lasts only during the session.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:19:"clipboardNumberPads";s:8:"datatype";s:10:"int (0-20)";s:11:"description";s:65:"This allows you to enter how many pads you want on the clipboard.";s:7:"default";s:1:"3";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:20:"disableDocModuleInAB";s:8:"datatype";s:7:"boolean";s:11:"description";s:82:"If set, the doc module is not displayed in the backend even if enabled in general.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:13:"shortcutFrame";s:8:"datatype";s:7:"boolean";s:11:"description";s:63:"If set, the shortcut frame in the bottom of the window appears.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:14:"shortcutGroups";s:8:"datatype";s:25:"Array of integers/strings";s:11:"description";s:819:"Set shortCutGroups that can be accessed by the user.<br>By default, 5 default groups will be defined globally (shared, can only be set by admins) and also for each user (personal shortcuts):<br>&nbsp;<br>1: Pages<br>2: Records<br>3: Files<br>4: Tools<br>5: Miscellaneous<br>&nbsp;<br>Set 0 to disable one of these group IDs, 1 to enable it (this is the<br>default) or &quot;string&quot; to change the label accordingly.<br>&nbsp;<b><br>Example:</b><br>shortcutGroups {<br>&nbsp;&nbsp;&nbsp;1=1<br>&nbsp;&nbsp;&nbsp;2=My Group<br>&nbsp;&nbsp;&nbsp;3=0<br>&nbsp;&nbsp;&nbsp;4=<br>}<br>&nbsp;<br>Shortcut group 1 is loaded with the default label (Pages), group 2 is loaded and labeled as &quot;My Group&quot; and groups 3 and 4 are disabled. Group 5 has not been set, so it will be displayed by default, just like group 1.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:33:"shortcut_onEditId_dontSetPageTree";s:8:"datatype";s:7:"boolean";s:11:"description";s:127:"If set, the page tree is <i>not</i> opened to the page being edited when an id number is entered in the &quot;Edit Id&quot; box";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:38:"shortcut_onEditId_keepExistingExpanded";s:8:"datatype";s:7:"boolean";s:11:"description";s:185:"If set, the existing expanded pages in the page tree are not collapsed when an id is entered in the &quot;Edit Id&quot; box.<br>(provided .shortcut_onEditId_dontSetPageTree is not set!)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:25:"mayNotCreateEditShortcuts";s:8:"datatype";s:7:"boolean";s:11:"description";s:91:"If set, then the user cannot create or edit shortcuts. Depends on .shortcutFrame being set.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:17:"createFoldersInEB";s:8:"datatype";s:7:"boolean";s:11:"description";s:103:"If set, a createFolders option appears in the element browser (for admin-users this is always enabled).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:12:"noThumbsInEB";s:8:"datatype";s:7:"boolean";s:11:"description";s:67:"If set, then image thumbnails are not shown in the element browser.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:24:"noThumbsInRTEimageSelect";s:8:"datatype";s:7:"boolean";s:11:"description";s:61:"As .noThumbsInEB but for the Rich Text Editor image selector.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:21:"uploadFieldsInTopOfEB";s:8:"datatype";s:7:"boolean";s:11:"description";s:82:"If set, the upload-fields in the element browser are put in the top of the window.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:32:"saveDocNew<br>saveDocNew.[table]";s:8:"datatype";s:25:"boolean / &quot;top&quot;";s:11:"description";s:479:"If set, a button &quot;Save and create new&quot; will appear in TCEFORMs. <br>Any value set for a single table will override the default value set to the object &quot;saveDocNew&quot;.<br>&nbsp;<b><br>Example:</b><br>In this example the button is disabled for all tables, except tt_content where it will appear, and in addition create the records in the top of the page (default is after instead of top).<br>&nbsp;<br>options.saveDocNew = 0<br>options.saveDocNew.tt_content = top";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:38:"disableDelete<br>disableDelete.[table]";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:125:"Disables the &quot;Delete&quot; button in TCEFORMs. <br>Overriding for single tables works like &quot;saveDocNew&quot; above.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:34:"showHistory<br>showHistory.[table]";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:126:"Shows link to the history for the record in TCEFORMs.<br>Overriding for single tables works like &quot;saveDocNew&quot; above.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:80:"pageTree.disableIconLinkToContextmenu<br>folderTree.disableIconLinkToContextmenu";s:8:"datatype";s:31:"boolean / &quot;titlelink&quot;";s:11:"description";s:203:"If set, the page/folder-icons in the page/folder tree will not activate the clickmenu. <br>If the value is set &quot;titlelink&quot; then the icon will instead be wrapped with the same link as the title.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:30:"pageTree.disableTitleHighlight";s:8:"datatype";s:7:"boolean";s:11:"description";s:78:"If set, the page titles in the page tree will not be highlighted when clicked.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:22;a:6:{s:8:"property";s:28:"pageTree.showPageIdWithTitle";s:8:"datatype";s:7:"boolean";s:11:"description";s:109:"If set, the titles in the page navigation tree will have their ID numbers printed before the clickable title.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:23;a:6:{s:8:"property";s:28:"pageTree.onlineWorkspaceInfo";s:8:"datatype";s:7:"boolean";s:11:"description";s:135:"If set, the workspace info box will also be shown in the page tree even in online mode. Recommended when working with workspaces a lot.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:24;a:6:{s:8:"property";s:43:"&nbsp;contextMenu.[<i>key</i>].disableItems";s:8:"datatype";s:13:"list of items";s:11:"description";s:847:"List of context menu (&quot;clickmenu&quot;) items to disable.<br>&quot;key&quot; points to which kind of icon that brings up the menu, and possible options are &quot;pageTree&quot;, &quot;pageList&quot;, &quot;folderTree&quot;, &quot;folderList&quot;. &quot;page&quot; and &quot;folder&quot; obviously points to either the Web og File main module. &quot;Tree&quot; and &quot;List&quot; points to whether the menu is activated from the page/folder tree or the listing of records/files<br>Items to disable are (for &quot;page&quot; type - that is database records):<br>&nbsp;<br>view,edit,hide,new,info,copy,cut,paste,delete,move_wizard,<br>history,perms,new_wizard,hide,edit_access,edit_pageheader,db_list<br>&nbsp;<br>Items to disable are (for &quot;folder&quot; type - that is files/folders):<br>edit,upload,rename,new,info,copy,cut,paste,delete";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:25;a:6:{s:8:"property";s:29:"contextMenu.options.leftIcons";s:8:"datatype";s:7:"boolean";s:11:"description";s:70:"If set, the icons in the clickmenu appear to the left instead of right";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:26;a:6:{s:8:"property";s:42:"&nbsp;contextMenu.options.clickMenuTimeOut";s:8:"datatype";s:10:"int, 1-100";s:11:"description";s:93:"Number of seconds the click menu is visible in the top frame before it disappears by it self.";s:7:"default";s:1:"5";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:27;a:6:{s:8:"property";s:55:"&nbsp;contextMenu.options.alwaysShowClickMenuInTopFrame";s:8:"datatype";s:7:"boolean";s:11:"description";s:153:"If set, then the clickmenu in the top frame is always shown. Default is that it&#039;s shown only if the pop-up menus are disabled by user or by browser.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:28;a:6:{s:8:"property";s:18:"overridePageModule";s:8:"datatype";s:6:"string";s:11:"description";s:288:"By this value you can substitute the default &quot;Web &gt; Page&quot; module key (&quot;web_layout&quot;) with another backend module key.<br>&nbsp;<b><br>Example:</b><br>options.overridePageModule = web_txtemplavoilaM1<br>This will enable TemplaVoila page module as default page module.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:29;a:6:{s:8:"property";s:21:"moduleMenuCollapsable";s:8:"datatype";s:7:"boolean";s:11:"description";s:60:"If set, the user can collapse main modules in the left menu.";s:7:"default";s:1:"1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:30;a:6:{s:8:"property";s:11:"alertPopups";s:8:"datatype";s:7:"bitmask";s:11:"description";s:246:"Configure which Javascript popup alerts have to be displayed and which not:<br>&nbsp;<br>1 – onTypeChange<br>2 – copy / move / paste<br>4 - delete<br>8 – FE editing<br>128 - other (not used yet)<br>&nbsp;<br>Default: 255 (show all warnings)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:31;a:6:{s:8:"property";s:18:"defaultFileUploads";s:8:"datatype";s:7:"integer";s:11:"description";s:69:"Default number of file upload forms shown in the File-&gt;List module";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:32;a:6:{s:8:"property";s:19:"hideRecords.[table]";s:8:"datatype";s:21:"[list of record uids]";s:11:"description";s:555:"This hides records in the backend user interface. It is not an access <br>restriction but makes defined records invisible. That means in principle <br>those records can still be edited if the rights allow. This makes sense if a <br>specialized module should be used only to edit those records.<br>&nbsp;<br>This option is currently implemented for pages only and has an effect in <br>following places:<br>&nbsp;<br>- Pagetree navigation frame<br>- Web&gt;List module<br>- New record wizard<br>&nbsp;<b><br>Example:</b><br>options.hideRecords.pages = 12,45";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('8', '', '64dfc4b3acce1eaea54363c984c36980', '', 'beuser:setup.default/setup.override', 'a:1:{s:4:"rows";a:23:{i:0;a:6:{s:8:"property";s:19:"thumbnailsByDefault";s:8:"datatype";s:7:"boolean";s:11:"description";s:26:"Show Thumbnails by default";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:14:"emailMeAtLogin";s:8:"datatype";s:7:"boolean";s:11:"description";s:57:"Notify me by email, when somebody logs in from my account";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:17:"startInTaskCenter";s:8:"datatype";s:7:"boolean";s:11:"description";s:102:"If set, then the backend will start up in the task center (task center should be enabled for the user)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:8:"helpText";s:8:"datatype";s:7:"boolean";s:11:"description";s:30:"Show help text when applicable";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:8:"titleLen";s:8:"datatype";s:4:"int+";s:11:"description";s:17:"Max. Title Length";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:17:"edit_wideDocument";s:8:"datatype";s:7:"boolean";s:11:"description";s:24:"Wide document background";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:8:"edit_RTE";s:8:"datatype";s:7:"boolean";s:11:"description";s:23:"Enable Rich Text Editor";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:20:"edit_docModuleUpload";s:8:"datatype";s:7:"boolean";s:11:"description";s:35:"File upload directly in Doc. module";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:18:"edit_showFieldHelp";s:8:"datatype";s:6:"string";s:11:"description";s:122:"Keywords: &quot;&quot;, &quot;icon&quot; or &quot;text&quot;<br>Determines the type of help text mode for TCA form fields.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:13:"navFrameWidth";s:8:"datatype";s:4:"int+";s:11:"description";s:77:"The width in pixels of the navigation frame in the Page and File main modules";s:7:"default";s:10:"245 pixels";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:17:"navFrameResizable";s:8:"datatype";s:7:"boolean";s:11:"description";s:99:"If set, the frameset modules will have the border between the navigation and list frame resizable. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:4:"lang";s:8:"datatype";s:12:"language-key";s:11:"description";s:131:"One of the language-keys. See t3lib/config_default.php for current options. Eg. &quot;dk&quot;, &quot;de&quot;, &quot;es&quot; etc.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:10:"copyLevels";s:8:"datatype";s:4:"int+";s:11:"description";s:84:"Recursive Copy: Enter the number of page sublevels to include, when a page is copied";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:15:"recursiveDelete";s:8:"datatype";s:7:"boolean";s:11:"description";s:74:"Recursive Delete(!): Allow ALL subpages to be deleted when deleting a page";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:16:"allSaveFunctions";s:8:"datatype";s:7:"boolean";s:11:"description";s:45:"Display all save functions in Doc-module menu";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:15:"neverHideAtCopy";s:8:"datatype";s:7:"boolean";s:11:"description";s:72:"If set, then the hideAtCopy feature for records in TCE will not be used.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:13:"condensedMode";s:8:"datatype";s:7:"boolean";s:11:"description";s:213:"If set, the backend will not load the Web-submodules and File-submodules in a frameset but allow the page and folder trees to load the submodule in its own frame. This allows for a better display on small screens.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:10:"noMenuMode";s:8:"datatype";s:16:"boolean / string";s:11:"description";s:580:"If set, the backend will not load the left menu frame but rather put a selector-box menu in the topframe. This saves a lot of space on small screens. Also icons will not be displayed in the clickmenu panel in the top.<br>&nbsp;<b><br>Value &quot;icons&quot;: </b><br>Setting noMenuMode to &quot;icons&quot; will still remove the menu, but instead of the selectorbox menu you will have the whole clickmenu panel as a menu with the icons only as the hidden state of the clickmenu panel. This is extremely nice (in my opinion) for experienced users who know the icons of the modules.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:19:"classicPageEditMode";s:8:"datatype";s:7:"boolean";s:11:"description";s:287:"Setting this option will not open the Web&gt;Page module but rather load the content elements (normal column/default language) together with the page header in one big form when a page is edited (clicking a page icon in the page tree). This simulates the old behaviour in Classic Backend";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:18:"hideSubmoduleIcons";s:8:"datatype";s:7:"boolean";s:11:"description";s:78:"If set then submodule icons will not be shown in the left menu of the backend.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:27:"dontShowPalettesOnFocusInAB";s:8:"datatype";s:7:"boolean";s:11:"description";s:82:"If set, palettes are not activated in the TCEFORMs when focus is moved to a field.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:15:"disableCMlayers";s:8:"datatype";s:7:"boolean";s:11:"description";s:47:"Disable the context menu layers in the backend.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:22;a:6:{s:8:"property";s:20:"disableTabInTextarea";s:8:"datatype";s:7:"boolean";s:11:"description";s:213:"If you are using IE or Mozilla, TYPO3 will load a little JavaScript file that makes it possible to use the &lt;tab&gt; key in textareas. If you don&#039;t like the feature for some reason, you can disable it here.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('9', '', '71860c77c6745379b0d44304d66b6a13', '', 'page', 'a:1:{s:4:"rows";a:7:{i:0;a:6:{s:8:"property";s:3:"mod";s:8:"datatype";s:8:"-&gt;MOD";s:11:"description";s:157:"Options for the backend modules.<br>&nbsp;<i><br>Notice that these options are merged with settings from User TSconfig (TLO: mod) which takes precedence.</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:3:"RTE";s:8:"datatype";s:8:"-&gt;RTE";s:11:"description";s:96:"This defines configuration for the Rich Text Editor.<br>&nbsp;<br>Please refer to the  document.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:7:"TCEMAIN";s:8:"datatype";s:12:"-&gt;TCEMAIN";s:11:"description";s:49:"Configuration for the TYPO3 Core Engine (TCEmain)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:7:"TCEFORM";s:8:"datatype";s:12:"-&gt;TCEFORM";s:11:"description";s:82:"Extra configuration for the form fields rendered by the TCEforms-class in general.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:4:"TSFE";s:8:"datatype";s:9:"-&gt;TSFE";s:11:"description";s:38:"Options for the TSFE front end object.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:4:"user";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:87:"This is for custom purposes. <br>Deprecated, use &quot;tx_*&quot; below from extensions";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:37:"tx_[extension key with no underscore]";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:38:"This is reserved space for extensions.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('10', '', '7868483dcb3f552ecc4d86326398cc9e', '', 'page:mod; beuser:mod', 'a:1:{s:4:"rows";a:6:{i:0;a:6:{s:8:"property";s:24:"web_layout.menu.function";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:879:"<b>Web &gt; Page module</b><br>&nbsp;<br>&nbsp;<br>&nbsp;<b><br>Option tags:</b><br>&nbsp;<br>&lt;select name<b>=&quot;</b>SET[function]<b>&quot;</b>&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>1<b>&quot;</b>&gt;Columns&lt;/option&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>0<b>&quot;</b>&gt;QuickEdit&lt;/option&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>2<b>&quot;</b>&gt;Languages&lt;/option&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>3<b>&quot;</b>&gt;Page information&lt;/option&gt;<br>&lt;/select&gt;<b><br>Example:</b><br>&nbsp;<br>&nbsp;&nbsp;&nbsp;<i># Disables all items except the &quot;QuickEdit&quot; item:</i><br>&nbsp;mod.web_layout.menu.function <b>{</b><br>&nbsp;&nbsp;&nbsp;1 <b>=</b> 0<br>&nbsp;&nbsp;&nbsp;2 <b>=</b> 0<br>&nbsp;&nbsp;&nbsp;3 <b>=</b> 0<b><br>}</b>";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:22:"web_info.menu.function";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:1023:"<b>Web &gt; Info module</b><br>&nbsp;<br>&nbsp;<b><br>Option tags:</b><br>&nbsp;<br>&lt;select name<b>=&quot;</b>SET[function]<b>&quot;</b>&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>tx_cms_webinfo_page<b>&quot;</b>&gt;Pagetree overview&lt;/option&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>tx_belog_webinfo<b>&quot;</b>&gt;Log&lt;/option&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>tx_infopagetsconfig_webinfo<b>&quot;</b>&gt;Page TSconfig&lt;/option&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>tx_cms_webinfo_hits<b>&quot;</b>&gt;Hit Statistics&lt;/option&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>tx_indexedsearch_modfunc1<b>&quot;</b>&gt;Indexed search&lt;/option&gt;<br>&lt;/select&gt;<b><br>Example:</b><br>&nbsp;<br>&nbsp;&nbsp;&nbsp;<i># Disables the item &quot;Hit Statistics&quot;:</i><br>&nbsp;mod.web_info.menu.function <b>{</b><br>&nbsp;&nbsp;&nbsp;tx_cms_webinfo_hits <b>=</b> 0<b><br>}</b>";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:22:"web_func.menu.function";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:292:"<b>Web &gt; Functions module</b><br>&nbsp;<br>&nbsp;<b><br>Option tags:</b><br>&nbsp;<br>&lt;select name<b>=&quot;</b>SET[function]<b>&quot;</b>&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>tx_funcwizards_webfunc<b>&quot;</b>&gt;Wizards&lt;/option&gt;<br>&lt;/select&gt;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:17:"web_func.menu.wiz";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:862:"<b>Web &gt; Functions module, Wizards sub module</b><br>This is the 2nd-level Function Menu in the Web &gt; Functions module. Instead of the &quot;function&quot; key of the main menu it just uses the key &quot;wiz&quot; instead.<br>&nbsp;<br>&nbsp;<b><br>Option tags:</b><br>&nbsp;<br>&lt;select name<b>=&quot;</b>SET[wiz]<b>&quot;</b>&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>tx_wizardcrpages_webfunc_2<b>&quot;</b>&gt;Create multiple pages&lt;/option&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>tx_wizardsortpages_webfunc_2<b>&quot;</b>&gt;Sort pages&lt;/option&gt;<br>&lt;/select&gt;<b><br>Example:</b><br>&nbsp;<br>&nbsp;&nbsp;&nbsp;<i># Disables the sub-item &quot;Create multiple pages&quot;:</i><br>&nbsp;mod.web_func.menu.wiz <b>{</b><br>&nbsp;&nbsp;&nbsp;tx_wizardcrpages_webfunc_2 <b>=</b> 0<b><br>}</b>";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:20:"web_ts.menu.function";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:843:"<b>Web &gt; Template module</b><br>&nbsp;<br>&nbsp;<br>&nbsp;<b><br>Option tags:</b><br>&nbsp;<br>&lt;select name<b>=&quot;</b>SET[function]<b>&quot;</b>&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>tx_tstemplateceditor<b>&quot;</b>&gt;Constant Editor&lt;/option&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>tx_tstemplateinfo<b>&quot;</b>&gt;Info/Modify&lt;/option&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>tx_tstemplateobjbrowser<b>&quot;</b>&gt;TypoScript Object Browser&lt;/option&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>tx_tstemplateanalyzer<b>&quot;</b>&gt;Template Analyzer&lt;/option&gt;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&lt;option value<b>=&quot;</b>tx_tstemplatestyler_modfunc1<b>&quot;</b>&gt;CSS Styler&lt;/option&gt;<br>&lt;/select&gt;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:23:"user_task.menu.function";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:1146:"<b>User &gt; Task Center</b><br>This is slightly different because the Task Center does not provide a selector box function menu. But behind the scene it uses the same functionality of saving &quot;states&quot; and therefore you can also blind items in the Task Center.<br>There is one tricky thing thought: The Task Center is not depending on a page in the page tree! So you either have to set default Page TSconfig or User TSconfig to blind options here!<br>&nbsp;<br>&nbsp;<br>&nbsp;<b><br>Keys are:</b><br>&nbsp;<br>tx_sysnotepad = Quick Notetx_taskcenterrecent = Recent Pagestx_taskcenterrootlist = Web&gt;List module / roottx_taskcentermodules = Pluginstx_sysaction = Actionstx_systodos = Tasks<br>&nbsp;<b><br>Example:</b><br>Set this as <i>User TSconfig</i>:<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;<i># Task Center configuration:</i><br>&nbsp;mod.user_task.menu.function <b>{</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Disable &quot;Recent Pages&quot; display:</i><br>&nbsp;&nbsp;&nbsp;tx_taskcenterrecent <b>=</b> 0<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Disable &quot;Action&quot; list</i><br>&nbsp;&nbsp;&nbsp;tx_sysaction <b>=</b> 0<b><br>}</b>";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('11', '', 'ef29a11397049df8d64b160558d05e89', '', 'page:mod.SHARED; beuser:mod.SHARED', 'a:1:{s:4:"rows";a:3:{i:0;a:6:{s:8:"property";s:11:"colPos_list";s:8:"datatype";s:51:"(list of integers, blank = don&#039;t do anything.)";s:11:"description";s:841:"This option lets you specify which columns of tt_content elements should be displayed in the &#039;Columns&#039; view of the modules, in particular Web&gt;Page. <br>By default there are four columns, Left, Normal, Right, Border. However most websites use only the Normal column, maybe another also. In that case the remaining columns are not needed. By this option you can specify exactly which of the columns you want to display.<br>Each column has a number which ultimately comes from the configuration of the table tt_content, field &#039;colPos&#039; found in the tables.php file. This is the values of the four default columns:<br>Left: 1<br>Normal: 0<br>Right: 2<br>&nbsp;Border: 3<br>&nbsp;<b><br>Example:</b><br>This results in only the Normal and Border column being displayed:<br>&nbsp;<br>&nbsp;mod.SHARED.colPos_list <b>=</b> 0,3";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:20:"defaultLanguageLabel";s:8:"datatype";s:6:"string";s:11:"description";s:166:"Alternative label for &quot;Default&quot; when language labels are shown in the interface.<br>&nbsp;<br>Used on Web&gt;List, Web&gt;Page and TemplaVoilas page module.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:19:"defaultLanguageFlag";s:8:"datatype";s:6:"string";s:11:"description";s:117:"Flag icon filename from gfx/flags/ for default language<br>&nbsp;<br>User in Web&gt;List and TemplaVoila page module.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('12', '', '4bce98e2b4a7c289073897b4dbc86601', '', 'page:mod.web_layout; beuser:mod.web_layout', 'a:1:{s:4:"rows";a:12:{i:0;a:6:{s:8:"property";s:22:"tt_content.colPos_list";s:8:"datatype";s:51:"(list of integers, blank = don&#039;t do anything.)";s:11:"description";s:288:"See mod.SHARED.colPos_list for details.<br>If non-blank, this list will override the one set by mod.SHARED.colPos_list.<br>&nbsp;<b><br>Example:</b><br>This results in only the Normal and Border column being displayed:<br>&nbsp;<br>&nbsp;mod.web_layout.tt_content.colPos_list <b>=</b> 0,3";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:21:"tt_content.fieldOrder";s:8:"datatype";s:41:"list of field names from tt_content table";s:11:"description";s:646:"This allows you to specify (and thereby overrule) the preferred order of the fieldnames of the &quot;Quick Edit&quot; editing forms of the tt_content table (Content Elements). Just specify the list of fields, separated by comma. Then these fields will be listed first and all remaining fields thereafter in their original order.<br>&nbsp;<b><br>Example:</b><br>This results in the &#039;Text&#039; field and thereafter &#039;Header&#039; field being display as the very first fields instead of the &#039;Type&#039; field. <br>&nbsp;<br>&nbsp;mod.web_layout.tt_content <b>{</b><br>&nbsp;&nbsp;&nbsp;fieldOrder <b>=</b> bodytext, header<b><br>}</b>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:17:"editFieldsAtATime";s:8:"datatype";s:4:"int+";s:11:"description";s:305:"Specifies the number of subsequent content elements to load in the editform when clicking the editicon of a content element in the &#039;Columns&#039; view of the module. <br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;mod.web_layout <b>{</b><br>&nbsp;&nbsp;&nbsp;editFieldsAtATime <b>=</b> 2<b><br>}</b>";s:7:"default";s:1:"1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:19:"noCreateRecordsLink";s:8:"datatype";s:7:"boolean";s:11:"description";s:85:"If set, the link in the bottom of the page, &quot;Create new record&quot;, is hidden.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:11:"QEisDefault";s:8:"datatype";s:7:"boolean";s:11:"description";s:108:"If set, then the QuickEditor is the first element in the Function Menu in the top of the menu in Web&gt;Page";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:16:"disableSearchBox";s:8:"datatype";s:7:"boolean";s:11:"description";s:40:"Disables the search box in Columns view.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:17:"disableBigButtons";s:8:"datatype";s:7:"boolean";s:11:"description";s:141:"Disables the large buttons in top of the Columns view.<br>&nbsp;<br>These are the buttons that are hidden by this option:<br>&nbsp;<br>&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:15:"disableAdvanced";s:8:"datatype";s:7:"boolean";s:11:"description";s:133:"Disables the clear cache advanced function in the bottom of the page in the module, including the &quot;Create new record&quot; link.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:30:"disableNewContentElementWizard";s:8:"datatype";s:7:"boolean";s:11:"description";s:138:"Disables the fact that the new-content-element icons links to the content element wizard and not directly to a blank &quot;NEW&quot; form.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:20:"defaultLanguageLabel";s:8:"datatype";s:6:"string";s:11:"description";s:156:"Alternative label for &quot;Default&quot; when language labels are shown in the interface.<br>&nbsp;<br>Overrides the same property from mod.SHARED if set. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:14:"defLangBinding";s:8:"datatype";s:7:"boolean";s:11:"description";s:521:"If set, translations of content elements are bound to the default record in the display. This means that within each column with content elements any translation found for exactly the shown default content element will be shown in the language column next to.<br>&nbsp;<br>This display mode should be used depending on how the frontend is configured to display localization. The frontend must display localized pages by selecting the default content elements and for each one overlay with a possible translation if found.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:18:"disableIconToolbar";s:8:"datatype";s:7:"boolean";s:11:"description";s:95:"Disables the topmost icon toolbar with the &quot;view&quot;-Icon and the icon<br>toolbar below.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('13', '', '2f1769c34fe68445a2679c113ab252c3', '', 'page:mod.web_list; beuser:mod.web_list', 'a:1:{s:4:"rows";a:9:{i:0;a:6:{s:8:"property";s:19:"noCreateRecordsLink";s:8:"datatype";s:7:"boolean";s:11:"description";s:219:"If set, the link in the bottom of the page, &quot;Create new record&quot;, is hidden.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;mod.web_list <b>{</b><br>&nbsp;&nbsp;&nbsp;noCreateRecordsLink <b>=</b> 1<b><br>}</b>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:17:"alternateBgColors";s:8:"datatype";s:7:"boolean";s:11:"description";s:274:"If set, the background colors of elements will alternate.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;mod.web_list <b>{</b><br>&nbsp;&nbsp;&nbsp;alternateBgColors <b>=</b> 1<b><br>}</b><br>The result is alternating background colors for each element:<br>&nbsp;<br>&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:22:"disableSingleTableView";s:8:"datatype";s:7:"boolean";s:11:"description";s:199:"If set, then the links on the table titles which shows a single table listing only will not be available (including sorting links on columns titles, because these links jumps to the table-only view).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:25:"listOnlyInSingleTableView";s:8:"datatype";s:7:"boolean";s:11:"description";s:500:"If set, then records will be listed only when the single table view is enabled. This is very practical for pages containing many records from many tables!<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;mod.web_list <b>{</b><br>&nbsp;&nbsp;&nbsp;listOnlyInSingleTableView <b>=</b> 1<b><br>}</b><br>The result will be that records from tables are listed only in the single-table mode and the default view will just show number of table records in page and the table description if available:<br>&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:16:"allowedNewTables";s:8:"datatype";s:25:"<i>list of tablenames</i>";s:11:"description";s:661:"If this list is set, then only tables listed here will have a link to &quot;create new&quot; in the page and subpages.<br>&nbsp;<br>This also affects &quot;db_new.php&quot; (the display of &quot;Create new record&quot;)<br>&nbsp;<b>Note:</b> Technically records can be created (eg. by copying/moving), so this is &quot;pseudo security&quot;. The point is to reduce the number of options for new records visually.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;mod.web_list <b>{</b><br>&nbsp;&nbsp;&nbsp;allowedNewTables <b>=</b> pages, tt_news<b><br>}</b><br>Only pages and tt_news table elements will be linked to in the New record screen:<br>&nbsp;<br>&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:10:"newWizards";s:8:"datatype";s:7:"boolean";s:11:"description";s:177:"If set, then the new-link over the control panel of the pages and tt_content listings in the List module will link to the wizards and not create a record in the top of the list.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:38:"showClipControlPanelsDespiteOfCMlayers";s:8:"datatype";s:7:"boolean";s:11:"description";s:237:"If set, then the control- and clipboard panels of the module is shown even if the context-popups (ClickMenu) are available. Normally the control- and clipboard panels are disabled (unless extended mode is set) in order to save bandwidth.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:71:"newPageWiz.overrideWithExtension<br>newContentWiz.overrideWithExtension";s:8:"datatype";s:6:"string";s:11:"description";s:351:"If set to an extension key, (eg. &quot;templavoila&quot;) then the &quot;mod1/index.php&quot; file of that extension will be used for creating new elements on the page. &quot;newContentWiz&quot; will likewise use the &quot;mod1/db_new_content_el.php&quot; for creating new content elements.<br>&nbsp;<br>Also see &quot;options.overridePageModule&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:14:"clickTitleMode";s:8:"datatype";s:6:"string";s:11:"description";s:337:"Keyword which defines what happens when a user clicks the title in the list.<br>&nbsp;<br>Default is that pages will go one level down while other records have no link at all.<br>&nbsp;<br>Keywords:<br>&nbsp;<b>edit</b> = Edits record<br>&nbsp;<b>info</b> = Shows information<br>&nbsp;<b>show</b> = Shows page/content element in frontend";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('14', '', '2c0faa1efede00c1315123808e0536ef', '', 'page:mod.web_view; beuser:mod.web_view', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:4:"type";s:8:"datatype";s:4:"int+";s:11:"description";s:314:"Enter the value of the &amp;type parameter passed to the webpage.<br>&nbsp;<b><br>Example:</b><br>By this configuration frontend pages will be shown with &quot;index.php?id=123&amp;type=1&quot; from the Web &gt; View module:<br>&nbsp;<br>&nbsp;mod.web_view <b>{</b><br>&nbsp;&nbsp;&nbsp;type <b>=</b> 1<b><br>}</b>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('15', '', '14bf6725234188138476fdcb63eaba70', '', 'beuser:mod.tools_em', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:14:"allowTVlisting";s:8:"datatype";s:7:"boolean";s:11:"description";s:350:"If set the Technical and Validation listings are available in the EM. Those will evaluate ALL available extensions and that can take many seconds (up to 30) depending on number of extensions. <br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;mod.tools_em.allowTVlisting <b>=</b> 1<br>Enables these options in the Extension Manager:<br>&nbsp;<br>&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('16', '', 'b6ee1f8429c301026c90ac1561f84770', '', 'page:mod.xMOD_alt_doc; beuser:mod.xMOD_alt_doc', 'a:1:{s:4:"rows";a:2:{i:0;a:6:{s:8:"property";s:18:"disableDocSelector";s:8:"datatype";s:7:"boolean";s:11:"description";s:393:"If set, the document selector is disabled<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;mod.xMOD_alt_doc <b>{</b><br>&nbsp;&nbsp;&nbsp;disableDocSelector <b>=</b> 1<br>&nbsp;&nbsp;&nbsp;disableCacheSelector <b>=</b> 1<b><br>}</b><br>The result is that both the document and cache action selector is hidden in the form page:<br>&nbsp;<br>&nbsp;<br>(The interesting part is what is missing...)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:20:"disableCacheSelector";s:8:"datatype";s:7:"boolean";s:11:"description";s:89:"If set, the cache/save/close selector is disabled.<br>&nbsp;<i><br>See example above.</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('17', '', 'dc552e3c78a7a59de68ad59044c36468', '', 'page:TCEMAIN', 'a:1:{s:4:"rows";a:8:{i:0;a:6:{s:8:"property";s:35:"table.[<i>tablename</i>]<br>default";s:8:"datatype";s:19:"-&gt;TCEMAIN_tables";s:11:"description";s:23:"Options for each table.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:41:"permissions.userid<br>permissions.groupid";s:8:"datatype";s:4:"int+";s:11:"description";s:861:"Hardcodes the default owner Backend User / Group UID of new and copied pages.<br>&nbsp;<br>(The default owner is the backend user that creates / copies the record. The default user group is the &quot;main group&quot; of the backend user - the group in the very top of the users group-list.)<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;TCEMAIN <b>{</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Owner be_users UID for new pages:</i><br>&nbsp;&nbsp;&nbsp;permissions.userid <b>=</b> 2<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Owner be_groups UID for new pages:</i><br>&nbsp;&nbsp;&nbsp;permissions.groupid <b>=</b> 3<b><br>}</b><br>Backend User with UID 2 is &quot;test&quot; and the Backend Group with UID 3 is &quot;test_group&quot;. With the configuration above a new page would be created with this user/group setting instead of the defaults:<br>&nbsp;<br>&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:62:"permissions.user<br>permissions.group<br>permissions.everybody";s:8:"datatype";s:24:"list of string/int[0-31]";s:11:"description";s:1413:"Default permissions set for owner-user, owner-group and everybody.<br>&nbsp;<br>Keylist: show,edit,delete,new,editcontent<br>Alternatively you can specify an integer from 0 to 31 indicating which bits corresponding to the keylist should be set. (Bits in keylist: show=1,edit=2,delete=4,new=8,editcontent=16)<br>&nbsp;<br>Defaults from $TYPO3_CONF_VARS:<br>&quot;user&quot; =&gt; &quot;show,edit,delete,new,editcontent&quot;,<br>&quot;group&quot; =&gt; &quot;show,edit,new,editcontent&quot;,<br>&quot;everybody&quot; =&gt; &quot;&quot;<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;TCEMAIN.permissions <b>{</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># User can do anything (default):</i><br>&nbsp;&nbsp;&nbsp;user <b>=</b> 31<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Group can do anything </i><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># (normally &quot;delete&quot; is disabled)</i><br>&nbsp;&nbsp;&nbsp;group <b>=</b> 31<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Everybody can at least see the page</i><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># (normally everybody can do nothing)</i><br>&nbsp;&nbsp;&nbsp;everybody <b>=</b> show<b><br>}</b><br>The page &quot;Test (copy 3)&quot; was created with the settings above for permissions. Compared to the two other pages created with default permissions you can see the effect: The Backend Group can now also delete the page by default and Everybody has read access:<br>&nbsp;<br>&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:13:"clearCacheCmd";s:8:"datatype";s:61:"List of values (integers, &quot;all&quot;, &quot;pages&quot;)";s:11:"description";s:563:"This can allow you to have the cache for additional pages cleared when saving to some page or branch of the page tree.<br>&nbsp;<b><br>Examples:</b><br>&nbsp;<br>&nbsp;&nbsp;&nbsp;<i># Will clear the cache for page ID 12 and 23 </i><br>&nbsp;&nbsp;&nbsp;<i># when saving a record in this page:</i><br>&nbsp;TCEMAIN.clearCacheCmd <b>=</b> 12,23<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;<i># Will clear all pages cache:</i><br>&nbsp;TCEMAIN.clearCacheCmd <b>=</b> pages<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;<i># Will clear ALL cache:</i><br>&nbsp;TCEMAIN.clearCacheCmd <b>=</b> all";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:30:"clearCache_pageSiblingChildren";s:8:"datatype";s:7:"boolean";s:11:"description";s:204:"If set, then children of all siblings of a page being edited will have the page cache cleared.<br>(Default is that when a page record is edited, the cache for itself and siblings (same level) is cleared.)";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:26:"clearCache_pageGrandParent";s:8:"datatype";s:7:"boolean";s:11:"description";s:86:"If set, then the grand parent of a page being edited will have the page cache cleared.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:18:"clearCache_disable";s:8:"datatype";s:7:"boolean";s:11:"description";s:189:"If set, then the automatic clearing of page cache when records are edited etc. is disabled. This also disables the significance of the two &quot;clearCache_page*&quot; options listed above.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:18:"translateToMessage";s:8:"datatype";s:6:"string";s:11:"description";s:480:"Defines the string that will be prepended to every field value if you copy an element to another language version.<br>&nbsp;<br>The special string &quot;%s&quot; will be replaced with the language title.<br>Default ist &quot;Translate to [language title]:&quot;.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;TCEMAIN <b>{</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Set a German label:</i><br>&nbsp;&nbsp;&nbsp;translateToMessage = Bitte in &quot;%s&quot; übersetzen:<b><br>}</b>";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('18', '', 'bdedb7b326ecbf571a94829143391fa3', '', 'page:TCEMAIN.default/TCEMAIN.table.(tablename)/->TCEMAIN_tables', 'a:1:{s:4:"rows";a:3:{i:0;a:6:{s:8:"property";s:18:"history.maxAgeDays";s:8:"datatype";s:4:"int+";s:11:"description";s:155:"The number of days elements are in the history at most. Takes precedence over keepEntries.<br>Default is 7 days. Range 0-200. Zero turns the magAgeDays of.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:20:"disablePrependAtCopy";s:8:"datatype";s:7:"boolean";s:11:"description";s:1178:"Disables the &quot;prependAtCopy&quot; feature (if configured for table in $TCA)<br>&nbsp;<br>(The word &quot;prepend&quot; is misguiding - the &quot;(copy)&quot; label is <i>appended</i> to (put after) the record title! Sorry for that mistake, it isn&#039;t the only time I have made that.)<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;TCEMAIN.table.pages <b>{</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Pages will NOT have &quot;(copy)&quot; appended:</i><br>&nbsp;&nbsp;&nbsp;disablePrependAtCopy <b>=</b> 1<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Pages will NOT be hidden upon copy:</i><br>&nbsp;&nbsp;&nbsp;disableHideAtCopy <b>=</b> 1<b><br>}</b><br>These settings means that a page copied (say, the last page in this tree, labeled &quot;Test&quot;) will neither have &quot;(copy X)&quot; appended nor be hidden. <br>This effect is shown in the first sub page here, labeled &quot;Test&quot;. It appears exactly like the third page that was copied. <br>The page in the middle, labeled &quot;Test (copy 3)&quot; is the default mode where the page is hidden and the &quot;(copy X)&quot; suffix is added if another page with the same named existed already.<br>&nbsp;<br>&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:17:"disableHideAtCopy";s:8:"datatype";s:7:"boolean";s:11:"description";s:147:"Disables the &quot;hideAtCopy&quot; feature (if configured for table in $TCA)<br>&nbsp;<br>For example, see &quot;disablePrependAtCopy&quot; above.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('19', '', '635aff2d727b50d7cdaaaf6a4144318e', '', 'page:TCEFORM', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:90:"[<i>tablename</i>].[<i>field</i>]<br>[<i>tablename</i>].[<i>field</i>].types.[<i>type</i>]";s:8:"datatype";s:20:"-&gt;TCEFORM_confObj";s:11:"description";s:459:"These objects contain additional configuration of the TCEFORM interface. For the properties available, refer to the table below. This is a description of how you can customize in general and override for specific types.<br>&nbsp;<br>TCEFORM.[tablename].[field] - configures the field in TCEFORM for all types.<br>&nbsp;<br>TCEFORM.[tablename].[field].types.[type] - configures the field in TCEFORM in case the &#039;type&#039;-value of the field matches type.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('20', '', 'aa7f13fe687c77a191a431405d3f9631', '', 'page:TCEFORM.(tablename).(field)/TCEFORM.(tablename).(field).types.(type)', 'a:1:{s:4:"rows";a:12:{i:0;a:6:{s:8:"property";s:8:"disabled";s:8:"datatype";s:7:"boolean";s:11:"description";s:248:"If set, the field is not rendered.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;TCEFORM.pages.title <b>{</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># You cannot edit the Page title field now:</i><br>&nbsp;&nbsp;&nbsp;disabled <b>=</b> 1<b><br>}</b>";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:11:"removeItems";s:8:"datatype";s:14:"list of values";s:11:"description";s:354:"<i>(applies to select-types only)</i><i><br>&nbsp;</i><br>This removes the items from the list which has a value found in this comma list of values.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;TCEFORM.pages.doktype {<br>&nbsp;    # Remove the &quot;Recycler&quot; and &quot;Spacer&quot; page type options:<br>&nbsp;  removeItems = 199, 255<br>}";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:20:"addItems.[itemValue]";s:8:"datatype";s:18:"string (label, LS)";s:11:"description";s:935:"<i>(applies to select-types only)</i><i><br>&nbsp;</i><br>This will add elements to the list. Notice that the added elements might be removed if the selector represents records. In that case only still existing records will be preserved.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;TCEFORM.pages.doktype <b>{</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Creates a new page type option:</i><br>&nbsp;&nbsp;&nbsp;addItems.123 <b>=</b> New Page type!<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Creates yet a page type with &quot;locallang&quot; title:</i><br>&nbsp;&nbsp;&nbsp;addItems.124 <b>=</b> LLL:EXT:lang/locallang_tca.php:title<b><br>}</b><br>This example extends the options for Page types with two new items:<br>&nbsp;<br>&nbsp;<br>&nbsp;<b>Warning:</b> This example shows the principle of adding adhoc-items to a selector box in TYPO3 but you <i>should not</i> add new <i>page types</i> or Content Element types this way!";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:29:"disableNoMatchingValueElement";s:8:"datatype";s:7:"boolean";s:11:"description";s:771:"<i>(applies to select-types only)</i><i><br>&nbsp;</i><br>If set, the element &quot;CURRENT VALUE IS NOT AVAILABLE&quot; will not be added to the list.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>If a selector box value is not available among the options in the box the default behavior of TYPO3 is to preserve the value and show a label that warns about this special state:<br>&nbsp;<br>&nbsp;<br>Setting this option disables that behavior:<br>&nbsp;<br>&nbsp;TCEFORM.pages.doktype <b>{</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># &quot;CURRENT VALUE IS NOT ...&quot; label will never show up:</i><br>&nbsp;&nbsp;&nbsp;disableNoMatchingValueElement <b>=</b> 1<b><br>}</b><br>... and the selector box will default to the first element in the selector box:<br>&nbsp;<br>&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:21:"noMatchingValue_label";s:8:"datatype";s:11:"string (LS)";s:11:"description";s:581:"<i>(applies to select-types only)</i><i><br>&nbsp;</i><br>Allows for an alternative label the &quot;noMatchingValue&quot; element. <br>You can insert the placeholder &quot;%s&quot; to insert the value.<br>If you supply a blank value the label will be blank.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<b><br>&nbsp;TCEFORM.pages.doktype {</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Alternative &quot;CURRENT VALUE IS NOT ...&quot; label:</i><br>&nbsp;&nbsp;&nbsp;noMatchingValue_label <b>=</b> VALUE &quot;%s&quot; was not available!<b><br>}</b><br>The result will be:<br>&nbsp;<br>&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:22:"altLabels.[item_value]";s:8:"datatype";s:11:"string (LS)";s:11:"description";s:727:"<i>(applies to select-types only)</i><i><br>&nbsp;</i><br>This allows you to enter alternative labels for the items in the list. <br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;TCEFORM.pages.doktype <b>{</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Setting alternative labels:</i><br>&nbsp;&nbsp;&nbsp;altLabels.1 <b>=</b> STANDARD page type<br>&nbsp;&nbsp;&nbsp;altLabels.2 <b>=</b> ADVANCED page type<br>&nbsp;&nbsp;&nbsp;altLabels.254 <b>=</b> System Folder (for various elements)<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># Sets the default labels for Recycler (via &quot;locallang&quot;):</i><br>&nbsp;&nbsp;&nbsp;altLabels.255 <b>=</b> LLL:EXT:lang/locallang_tca.php:doktype.I.2<b><br>}</b><br>Result will be:<br>&nbsp;<br>&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:16:"PAGE_TSCONFIG_ID";s:8:"datatype";s:7:"integer";s:11:"description";s:289:"<i>(applies to select-types with foreign table)</i><i><br>&nbsp;</i><br>When the select-types are used with foreign-table the where-query has four markers (see description of $TCA in the &quot;Inside TYPO3&quot; document.) The value of three of these markers may be set from Page TSconfig.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:20:"PAGE_TSCONFIG_IDLIST";s:8:"datatype";s:22:"comma list of integers";s:11:"description";s:81:"<i>(applies to select-types with foreign table)</i><i><br>&nbsp;</i><br>See above";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:17:"PAGE_TSCONFIG_STR";s:8:"datatype";s:6:"string";s:11:"description";s:81:"<i>(applies to select-types with foreign table)</i><i><br>&nbsp;</i><br>See above";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:19:"itemsProcFunc.[...]";s:8:"datatype";s:8:"(custom)";s:11:"description";s:188:"<i>(applies to select-types with itemsProcFunc)</i><i><br>&nbsp;</i><br>The properties of this key is passed on to the itemsProcFunc in the parameter array by the key &quot;TSconfig&quot;.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:18:"RTEfullScreenWidth";s:8:"datatype";s:6:"int+/%";s:11:"description";s:269:"<i>(applies for RTE text fields only with the RTE wizard configured)</i><i><br>&nbsp;</i><br>The width of the RTE full screen display. If nothing is set, the whole width is used which means &quot;100%&quot;. If you set an integer value, that indicates the pixels width.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:15:"linkTitleToSelf";s:8:"datatype";s:7:"boolean";s:11:"description";s:870:"<i>(all fields)</i><i><br>&nbsp;</i><br>If set, then the title of the field in the forms links to alt_doc.php editing ONLY that field. <br>Works for existing records only - not new records.<br>&nbsp;<b><br>Extra property:</b><br>.returnUrl = boolean; if set, then the return URL is also set.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;TCEFORM.pages.title <b>{</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># The label for the &quot;title&quot; field will link itself</i><br>&nbsp;&nbsp;&nbsp;linkTitleToSelf <b>=</b> 1<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i># From the form with &quot;title&quot;, return to full form:</i><br>&nbsp;&nbsp;&nbsp;linkTitleToSelf.returnUrl <b>=</b> 1<b><br>}</b><br>The result is that the label for the title field will be a link:<br>&nbsp;<br>&nbsp;<br>Clicking the link brings you to a form where only this field is shown:<br>&nbsp;<br>&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('21', '', '7a924c59af67c619fd51493947aa7abb', '', 'page:TSFE', 'a:1:{s:4:"rows";a:2:{i:0;a:6:{s:8:"property";s:23:"jumpUrl_transferSession";s:8:"datatype";s:7:"boolean";s:11:"description";s:901:"If set, the jumpUrl redirection to the URL will be prepended with a parameter that transfers the current fe_users session to that URL. This URL should be the TYPO3 frontend in the same database, just at another domain (else it makes no sense).<br>&nbsp;<br>You can implement it in your own links if you like. This is how you do:<br>You must send the parameter &#039;FE_SESSION_KEY&#039; as GET or POST. The parameter looks like this: [fe_user-session-id]-[a hash made to prevent misuse]<br>The parameter can be calculated like this:<br>&nbsp;<br>&nbsp;$param = &#039;&amp;FE_SESSION_KEY=&#039;.rawurlencode(<br>&nbsp;   $GLOBALS[&#039;TSFE&#039;]-&gt;fe_user-&gt;id.&#039;-&#039;.<br>&nbsp;   md5(<br>&nbsp;     $GLOBALS[&#039;TSFE&#039;]-&gt;fe_user-&gt;id.&#039;/&#039;.<br>&nbsp;     $GLOBALS[&#039;TYPO3_CONF_VARS&#039;][&#039;SYS&#039;][&#039;encryptionKey&#039;]<br>   )<br>);";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:9:"constants";s:8:"datatype";s:40:"[TypoScript Frontend Constants defaults]";s:11:"description";s:1692:"Defaults for TypoScript Template constants!<br>&nbsp;<br>This features allows you to pass some amount of information (in the form of TypoScript Template constants) to the frontend. <br>The specific use of this should be information which you want to configure for both frontend and backend. For instance you could have a backend module which should act in a certain way depending on in which branch of the page tree it operates. The change of behavior is set by Page TSconfig as always but since you need the same setting applied somewhere in the frontend you don&#039;t want the redundancy of specifying the value twice. In such a case you can use this feature. <br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>&nbsp;TSFE.constants.websiteConfig.id <b>=</b> 123<br>&nbsp;<br>In the TypoScript templates you can now insert this constant as {$websiteConfig.id}<br>&nbsp;<br>&nbsp;<br>&nbsp;<br>In the backend module (in the Web main module) you can reach the value by a few codelines like these:<br>&nbsp;<br>&nbsp;$PageTSconfig = <br>&nbsp;    t3lib_BEfunc::getPagesTSconfig($this-&gt;pObj-&gt;id);<br>&nbsp;$websiteID = <br>&nbsp;    $PageTSconfig[&#039;TSFE.&#039;][&#039;constants.&#039;][&#039;websiteConfig.&#039;][&#039;id&#039;];<br>&nbsp;<b>Notice:</b> In the frontend the setting of default constants will only apply to a branch of the tree <i>if</i> a template record is found on that page (or if a template record is set for &quot;next level&quot;). In other words: If you want the Page TSconfig constant defaults to affect only a certain branch of the page tree, make sure to create a template record (a blank one will do) on the page that carries the Page TSconfig information.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');

#
# ==== Data extracted from CoreDocs/doc_core_tsref_4.0.0.t3x
#
INSERT INTO static_tsconfig_help VALUES ('22', '', '562ee021929de249706534bf02f731ff', '', 'tsref:(datatypes)', 'a:1:{s:4:"rows";a:34:{i:0;a:6:{s:8:"property";s:11:"&lt;tag&gt;";s:8:"datatype";s:43:"<b>&lt;BODY bgcolor=&quot;red&quot;&gt;</b>";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:5:"align";s:8:"datatype";s:12:"<b>right</b>";s:11:"description";s:73:"<b>right / left / center</b><br>Decides alignment, typically in HTML-tags";s:7:"default";s:4:"left";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:7:"VHalign";s:8:"datatype";s:67:"<i>Hori.align = right and Vert.align = center:</i><b><br>r , c </b>";s:11:"description";s:97:"<b>r/c/l , t/c/b</b><br>Horizontal (right, center, left) , Vertical align (top / center / bottom)";s:7:"default";s:5:"l , t";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:8:"resource";s:8:"datatype";s:116:"<i>From the resourcefield:</i><br>toplogo*.gif<br>&nbsp;<i><br>Reference to filesystem:</i><br>fileadmin/picture.gif";s:11:"description";s:603:"1) A reference to a file from the resource-field in the template.<br>You can write the exact filename or you can include an asterisk (*) as wildcard. <br>It&#039;s recommended to include a &quot;*&quot; before the fileextension (see example to the left). This will ensure that the file is still referenced correct even if the template is copied and the file will have it&#039;s name prepended with numbers!!<br>&nbsp;2) If the value contains a &quot;/&quot; it&#039;s expected to be a reference (absolute or relative) to a file on the file-system instead of the resource-field. No support for wildcards.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:11:"imgResource";s:8:"datatype";s:204:"Here &quot;file&quot; is an imgResource:<br>file = toplogo*.gif<br>file.width = 200<br>&nbsp;<br>GIFBUILDER:<br>file = GIFBUILDER<br>file {<br>&nbsp;&nbsp;&nbsp;&nbsp;... (GIFBUILDER-properties here)<br>}";s:11:"description";s:371:"1) A &quot;resource&quot; (see above) + imgResource-properties (see example to the left and object-reference below)<br>Filetypes can be anything among the allowed types defined in the configuration variable $TYPO3_CONF_VARS[&quot;GFX&quot;][&quot;imagefile_ext&quot;] (localconf.php). Standard is pdf,gif,jpg,jpeg,tif,bmp,ai,pcx,tga,png.<br>&nbsp;<br>2) GIFBUILDER-object";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:9:"HTML-code";s:8:"datatype";s:43:"<b>&lt;B&gt;Some text in bold&lt;/B&gt;</b>";s:11:"description";s:14:"pure HTML-code";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:6:"target";s:8:"datatype";s:46:"<b>_top</b><b><br>_blank</b><b><br>content</b>";s:11:"description";s:121:"target in &lt;A&gt;-tag. <br>This is normally the same value as the name of the root-level object that defines the frame.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:14:"imageExtension";s:8:"datatype";s:46:"<b>jpg</b><b><br>web<i>(gif or jpg ..)</i></b>";s:11:"description";s:388:"Image extensions can be anything among the allowed types defined in the global variable $TYPO3_CONF_VARS[&quot;GFX&quot;][&quot;imagefile_ext&quot;] (localconf.php). Standard is pdf,gif,jpg,jpeg,tif,bmp,ai,pcx,tga,png.<br>&nbsp;<b>The value &quot;web&quot;</b> is special. This will just ensure that an image is converted to a web imageformat (gif or jpg) if it happens not to be already!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:6:"degree";s:8:"datatype";s:13:"<b>&nbsp;</b>";s:11:"description";s:19:"-90 to 90, integers";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:13:"posint / int+";s:8:"datatype";s:13:"<b>&nbsp;</b>";s:11:"description";s:16:"Positive integer";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:3:"int";s:8:"datatype";s:13:"<b>&nbsp;</b>";s:11:"description";s:115:"integer<br>(sometimes used generally though another type would have been more appropriate, like &quot;pixels&quot;)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:20:"str / string / value";s:8:"datatype";s:13:"<b>&nbsp;</b>";s:11:"description";s:114:"string.<br>(sometimes used generally though another type would have been more appropriate, like &quot;align&quot;)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:7:"boolean";s:8:"datatype";s:8:"<b>1</b>";s:11:"description";s:65:"boolean <br>non-empty strings (but not zero) are &quot;true&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:8:"rotation";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:29:"integer, degrees from 0 - 360";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:7:"x,y,w,h";s:8:"datatype";s:16:"<b>10,10,5,5</b>";s:11:"description";s:77:"x,y is the offset from the upper left corner. <br>w,h is the width and height";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:10:"HTML-color";s:8:"datatype";s:29:"<b>red</b><b><br>#ffeecc </b>";s:11:"description";s:633:"<b>HTML-color codes:</b><br>&nbsp;<br>Black = &quot;#000000&quot; &nbsp;&nbsp;<br>Silver = &quot;#C0C0C0&quot; &nbsp;&nbsp;<br>Gray = &quot;#808080&quot; &nbsp;&nbsp;<br>White = &quot;#FFFFFF&quot; &nbsp;&nbsp;<br>Maroon = &quot;#800000&quot; &nbsp;&nbsp;<br>Red = &quot;#FF0000&quot; &nbsp;&nbsp;<br>Purple = &quot;#800080&quot; &nbsp;&nbsp;<br>Fuchsia = &quot;#FF00FF&quot; &nbsp;&nbsp;<br>Green = &quot;#008000&quot;<br>Lime = &quot;#00FF00&quot;<br>Olive = &quot;#808000&quot;<br>Yellow = &quot;#FFFF00&quot;<br>Navy = &quot;#000080&quot;<br>Blue = &quot;#0000FF&quot;<br>Teal = &quot;#008080&quot;<br>Aqua = &quot;#00FFFF&quot; ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:12:"GraphicColor";s:8:"datatype";s:166:"<b>red</b><b><br>#ffeecc </b><b><br>255,0,255</b><i><br>&nbsp;</i><i><br>Extra:</i><b><br>red<i> : *0.8</i></b><b><br>#ffeecc <i>: +16</i></b><b><i><br>&nbsp;</b></i>";s:11:"description";s:399:"The color can be given as HTML-colors or as a comma-seperated list of RGB-values (integers)<br>You can add an extra parameter that will modify the color mathematically:<br>Syntax: <br>[colordef] : [modifier]<br>where modifier can be and integer which is added/subtracted to the three RGB-channels or a floatingpoint with an &quot;*&quot; before, which will then multiply the values with that factor.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:7:"page_id";s:8:"datatype";s:24:"<b>this</b><b><br>34</b>";s:11:"description";s:54:"A page id (int) or &quot;this&quot; (=current page id)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:6:"pixels";s:8:"datatype";s:10:"<b>345</b>";s:11:"description";s:14:"pixel-distance";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:4:"list";s:8:"datatype";s:23:"<b>item,item2,item3</b>";s:11:"description";s:14:"list of values";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:7:"margins";s:8:"datatype";s:108:"<i>This sets leftmargin to 10 and bottom-margin to 5. Top and right is not set (zero)</i><b><br>10,0,0,5</b>";s:11:"description";s:35:"l,t,r,b<br>left, top, right, bottom";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:145:"<i>This will cause the value to be wrapped in a font-tag coloring the value red:</i><b><br>&lt;font color=&quot;red&quot;&gt; | &lt;/font&gt;</b>";s:11:"description";s:156:"&lt;...&gt; | &lt;/...&gt;<br>Used to wrap something. The part on the left and right of the vertical line is placed on the left and right side of the value.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:22;a:6:{s:8:"property";s:8:"linkWrap";s:8:"datatype";s:118:"<i>This will make a link to the root-level of a website:</i><b><br>&lt;A HREF=&quot;?id={0}&quot;&gt; | &lt;/A&gt;</b>";s:11:"description";s:351:"&lt;.. {x}.&gt; | &lt;/...&gt;<br>{x}; x is an integer (0-9) and points to a key in the PHP-array rootLine. The key is equal to the level the current page is on measured relatively to the root of the website.<br>If the key exists the uid of the level that key pointed to is inserted instead of {x}.<br>Thus we can insert page_ids from previous levels.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:23;a:6:{s:8:"property";s:4:"case";s:8:"datatype";s:12:"<b>upper</b>";s:11:"description";s:56:"&quot;upper&quot; / &quot;lower&quot;<br>Case-conversion";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:24;a:6:{s:8:"property";s:5:"space";s:8:"datatype";s:12:"<b>5 | 5</b>";s:11:"description";s:89:"&quot;before | after&quot;<br>Used for content and sets space &quot;before | after&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:25;a:6:{s:8:"property";s:9:"date-conf";s:8:"datatype";s:36:"<b>d-m-y<i>(dd-mm-yy format)</i></b>";s:11:"description";s:931:"See PHP function Date()!<br>&nbsp;<br>a - &quot;am&quot; or &quot;pm&quot;<br>A - &quot;AM&quot; or &quot;PM&quot;<br>d - day of the month, numeric, 2 digits (with leading zeros)<br>D - day of the week, textual, 3 letters; i.e. &quot;Fri&quot;<br>F - month, textual, long; i.e. &quot;January&quot;<br>h - hour, numeric, 12 hour format<br>H - hour, numeric, 24 hour format<br>i - minutes, numeric<br>j - day of the month, numeric, without leading zeros<br>l (lowercase &#039;L&#039;) - day of the week, textual, long; i.e. &quot;Friday&quot;<br>m - month, numeric<br>M - month, textual, 3 letters; i.e. &quot;Jan&quot;<br>s - seconds, numeric<br>S - English ordinal suffix, textual, 2 characters; i.e. &quot;th&quot;, &quot;nd&quot;<br>U - seconds since the epoch<br>Y - year, numeric, 4 digits<br>w - day of the week, numeric, 0 represents Sunday<br>y - year, numeric, 2 digits<br>z - day of the year, numeric; i.e. &quot;299&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:26;a:6:{s:8:"property";s:13:"strftime-conf";s:8:"datatype";s:122:"Date &quot;DD-MM-YY&quot; = <b><br>%e:%m:%y</b><br>Time &quot;HH:MM:SS&quot; = <b><br>%H:%M:%S</b><br>or just<b><br>%T</b>";s:11:"description";s:2273:"%a - abbreviated weekday name according to the current locale <br>%A - full weekday name according to the current locale <br>%b - abbreviated month name according to the current locale <br>%B - full month name according to the current locale <br>%c - preferred date and time representation for the current locale <br>%C - century number (the year divided by 100 and truncated to an integer, range 00 to 99) <br>%d - day of the month as a decimal number (range 00 to 31) <br>%D - same as %m/%d/%y <b><br>%e - day of the month as a decimal number, a single digit is preceded by a space (range &#039; 1&#039; to &#039;31&#039;) </b><br>%h - same as %b <b><br>%H - hour as a decimal number using a 24-hour clock (range 00 to 23) </b><br>%I - hour as a decimal number using a 12-hour clock (range 01 to 12) <br>%j - day of the year as a decimal number (range 001 to 366) <b><br>%m - month as a decimal number (range 01 to 12) </b><b><br>%M - minute as a decimal number </b><br>%n - newline character <br>%p - either `am&#039; or `pm&#039; according to the given time value, or the corresponding strings for the current locale <br>%r - time in a.m. and p.m. notation <br>%R - time in 24 hour notation <b><br>%S - second as a decimal number </b><br>%t - tab character <br>%T - current time, equal to %H:%M:%S <br>%u - weekday as a decimal number [1,7], with 1 representing Monday <br>%U - week number of the current year as a decimal number, starting with the first Sunday as the first day of the first week <br>%V - The ISO 8601:1988 week number of the current year as a decimal number, range 01 to 53, where week 1 is the first week that has at least 4 days in the current year, and with Monday as the first day of the week. <br>%W - week number of the current year as a decimal number, starting with the first Monday as the first day of the first week <br>%w - day of the week as a decimal, Sunday being 0 <br>%x - preferred date representation for the current locale without the time <br>%X - preferred time representation for the current locale without the date <b><br>%y - year as a decimal number without a century (range 00 to 99) </b><br>%Y - year as a decimal number including the century <br>%Z - time zone or name or abbreviation <br>%% - a literal `%&#039; character ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:27;a:6:{s:8:"property";s:9:"UNIX-time";s:8:"datatype";s:55:"<i>Seconds to 07/04 2000 23:58:</i><b><br>955144722</b>";s:11:"description";s:25:"Seconds since 1/1 1970...";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:28;a:6:{s:8:"property";s:4:"path";s:8:"datatype";s:23:"<i>fileadmin/stuff/</i>";s:11:"description";s:53:"path relative to the directory from which we operate.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:29;a:6:{s:8:"property";s:23:"&lt;<i>tag</i>&gt;-data";s:8:"datatype";s:13:"<i>&nbsp;</i>";s:11:"description";s:89:"<b>Example:</b><i><br>&lt;frameset&gt;-data: row</i><br>could be &#039;<i>150,*</i>&#039;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:30;a:6:{s:8:"property";s:25:"&lt;<i>tag</i>&gt;-params";s:8:"datatype";s:13:"<i>&nbsp;</i>";s:11:"description";s:128:"<b>Example:</b><i><br>&lt;frameset&gt;-params</i><br>could be &#039;<i>border=&quot;0&quot; framespacing=&quot;0&quot;</i>&#039;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:31;a:6:{s:8:"property";s:7:"getText";s:8:"datatype";s:2090:"<i>get content from the $cObj-&gt;data-array[<b>header</b>]:</i><b><br>= field : header</b><i><br>get content from the $cObj-&gt;parameters-array[<b>color</b>]:</i><b><br>= parameters : color</b><i><br>get content from the $GLOBALS[&quot;TSFE&quot;]-&gt;register[<b>color</b>]:</i><b><br>= register : color</b><i><br>get the title of the page on the first level of the rootline:</i><b><br>= leveltitle : 1</b><i><br>get the title of the page on the level right below the current page AND if that is not present, walt to the bottom of the rootline until there&#039;s a title:</i><b><br>= leveltitle : -2 , slide</b><i><br>get the id of the root-page of the website (level zero)</i><b><br>= leveluid : 0</b><i><br>Gets the value of the user defined field &quot;user_myExtField&quot; in the root line (requires additional config in TYPO3_CONF_VARS to include field!)</i><b><br>= levelfield : -1 , user_myExtField , slide</b><i><br>get the env var HTTP_REFERER:</i><b><br>= getenv : HTTP_REFERER</b><i><br>get the env variable $HTTP_COOKIE_VARS[some_cookie]:</i><b><br>= global : HTTP_COOKIE_VARS | some_cookie</b><i><br>get the current time formatted dd-mm-yy:</i><b><br>= date : d-m-y</b><i><br>get the current page-title:</i><b><br>= page : title</b><i><br>get the current value:</i><b><br>= current : 1</b><br>get input value from query string, (&amp;stuff=)<b><br>= GPvar : stuff</b><br>get input value from query string, (&amp;stuff[key]=)<b><br>= GPvar : stuff | key</b><br>get the current id<b><br>= TSFE : id</b><br>get the value of the header of record with uid 234 from table tt_content:<b><br>= DB : tt_content:234:header</b><i><br>Gets the title of the page right before the start of the current website:</i><b><br>= fullRootLine : -1, title</b><i><br>Returns localized label for logout button</i><b><br>= LLL:EXT:css_styled_content/pi1/locallang.x:login.logout</b><i><br>Outputs the current root-line visually in HTML:</i><b><br>= debug : rootLine</b><i><br>Gets path to file relative file to siteroot possibly placed in an extension:</i><b><br>path:EXT:ie7/js/ie7-standard.js</b>";s:11:"description";s:4323:"This returns a value from somewhere in PHP-array, defined by the type. The syntax is &quot;type : pointer&quot;<br>&nbsp;<br>&nbsp;<b>field :</b> [fieldname from the current <i>$cObj</i>-&gt;data-array in the cObj.]<br>As default the <i>$cObj</i>-&gt;data-array is $GLOBALS[&quot;TSFE&quot;]-&gt;page (record of the current page!) <br>In TMENU: <i>$cObj</i>-&gt;data is set to the page-record for each menuitem.<br>In CONTENT/RECORDS <i>$cObj</i>-&gt;data is set to the actual record<br>In GIFBUILDER <i>$cObj</i>-&gt;data is set to the data GIFBUILDER is supplied with.<br>&nbsp; [fieldname from the current <i>$cObj</i>-&gt;parameters-array in the cObj.]<br>See -&gt;parseFunc!<br>&nbsp;<b>register :</b> [fieldname from the $GLOBALS[&quot;TSFE&quot;]-&gt;register]<br>See cObject &quot;LOAD_REGISTER&quot;<br>&nbsp;<b>leveltitle, leveluid, levelmedia:</b> [levelTitle, uid or media in rootLine, 0- , negative = from behind, &quot; , slide&quot; parameter forces a walk to the bottom of the rootline until there&#039;s a &quot;true&quot; value to return. Useful with levelmedia.]<br>&nbsp;<b>levelfield:</b> Like &quot;leveltitle&quot; et al. but where the second parameter is the rootLine field you want to fetch. Syntax: [pointer, integer], [fieldname], [&quot;slide&quot;]<br>&nbsp;<b>global :</b> [GLOBAL-var, split with | if you want to get from an array! DEPRECATED, use GPvar, TSFE or getenv]<br>&nbsp;<b>date :</b> [date-conf]<br>&nbsp;<b>page :</b> [current page record]<br>&nbsp;<b>current : 1</b> (gets &#039;current&#039; value)<b><br>level : 1 (gets the rootline level of the current page)</b><br>&nbsp;<b>GPvar:</b> Value from GET or POST method. Use this instead of global<br>&nbsp;<b>TSFE: </b>Value from TSFE global main object<br>&nbsp;<b>getenv:</b> Value from environment vars<br>&nbsp;<b>getIndpEnv:</b> Value from t3lib_div::getIndpEnv()<br>&nbsp;<b>DB:</b> Value from database, syntax is [tablename] : [uid] : [field]. Any record from a table in TCA can be selected here. Only marked-deleted records does not return a value here.<br>&nbsp;<b>fullRootLine :</b> This gets the title &quot;1. page before&quot; in a page tree like the one below provided we are are the page &quot;Here you are!&quot; (or &quot;Site root&quot;) and this TypoScript is in the template with root at &quot;Site root&quot;. Red numbers indicate what values of <i>keynumber</i> would point to:<br>- Page tree root &nbsp;&nbsp;-2<br>&nbsp;&nbsp;&nbsp;&nbsp;|- 1. page before &nbsp;&nbsp;-1 <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|- Site root (root template here!) &nbsp;&nbsp;0<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|- Here you are! 1<br>&nbsp;<br>&nbsp;<b>LLL:</b> Reference to a locallang (php or xml) label. Reference consists of [fileref]:[labelkey]<br>&nbsp;<b>path:</b> path to a file, possibly placed in an extension, returns empty if the file doesn&#039;t exist.<br>&nbsp;<b>cObj</b>: [internal variable from list: &quot;parentRecordNumber&quot;]: For CONTENT and RECORDS cObjects that are returned <br>by a select query, this returns the row number (1,2,3,...) of the current cObject record.<br>&nbsp;<b>debug</b>: Returns HTML formated content of PHP variable defined by keyword. Available keys are &quot;rootLine&quot;, &quot;fullRootLine&quot;, &quot;data&quot;<b><br>--------------------</b><b><br>Getting array/object elements.</b><br>You can fetch the value of an array/object by splitting it with a pipe &quot;|&quot;.Example: <i>TSFE:fe_user|user|username</i><b><br>Getting more values.</b><br>By separating the value of getText with &quot;//&quot; (double slash) you let getText fetch the first value. If it appears empty (&quot;&quot; or zero) the next value is fetched and so on. Example:<br>= field:header // field:title // field:uid<br>This gets &quot;title&quot; if &quot;header&quot; is empty. If &quot;title&quot; is also empty it gets field &quot;uid&quot;<br>&nbsp;<b>fullRootLine </b>:<br>Getting a value from the rootline (TSFE-&gt;rootLine) going all the way to the root of the page tree.<i><br>[keynumber, fieldname, &quot;slide&quot;]</i><br>Keynumber is relative to the current site root, so negative numbers refer to subsequent levels below the site root. Fieldname is the name of the datafield to get. For &quot;slide&quot;, see <i>levelmedia</i> type above.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:32;a:6:{s:8:"property";s:3:"dir";s:8:"datatype";s:251:"&nbsp;<i>returns a list of all pdf, gif and jpf-filer from fileadmin/files/ sorted by their name</i> reversely and with the full path (with &quot;<i>fileadmin/files/&quot; prepended)</i><br>&nbsp;<b>fileadmin/files/ | pdf,gif,jpg | name</b> | r | true";s:11:"description";s:380:"[path relative to the webroot of the site] | [list of valid extensions] | [sorting: name, size, ext, date] | [reverse: &quot;r&quot;] | [return full path: boolean<br>Files matching is returned in a comma-separated string.<b><br>Note:</b><br>&nbsp;The value of config-option &quot;lockFilePath&quot; must equal the first part of the path. Thereby the path is locked to that folder.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:33;a:6:{s:8:"property";s:13:"function-name";s:8:"datatype";s:107:"Function:<b><br>user_reverseString</b><br>Method in class:<b><br>user_stringReversing-&gt;reverseString</b>";s:11:"description";s:747:"Indicates a function or method in a class to call. See more information at the USER cObject.<br>Depending on implementation the class or function name (but not the method name) should probably be prefixed with &quot;user_&quot;. This can be changed in the TYPO3_CONF_VARS config though. Also the function / method is normally called with 2 parameters, typ. $conf (TS config) and $content (some content to be processed and returned)<br>Also if you call a method in a class, it is checked (when using the USER/USER_INT objects) whether a class with the same name, but prefixed with &quot;ux_&quot; is present and if so, this class is instantiated instead. See &quot;Inside TYPO3&quot; document for more information on extending the classes in TYPO3!";s:7:"default";s:13:"<b>&nbsp;</b>";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('23', '', 'dd3620dfffa9b5fa5da8d430c83cae46', '', 'tsref:->stdWrap', 'a:1:{s:4:"rows";a:79:{i:0;a:6:{s:8:"property";s:16:"<b>Get data:</b>";s:8:"datatype";N;s:11:"description";N;s:7:"default";N;s:12:"column_count";i:1;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:19:"setContentToCurrent";s:8:"datatype";s:7:"boolean";s:11:"description";s:63:"Sets the current value to the incoming content of the function.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:10:"setCurrent";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:141:"Sets the &quot;current&quot;-value. This is normally set from some outside routine, so be careful with this. But it might be handy to do this";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:4:"lang";s:8:"datatype";s:29:"<i>Array of language keys</i>";s:11:"description";s:457:"This is used to define optional language specific values. <br>If the global language key set by the -&gt;config property .language is found in this array, then this value is used instead of the default input value to stdWrap.<br>&nbsp;<b><br>Example:</b><br>config.language = de<br>page.10 = TEXT<br>page.10.value = I am a Berliner!<br>page.10.lang.de = Ich bin ein Berliner!<br>&nbsp;<br>Output will be &quot;Ich bin...&quot; instead of &quot;I am...&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:4:"data";s:8:"datatype";s:7:"getText";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:5:"field";s:8:"datatype";s:16:"<i>fieldname</i>";s:11:"description";s:556:"Sets the content to the value $cObj-&gt;data[<i>field</i>]<br>&nbsp;<br>&nbsp;<b>Example:</b> Set content to the value of field &quot;title&quot;: &quot;.field = title&quot;<br>$cObj-&gt;data changes. See the description for the data type &quot;getText&quot;/field!<b><br>&nbsp;</b><br>&nbsp;<b>Note:</b> You can also divide fieldnames by &quot;//&quot;. Say, you set &quot;nav_title // title&quot; as the value, then the content from the field nav_title will be returned unless it is a blank string, in which case the title-field&#039;s value is returned.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:7:"current";s:8:"datatype";s:7:"boolean";s:11:"description";s:66:"Sets the content to the &quot;current&quot;-value (see -&gt;split)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:7:"cObject";s:8:"datatype";s:7:"cObject";s:11:"description";s:35:"Loads content from a content-object";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:7:"numRows";s:8:"datatype";s:12:"-&gt;numRows";s:11:"description";s:52:"Returns the number of rows resulting from the select";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:8:"filelist";s:8:"datatype";s:12:"dir /stdWrap";s:11:"description";s:442:"Reads a directory and returns a list of files.<br>The value is exploded by &quot;|&quot; into parameters:<br>1: The path<br>2: comma-list of allowed extensions (no spaces between); if empty all extensions goes.<br>3: sorting: name, size, ext, date, mdate (modification date)<br>4: reverse: Set to &quot;r&quot; if you want a reversed sorting<br>5: fullpath_flag: If set, the filelist is returned with complete paths, and not just the filename";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:11:"preUserFunc";s:8:"datatype";s:13:"function-name";s:11:"description";s:168:"Calling a PHP-function or method in a class, passing the current content to the function as first parameter and any properties as second parameter.<br>See .postUserFunc";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:29:"<b>Override / Conditions:</b>";s:8:"datatype";N;s:11:"description";N;s:7:"default";N;s:12:"column_count";i:1;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:8:"override";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:117:"if &quot;override&quot; returns something else than &quot;&quot; or zero (trimmed), the content is loaded with this! ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:17:"preIfEmptyListNum";s:8:"datatype";s:30:"(as &quot;listNum&quot; below)";s:11:"description";s:30:"(as &quot;listNum&quot; below)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:7:"ifEmpty";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:131:"if the content is empty (trimmed) at this point, the content is loaded with &quot;ifEmpty&quot;. Zeros are treated as empty values!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:7:"ifBlank";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:65:"Same as &quot;ifEmpty&quot; but the check is done using strlen().";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:7:"listNum";s:8:"datatype";s:34:"int<br>+calc <br>+&quot;last&quot;";s:11:"description";s:725:"Explodes the content with &quot;,&quot; (comma) and the content is set to the item[<i>value</i>]. <b><br>&nbsp;</b><br>&nbsp;<b>Special keyword:</b> &quot;last&quot; is set to the last element of the array!<b><br>&nbsp;</b><br>&nbsp;<b>.splitChar</b> (string):<i><br>Defines the string used to explode the value. If splitChar is an integer, the character with that number is used (eg. &quot;10&quot; to split lines...).</i><i><br>Default: &quot;,&quot; (comma)</i><br>&nbsp;<b>.stdWrap </b>(stdWrap properties):<i><br>stdWrap properties of the listNum...</i><b><br>&nbsp;</b><b><br>Examples:</b><br>We have a value of &quot;item 1, item 2, item 3, item 4&quot;:<br>This would return &quot;item 3&quot;:<br>.listNum = last - 1";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:4:"trim";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:52:"PHP-function trim(); Removes whitespace around value";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:34:"Recursive call to stdWrap function";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:8:"required";s:8:"datatype";s:7:"boolean";s:11:"description";s:291:"This flag requires the content to be set to some value after any content-import and treatment that might have happend now (data, field, current, listNum, trim). Zero&#039;s is NOT regarded as empty! Use &quot;if&quot; instead!<br>If the content i empty, &quot;&quot; is returned immediately.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:2:"if";s:8:"datatype";s:7:"-&gt;if";s:11:"description";s:72:"If the if-object returns false, stdWrap returns &quot;&quot; immediately";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:13:"fieldRequired";s:8:"datatype";s:16:"<i>fieldname</i>";s:11:"description";s:31:"value in this field MUST be set";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:22;a:6:{s:8:"property";s:18:"<b>Parse data:</b>";s:8:"datatype";N;s:11:"description";N;s:7:"default";N;s:12:"column_count";i:1;s:16:"is_propertyTable";i:1;}i:23;a:6:{s:8:"property";s:6:"csConv";s:8:"datatype";s:6:"string";s:11:"description";s:131:"Convert the charset of the string from the charset given as value to the current rendering charset of the frontend (renderCharset).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:24;a:6:{s:8:"property";s:9:"parseFunc";s:8:"datatype";s:38:"object path reference / -&gt;parseFunc";s:11:"description";s:529:"Processing instructions for the content. <br>&nbsp;<b>Notice:</b> If you enter a string as value this will be taken as a reference to an object path globally in the TypoScript object tree. This will be the basis configuration for parseFunc merged with any properties you add here. It works exactly like references does for content elements.<br>&nbsp;<b><br>Example:</b><br>parseFunc = &lt; lib.parseFunc_RTE<br>parseFunc.tags.myTag = TEXT<br>parseFunc.tags.myTag.value = This will be inserted when &amp;lt;myTag&amp;gt; is found!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:25;a:6:{s:8:"property";s:10:"HTMLparser";s:8:"datatype";s:25:"boolean / -&gt;HTMLparser";s:11:"description";s:220:"This object allows you to parse the HTML-content and make all kinds of advanced filterings on the content.<br>Value must be set and properties are those of -&gt;HTMLparser.<br>(See adminguide for -&gt;HTMLparser options)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:26;a:6:{s:8:"property";s:5:"split";s:8:"datatype";s:10:"-&gt;split";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:27;a:6:{s:8:"property";s:10:"prioriCalc";s:8:"datatype";s:7:"boolean";s:11:"description";s:657:"Calculation of the value using operators -+*/%^ plus respects priority to + and - operators and parenthesis levels ().<br>. (period) is decimal delimiter.<br>Returns a doublevalue.<br>If .prioriCalc is set to &quot;intval&quot; an integer is returned.<br>There is no errorchecking and division by zero or other invalid values may generate strange results. Also you use a proper syntax because future modifications to the function used may allow for more operators and features. <br>&nbsp;<b><br>Examples:</b><br>100%7 = 2<br>-5*-4 = 20<br>+6^2 = 36<br>6 ^(1+1) = 36<br>-5*-4+6^2-100%7 = 54 <br>-5 * (-4+6) ^ 2 - 100%7 = 98<br>-5 * ((-4+6) ^ 2) - 100%7 = -22";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:28;a:6:{s:8:"property";s:4:"char";s:8:"datatype";s:3:"int";s:11:"description";s:94:"Content is set to the chr(<i>value</i>).<br>PHP: $content=chr(intval($conf[&quot;char&quot;]);";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:29;a:6:{s:8:"property";s:6:"intval";s:8:"datatype";s:7:"boolean";s:11:"description";s:77:"PHP function intval(); Returns an integer.<br>PHP: $content=intval($content);";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:30;a:6:{s:8:"property";s:4:"date";s:8:"datatype";s:9:"date-conf";s:11:"description";s:256:"The content should be data-type &quot;UNIX-time&quot;. Returns the content formatted as a date.<br>$content=Date($conf[&quot;date&quot;], $content);<br>&nbsp;<br>&nbsp;<b>Example</b> where a timestamp is imported:<br>.value.field = tstamp<br>.value.date = ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:31;a:6:{s:8:"property";s:8:"strftime";s:8:"datatype";s:20:"<i>strftime-conf</i>";s:11:"description";s:424:"Exactly like &quot;date&quot; above. See the PHP-manual (strftime) for the codes, or datatype &quot;strftime-conf&quot;.<br>This formatting is useful if the locale is set in advance in the CONFIG-object. See this.<br>&nbsp;<br>Properties:<br>&nbsp;<b>.charset</b> : Can be set to the charset of the output string if you need to convert it to renderCharset. Default is to take the intelligently guessed charset from t3lib_cs.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:32;a:6:{s:8:"property";s:3:"age";s:8:"datatype";s:17:"boolean or string";s:11:"description";s:666:"If enabled with a &quot;1&quot; (number, integer) the content is seen as a date (UNIX-time) and the difference from present time and the content-time is returned as one of these four variations:<br>&quot;xx min&quot; or &quot;xx hrs&quot; or &quot;xx days&quot; or &quot;xx yrs&quot;<br>The limits between which layout is used are 60 minutes, 24 hours, 365 days,<br>&nbsp;<b><br>NOTE: </b><br>If you set this property with a non-integer, it&#039;s used to format the four units. This is the default value: <br>&quot; min| hrs| days| yrs&quot;<br>&nbsp;<br>Set another string if you want to change the units. You may include the &quot;-signs. They are removed anyway.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:33;a:6:{s:8:"property";s:4:"case";s:8:"datatype";s:4:"case";s:11:"description";s:76:"Converts case<br>&nbsp;<br>Uses &quot;renderCharset&quot; for the operation.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:34;a:6:{s:8:"property";s:5:"bytes";s:8:"datatype";s:7:"boolean";s:11:"description";s:393:"Will format the input (an integer) as bytes: bytes, kb, mb<br>&nbsp;<br>If you add a value for the property &quot;labels&quot; you can alter the default suffixes. Labels for bytes, kilo, mega and giga are separated by vertical bar (|) and possibly encapsulated in &quot;&quot;. Eg: &quot; | K| M| G&quot; (which is the default value)<br>Thus:<br>&nbsp;<br>bytes.labels = &quot; | K| M| G&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:35;a:6:{s:8:"property";s:9:"substring";s:8:"datatype";s:10:"[p1], [p2]";s:11:"description";s:168:"Returns the substring with [p1] and [p2] send as the 2nd and 3rd parameter to the PHP substring function.<br>&nbsp;<br>Uses &quot;renderCharset&quot; for the operation.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:36;a:6:{s:8:"property";s:13:"removeBadHTML";s:8:"datatype";s:7:"boolean";s:11:"description";s:118:"Removes &quot;bad&quot; HTML code based on a pattern that filters away HTML that is considered dangerous for XSS bugs.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:37;a:6:{s:8:"property";s:9:"stripHtml";s:8:"datatype";s:7:"boolean";s:11:"description";s:21:"Strips all html-tags.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:38;a:6:{s:8:"property";s:4:"crop";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:831:"Crops the content to a certain length<br>Syntax: +/- (chars) = from left / from right | [string] | [boolean: keep whole words]<br>&nbsp;<br>&nbsp;<b>Examples:</b> <br>&nbsp;<b>20 | ... </b>&nbsp;&nbsp;&nbsp;<i>=&gt; max 20 characters. If more, the value will be truncated to </i><b><i>first</b></i><i> 20 chars and prepended with &quot;...&quot;</i><br>&nbsp;<b><i>-20 | ...</b></i><i> =&gt; max 20 characters. If more, the value will be truncated to </i><b><i>last</b></i><i> 20 chars and appended with &quot;...&quot;</i><i><br>&nbsp;<b>20 | ... | 1</b> =&gt; max 20 characters. If more, the value will be truncated to <b>last</b> 20 chars and appended with &quot;...&quot;. If the division is in the middle of a word, the remains of that word is removed.</i><i><br>&nbsp;</i><br>Uses &quot;renderCharset&quot; for the operation.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:39;a:6:{s:8:"property";s:12:"rawUrlEncode";s:8:"datatype";s:7:"boolean";s:11:"description";s:54:"Passes the content through rawurlencode()-PHP-function";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:40;a:6:{s:8:"property";s:16:"htmlSpecialChars";s:8:"datatype";s:7:"boolean";s:11:"description";s:173:"Passes the content through htmlspecialchars()-PHP-function<br>Additional property &quot;.preserveEntities&quot; will preserve entities so only non-entity chars are affected.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:41;a:6:{s:8:"property";s:11:"doubleBrTag";s:8:"datatype";s:6:"string";s:11:"description";s:55:"All double-line-breaks are substituted with this value.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:42;a:6:{s:8:"property";s:2:"br";s:8:"datatype";s:7:"boolean";s:11:"description";s:62:"PHP function nl2br(); Converts linebreaks to &lt;br /&gt;-tags";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:43;a:6:{s:8:"property";s:5:"brTag";s:8:"datatype";s:6:"string";s:11:"description";s:77:"&nbsp;All ASCII-codes of &quot;10&quot; (CR) is substituted with <i>value</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:44;a:6:{s:8:"property";s:11:"encapsLines";s:8:"datatype";s:16:"-&gt;encapsLines";s:11:"description";s:115:"Lets you split the content by chr(10) and proces each line independently. Used to format content made with the RTE.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:45;a:6:{s:8:"property";s:8:"keywords";s:8:"datatype";s:7:"boolean";s:11:"description";s:149:"splits the content by characters &quot;,&quot; &quot;;&quot; and chr(10) (return), trims each value and returns a comma-separated list of the values.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:46;a:6:{s:8:"property";s:9:"innerWrap";s:8:"datatype";s:13:"wrap /stdWrap";s:11:"description";s:17:"Wraps the content";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:47;a:6:{s:8:"property";s:10:"innerWrap2";s:8:"datatype";s:13:"wrap /stdWrap";s:11:"description";s:74:"<i>same as .innerWrap (but watch the order in which they are executed)</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:48;a:6:{s:8:"property";s:7:"fontTag";s:8:"datatype";s:4:"wrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:49;a:6:{s:8:"property";s:9:"addParams";s:8:"datatype";s:14:"-&gt;addParams";s:11:"description";s:74:"Lets you add tag-parameters to the content <i>if </i>the content is a tag!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:50;a:6:{s:8:"property";s:9:"textStyle";s:8:"datatype";s:14:"-&gt;textStyle";s:11:"description";s:26:"Wraps content in font-tags";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:51;a:6:{s:8:"property";s:10:"tableStyle";s:8:"datatype";s:15:"-&gt;tableStyle";s:11:"description";s:29:"Wraps content with table-tags";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:52;a:6:{s:8:"property";s:8:"filelink";s:8:"datatype";s:13:"-&gt;filelink";s:11:"description";s:37:"Used to make lists of links to files.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:53;a:6:{s:8:"property";s:10:"preCObject";s:8:"datatype";s:7:"cObject";s:11:"description";s:30:"cObject prepended the content ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:54;a:6:{s:8:"property";s:11:"postCObject";s:8:"datatype";s:7:"cObject";s:11:"description";s:28:"cObject appended the content";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:55;a:6:{s:8:"property";s:9:"wrapAlign";s:8:"datatype";s:14:"align /stdWrap";s:11:"description";s:89:"Wraps content with &lt;DIV align=[<i>value</i>]&gt; | &lt;/DIV&gt; <i>if </i>align is set";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:56;a:6:{s:8:"property";s:8:"typolink";s:8:"datatype";s:13:"-&gt;typolink";s:11:"description";s:33:"Wraps the content with a link-tag";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:57;a:6:{s:8:"property";s:14:"TCAselectItem.";s:8:"datatype";s:26:"<i>Array of properties</i>";s:11:"description";s:442:"Resolves a comma seperated list of values into the TCA item representation.<br>&nbsp;<br>&nbsp;<b>.table</b> (string): <i>The Table to look up</i><br>&nbsp;<b>.field</b> (string): <i>The field to resolve</i><br>&nbsp;<b>.delimiter </b>(string): <i>Delimiter for concatenating multiple elements.</i><br>&nbsp;<i><br>&nbsp;<b>Notice: </b>Currently this works only with TCA fields of type &quot;select&quot; which are not database relations.</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:58;a:6:{s:8:"property";s:11:"spaceBefore";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:69:"Pixels space before. Done with a clear-gif; &lt;img ...&gt;&lt;BR&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:59;a:6:{s:8:"property";s:10:"spaceAfter";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:68:"Pixels space after. Done with a clear-gif; &lt;img ...&gt;&lt;BR&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:60;a:6:{s:8:"property";s:5:"space";s:8:"datatype";s:5:"space";s:11:"description";s:260:"[spaceBefore] &nbsp;&nbsp;| &nbsp;&nbsp;[spaceAfter]<br>&nbsp;<b><br>Additional property:</b><br>.useDiv = 1<br>If set, a clear gif is not used by rather a &lt;div&gt; tag with a style-attribute setting the height. (Affects spaceBefore and spaceAfter as well).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:61;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:17:"wrap /+.splitChar";s:11:"description";s:100:".splitChar defines an alternative splitting character (default is &quot;|&quot; - the vertical line)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:62;a:6:{s:8:"property";s:10:"noTrimWrap";s:8:"datatype";s:24:"&quot;special&quot; wrap";s:11:"description";s:292:"This wraps the content with the values val1 and val2 in the example below - including surrounding whitespace! - without trimming the values. Note that this kind of wrap requires a &quot;|&quot; character to begin and end the wrap.<br>&nbsp;<b><br>Example:</b><br>| <b>val1</b> | <b>val2</b> |";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:63;a:6:{s:8:"property";s:5:"wrap2";s:8:"datatype";s:17:"wrap /+.splitChar";s:11:"description";s:69:"<i>same as .wrap (but watch the order in which they are executed)</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:64;a:6:{s:8:"property";s:8:"dataWrap";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:336:"The content is parsed for sections of {...} and the content of {...} is of the type getText and substituted with the result of getText.<br>&nbsp;<b><br>Example:</b><br>This should result in a font-tag where the fontsize is decided by the global variable &quot;size&quot;:<br>&lt;font size=&quot;{global : size}&quot;&gt; | &lt;/font&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:65;a:6:{s:8:"property";s:7:"prepend";s:8:"datatype";s:7:"cObject";s:11:"description";s:37:"cObject prepended to content (before)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:66;a:6:{s:8:"property";s:6:"append";s:8:"datatype";s:7:"cObject";s:11:"description";s:35:"cObject appended to content (after)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:67;a:6:{s:8:"property";s:5:"wrap3";s:8:"datatype";s:17:"wrap /+.splitChar";s:11:"description";s:69:"<i>same as .wrap (but watch the order in which they are executed)</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:68;a:6:{s:8:"property";s:9:"outerWrap";s:8:"datatype";s:13:"wrap /stdWrap";s:11:"description";s:33:"<i>Wraps the complete content</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:69;a:6:{s:8:"property";s:10:"insertData";s:8:"datatype";s:7:"boolean";s:11:"description";s:205:"If set, then the content string is parsed like .dataWrap above.<br>&nbsp;<b><br>Example:</b><br>Displays the page title:<br>10 = TEXT<br>10.value = This is the page title: {page:title}<br>10.insertData = 1";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:70;a:6:{s:8:"property";s:10:"offsetWrap";s:8:"datatype";s:3:"x,y";s:11:"description";s:387:"This wraps the input in a table with columns to the left and top that offsets the content by the values of x,y. Based on the cObject OTABLE.<br>&nbsp;<b><br>.tableParams / .tdParams +stdWrap</b><br>- used to manipulate tableParams/tdParams (default width=99%) of the offset. Default: See OTABLE.<br>&nbsp;<b><br>.stdWrap</b><br>- stdWrap properties wrapping the offsetWrap&#039;ed output";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:71;a:6:{s:8:"property";s:12:"postUserFunc";s:8:"datatype";s:13:"function-name";s:11:"description";s:871:"&nbsp;Calling a PHP-function or method in a class, passing the current content to the function as first parameter and any properties as second parameter. Please see the description of the cObject USER for in-depth information.<br>&nbsp;<b><br>Example:</b><br>You can paste this example directly into a new template record.<br>&nbsp;<br>page = PAGE<br>page.typeNum=0<br>includeLibs.something = media/scripts/example_callfunction.php<br>&nbsp;<br>page.10 = TEXT<br>page.10 {<br>&nbsp;&nbsp;&nbsp;value = Hello World<br>&nbsp;&nbsp;&nbsp;postUserFunc = user_reverseString<br>&nbsp;&nbsp;&nbsp;postUserFunc.uppercase = 1<br>}<br>&nbsp;<br>page.20 = TEXT<br>page.20 {<br>&nbsp;&nbsp;&nbsp;value = Hello World<br>&nbsp;&nbsp;&nbsp;postUserFunc = user_various-&gt;reverseString<br>&nbsp;&nbsp;&nbsp;postUserFunc.uppercase = 1<br>&nbsp;&nbsp;&nbsp;postUserFunc.typolink = 11<br>}";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:72;a:6:{s:8:"property";s:15:"postUserFuncInt";s:8:"datatype";s:13:"function-name";s:11:"description";s:347:"Calling a PHP-function or method in a class, passing the current content to the function as first parameter and any properties as second parameter. The result will be rendered non-cached, outside the main page-rendering. Please see the description of the cObject USER_INT and PHP_SCRIPT_INT for in-depth information.<br>Supplied by Jens Ellerbrock";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:73;a:6:{s:8:"property";s:13:"prefixComment";s:8:"datatype";s:6:"string";s:11:"description";s:462:"Prefixes content with a HTML comment with the second part of input string (divided by &quot;|&quot;) where first part is an integer telling how many trailing tabs to put before the comment on a new line.<br>The content is parsed through insertData.<br>&nbsp;<b><br>Example:</b><br>prefixComment = 2 | CONTENT ELEMENT, uid:{field:uid}/{field:CType}<br>&nbsp;<br>Will indent the comment with 1 tab (and the next line with 2+1 tabs)<br>(Added in TYPO3 &gt;3.6.0RC1)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:74;a:6:{s:8:"property";s:9:"editIcons";s:8:"datatype";s:6:"string";s:11:"description";s:1783:"If not empty, then insert an icon linking to the typo3/alt_doc.php with some parameters to build and backend user edit form for certain fields.<br>The value of this property is a list of fields from a table to edit. It&#039;s assumed that the current record of the cObj is the record to be edited.<br>Syntax: <i>optional tablename</i> : <i>comma list of fieldnames[list of pallette-field names separated by | ]</i><i><br>&nbsp;</i><br>&nbsp;<b>.beforeLastTag</b> (1,0,-1): If set (1), the icon will be inserted before the last HTML tag in the content. If -1 the icon will be prepended to the content. If zero (0) the icon is appended in the end of the content.<br>&nbsp;<br>&nbsp;<b>.styleAttribute</b> (string): Adds a style-attribute to the icon image with this value. For instance you can set &quot;position:absolute&quot; if you want a non-destructive insertion of the icon. Notice: For general styling all edit icons has the class &quot;frontEndEditIcons&quot; which can be addressed from the stylesheet of the site.<br>&nbsp;<b><br>.iconTitle (string): The title attribute of the image tag.</b><br>&nbsp;<br>&nbsp;<b>.iconImg</b> (HTML): Alternative HTML code instead of the default icon shown. Can be used to set another icon for editing (for instance a red dot or otherwise... :-)<br>&nbsp;<b><br>Example:</b><br>This will insert an edit icon which links to a form where the header and bodytext fields are displayed and made available for editing (provided the user has access!).<br>editIcons = tt_content : header, bodytext<br>&nbsp;<br>Or this line that puts the header_align and date field into a &quot;palette&quot; which means they are displayed on a single line below the header field. This saves some space.<br>editIcons = header[header_align|date], bodytext<br>&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:75;a:6:{s:8:"property";s:9:"editPanel";s:8:"datatype";s:19:"boolean / editPanel";s:11:"description";s:22:"See cObject EDITPANEL.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:76;a:6:{s:8:"property";s:5:"debug";s:8:"datatype";s:7:"boolean";s:11:"description";s:231:"Prints content with HTMLSpecialChars() and &lt;PRE&gt;&lt;/PRE&gt;: Usefull for debugging which value stdWrap actually ends up with, if you&#039;re constructing a website with TypoScript. <br>Should be used under construction only.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:77;a:6:{s:8:"property";s:9:"debugFunc";s:8:"datatype";s:7:"boolean";s:11:"description";s:192:"Prints the content directly to browser with the debug() function.<br>Should be used under construction only.<br>Set to value &quot;2&quot; the content will be printed in a table - looks nicer.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:78;a:6:{s:8:"property";s:9:"debugData";s:8:"datatype";s:7:"boolean";s:11:"description";s:160:"Prints the current data-array, $cObj-&gt;data, directly to browser. This is where &quot;.field&quot; gets data from.<br>Should be used under construction only. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('24', '', 'a86e19eef308f8779c6e1c720defaacb', '', 'tsref:->imgResource', 'a:1:{s:4:"rows";a:17:{i:0;a:6:{s:8:"property";s:3:"ext";s:8:"datatype";s:27:"imageExtension /<br>stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:3:"web";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:5:"width";s:8:"datatype";s:15:"pixels /stdWrap";s:11:"description";s:1313:"If both the width and the heigth are set and one of the numbers is appended by an &quot;m&quot;, the proportions will be preserved and thus width/height are treated as maximum dimensions for the image. The image will be scaled to fit into width/height rectangle.<br>&nbsp;<br>If both the width and the heigth are set and at least one of the numbers is appended by a &quot;c&quot;, cropscaling will be enabled. This means that the proportions will be preserved and the image will be scaled to fit around a rectangle with width/height dimensions. Then, a centered portion from inside of the image (size defined by width/height) will be cut out.<br>The &quot;c&quot; can have a percentage value (-100 ... +100) after it, which defines how much the cropping will be moved off the center to the border.<br>&nbsp;<br>Notice that you can only use &quot;m&quot; or &quot;c&quot; at the same time!<br>&nbsp;<b><br>Examples:</b><br>This crops 120x80px from the center of the scaled image:<br>.width = 120c.height = 80c<br>&nbsp;<br>This crops 100x100px; from landscape-images at the left and portrait-images centered:<br>.width = 100c-100.height = 100c<br>&nbsp;<br>This crops 100x100px; from landscape-images a bit right of the center and portrait-images a bit upper than centered:<br>.width = 100c+30<br>.height = 100c-25";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:6:"height";s:8:"datatype";s:15:"pixels /stdWrap";s:11:"description";s:22:"see &quot;.width&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:6:"params";s:8:"datatype";s:6:"string";s:11:"description";s:78:"ImageMagick command-line:<br>fx. &quot;-rotate 90&quot; or &quot;-negate&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:6:"sample";s:8:"datatype";s:7:"boolean";s:11:"description";s:124:"If set, -sample is used to scale images instead of -geometry. Sample does not use antialiasing and is therefore much faster.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:19:"alternativeTempPath";s:8:"datatype";s:6:"string";s:11:"description";s:116:"Enter an alternative path to use for temp images. Must be found in the list in TYPO3_CONF_VARS[FE][allowedTempPaths]";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:5:"frame";s:8:"datatype";s:3:"int";s:11:"description";s:90:"Chooses which frame in an gif-animation or pdf-file. <br>&quot;&quot; = first frame (zero)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:6:"import";s:8:"datatype";s:13:"path /stdWrap";s:11:"description";s:301:"&nbsp;<i>value</i> should be set to the path of the file<br>with stdWrap you get the filename from the data-array<br>&nbsp;<b><br>Example:</b><br>This returns the first image in the field &quot;image&quot; from the data-array:<br>.import = uploads/pics/<br>.import.field = image<br>.import.listNum = 0";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:4:"maxW";s:8:"datatype";s:15:"pixels /stdWrap";s:11:"description";s:9:"Max width";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:4:"maxH";s:8:"datatype";s:15:"pixels /stdWrap";s:11:"description";s:10:"Max height";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:4:"minW";s:8:"datatype";s:6:"pixels";s:11:"description";s:31:"Min width (overrules maxW/maxH)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:4:"minH";s:8:"datatype";s:6:"pixels";s:11:"description";s:32:"Min height (overrules maxW/maxH)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:45:"<b>Masking:</b><br>(Black hides, white shows)";s:8:"datatype";N;s:11:"description";N;s:7:"default";N;s:12:"column_count";i:1;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:6:"m.mask";s:8:"datatype";s:11:"imgResource";s:11:"description";s:262:"The mask by which the image is masked onto &quot;m.bgImg&quot;. Both &quot;m.mask&quot; and &quot;m.bgImg&quot; <b>is scaled to fit</b> the size of the imgResource image!<br>&nbsp;<b>NOTE:</b> Both &quot;m.mask&quot; and &quot;m.bgImg&quot; must be valid images.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:7:"m.bgImg";s:8:"datatype";s:11:"imgResource";s:11:"description";s:88:"&nbsp;<b>NOTE:</b> Both &quot;m.mask&quot; and &quot;m.bgImg&quot; must be valid images.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:11:"m.bottomImg";s:8:"datatype";s:11:"imgResource";s:11:"description";s:430:"An image masked by &quot;m.bottomImg_mask&quot; onto &quot;m.bgImg&quot; before the imgResources is masked by &quot;m.mask&quot;. <br>Both &quot;m.bottomImg&quot; and &quot;m.bottomImg_mask&quot; <b>is scaled to fit</b> the size of the imgResource image!<br>This is most often used to create an underlay for the imgResource.<br>&nbsp;<b>NOTE:</b> Both &quot;m.bottomImg&quot; and &quot;m.bottomImg_mask&quot; must be valid images.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:16:"m.bottomImg_mask";s:8:"datatype";s:11:"imgResource";s:11:"description";s:116:"(optional)<br>&nbsp;<b>NOTE:</b> Both &quot;m.bottomImg&quot; and &quot;m.bottomImg_mask&quot; must be valid images.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('25', '', '995f8106dda949b01ff8cc2cc0da016c', '', 'tsref:->imageLinkWrap', 'a:1:{s:4:"rows";a:16:{i:0;a:6:{s:8:"property";s:5:"width";s:8:"datatype";s:12:"int (1-1000)";s:11:"description";s:134:"If you add &quot;m&quot; to either the width or height, the image will be held in proportions and width/height works as max-dimensions";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"height";s:8:"datatype";s:12:"int (1-1000)";s:11:"description";s:22:"see &quot;.width&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:7:"effects";s:8:"datatype";s:66:"&nbsp;<i>see GIFBUILDER / effects. (from stdgraphics-library)</i> ";s:11:"description";s:55:"<b>Example:</b><br>gamma=1,3 | sharpen=80 | solarize=70";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:6:"sample";s:8:"datatype";s:7:"boolean";s:11:"description";s:124:"If set, -sample is used to scale images instead of -geometry. Sample does not use antialiasing and is therefore much faster.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:19:"alternativeTempPath";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:116:"Enter an alternative path to use for temp images. Must be found in the list in TYPO3_CONF_VARS[FE][allowedTempPaths]";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:5:"title";s:8:"datatype";s:6:"string";s:11:"description";s:35:"page title of the new window (HTML)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:7:"bodyTag";s:8:"datatype";s:11:"&lt;tag&gt;";s:11:"description";s:26:"Body tag of the new window";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:56:"Wrap of the image, which is output between the body-tags";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:6:"target";s:8:"datatype";s:21:"&lt;A&gt;-data:target";s:11:"description";s:42:"NOTE: Only if &quot;.JSwindow&quot; is set";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:8:"JSwindow";s:8:"datatype";s:7:"boolean";s:11:"description";s:88:"The image will be opened in a new window which is fitted to the dimensions of the image!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:15:"JSwindow.expand";s:8:"datatype";s:3:"x,y";s:11:"description";s:42:"x and y is added to the window dimensions.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:18:"JSwindow.newWindow";s:8:"datatype";s:7:"boolean";s:11:"description";s:39:"Each picture will open in a new window!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:15:"JSwindow.altUrl";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:99:"If this returns anything, the URL shown in the JS-window is NOT showpic.php but the url given here!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:31:"JSwindow.altUrl_noDefaultParams";s:8:"datatype";s:7:"boolean";s:11:"description";s:159:"If this is set, the image parameters are not appended to the altUrl<br>automatically. This is useful if you want to create them with a userfunction<br>instead.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:8:"typolink";s:8:"datatype";s:13:"-&gt;typolink";s:11:"description";s:63:"NOTE: This overrides the imageLinkWrap if it returns anything!!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:6:"enable";s:8:"datatype";s:16:"boolean /stdWrap";s:11:"description";s:49:"<b>The image is linked ONLY if this is true!!</b>";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('26', '', '8354e493f67a8b31615797f35c761ce3', '', 'tsref:->numRows', 'a:1:{s:4:"rows";a:2:{i:0;a:6:{s:8:"property";s:5:"table";s:8:"datatype";s:9:"tablename";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"select";s:8:"datatype";s:11:"-&gt;select";s:11:"description";s:134:"Select query for the operation.<br>&nbsp;<br>The property &quot;selectFields&quot; is overridden internally with &quot;count(*)&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('27', '', '232474bb912dfb37279eda0d54a3cebe', '', 'tsref:->select', 'a:1:{s:4:"rows";a:11:{i:0;a:6:{s:8:"property";s:9:"uidInList";s:8:"datatype";s:22:"<i>list of page_id</i>";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:9:"pidInList";s:8:"datatype";s:37:"&nbsp;<i>list of page_id</i> /stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:4:"this";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:7:"orderBy";s:8:"datatype";s:18:"<i>SQL-orderBy</i>";s:11:"description";s:60:"without &quot;order by&quot;! Eg. &quot;sorting, title&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:7:"groupBy";s:8:"datatype";s:18:"<i>SQL-groupBy</i>";s:11:"description";s:51:"without &quot;group by&quot;! Eg. &quot;CType&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:3:"max";s:8:"datatype";s:35:"int <br>+calc<br>+&quot;total&quot;";s:11:"description";s:95:"max records<br>&nbsp;<b><br>Special keyword: &quot;total&quot; is substituted with count(*)</b>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:5:"begin";s:8:"datatype";s:36:"int <br>+calc <br>+&quot;total&quot;";s:11:"description";s:134:"begin with record number <i>value</i><i><br>&nbsp;</i><br>&nbsp;<b>Special keyword:</b> &quot;total&quot; is substituted with count(*)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:5:"where";s:8:"datatype";s:16:"<i>SQL-where</i>";s:11:"description";s:98:"without &quot;where&quot;!, Eg. &quot; (title LIKE &#039;%SOMETHING%&#039; AND NOT doktype) &quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:8:"andWhere";s:8:"datatype";s:31:"&nbsp;<i>SQL-where</i> /stdWrap";s:11:"description";s:54:"without &quot;AND&quot;!, Eg. &quot;NOT doktype&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:13:"languageField";s:8:"datatype";s:6:"string";s:11:"description";s:323:"If set, this points to the field in the record which holds a reference to a record in sys_language table. And if set, the records returned by the select-function will be selected only if the value of this field matches the $GLOBALS[&quot;TSFE&quot;]-&gt;sys_language_uid (which is set by the config.sys_language_uid option)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:12:"selectFields";s:8:"datatype";s:6:"string";s:11:"description";s:50:"List of fields to select, or &quot;count(*)&quot;.";s:7:"default";s:1:"*";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:29:"join<br>leftjoin<br>rightjoin";s:8:"datatype";s:6:"string";s:11:"description";s:77:"Enter tablename for JOIN , LEFT OUTER JOIN and RIGHT OUTER JOIN respectively.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('28', '', 'd31c5c1d83f5f71ea314f95fa18982b3', '', 'tsref:->split', 'a:1:{s:4:"rows";a:7:{i:0;a:6:{s:8:"property";s:5:"token";s:8:"datatype";s:12:"str /stdWrap";s:11:"description";s:51:"string or character (token) used to split the value";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:3:"max";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:20:"max number of splits";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:3:"min";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:21:"min number of splits.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:9:"returnKey";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:87:"Instead of parsing the split result, just return this element of the index immediately.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:7:"cObjNum";s:8:"datatype";s:30:"<i>cObjNum</i><br>+optionSplit";s:11:"description";s:120:"This is a pointer the array of this object (&quot;1,2,3,4&quot;), that should treat the items, resulting from the split.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:7:"1,2,3,4";s:8:"datatype";s:20:"-&gt;CARRAY /stdWrap";s:11:"description";s:537:"The object that should treat the value. <b><br>NOTE: The &quot;current&quot;-value is set to the value of current item, when the objects are called. See &quot;stdWrap&quot; / current.</b><b><br>&nbsp;</b><b><br>Example (stdWrap used):</b><br>1.current = 1<br>1.wrap = &lt;B&gt; | &lt;/B&gt;<br>&nbsp;<b><br>Example (CARRAY used):</b><br>1 {<br>&nbsp;&nbsp;&nbsp;10 = TEXT<br>&nbsp;&nbsp;&nbsp;10.current = 1<br>&nbsp;&nbsp;&nbsp;10.wrap = &lt;B&gt; | &lt;/B&gt;<br>&nbsp;&nbsp;&nbsp;20 = CLEARGIF<br>&nbsp;&nbsp;&nbsp;20.height = 20<br>}";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:21:"wrap <br>+optionSplit";s:11:"description";s:29:"Defines a wrap for each item.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('29', '', 'c3abe7b3e50e8c5a3ec49c6fc37e7c6c', '', 'tsref:->if', 'a:1:{s:4:"rows";a:10:{i:0;a:6:{s:8:"property";s:6:"isTrue";s:8:"datatype";s:12:"str /stdWrap";s:11:"description";s:70:"If the content is &quot;true&quot;.... (not empty string and not zero)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:7:"isFalse";s:8:"datatype";s:12:"str /stdWrap";s:11:"description";s:54:"If the content is &quot;false&quot;... (empty or zero)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:10:"isPositive";s:8:"datatype";s:22:"int /stdWrap<br>+ calc";s:11:"description";s:40:"returns false if content is not positive";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:13:"isGreaterThan";s:8:"datatype";s:14:"value /stdWrap";s:11:"description";s:63:"returns false if content is not greater than &quot;.value&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:10:"isLessThan";s:8:"datatype";s:14:"value /stdWrap";s:11:"description";s:60:"returns false if content is not less than &quot;.value&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:6:"equals";s:8:"datatype";s:14:"value /stdWrap";s:11:"description";s:58:"returns false if content does not equal &quot;.value&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:8:"isInList";s:8:"datatype";s:14:"value /stdWrap";s:11:"description";s:152:"returns false if content is not in the comma-separated list &quot;.value&quot;.<br>The list in &quot;.value&quot; may not have spaces between elements!!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:5:"value";s:8:"datatype";s:14:"value /stdWrap";s:11:"description";s:56:"&quot;value&quot; (the comparison value mentioned above)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:6:"negate";s:8:"datatype";s:7:"boolean";s:11:"description";s:125:"This negates the result just before it exits. So if anything above returns true the overall returns ends up returning false!!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:12:"directReturn";s:8:"datatype";s:7:"boolean";s:11:"description";s:120:"If this property exists the true/false of this value is returned. Could be used to set true/false by TypoScript constant";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('30', '', '8d5bffcf7ab541700c652a5edf894713', '', 'tsref:->typolink', 'a:1:{s:4:"rows";a:15:{i:0;a:6:{s:8:"property";s:9:"extTarget";s:8:"datatype";s:15:"target /stdWrap";s:11:"description";s:30:"target used for external links";s:7:"default";s:4:"_top";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"target";s:8:"datatype";s:15:"target /stdWrap";s:11:"description";s:30:"target used for internal links";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:8:"no_cache";s:8:"datatype";s:16:"boolean /stdWrap";s:11:"description";s:56:"Adds a &quot;&amp;no_cache=1&quot;-parameter to the link";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:12:"useCacheHash";s:8:"datatype";s:7:"boolean";s:11:"description";s:528:"If set, the additionalParams list is exploded and calculated into a hashstring appended to the url, like &quot;&amp;cHash=ae83fd7s87&quot;. When the caching mechanism sees this value, it calculates the same value on the server based on incoming values in HTTP_GET_VARS, excluding id,type,no_cache,ftu,cHash,MP values. If the incoming cHash value matches the calculated value, the page may be cached based on this.<br>The [SYS][encryptionKey] is included in the hash in order to make it unique for the server and non-predictable.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:16:"additionalParams";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:556:"This is parameters that are added to the end of the url. This must be code ready to insert after the last parameter. <br>&nbsp;<b><br>Example:</b><br>&#039;&amp;print=1&#039;<br>&#039;&amp;sword_list[]=word1&amp;sword_list[]=word2&#039;<br>&nbsp;<b><br>Applications:</b><br>This is very useful when linking to pages from a searchresult. The searchwords are stored in the register-key SWORD_PARAMS and can be insert directly like this:<br>.additionalParams.data = register:SWORD_PARAMS<br>&nbsp;<br>&nbsp;<b>NOTE:</b> This is only active for internal links!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:14:"addQueryString";s:8:"datatype";s:7:"boolean";s:11:"description";s:632:"Add the QUERY_STRING to the start of the link. Notice that this does not check for any duplicate parameters! This is not a problem (only the last parameter of the same name will be applied), but enable &quot;config.uniqueLinkVars&quot; if you still don&#039;t like it.<br>&nbsp;<br>&nbsp;<b>.method: </b>If set to to GET or POST then then the parsed query arguments (GET or POST data) will be used. This settings are useful if you use URL processing extensions like Real URL, which translate part of the path into query arguments.<br>&nbsp;<br>&nbsp;<b>.exclude: </b>List of query arguments to exclude from the link (eg L or cHash).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:16:"Wraps the links.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:14:"ATagBeforeWrap";s:8:"datatype";s:7:"boolean";s:11:"description";s:91:"If set, the link is first wrapped with &quot;<i>.wrap&quot;</i> and then the &lt;A&gt;-tag.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:9:"parameter";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:4024:"This is the data, that -&gt;typolink uses to create the link. The value is trimmed and if it&#039;s empty, -&gt;typolink returns the input value untouched.<br>&nbsp;<br>&nbsp;<b>NOTE:</b> If used from parseFunc, this value should be imported by:<br>typolink.parameter.data = parameters : allParams<br>&nbsp;<b><br>Examples:</b><br>Internal links:<br>integers (51): creates a link to page with uid = 51<br>filerefs (fileadmin/somedir/thedoc.html): creates a link to the file on the local server.<br>strings (some_alias): creates a link to the page with alias = &quot;some_alias&quot;<br>&nbsp;<br>External links:<br>email-adresses (name@email.com): creates a link to the email-addr.<br>domains (www.domain.com): creates link to http://-page<br>&nbsp;<b><br>The input is parsed like this:</b><br>First the parameter is splitted by character-space. This provides a way to pass more parameters. See &quot;target&quot; below here.<br>If a &quot;@&quot; is in the string, it&#039;s an email<br>If a period (.) is in the string AND if the period (.) is found before a slash (/) is found OR if a doubleslash is found, then it&#039;s a URL<br>If a slash (/) is found, it&#039;s a filereference. If the file/directory does not exist on the server, the link is NOT made!<br>&nbsp;<br>Now the input can be an alias or page-id. If the input is an integer it&#039;s a page-id, if it&#039;s two comma separated integers, it&#039;s a id/type pair, else it&#039;s an alias. For page-id&#039;s or aliases you can prepend a &quot;#&quot; mark with a number indication tt_content record number on the page to jump to! (if .section-property is present, it overrides this).<br>If you insert only &quot;#234&quot; where &quot;234&quot; is the tt_content record number, it links to the current page-id<b><br>&nbsp;</b><b><br>Target</b><br>Target is normally defined by the &quot;extTarget&quot; and &quot;target&quot; properties of typolink. But you may override this target by adding the new target after the parameter separated by a whitespace. Thus the target becomes the second parameter.<br>If the &quot;Target&quot; parameter is set to the &quot;-&quot; character, then it&#039;s the same as no target passed to the function. This feature enables you to still pass a class as third parameter and title as fourth parameter without setting the target also.<br>&nbsp;<b><br>Open in windows with fixed dimensions (JavaScript)</b><br>It is possible to open the link in a window opened by JavaScript (with &quot;window.open&quot;). For this, just set the target value to &quot;123x456&quot; where 123 is the window width and 456 is the window height. You can also specify additional parameters to the function by entering them separated from the width and height with a colon &quot;:&quot;. For instance &quot;230x450:resizable=0,location=1&quot; will disable resizing of the window and enable the location bar.<br>Also see property &quot;JSwindow&quot;.<br>&nbsp;<b><br>Class</b><br>If you specify a third parameter separated by whitespace in the parameter value this becomes the class-parameter of the link. This class parameter is inserted in the link-tag before any values from .ATagParams which means this class value will override any class value set in ATagParams (at least for MSIE). If set to &quot;-&quot;, then it&#039;s the same as no class passed to the function. This feature enables you to still pass a title as fourth parameter without setting the class also.<br>&nbsp;<b><br>Title</b><br>The title attribute is normally specified via .ATagParams or directly via the .title property. But you may override this value by adding the desired title as the fourth parameter (parameters separated by whitespace) to typolink.<br>&nbsp;<b><br>Examples of multiparameters:</b><br>Consider this .parameter value passed to this function:<br>&nbsp;<br>51 _blank blueLink<br>&nbsp;<br>&nbsp;This would result in a link approx like this:<br>&nbsp;<br>&lt;A href=&quot;?id=51&quot; target=&quot;_blank&quot; class=&quot;blueLink&quot;&gt;<br>&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:5:"title";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:38:"Sets the title parameter of the A-tag.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:15:"JSwindow_params";s:8:"datatype";s:6:"string";s:11:"description";s:170:"Preset values for opening the window. This example lists almost all possible attributes:<br>status=1,menubar=1,scrollbars=1,resizable=1,location=1,directories=1,toolbar=1";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:10:"returnLast";s:8:"datatype";s:6:"string";s:11:"description";s:263:"If set to &quot;url&quot; then it will return the URL of the link ($this-&gt;lastTypoLinkUrl)<br>If set to &quot;target&quot; it will return the target of the link.<br>So, in these two cases you will not get the value wrapped but the url or target value returned!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:7:"section";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:221:"If this value is present, it&#039;s prepended with a &quot;#&quot; and placed after any internal url to another page in TYPO3.<br>This is used create a link, which jumps from one page directly the section on another page.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:10:"ATagParams";s:8:"datatype";s:38:"&nbsp;<i>&lt;A&gt;-params</i> /stdWrap";s:11:"description";s:77:"Additional parameters<br>&nbsp;<b><br>Example:</b><br>class=&quot;board&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:8:"userFunc";s:8:"datatype";s:13:"function-name";s:11:"description";s:782:"This passes the link-data compiled by the typolink function to a user-defined function for final manipulation.<br>The $content variable passed to the user-function (first parameter) is an array with the keys &quot;TYPE&quot;, &quot;TAG&quot;, &quot;url&quot;, &quot;targetParams&quot; and &quot;aTagParams&quot;. <br>TYPE is an indication of link-kind: mailto, url, file, page<br>TAG is the full &lt;A&gt;-tag as generated and ready from the typolink function.<br>The latter three is combined into the &#039;TAG&#039; value after this formula:<br>&nbsp;<br>&lt;A HREF=&quot;&#039;.$finalTagParts[&quot;url&quot;].&#039;&quot;&#039;.$finalTagParts[&quot;targetParams&quot;].$finalTagParts[&quot;aTagParams&quot;].&#039;&gt;<br>&nbsp;<br>The userfunction must return an &lt;A&gt;-tag.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('31', '', '80780565cc3f65439bc9a712a1a05942', '', 'tsref:->textStyle', 'a:1:{s:4:"rows";a:11:{i:0;a:6:{s:8:"property";s:11:"align.field";s:8:"datatype";s:5:"align";s:11:"description";s:46:"Set to fieldname from the $cObj-&gt;data-array";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:30:"face.field<br>&nbsp;<br>&nbsp;";s:8:"datatype";s:6:"string";s:11:"description";s:200:"Set to fieldname from the $cObj-&gt;data-array<br>&nbsp;<br>[1] = &quot;Times New Roman&quot;;<br>[2] = &quot;Verdana,Arial,Helvetica,Sans serif&quot;;<br>[3] = &quot;Arial,Helvetica,Sans serif&quot;;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:12:"face.default";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:24:"[default] = User defined";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:30:"size.field<br>&nbsp;<br>&nbsp;";s:8:"datatype";s:6:"string";s:11:"description";s:144:"Set to fieldname from the $cObj-&gt;data-array<br>&nbsp;<br>[1] = 1;<br>[2] = 2;<br>[3] = 3;<br>[10] = &quot;+1&quot;;<br>[11] = &quot;-1&quot;;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:12:"size.default";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:24:"[default] = User defined";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:41:"color.field<br>&nbsp;<br>&nbsp;<br>&nbsp;";s:8:"datatype";s:6:"string";s:11:"description";s:112:"Set to fieldname from the $cObj-&gt;data-array<br>&nbsp;<br>See &quot;content.php&quot; for the colors available";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:13:"color.default";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:24:"[default] = User defined";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:18:"color.1<br>color.2";s:8:"datatype";s:6:"string";s:11:"description";s:22:"[1],[2] = User defined";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:16:"properties.field";s:8:"datatype";s:3:"int";s:11:"description";s:249:"Set to fieldname from the $cObj-&gt;data-array<br>&nbsp;<br>The property values goes like this:<br>bit 0: &lt;B&gt;<br>bit 1: &lt;I&gt;<br>bit 2: &lt;U&gt;<br>bit 3: (uppercase)<br>&nbsp;<br>Thus a value of 5 would result in bold and underlined text";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:18:"properties.default";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:88:"[default] = User defined (This value will be used whenever &quot;.field&quot; is false!)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:7:"altWrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:264:"If this value is set, the wrapping with a font-tag based on font,size and color is NOT done. Rather the element is wrapped with this value.<br>Use it to assign a stylesheet by setting this value to eg.<br>&nbsp;<br>&lt;div class=&quot;text&quot;&gt; | &lt;/div&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('32', '', '5117f2da4a9bf819b7f78f176d3ede8e', '', 'tsref:->encapsLines', 'a:1:{s:4:"rows";a:9:{i:0;a:6:{s:8:"property";s:13:"encapsTagList";s:8:"datatype";s:15:"list of strings";s:11:"description";s:374:"List of tags which qualify as encapsulating tags. Must be lowercase.<br>&nbsp;<b><br>Example:</b><br>encapsTagList = div, p<br>&nbsp;<br>This setting will recognize the red line below as encapsulated lines:<br>&nbsp;<br>First line of text<br>Some &lt;div&gt;text&lt;/div&gt;<br>&lt;p&gt;Some text&lt;/p&gt;<br>&lt;div&gt;Some text&lt;/div&gt;<br>&lt;B&gt;Some text&lt;/B&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:25:"remapTag.[<i>tagname</i>]";s:8:"datatype";s:6:"string";s:11:"description";s:436:"Enter a new tag name here if you wish the tagname of any encapsulation to be unified to a single tag name.<br>&nbsp;<br>For instance, setting this value to &quot;remapTags.P=DIV&quot; would convert:<br>&nbsp;<br>&nbsp;&lt;p&gt;Some text&lt;/p&gt;<br>&lt;div&gt;Some text&lt;/div&gt;<br>&nbsp;<br>to <br>&nbsp;<br>&nbsp;&lt;div&gt;Some text&lt;/div&gt;<br>&lt;div&gt;Some text&lt;/div&gt;<br>&nbsp;<br>([<i>tagname</i>] is in uppercase.)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:30:"addAttributes.[<i>tagname</i>]";s:8:"datatype";s:16:"array of strings";s:11:"description";s:550:"Attributes to set in the encapsulation tag.<b><br>&nbsp;</b><b><br>Example:</b><br>addAttributes.P {<br>&nbsp;&nbsp;&nbsp;style=padding-bottom:0px; margin-top:1px; margin-bottom:1px;<br>&nbsp;&nbsp;&nbsp;align=center<br>}<br>&nbsp;<br>([<i>tagname</i>] is in uppercase.)<br>&nbsp;<br>.setOnly = <br>exists : This will set the value ONLY if the property does not already exist<br>blank : This will set the value ONLY if the property does not already exist OR is blank (&quot;&quot;)<br>&nbsp;<br>Default is to always override/set the attributes value.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:14:"removeWrapping";s:8:"datatype";s:6:"boolen";s:11:"description";s:391:"If set, then all existing wrapping will be removed.<br>&nbsp;<br>This:<br>&nbsp;<br>First line of text<br>Some &lt;div&gt;text&lt;/div&gt;<br>&lt;p&gt;Some text&lt;/p&gt;<br>&lt;div&gt;Some text&lt;/div&gt;<br>&lt;B&gt;Some text&lt;/B&gt;<br>&nbsp;<br>becomes this:<br>&nbsp;<br>First line of text<br>Some &lt;div&gt;text&lt;/div&gt;<br>Some text<br>Some text<br>&lt;B&gt;Some text&lt;/B&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:19:"wrapNonWrappedLines";s:8:"datatype";s:4:"wrap";s:11:"description";s:304:"Wrapping for non-encapsulated lines<br>&nbsp;<b><br>Example:</b><br>.wrapNonWrappedLines = &lt;P&gt;|&lt;/P&gt;<br>&nbsp;<br>This:<br>&nbsp;<br>First line of text<br>&lt;p&gt;Some text&lt;/p&gt;<br>&nbsp;<br>becomes this:<br>&nbsp;<br>&lt;P&gt;First line of text&lt;/P&gt;<br>&lt;p&gt;Some text&lt;/p&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:16:"innerStdWrap_all";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:73:"Wraps the content inside all lines, whether they are encapsulated or not.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:35:"encapsLinesStdWrap.[<i>tagname</i>]";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:87:"Wraps the content inside all encapsulated lines.<br>([<i>tagname</i>] is in uppercase.)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:12:"defaultAlign";s:8:"datatype";s:21:"string / -&gt;stdWrap";s:11:"description";s:152:"If set, this value is set as the default &quot;align&quot; value of the wrapping tags, both from .encapsTagList, .bypassEncapsTagList and .nonWrappedTag";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:13:"nonWrappedTag";s:8:"datatype";s:7:"tagname";s:11:"description";s:339:"For all non-wrapped lines, you can set here which tag it should be wrapped in. Example would be &quot;P&quot;. This is an alternative to .wrapNonWrappedLines and has the advantage that it&#039;s attributes are set by .addAttributes as well as defaultAlign. Thus you can easier match the wrapping tags used for nonwrapped and wrapped lines.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('33', '', '1678f0ea79537a75222cb478bbf92623', '', 'tsref:->tableStyle', 'a:1:{s:4:"rows";a:7:{i:0;a:6:{s:8:"property";s:5:"align";s:8:"datatype";s:14:"align /stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"border";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:11:"cellspacing";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:11:"cellpadding";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:11:"color.field";s:8:"datatype";s:6:"string";s:11:"description";s:46:"Set to fieldname from the $cObj-&gt;data-array";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:35:"color.default<br>color.1<br>color.2";s:8:"datatype";s:6:"string";s:11:"description";s:42:"[default],[1],[2] = User defined<br>&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:6:"params";s:8:"datatype";s:20:"&lt;TABLE&gt;-params";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('34', '', '91a86be2eb43c2534b3785464471e0c3', '', 'tsref:->addParams', 'a:1:{s:4:"rows";a:2:{i:0;a:6:{s:8:"property";s:7:"_offset";s:8:"datatype";s:3:"int";s:11:"description";s:143:"Use this to define which tag you want to manipulate.<br>1 is the first tag in the input, 2 is the second, -1 is the last, -2 is the second last";s:7:"default";s:1:"1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:25:"<i>(array of strings)</i>";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:284:"This defines the content of each added property to the tag.<br>If there is a tag-property with this name already (case-sensitive!) that property will be overridden! <br>If the returned value is a blank string (but not zero!) then the existing (if any) property will not be overridden.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('35', '', 'f7e884f75020be6aeaf62ddc5e89bce0', '', 'tsref:->filelink', 'a:1:{s:4:"rows";a:17:{i:0;a:6:{s:8:"property";s:4:"path";s:8:"datatype";s:13:"path /stdWrap";s:11:"description";s:45:"<b>Example:</b><br>&quot;uploads/media/&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:4:"icon";s:8:"datatype";s:16:"boolean /stdWrap";s:11:"description";s:27:"Set if icon should be shown";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:19:"icon_image_ext_list";s:8:"datatype";s:30:"<i>list of imageextensions</i>";s:11:"description";s:74:"This is the extensions that should render as thumbsnails instead of icons.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:11:"iconCObject";s:8:"datatype";s:7:"cObject";s:11:"description";s:164:"Enter a cObject to use alternatively for the icons, eg. IMAGE type.<br>If this is set, it&#039;ll substitute the use of the thumbs-script for display of thumbnails.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:9:"icon_link";s:8:"datatype";s:7:"boolean";s:11:"description";s:33:"If the icon should be linked also";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:12:"labelStdWrap";s:8:"datatype";s:13:"-&gt; stdWrap";s:11:"description";s:177:"stdWrap options for the label (by default the label is the filename) before being wrapped with the A-tags.<br>Use this to eg. import another label from a database field or such.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:16:"Wraps the links.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:14:"ATagBeforeWrap";s:8:"datatype";s:7:"boolean";s:11:"description";s:91:"If set, the link is first wrapped with &quot;<i>.wrap&quot;</i> and then the &lt;A&gt;-tag.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:4:"file";s:8:"datatype";s:13:"-&gt; stdWrap";s:11:"description";s:97:"stdWrap of the label (by default the label is the filename) after having been wrapped with A-tag!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:4:"size";s:8:"datatype";s:16:"boolean /stdWrap";s:11:"description";s:27:"Set if size should be shown";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:7:"jumpurl";s:8:"datatype";s:7:"boolean";s:11:"description";s:949:"Decides if the link should call the script with the jumpurl paramter in order to register any clicks in the stat.<br>This has the advantage that any clicks on the file will register in the stat.<br>The disadvantage is, that users cant right-click and select &quot;Save Target As&quot; in the browser.<b><br>&nbsp;</b><b><br>Properties:</b><br>.secure (boolean)If set, then the file pointed to by jumpurl is NOT redirected to, but rather it&#039;s read from the file and returned with a correct header. This option adds a hash and locationData to the url and there MUST be access to the record in order to download the file. If the fileposition on the server is furthermore secured by a .htaccess file preventing ANY access, you&#039;ve got secure download here!<br>&nbsp;<br>.secure.mimeTypes (list of mimetypes, syntax [ext] = [mimetype]<br>&nbsp;<b><br>Example:</b><br>.secure = 1<br>.secure.mimeTypes = pdf=application/pdf, doc=application/msword";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:6:"target";s:8:"datatype";s:6:"target";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:10:"ATagParams";s:8:"datatype";s:38:"&nbsp;<i>&lt;A&gt;-params</i> /stdWrap";s:11:"description";s:77:"Additional parameters<br>&nbsp;<b><br>Example:</b><br>class=&quot;board&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:22:"removePrependedNumbers";s:8:"datatype";s:7:"boolean";s:11:"description";s:86:"if set, any 2-digit prepended numbers (&quot;eg _23&quot;) in the filename is removed.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:20:"altText<br>titleText";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:212:"For icons (image made with &quot;iconCObject&quot; must have their own properties)<br>&nbsp;<br>If no titltext is specified, it will use the alttext insteadIf no alttext is specified, it will use an empty alttext";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:11:"longdescURL";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:189:"For icons (image made with &quot;iconCObject&quot; must have their own properties)<br>&nbsp;<br>&quot;longdesc&quot; attribute (URL pointing to document with extensive details about image).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('36', '', 'ce1240f8c0d72bb639611ea407625c88', '', 'tsref:->parseFunc', 'a:1:{s:4:"rows";a:13:{i:0;a:6:{s:8:"property";s:15:"externalBlocks ";s:8:"datatype";s:28:"list of tagnames/+properties";s:11:"description";s:3527:"This allows you to pre-split the content passed to parseFunc so that only content outside the blocks with the given tags is parsed.<b><br>Extra properties:</b><br>&nbsp;<b>.[tagname]</b> {<br>&nbsp;&nbsp;&nbsp;<b>callRecursive</b> = [boolean]; If set, the content of the block is directed into parseFunc again. Otherwise the content is just passed through with no other processing than stdWrap (see below)<br>&nbsp;&nbsp;&nbsp;<b>callRecursive.dontWrapSelf </b>= [boolean]; If set, the tags of the block is <i>not</i> wrapped around the content returned from parseFunc.<br>&nbsp;&nbsp;&nbsp;<b>callRecursive.alternativeWrap</b> = Alternative wrapping instead of the original tags.<br>&nbsp;&nbsp;&nbsp;<b>callRecursive.tagStdWrap</b> = -&gt;stdWrap processing of the block-tags.<br>&nbsp;&nbsp;&nbsp;<b>stdWrap </b>= -&gt;stdWrap processing of the whole block (regardless of whether callRecursive was set.)<br>&nbsp;&nbsp;&nbsp;<b>stripNLprev </b>= [boolean]; Strips off last linebreak of the previous outside block<br>&nbsp;&nbsp;&nbsp;<b>stripNLnext </b>= [boolean]; Strips off first linebreak of the next outside block<br>&nbsp;&nbsp;&nbsp;<b>stripNL </b>= [boolean]: Does both of the above.<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;= [boolean]; If set, then the content is expected to be a table and every table-cell is traversed.<br>&nbsp;&nbsp;&nbsp;&nbsp;# Below, default is all cells and 1,2,3... overrides for specific cols.<br>&nbsp;&nbsp;&nbsp;&nbsp;{<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>callRecursive </b>= [boolean]; The content is parsed through current parseFunc<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>stdWrap </b>= -&gt;stdWrap processing of the content in the cell<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>tagStdWrap</b> = -&gt; The &lt;TD&gt; tag is processed by -&gt;stdWrap<br>&nbsp;&nbsp;&nbsp;&nbsp;}<br>&nbsp;&nbsp;&nbsp;&nbsp;<b>HTMLtableCells.addChr10BetweenParagraphs </b>= [boolean]; If set, then all &lt;/P&gt;&lt;P&gt; appearances will have a chr(10) inserted between them<br>}<br>&nbsp;<b><br>Example:</b><br>This example is used to split regular bodytext content so that tables and blockquotes in the bodytext are processed correctly. The blockquotes are passed into parseFunc again (recursively) and further their top/bottom margins are set to 0 (so no apparent linebreaks are seen)<br>The tables are also displayed with a number of properties of the cells overridden.<br>tt_content.text.20.parseFunc.externalBlocks {<br>&nbsp;&nbsp;&nbsp;blockquote.callRecursive=1<br>&nbsp;&nbsp;&nbsp;blockquote.callRecursive.tagStdWrap.HTMLparser = 1<br>&nbsp;&nbsp;&nbsp;blockquote.callRecursive.tagStdWrap.HTMLparser {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;tags.blockquote.fixAttrib.style.list = margin-bottom:0;margin-top:0;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;tags.blockquote.fixAttrib.style.always=1<br>&nbsp;&nbsp;&nbsp;}<br>&nbsp;&nbsp;&nbsp;blockquote.stripNLprev=1<br>&nbsp;&nbsp;&nbsp;blockquote.stripNLnext=1<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;table.stripNL=1<br>&nbsp;&nbsp;&nbsp;table.stdWrap.HTMLparser = 1<br>&nbsp;&nbsp;&nbsp;table.stdWrap.HTMLparser {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;tags.table.overrideAttribs = border=0 cellpadding=2 cellspacing=1 style=&quot;margin-top:10px; margin-bottom:10px;&quot;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;tags.tr.allowedAttribs=0<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;tags.td.overrideAttribs = valign=top bgcolor=&quot;#eeeeee&quot; style=&quot;font-family : Verdana, Geneva, Arial, Helvetica, sans-serif;font-size : 10px;&quot;<br>&nbsp;&nbsp;&nbsp;}<br>}";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:9:"constants";s:8:"datatype";s:7:"boolean";s:11:"description";s:346:"The toplevel-defined constants will be substituted in the text. The constant-name is wrapped in &quot;###&quot;.<br>&nbsp;<b><br>Example:</b><br>constants.EMAIL = <i>email@email.com</i><br>(NOTE: This is toplevel TypoScript!)<br>All cases of the string ###EMAIL### will be substituted in the text. The constants are defined as a toplevel object. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:5:"short";s:8:"datatype";s:23:"<i>array of strings</i>";s:11:"description";s:330:"Like constants above, but local.<br>&nbsp;<b><br>Example:</b><br>This substitutes all occurencies of &quot;T3&quot; with &quot;TYPO3 CMS&quot; and &quot;T3web&quot; with a link to typo3.com.<br>short {<br>&nbsp;&nbsp;&nbsp;T3 = TYPO3 CMS<br>&nbsp;&nbsp;&nbsp;T3web = &lt;a href=&quot;http://typo3.com&quot;&gt;typo3&lt;/a&gt;<br>}";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:16:"plainTextStdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:52:"This is stdWrap properties for all non-tag content. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:8:"userFunc";s:8:"datatype";s:13:"function name";s:11:"description";s:181:"This passes the non-tag content to a function of your own choice. Similar to eg. .postUserFunc in stdWrap.<br>Remember the function name must possibly be prepended &quot;user_&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:17:"nonTypoTagStdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:250:"Like .plainTextStdWrap. Difference: <br>.plainTextStdWrap works an ALL non-tag pieces in the text. .nonTypoTagStdWrap is post processing of all text (including tags) between special TypoTags (unless .breakoutTypoTagContent is not set for the TypoTag)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:18:"nonTypoTagUserFunc";s:8:"datatype";s:13:"function name";s:11:"description";s:276:"Like .userFunc. Differences is (like nonTypoTagStdWrap) that this is post processing of all content pieces around TypoTags while .userFunc processes all non-tag content. (Notice: .breakoutTypoTagContent must be set for the TypoTag if it&#039;s excluded from nonTypoTagContent)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:5:"sword";s:8:"datatype";s:4:"wrap";s:11:"description";s:203:"Marks up any words from the GET-method send array sword_list[] in the text. The word MUST be at least two characters long!<br>&nbsp;<b>NOTE:</b> works only with $GLOBALS[&quot;TSFE&quot;]-&gt;no_cache==1";s:7:"default";s:48:"&lt;font color=&quot;red&quot;&gt;|&lt;/font&gt;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:9:"makelinks";s:8:"datatype";s:24:"boolean / -&gt;makelinks";s:11:"description";s:115:"Convert webadresses prefixed with &quot;http://&quot; and mail-adresses prefixed with &quot;mailto:&quot; to links.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:4:"tags";s:8:"datatype";s:16:"<i>-&gt;tags</i>";s:11:"description";s:80:"Here you can define <b>custom tags</b> that will parse the content to something.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:9:"allowTags";s:8:"datatype";s:15:"list of strings";s:11:"description";s:125:"List of tags, which are allowed to exist in code! <br>Highest priority: If a tag is found in allowTags, denyTags is ignored!!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:8:"denyTags";s:8:"datatype";s:15:"list of strings";s:11:"description";s:388:"List of tags, which may NOT exist in code! (use &quot;*&quot; for all.)<br>Lowest priority: If a tag is NOT found in allowTags, denyTags is checked. If denyTags is not &quot;*&quot; and the tag is not found in the list, the tag may exist!<br>&nbsp;<b><br>Example:</b><br>This allows &lt;B&gt;, &lt;I&gt;, &lt;A&gt; and &lt;IMG&gt; -tags to exist<br>.allowTags = b,i,a,img<br>.denyTags = *";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:2:"if";s:8:"datatype";s:7:"-&gt;if";s:11:"description";s:85:"if &quot;if&quot; returns false the input value is not parsed, but returned directly.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('37', '', '87d6057bd7b0beb18019a72c170a32fa', '', 'tsref:->makelinks', 'a:1:{s:4:"rows";a:8:{i:0;a:6:{s:8:"property";s:14:"http.extTarget";s:8:"datatype";s:6:"target";s:11:"description";s:22:"The target of the link";s:7:"default";s:4:"_top";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:9:"http.wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:20:"wrap around the link";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:19:"http.ATagBeforeWrap";s:8:"datatype";s:7:"boolean";s:11:"description";s:83:"If set, the link is first wrapped with <i>http.wrap</i> and then the &lt;A&gt;-tag.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:9:"http.keep";s:8:"datatype";s:66:"list: <i>&quot;scheme&quot;,&quot;path&quot;,&quot;query&quot;</i>";s:11:"description";s:381:"As default the link-text will be the full domain-name of the link. <br>&nbsp;<br>&nbsp;<b>Examples</b>:<br>http://www.webaddress.rld/test/doc.php?id=3 <br>&quot;&quot;: www.webaddress.rld<br>&quot;scheme&quot;: http://www.webaddress.rld<br>&quot;scheme,path&quot;: http://www.webaddress.rld/test/doc.php<br>&quot;scheme,path,query&quot;: http://www.webaddress.rld/test/doc.php?id=3";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:15:"http.ATagParams";s:8:"datatype";s:38:"&nbsp;<i>&lt;A&gt;-params</i> /stdWrap";s:11:"description";s:77:"Additional parameters<br>&nbsp;<b><br>Example:</b><br>class=&quot;board&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:11:"mailto.wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:20:"wrap around the link";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:21:"mailto.ATagBeforeWrap";s:8:"datatype";s:7:"boolean";s:11:"description";s:85:"If set, the link is first wrapped with mailto<i>.wrap</i> and then the &lt;A&gt;-tag.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:17:"mailto.ATagParams";s:8:"datatype";s:38:"&nbsp;<i>&lt;A&gt;-params</i> /stdWrap";s:11:"description";s:77:"Additional parameters<br>&nbsp;<b><br>Example:</b><br>class=&quot;board&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('38', '', 'a465bb5ed515df37786b15b6049198e8', '', 'tsref:->tags', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:15:"<i>Array...</i>";s:8:"datatype";s:58:"cObject <i>+stripNL</i><i><br>+ breakoutTypoTagContent</i>";s:11:"description";s:1226:"Every entry in the <i>Array...</i> corresponds to a tag, that will be parsed. The elements MUST be in lowercase. <br>Every entry must be set to a content-object.<br>&quot;current&quot; is set to the content of the tag, eg &lt;TAG&gt;content&lt;/TAG&gt;: here &quot;current&quot; is set to &quot;content&quot;.<b><br>Parameters:</b><br>Parameters of the tag is set in $cObj-&gt;parameters (key is lowercased):<br>&lt;TAG COLOR=&quot;red&quot;&gt;content&lt;/TAG&gt;<br>=&gt; $cObj-&gt;parameters[color] = red <b><br>Special added properties to the content-object:</b><br>$cObj-&gt;parameters[allParams]: this is automatically set to the whole parameter-string of the tag, eg &#039; color=&quot;red&quot;&#039;<br>[cObject].stripNL: is a boolean option, which tells <i>parseFunc</i> that NewLines before and after content of the tag should be stripped.<br>[cObject].breakoutTypoTagContent: is a boolean option, which tells parseFunc that this block of content is breaking up the nonTypoTag content and that the content after this must be re-wrapped.<br>&nbsp;<b><br>Examples:</b><br>tags.bold = TEXT<br>tags.bold {<br>&nbsp;&nbsp;&nbsp;current = 1<br>&nbsp;&nbsp;&nbsp;wrap = &lt;B&gt; | &lt;/B&gt;<br>}<br>tags.bold.stripNL = 1";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('39', '', 'eb48183e6181b87770ebe8ae2364c70d', '', 'page:->HTMLparser; tsref:->HTMLparser', 'a:1:{s:4:"rows";a:10:{i:0;a:6:{s:8:"property";s:9:"allowTags";s:8:"datatype";s:12:"list of tags";s:11:"description";s:20:"Default allowed tags";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:14:"tags.[tagname]";s:8:"datatype";s:28:"boolean/-&gt;HTMLparser_tags";s:11:"description";s:212:"Either set this property to 0 or 1 to allow or deny the tag. If you enter -&gt;HTMLparser_tags properties, those will automatically overrule this option, thus it&#039;s not needed then.<br>[tagname] in lowercase.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:12:"localNesting";s:8:"datatype";s:42:"list of tags, must be among preserved tags";s:11:"description";s:100:"List of tags (among the already set tags), which will be forced to have the nesting-flag set to true";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:13:"globalNesting";s:8:"datatype";s:6:"(ibid)";s:11:"description";s:114:"List of tags (among the already set tags), which will be forced to have the nesting-flag set to &quot;global&quot;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:15:"rmTagIfNoAttrib";s:8:"datatype";s:6:"(ibid)";s:11:"description";s:103:"List of tags (among the already set tags), which will be forced to have the rmTagIfNoAttrib set to true";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:8:"noAttrib";s:8:"datatype";s:6:"(ibid)";s:11:"description";s:154:"List of tags (among the already set tags), which will be forced to have the allowedAttribs value set to zero (which means, all attributes will be removed.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:10:"removeTags";s:8:"datatype";s:6:"(ibid)";s:11:"description";s:95:"List of tags (among the already set tags), which will be configured so they are surely removed.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:18:"keepNonMatchedTags";s:8:"datatype";s:29:"boolean / &quot;protect&quot;";s:11:"description";s:328:"If set (true=1), then all tags are kept regardless of tags present as keys in $tags-array. <br>If &quot;protect&quot;, then the preserved tags have their &lt;&gt; converted to &amp;lt; and &amp;gt;<br>Default is to REMOVE all tags, which are not specifically assigned to be allowed! So you might probably want to set this value!";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:16:"htmlSpecialChars";s:8:"datatype";s:14:"-1 / 0 / 1 / 2";s:11:"description";s:498:"This regards all content which is NOT tags: <br>&quot;0&quot; means &quot;disabled&quot; - nothing is done<br>&quot;1&quot; means the content outside tags is htmlspecialchar()&#039;ed (PHP-function which converts &amp;&quot;&lt;&gt; to &amp;...;)<br>&quot;2&quot; is the same as &quot;1&quot; but entities like &quot;&amp;amp;&quot; or &quot;&amp;#234&quot; are untouched.<br>&quot;-1&quot; does the opposite of &quot;1&quot; - converts &amp;lt; to &lt;, &amp;gt; to &gt;, &amp;quot; to &quot; etc.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:14:"xhtml_cleaning";s:8:"datatype";s:7:"boolean";s:11:"description";s:167:"Cleans up the content for XHTML compliance. Still slightly experimental and supports only some clean up operations (like convertion tags and attributes to lower case).";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('40', '', '0adbed858831d26590fb2051a38b06d1', '', 'page:->HTMLparser_tags; tsref:->HTMLparser_tags', 'a:1:{s:4:"rows";a:19:{i:0;a:6:{s:8:"property";s:15:"overrideAttribs";s:8:"datatype";s:6:"string";s:11:"description";s:60:"If set, this string is preset as the attributes of the tag. ";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:14:"allowedAttribs";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:156:"&#039;0&#039; (zero) = no attributes allowed, &#039;[commalist of attributes]&#039; = only allowed attributes. If blank/not set, all attributes are allowed.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:31:"&nbsp;fixAttrib.[attribute].set";s:8:"datatype";s:6:"string";s:11:"description";s:40:"Force the attribute value to this value.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:33:"&nbsp;fixAttrib.[attribute].unset";s:8:"datatype";s:7:"boolean";s:11:"description";s:37:"&nbsp;If set, the attribute is unset.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:35:"&nbsp;fixAttrib.[attribute].default";s:8:"datatype";s:6:"string";s:11:"description";s:100:"If no attribute exists by this name, this value is set as default value (if this value is not blank)";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:34:"&nbsp;fixAttrib.[attribute].always";s:8:"datatype";s:7:"boolean";s:11:"description";s:95:"If set, the attribute is always processed. Normally an attribute is processed only if it exists";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:144:"&nbsp;fixAttrib.[attribute].trim<br>&nbsp;fixAttrib.[attribute].intval<br>&nbsp;fixAttrib.[attribute].upper<br>&nbsp;fixAttrib.[attribute].lower";s:8:"datatype";s:7:"boolean";s:11:"description";s:87:"If any of these keys are set, the value is passed through the respective PHP-functions.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:33:"&nbsp;fixAttrib.[attribute].range";s:8:"datatype";s:12:"[low],[high]";s:11:"description";s:23:"Setting integer range. ";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:32:"&nbsp;fixAttrib.[attribute].list";s:8:"datatype";s:23:"list of values, trimmed";s:11:"description";s:84:"Attribute value must be in this list. If not, the value is set to the first element.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:41:"&nbsp;fixAttrib.[attribute].removeIfFalse";s:8:"datatype";s:32:"boolean/&quot;blank&quot; string";s:11:"description";s:203:"If set, then the attribute is removed if it is &quot;false&quot;. If this value is set to &quot;blank&quot; then the value must be a blank string (that means a &quot;zero&quot; value will not be removed)";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:42:"&nbsp;fixAttrib.[attribute].removeIfEquals";s:8:"datatype";s:6:"string";s:11:"description";s:70:"If the attribute value matches the value set here, then it is removed.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:45:"&nbsp;fixAttrib.[attribute].casesensitiveComp";s:8:"datatype";s:7:"boolean";s:11:"description";s:113:"If set, the comparison in .removeIfEquals and .list will be case-sensitive. At this point, it&#039;s insensitive.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:46:"&nbsp;fixAttrib.[attribute].prefixLocalAnchors";s:8:"datatype";s:7:"integer";s:11:"description";s:461:"If the first char is a &quot;#&quot; character (anchor of fx. &lt;a&gt; tags) this will prefix either a relative or absolute path.<br>If the value is &quot;1&quot; you will get the absolute path (t3lib_div::getIndpEnv(&#039;TYPO3_REQUEST_URL&#039;))<br>If the value is &quot;2&quot; you will get the relative path (stripping of t3lib_div::getIndpEnv(&#039;TYPO3_SITE_URL&#039;))<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>...fixAttrib.href.prefixLocalAnchors = 1";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:45:"&nbsp;fixAttrib.[attribute].prefixRelPathWith";s:8:"datatype";s:6:"string";s:11:"description";s:306:"If the value of the attribute seems to be a relative URL (no scheme like &quot;http&quot; and no &quot;/&quot; as first char) then that value of this property will be prefixed the attribute.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>...fixAttrib.src.prefixRelPathWith = http://192.168.230.3/typo3/32/dummy/";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:36:"&nbsp;fixAttrib.[attribute].userFunc";s:8:"datatype";s:18:"function reference";s:11:"description";s:145:"User function for processing of the attribute.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>...fixAttrib.href.userFunc = tx_realurl-&gt;test_urlProc";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:7:"protect";s:8:"datatype";s:7:"boolean";s:11:"description";s:62:"If set, the tag &lt;&gt; is converted to &amp;lt; and &amp;gt;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:5:"remap";s:8:"datatype";s:6:"string";s:11:"description";s:47:"If set, the tagname is remapped to this tagname";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:15:"rmTagIfNoAttrib";s:8:"datatype";s:7:"boolean";s:11:"description";s:69:"If set, then the tag is removed if no attributes happend to be there.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:7:"nesting";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:624:"If set true, then this tag must have starting and ending tags in the correct order. Any tags not in this order will be discarded. Thus &#039;&lt;/B&gt;&lt;B&gt;&lt;I&gt;&lt;/B&gt;&lt;/I&gt;&lt;/B&gt;&#039; will be converted to &#039;&lt;B&gt;&lt;I&gt;&lt;/B&gt;&lt;/I&gt;&#039;. <br>Is the value &quot;global&quot; then true nesting in relation to other tags marked for &quot;global&quot; nesting control is preserved. This means that if &lt;B&gt; and &lt;I&gt; are set for global nesting then this string &#039;&lt;/B&gt;&lt;B&gt;&lt;I&gt;&lt;/B&gt;&lt;/I&gt;&lt;/B&gt;&#039; is converted to &#039;&lt;B&gt;&lt;/B&gt;&#039;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('41', '', '2bcf41f3a27a1da90a09ebdf3a40f315', '', 'tsref:(TLO)', 'a:1:{s:4:"rows";a:10:{i:0;a:6:{s:8:"property";s:5:"types";s:8:"datatype";s:8:"readonly";s:11:"description";s:59:"Types (internal)<br>type=99 reserved for plaintext display ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:9:"resources";s:8:"datatype";s:8:"readonly";s:11:"description";s:28:"Resources in list (internal)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:9:"sitetitle";s:8:"datatype";s:8:"readonly";s:11:"description";s:20:"SiteTitle (internal)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:6:"config";s:8:"datatype";s:11:"-&gt;CONFIG";s:11:"description";s:135:"Global configuration. <br>These values are stored with cached pages which means they are also accessible when retrieving a cached page.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:9:"constants";s:8:"datatype";s:14:"-&gt;CONSTANTS";s:11:"description";s:183:"Site-specific constants, eg. a general email-adresse. These constants may be substituted in the text throughout the pages. The substitution is done by parseFunc. (Option: constants=1)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:6:"FEData";s:8:"datatype";s:19:"<i>-&gt;FE_DATA</i>";s:11:"description";s:105:"Here you can configure how data submitted from the front-end should be processed, which script and so on.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:11:"includeLibs";s:8:"datatype";s:23:"<i>Array of strings</i>";s:11:"description";s:160:"With this you can include php-files with function libraries for use in your includescript in TYPO3. <br>Please see the PAGE-object, which has the same property.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:101:"<i>Other reserved TLO&#039;s:</i><br>&nbsp;<br>plugin<br>tt_*<br>temp<br>styles<br>lib<br>_GIFBUILDER";s:8:"datatype";s:13:"<i>&nbsp;</i>";s:11:"description";s:840:"These toplevel object names are reserved. That means you can risk static_templates to use them:<br>&quot;plugin&quot; is used for rendering of special content like boards, ecommerce solutions, guestbooks and so on. Normally set from static_templates. <i>Please see separate description below!</i><br>&quot;tt_*&quot;, eg tt_content (from &quot;content (default)&quot;) is used to render content from tables.<br>&quot;temp&quot; and &quot;styles&quot; are used for conde-libraries you can copy during parse-time, but they are not saved with the template in cache. <b>&quot;temp&quot; / &quot;styles&quot; are unset</b> before the template is cached! Therefore use these names to store temporary data.<br>&quot;lib&quot; can be used for a &quot;library&quot; of code, you can reference in TypoScript (unlike &quot;styles&quot; which is unset)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:3:"...";s:8:"datatype";s:4:"PAGE";s:11:"description";s:469:"Start a new page<br>&nbsp;<b><br>Example:</b><br>page = PAGE<br>page.typeNum = 1<br>&nbsp;<b><br>Guidelines:</b><br>Good, general PAGE object names to use are such as:<br>&nbsp;<i>page </i>for the main page with content<br>&nbsp;<i>frameset, frameset2 </i>for framesets.<br>&nbsp;<i>top, left, menu, right, bottom, border </i>for top and menu frames etc.<br>This is just recommandations. Especially the name &#039;page&#039; for the content bearing page is very common.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:3:"...";s:8:"datatype";s:17:"<i>(whatever)</i>";s:11:"description";s:368:"If a toplevel-object is not a PAGE-object it could be used as a temporary repository for setup. In this case you should use the &quot;temp&quot; or &quot;styles&quot; objects.<br>&quot;tt_...&quot; is normally used to define the setup of content-records. Eg. &quot;tt_content&quot; would be used for the tt_content-table as default. See the &quot;CONTENT&quot;-cObject";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('42', '', '270df189982a4482d7b570baa95cba05', '', 'tsref:plugin', 'a:1:{s:4:"rows";a:5:{i:0;a:6:{s:8:"property";s:15:"<i>userFunc</i>";s:8:"datatype";s:13:"<i>&nbsp;</i>";s:11:"description";s:67:"<i>Property setting up the USER / USER_INT object of the plugin</i>";s:7:"default";s:13:"<i>&nbsp;</i>";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:18:"<i>includeLibs</i>";s:8:"datatype";s:13:"<i>&nbsp;</i>";s:11:"description";s:67:"<i>Property setting up the USER / USER_INT object of the plugin</i>";s:7:"default";s:13:"<i>&nbsp;</i>";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:18:"_CSS_DEFAULT_STYLE";s:8:"datatype";s:6:"string";s:11:"description";s:331:"Use this to have some default CSS styles inserted in the header section of the document. Most likely this will provide a default acceptable display from the plugin, but should ideally be cleared and moved to an external stylesheet.<br>This value is for all plugins read by the pagegen script when making the header of the document.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:28:"_DEFAULT_PI_VARS.[piVar-key]";s:8:"datatype";s:6:"string";s:11:"description";s:206:"Allows you to set default values of the piVars array which most plugins are using (and should use) for data exchange with themselves. <br>This works only if the plugin calls $this-&gt;pi_setPiVarDefaults().";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:34:"_LOCAL_LANG.[lang-key].[label-key]";s:8:"datatype";s:6:"string";s:11:"description";s:68:"Can be used to override the default locallang labels for the plugin.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('43', '', 'f98a9e5726c62fb08803c31cac589abb', '', 'tsref:config/->CONFIG', 'a:1:{s:4:"rows";a:107:{i:0;a:6:{s:8:"property";s:8:"linkVars";s:8:"datatype";s:4:"list";s:11:"description";s:364:"HTTP_GET_VARS, which should be passed on with links in Typo. This is compiled into a string stored in $GLOBALS[&quot;TSFE&quot;]-&gt;linkVars<br>&nbsp;<b><br>Example:</b><br>config.linkVars = noframes, print<br>&nbsp;<br>This will add &quot;&amp;noframes=[noframes-value]&amp;print=[print-value]&quot; to all links in TYPO3.<br>The values are rawurlencoded in PHP.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:14:"uniqueLinkVars";s:8:"datatype";s:7:"boolean";s:11:"description";s:192:"It might happen that TYPO3 generates links with the same parameter twice or <br>more. This is no problem because only the last parameter is used, thus the <br>problem is just a cosmetical one.";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:11:"MP_defaults";s:8:"datatype";s:6:"string";s:11:"description";s:385:"Allows you to set a list of page id numbers which will always have a certain &quot;&amp;MP=...&quot; parameter added.<br>&nbsp;<b><br>Syntax:</b><br>[id],[id],... : [MP-var] | [id],[id],... : [MP-var] | ... <br>&nbsp;<b><br>Example:</b><br>config.MP_defaults = 36,37,48 : 2-207<br>&nbsp;<br>This will by default add &quot;&amp;MP=2-207&quot; to all links pointing to pages 36,37 and 48";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:16:"MP_mapRootPoints";s:8:"datatype";s:19:"list of PIDs/string";s:11:"description";s:600:"Defines a list of ID numbers from which the MP-vars are automatically calculated for the branch.<br>The result is used just like MP_defaults are used to find MP-vars if none has been specified prior to the call to t3lib_tstemplate::linkData().<br>You can specify &quot;root&quot; as a special keyword in the list of IDs and that will create a map-tree for the whole site (but this may be VERY processing intensive if there are many pages!).<br>The order of IDs specified may have a significance; Any ID in a branch which is processed already (by a previous ID root point) will not be processed again.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:32:"MP_disableTypolinkClosestMPvalue";s:8:"datatype";s:7:"boolean";s:11:"description";s:83:"If set, the typolink function will not try to find the closest MP value for the id.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:13:"renderCharset";s:8:"datatype";s:6:"string";s:11:"description";s:887:"Charset used for rendering internally of the page content. It is highly recommended that this value is the same as the charset of the content coming from the main data source (eg. the database). Thus you don&#039;t need to do any other conversion.<br>All strings from locallang files and locale strings are (and should be) converted to &quot;renderCharset&quot; during rendering. <br>&nbsp;<br>If you need another output charset than the render charset, see &quot;metaCharset&quot; below. <br>&nbsp;<br>If you set TYPO3_CONF_VARS[&#039;BE&#039;][&#039;forceCharset&#039;] that value is used by default for &quot;renderCharset&quot;. It is highly recommended to use TYPO3_CONF_VARS[&#039;BE&#039;][&#039;forceCharset&#039;] for multilingual websites in TYPO3. If you set that you don&#039;t have to worry about renderCharset and metaCharset - the same charset is used in the whole system.";s:7:"default";s:79:"TYPO3_CONF_VARS[BE][forceCharset] if found, otherwise<br>&quot;iso-8859-1&quot;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:11:"metaCharset";s:8:"datatype";s:6:"string";s:11:"description";s:651:"Charset used for the output document. For example in the meta tag:<br>&lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;text/html; charset=...&gt;<br>&nbsp;<br>Is used for a) HTML meta-tag, b) HTTP header (unless disabled with .disableCharsetHeader) and c) xhtml prologues (if available)<br>&nbsp;<br>If renderCharset and metaCharset are different the output content is automatically converted to metaCharset before output and likewise are values posted back to the page converted from metaCharset to renderCharset for internal processing. This conversion takes time of course so there is another good reason to use the same charset for both.";s:7:"default";s:35:"value of &quot;.renderCharset&quot;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:20:"disableCharsetHeader";s:8:"datatype";s:7:"boolean";s:11:"description";s:106:"By default a header &quot;content-type:text/html; charset...&quot; is sent. This option will disable that.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:25:"enableContentLengthHeader";s:8:"datatype";s:7:"boolean";s:11:"description";s:359:"If set, a header &quot;content-length: [bytes of content]&quot; is sent.<br>&nbsp;<br>If a PHP_SCRIPT_EXT object is detected on the page or if the Backend user is logged in, this is disabled. The reason is that the content length header cannot include the lenght of these objects and the content-length will cut of the lenght of the document in some browsers.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:16:"sendCacheHeaders";s:8:"datatype";s:7:"boolean";s:11:"description";s:1474:"If set, TYPO3 will output cache-control headers to the client based mainly on whether the page was cached internally. This feature allows client browsers and/or reverse proxies to take load of TYPO3 websites.<br>&nbsp;<br>The conditions for allowing client caching are:<br>page was cached<br>No *_INT or *_EXT objects were on the page (eg. USER_INT)<br>No frontend user is logged in<br>No backend user is logged in<br>&nbsp;<br>If these conditions are met, the headers sent are:<br>Last-Modified [SYS_LASTCHANGED of page id]<br>Expires [expire time of page cache]<br>Etag [md5 of content]<br>Cache-Control: max-age: [seconds til expiretime]<br>Pragma: public<br>&nbsp;<br>In case caching is not allowed, these headers are sent to avoid client caching:<br>Cache-Control: private<br>&nbsp;<br>Notice that enabling the browser caches means you have to consider how log files are written. Because when a page is cached on the client it will not invoke a request to the webserver, thus not writing the request to the log. There should be ways to circumvent these problems but they are outside the domain of TYPO3 in any case.<br>&nbsp;<br>&nbsp;<b>Tip:</b> Enabling cache-control headers might confuse editors seeing old content served from the browser cache. &quot;Shift-Reload&quot; will bypass both browser- and reverse-proxy caches and even make TYPO3 regenerate the page. Teach them that trick!<br>&nbsp;<br>Thanks to Ole Tange, www.forbrug.dk for co-authoring this feature.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:44:"sendCacheHeaders_onlyWhenLoginDeniedInBranch";s:8:"datatype";s:7:"boolean";s:11:"description";s:1448:"If this is set, then cache-control headers allowing client caching is sent only if user-logins are disabled for the branch. This feature makes it easier to manage client caching on sites where you have a mixture of static pages and dynamic sections with user logins. <br>&nbsp;<br>The background problem is this: In TYPO3 the same URL can show different content depending on whether a user is logged in or not. If a user is logged in, cache-headers will never allow client caching. But if the same URL was visited without a login prior to the login (allowing caching) the user will still see the page from cache when logged in (and so thinks he is not logged in anyway)! The only general way to prevent this is to have a different URL for pages when users are logged in (which the extension &quot;realurl&quot; can accomplish).<br>&nbsp;<br>Another way to solve the problem is using this option in combination with disabling and enabling logins in various sections of the site. In the page records (&quot;Advanced&quot; page types) you can disable frontend user logins for branches of the page tree. Since many sites only needs the login in a certain branch of the page tree, disabling it in all other branches makes it much easier to use cache-headers in combination with logins; Cache-headers should simply be sent when logins are not allowed and never be send when logins are allowed! Then there will never be problems with logins and same-URLs.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:7:"doctype";s:8:"datatype";s:6:"string";s:11:"description";s:1056:"If set, then a document type declaration (and an XML prologue) will be generated. The value can either be a complete doctype or one of the following keywords:<br>&nbsp;<br>&quot;<b>xhtml_trans</b>&quot; for XHTML 1.0 Transitional doctype.<br>&quot;<b>xhtml_frames</b>&quot; for XHTML 1.0 Frameset doctype.<br>&quot;<b>xhtml_strict</b>&quot; for XHTML 1.0 Strict doctype.<br>&quot;<b>xhtml_basic</b>&quot; for XHTML basic doctype.<br>&quot;<b>xhtml_11</b>&quot; for XHTML 1.1 doctype.<br>&quot;<b>xhtml_2</b>&quot; for XHTML 2 doctype.<br>&quot;<b>none</b>&quot; for NO doctype at all.<br>&nbsp;<br>Note that the keywords also change the way TYPO3 generates some of the XHTML tags to ensure valid XML. If you set doctype to a string, then you must also set config.xhtmlDoctype (see below).<br>&nbsp;<br>See &quot;config.htmlTag_setParams&quot; and &quot;config.htmlTag_langKey&quot; for more details on the effect on the html tag.<br>&nbsp;<br>Default is a DOCTYPE like this:<br>&lt;!DOCTYPE HTML PUBLIC &quot;-//W3C//DTD HTML 4.0 Transitional//EN&quot;&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:13:"doctypeSwitch";s:8:"datatype";s:16:"boolean / string";s:11:"description";s:1118:"If set, the order of &lt;?xml...&gt; and &lt;!DOCTYPE...&gt; will be reversed. This is needed for MSIE to be standards compliant with XHTML.<br>&nbsp;<b><br>Background:</b><br>By default TYPO3 outputs the XML/DOCTYPE in compliance with the standards of XHTML. However a browser like MSIE will still run in &quot;quirks-mode&quot; unless the &lt;?xml&gt; and &lt;DOCTYPE&gt; tags are ordered opposite. But this breaks CSS validation... <br>With this option designers can decide for themselves what they want then.<br>&nbsp;<br>If you want to check the compatibility-mode of your webbrowser you can do so with a simple JavaScript that can be inserted on a TYPO3 page like this:<br>&nbsp;<br>page.headerData.1 = TEXT<br>page.headerData.1.value = &lt;script&gt;alert(document.compatMode);&lt;/script&gt;<br>&nbsp;<br>If your browser has detected the DOCTYPE correctly it will report &quot;CSS1Compat&quot;<br>If you are not running in compliance mode you will get some other message. MSIE will report &quot;BackCompat&quot; for instance - this means it runs in quirks-mode, supporting all the old &quot;browser-bugs&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:12:"xhtmlDoctype";s:8:"datatype";s:6:"string";s:11:"description";s:937:"Sets the document type for the XHTML version of the generated page.<br>&nbsp;<br>If config.doctype is set to a string then config.xhtmlDoctype must be set to one of these keywords:<br>&nbsp;<br>&quot;<b>xhtml_trans</b>&quot; for XHTML 1.0 Transitional doctype.<br>&quot;<b>xhtml_frames</b>&quot; for XHTML 1.0 Frameset doctype.<br>&quot;<b>xhtml_strict</b>&quot; for XHTML 1.0 Strict doctype.<br>&quot;<b>xhtml_basic</b>&quot; for XHTML basic doctype.<br>&quot;<b>xhtml_11</b>&quot; for XHTML 1.1 doctype.<br>&quot;<b>xhtml_2</b>&quot; for XHTML 2 doctype.<br>&nbsp;<br>&nbsp;<br>This is an example to use MathML 2.0 in an XHTML 1.1 document:<br>&nbsp;<br>config.doctype (<br>&lt;!DOCTYPE html<br>PUBLIC &quot;-//W3C//DTD XHTML 1.1 plus MathML 2.0//EN&quot;<br>&quot;http://www.w3.org/Math/DTD/mathml2/xhtml-math11-f.dtd&quot;&gt;<br>)<br>config.xhtmlDoctype = xhtml_11<br>&nbsp;<br>Default:<br>same as config.doctype if set to a keyword";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:11:"xmlprologue";s:8:"datatype";s:6:"string";s:11:"description";s:566:"If empty (not set) then the default XML 1.0 prologue is set, when the doctype is set to a known keyword (eg xhtml_11):<br>&nbsp;<br>&lt;?xml version=&quot;1.0&quot; encoding=&quot;[config.renderCharset]&quot;&gt;<br>&nbsp;<br>If set to one of the know keywords then a standard prologue will be set:<br>&nbsp;&quot;<b>xml_10</b>&quot;<b> </b>XML 1.0 prologue (see above)<br>&nbsp;&quot;<b>xml_11</b>&quot;<b> </b>XML 1.1 prologue<br>&nbsp;<br>If &quot;<b>none</b>&quot; then the default XML prologue is not set.<br>Any other string is used as the XML prologue itself.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:17:"htmlTag_setParams";s:8:"datatype";s:6:"string";s:11:"description";s:499:"Sets the attributes for the &lt;html&gt; tag on the page. If you set &quot;config.doctype&quot; to a keyword enabling XHTML then some attributes are already set. This property allows you to override any preset attributes with you own content if needed.<br>&nbsp;<br>&nbsp;<b>Special:</b> If you set it to &quot;none&quot; then no attributes will be set at any event.<br>&nbsp;<b><br>Example:</b><br>config.htmlTag_setParams = xmlns=&quot;http://www.w3.org/1999/xhtml&quot; xml:lang=&quot;en-US&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:15:"htmlTag_langKey";s:8:"datatype";s:6:"string";s:11:"description";s:295:"Allows you to set the language value for the attributes &quot;xml:lang&quot; and &quot;lang&quot; in the &lt;html&gt; tag (when using &quot;config.doctype = xhtml*&quot;).<br>&nbsp;<br>The values must follow the format specified in <br>&nbsp;<b><br>Example:</b><br>config.htmlTag_langKey = en-US";s:7:"default";s:2:"en";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:11:"htmlTag_dir";s:8:"datatype";s:6:"string";s:11:"description";s:373:"Sets text direction for whole document (useful for display of Arabic, Hebrew pages).<br>&nbsp;<br>Basically the value becomes the attribute value of &quot;dir&quot; for the &lt;html&gt; tag.<br>&nbsp;<b><br>Values:</b><br>rtl = Right-To-Left (for Arabic / Hebrew)<br>ltr = Left-To-Right (Default for other languages)<br>&nbsp;<b><br>Example:</b><br>config.htmlTag_dir = rtl";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:10:"ATagParams";s:8:"datatype";s:23:"<i>&lt;A&gt;-params</i>";s:11:"description";s:160:"Additional parameters to all links in TYPO3 (excluding menu-links)<br>&nbsp;<b><br>Example:</b><br>To blur links, insert: <br>onFocus=&quot;blurLink(this)&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:13:"setJS_openPic";s:8:"datatype";s:7:"boolean";s:11:"description";s:64:"If set, the openPic JavaScript function is forced to be included";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:15:"setJS_mouseOver";s:8:"datatype";s:7:"boolean";s:11:"description";s:75:"If set, the over() and out() JavaScript functions are forced to be included";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:15:"removeDefaultJS";s:8:"datatype";s:16:"boolean / string";s:11:"description";s:457:"if set, the default JavaScript in the header will be removed.<br>The default JavaScript is the blurLink function and browser detection variables.<br>&nbsp;<br>&nbsp;<b>Special case:</b> if the value is &quot;<b>external</b>&quot; then the default JavaScript is written to a temporary file and included from that file. See &quot;inlineStyle2TempFile&quot; below.<br>&nbsp;<b><br>Example:</b><br>config.removeDefaultJS = external<br>config.removeDefaultJS = 1";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:22;a:6:{s:8:"property";s:20:"inlineStyle2TempFile";s:8:"datatype";s:7:"boolean";s:11:"description";s:302:"If set, the inline styles TYPO3 controls in the core are written to a file, typo3temp/stylesheet_[hashstring].css, and the header will only contain the link to the stylesheet.<br>The file hash is based solely on the content of the styles.<br>&nbsp;<b><br>Example:</b><br>config.inlineStyle2TempFile = 1";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:23;a:6:{s:8:"property";s:24:"meaningfulTempFilePrefix";s:8:"datatype";s:7:"integer";s:11:"description";s:252:"If set it will try to render a meaningful prefix before temporary image files.<br>Works with GIFBUILDER files (taking content from the Gifbuilder TEXT objects), menus (taking the title of the menu item) and scaled images (using original filename base).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:24;a:6:{s:8:"property";s:3:"ftu";s:8:"datatype";s:7:"boolean";s:11:"description";s:882:"If set, the &quot;&amp;ftu=....&quot; GET-fallback identification is inserted.<br>&quot;&amp;ftu=[hash]&quot; is always inserted in the links on the first page a user hits. If it turns out in the next hit that the user has cookies enabled, this variable is not set anymore as the cookies does the job. If no cookies is accepted the &quot;ftu&quot; remains set for all links on the site and thereby we can still track the user.<br>&nbsp;<b><br>You should not set this feature if grabber-spiders like Teleport are going to grab your site!</b><b><br>You should not set this feature if you want search-engines to index your site (in conjunction with the simulateStaticDocuments feature!)</b><b><br>&nbsp;</b><br>You can also ignore this feature if you&#039;re certain, website users will use cookies.<br>&nbsp;&quot;ftu&quot; means fe_typo_user (&quot;fe&quot; is &quot;frontend&quot;).";s:7:"default";s:5:"false";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:25;a:6:{s:8:"property";s:10:"mainScript";s:8:"datatype";s:6:"string";s:11:"description";s:240:"This lets you specify an alternative &quot;mainScript&quot; which is the document that TYPO3 expects to be the default doc. This is used in form-tags and other places where TYPO3 needs to refer directly to the main-script of the application";s:7:"default";s:9:"index.php";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:26;a:6:{s:8:"property";s:13:"pageGenScript";s:8:"datatype";s:8:"resource";s:11:"description";s:613:"Alternative page generation script for applications using index_ts.php for initialization, caching, stating and so on. This script is included in the global scope of index_ts.php-script and thus you may include libraries here. Always use include_once for libraries.<br>Remember not to output anything from such an included script. <b>All content must be set into $TSFE-&gt;content. </b>Take a look at typo3/sysext/cms/tslib/pagegen.php<br>&nbsp;<br>&nbsp;<b>NOTE:</b> This option is ignored if <br>&nbsp;<br>$TYPO3_CONF_VARS[&quot;FE&quot;][&quot;noPHPscriptInclude&quot;]=1;<br>&nbsp;<br>is set in localconf.php.";s:7:"default";s:34:"typo3/sysext/cms/tslib/pagegen.php";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:27;a:6:{s:8:"property";s:5:"debug";s:8:"datatype";s:7:"boolean";s:11:"description";s:110:"If set any debug-information in the TypoScript code is output. Currently this applies only to the menu-objects";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:28;a:6:{s:8:"property";s:31:"message_page_is_being_generated";s:8:"datatype";s:6:"string";s:11:"description";s:343:"Alternative HTML message that appears if a page is being generated.<br>Normally when a page is being generated a temporary copy is stored in the cache-table with an expire-time of 30 seconds.<br>&nbsp;<br>It is possible to use some keywords that are replaced with the corresponding values. Possible keywords are: ###TITLE###, ###REQUEST_URI###";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:29;a:6:{s:8:"property";s:15:"message_preview";s:8:"datatype";s:6:"string";s:11:"description";s:77:"Alternative message in HTML that appears when the preview function is active!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:30;a:6:{s:8:"property";s:25:"message_preview_workspace";s:8:"datatype";s:7:"string ";s:11:"description";s:504:"Alternative message in HTML that appears when the preview function is active in a draft workspace. You can use sprintf() placeholders for Workspace title (first) and number (second).<br>&nbsp;<b><br>Examples:</b><br>config.message_preview_workspace = &lt;div class=&quot;previewbox&quot;&gt;Displaying workspace named &quot;%s&quot; (number %s)!&lt;/div&gt;<br>config.message_preview_workspace = &lt;div class=&quot;previewbox&quot;&gt;Displaying workspace number %2$s named &quot;%1$s&quot;!&lt;/div&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:31;a:6:{s:8:"property";s:10:"locale_all";s:8:"datatype";s:6:"string";s:11:"description";s:549:"PHP: setlocale(&quot;LC_ALL&quot;, [value]);<br>value-examples: deutsch, de_DE, danish, portuguese, spanish, french, norwegian, italian. See www.php.net for other value. Also on linux, look at /usr/share/locale/<br>&nbsp;<br>TSFE-&gt;localeCharset is intelligently set to the assumed charset of the locale strings. This is used in stdWrap.strftime to convert locale strings to the renderCharset of the frontend.<br>&nbsp;<b><br>Example:</b><br>This will render dates in danish made with stdWrap/strftime:<br>locale_all = danish<br>locale_all = da_DK";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:32;a:6:{s:8:"property";s:16:"sword_standAlone";s:8:"datatype";s:7:"boolean";s:11:"description";s:139:"Used by the parseFunc-substitution of search Words (sword):<br>If set, the words MUST be surrounded by whitespace in order to be marked up.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:33;a:6:{s:8:"property";s:17:"sword_noMixedCase";s:8:"datatype";s:7:"boolean";s:11:"description";s:132:"Used by the parseFunc-substitution of search Words (sword):<br>If set, the words MUST be the exact same case as the search word was.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:34;a:6:{s:8:"property";s:9:"intTarget";s:8:"datatype";s:6:"target";s:11:"description";s:61:"default internal target. Used by typolink if no target is set";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:35;a:6:{s:8:"property";s:9:"extTarget";s:8:"datatype";s:6:"target";s:11:"description";s:64:"default external target. Used by typolink if no extTarget is set";s:7:"default";s:4:"_top";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:36;a:6:{s:8:"property";s:25:"spamProtectEmailAddresses";s:8:"datatype";s:32:"&quot;ascii&quot; /<br>-10 to 10";s:11:"description";s:1130:"If set, then all email addresses in typolinks will be encrypted so spam <br>bots cannot detect them.<br>&nbsp;<br>If you set this value to a number, then the encryption is simply an <br>offset of character values. If you set this value to &quot;-2&quot; then all <br>characters will have their ASCII value offset by &quot;-2&quot;. To make this <br>possible, a little JavaScript code is added to every generated web page!<br>(It is recommended to set the value in the range from -5 to 1 since setting it to &gt;= 2 means a &quot;z&quot; is converted to &quot;|&quot; which is a special character in TYPO3 tables syntax – and that might confuse columns in tables. Now hardcoded range)<br>&nbsp;<br>Alternatively you can set this value to the keyword &quot;ascii&quot;. This way every <br>character of the &quot;mailto:&quot; address will be translated to a Unicode HTML <br>notation. Have a look at the example to see how this works.<br>&nbsp;<br>Example:<br>mailto:a@b.c will be converted to<br>mailto:&amp;#97;&amp;#64;&amp;#98;&amp;#46;&amp;#99;<br>The big advantage of this method is that it doesn&#039;t need any JavaScript!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:37;a:6:{s:8:"property";s:33:"spamProtectEmailAddresses_atSubst";s:8:"datatype";s:6:"string";s:11:"description";s:37:"Substitute label for the at-sign (@).";s:7:"default";s:4:"(at)";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:38;a:6:{s:8:"property";s:38:"spamProtectEmailAddresses_lastDotSubst";s:8:"datatype";s:6:"string";s:11:"description";s:73:"Substitute label for the last dot in the email address.<br>Example: (dot)";s:7:"default";s:37:"Default: . ( &lt;= just a simple dot)";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:39;a:6:{s:8:"property";s:14:"forceTypeValue";s:8:"datatype";s:3:"int";s:11:"description";s:329:"Force the &amp;type value of all TYPO3 generated links to a specific value (except if overruled by local forceTypeValue values).<br>Useful if you run a template with special content at - say &amp;type=95 - but still wants to keep your targets neutral. Then you set your targets to blank and this value to the type value you wish.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:40;a:6:{s:8:"property";s:26:"frameReloadIfNotInFrameset";s:8:"datatype";s:7:"boolean";s:11:"description";s:375:"If set, then the current page will check if the page object name (eg. &quot;page&quot; or &quot;frameset&quot;) exists as &quot;parent.[name]&quot; (eg. &quot;parent.page&quot;) and if not the page will be reloaded in top frame. This secures that links from search engines to pages inside a frameset will load the frameset.<br>Works only with type-values different from zero.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:41;a:6:{s:8:"property";s:14:"jumpurl_enable";s:8:"datatype";s:7:"boolean";s:11:"description";s:217:"Jumpurl is a concept where external links are redirected from the index_ts.php script, which first logs which url it was. This logging of external links is only interesting if you use the internal stat-table in TYPO3.";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:42;a:6:{s:8:"property";s:22:"jumpurl_mailto_disable";s:8:"datatype";s:7:"boolean";s:11:"description";s:59:"Disables the use of jumpUrl when linking to email-adresses.";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:43;a:6:{s:8:"property";s:20:"compensateFieldWidth";s:8:"datatype";s:6:"double";s:11:"description";s:574:"this floating point value will be used by the FORMS cObject to compensate the length of the formfields text and input.<br>This feature is useful, if the page-option &quot;smallFormFields&quot; is set. In that case Netscape renders formfields much longer than IE. If you want the two browsers to display the same size formfields, use a value of approx &quot;0.6&quot; for netscape-browsers.<br>&nbsp;<b><br>Example:</b><br>[browser = netscape]<br>&nbsp;&nbsp;&nbsp;config.compensateFieldWidth = 0.6<br>[global]<br>&nbsp;<br>This option may be overridden in the FORMS-cObject.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:44;a:6:{s:8:"property";s:14:"includeLibrary";s:8:"datatype";s:8:"resource";s:11:"description";s:24:"This includes a phpfile.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:45;a:6:{s:8:"property";s:18:"incT3Lib_htmlmail ";s:8:"datatype";s:7:"boolean";s:11:"description";s:38:"Include t3lib/class.t3lib_htmlmail.php";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:46;a:6:{s:8:"property";s:12:"lockFilePath";s:8:"datatype";s:6:"string";s:11:"description";s:105:"This is used to lock paths to be &quot;inside&quot; this path.<br>Used by &quot;filelist&quot; in stdWrap";s:7:"default";s:10:"fileadmin/";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:47;a:6:{s:8:"property";s:9:"noScaleUp";s:8:"datatype";s:7:"boolean";s:11:"description";s:356:"Normally images are scaled to the size specified via TypoScript. This also forces small images to be scaled to a larger size. This is not always a good thing. <br>If this property is set, images are <b>not</b> allowed to be scaled up in size. This parameter clears the $this-&gt;mayScaleUp var of the class t3lib_stdgraphics (often &quot;gifbuilder&quot;).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:48;a:6:{s:8:"property";s:19:"USERNAME_substToken";s:8:"datatype";s:6:"string";s:11:"description";s:169:"The is the token used on the page, which should be substituted with the current username IF a front-end user is logged in! If no login, the substitution will not happen.";s:7:"default";s:27:"&lt;!--###USERNAME###--&gt;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:49;a:6:{s:8:"property";s:18:"USERUID_substToken";s:8:"datatype";s:6:"string";s:11:"description";s:292:"The is the token used on the page, which should be substituted with the current users UID IF a front-end user is logged in! If no login, the substitution will not happen.<br>This value has no default value and only if you specify a value for this token will a substitution process take place.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:50;a:6:{s:8:"property";s:12:"cache_period";s:8:"datatype";s:12:"int, seconds";s:11:"description";s:182:"The number of second a page may remain in cache.<br>This value is overridden by the value set in the page-record (field=&quot;cache_timeout&quot;) if this value is greater than zero.";s:7:"default";s:12:"86400 (=24H)";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:51;a:6:{s:8:"property";s:21:"cache_clearAtMidnight";s:8:"datatype";s:7:"boolean";s:11:"description";s:99:"With this setting the cache always expires at midnight of the day, the page is scheduled to expire.";s:7:"default";s:5:"false";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:52;a:6:{s:8:"property";s:8:"no_cache";s:8:"datatype";s:7:"boolean";s:11:"description";s:147:"If this is set to true, the page will not be cached. If set to false, it&#039;s ignored. Other parameters may have set it to true of other reasons.";s:7:"default";s:1:"-";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:53;a:6:{s:8:"property";s:20:"disableAllHeaderCode";s:8:"datatype";s:7:"boolean";s:11:"description";s:404:"If this is set, none of the features of the PAGE-object is processed and the content of the page will be the result of the cObject array (1,2,3,4...) of the PAGE-object. This means that the result of the cObject should include everything from the &lt;HTML&gt; .... to the &lt;/HTML&gt; tag !!<br>Use this feature in templates supplying other content-types than HTML. That could be an image or a WAP-page!";s:7:"default";s:5:"false";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:54;a:6:{s:8:"property";s:17:"additionalHeaders";s:8:"datatype";s:32:"strings divided by &quot;|&quot;";s:11:"description";s:519:"This is additional headers. You separate each header by a vertical line &quot;|&quot;. Normally TYPO3 does <i>not</i> send any headers with the Header()-function in PHP.<br>&nbsp;<b><br>Examples:</b><br>Content-type: text/vnd.wap.wml<br>(this will sent a content-header for a WAP-site)<br>&nbsp;<br>Content-type: image/gif | Expires: Mon, 26 Jul 1997 05:00:00 GMT<br>(this will sent a content-header for a GIF-file and a Expires header)<br>&nbsp;<br>Location: www.typo3.com<br>(This redirects the page to www.typo3.com)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:55;a:6:{s:8:"property";s:22:"disablePageExternalUrl";s:8:"datatype";s:7:"boolean";s:11:"description";s:152:"If set, pages with doktype &quot;External Url&quot; will not trigger jumpUrl in TSFE. This may help you to have external urls open inside you framesets.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:56;a:6:{s:8:"property";s:4:"stat";s:8:"datatype";s:7:"boolean";s:11:"description";s:27:"Enable stat logging at all.";s:7:"default";s:4:"true";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:57;a:6:{s:8:"property";s:16:"stat_typeNumList";s:8:"datatype";s:8:"int/list";s:11:"description";s:281:"List of pagetypes that should be registered in the statistics table, sys_stat.<br>If no types are listed, all types are logged.<br>Default is &quot;0,1&quot; which normally logs all hits on framesets and hits on content keeping pages. Of course this depends on the template design.";s:7:"default";s:3:"0,1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:58;a:6:{s:8:"property";s:22:"stat_excludeBEuserHits";s:8:"datatype";s:7:"boolean";s:11:"description";s:65:"If set a pagehit is not logged if a user is logged in into TYPO3.";s:7:"default";s:5:"false";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:59;a:6:{s:8:"property";s:18:"stat_excludeIPList";s:8:"datatype";s:15:"list of strings";s:11:"description";s:126:"If the REMOTE_ADDR is in the list of IP-addresses, it&#039;s also not logged.<br>Can use wildcard, eg. &quot;192.168.1.*&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:60;a:6:{s:8:"property";s:10:"stat_mysql";s:8:"datatype";s:7:"boolean";s:11:"description";s:43:"Enable logging to the MySQL table sys_stat.";s:7:"default";s:5:"false";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:61;a:6:{s:8:"property";s:11:"stat_apache";s:8:"datatype";s:7:"boolean";s:11:"description";s:61:"Enable logging to the logfile &quot;stat_apache_logfile&quot;";s:7:"default";s:5:"false";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:62;a:6:{s:8:"property";s:19:"stat_apache_logfile";s:8:"datatype";s:8:"filename";s:11:"description";s:508:"This the filename of the logfile in the directory $TYPO3_CONF_VARS[&quot;FE&quot;][&quot;logfile_dir&quot;] (localconf) on the server where TYPO3 writes to the apachelogfile. The directory defined by $TYPO3_CONF_VARS[&quot;FE&quot;][&quot;logfile_dir&quot;] must exist and be writable. It can be relative (to PATH_site) or absolute, but in any case it must be within the regular allowed paths of TYPO3 (meaning for absolute paths that it must be within the &quot;lockRootDir&quot; set up in TYPO3_CONF_VARS).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:63;a:6:{s:8:"property";s:21:"stat_apache_pagenames";s:8:"datatype";s:6:"string";s:11:"description";s:306:"The &quot;pagename&quot; simulated for apache.<br>Default: &nbsp;&nbsp;&nbsp;&quot;[path][title]--[uid].html&quot;<br>Codes:<br>[title] = inserts title, no special characters and shortend to 30 chars.<br>[uid] = the id<br>[alias] = any alias<br>[type] = the type (typeNum)<br>[path] = the path of the page.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:64;a:6:{s:8:"property";s:23:"stat_apache_notExtended";s:8:"datatype";s:7:"boolean";s:11:"description";s:60:"If true the logfile is NOT written in Apache extended format";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:65;a:6:{s:8:"property";s:18:"stat_apache_noHost";s:8:"datatype";s:7:"boolean";s:11:"description";s:80:"If true the HTTP_HOST is - if available - NOT inserted instead of the IP-address";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:66;a:6:{s:8:"property";s:21:"stat_apache_niceTitle";s:8:"datatype";s:7:"boolean";s:11:"description";s:274:"If set, the URL will be transliterated from the renderCharset to ASCII (eg ä =&gt; ae, à =&gt; a, &amp;#945; &quot;alpha&quot; =&gt; a), which yields nice and readabe page titles in the log. All non-ASCII characters that cannot be converted will be changed to underscores.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:67;a:6:{s:8:"property";s:18:"stat_apache_noRoot";s:8:"datatype";s:7:"boolean";s:11:"description";s:185:"If set, the root part (level 0) of the path will be removed from the path. This makes a shorter name in case you have only a redundant part like &quot;home&quot; or &quot;my site&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:68;a:6:{s:8:"property";s:13:"stat_titleLen";s:8:"datatype";s:9:"int 1-100";s:11:"description";s:68:"The lenght of the page names in the path written to logfile/database";s:7:"default";s:2:"20";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:69;a:6:{s:8:"property";s:23:"simulateStaticDocuments";s:8:"datatype";s:19:"boolean /<br>string";s:11:"description";s:1429:"If set TYPO3 makes all links in another way than usual. This can be used with <b>Apache compiled with mod_rewrite and configured in httpd.conf for use of this in the &quot;.htaccess&quot;-files.</b><br>Include this in the .htaccess file<br>&nbsp;RewriteEngine On<br>&nbsp;RewriteRule &nbsp;&nbsp;^[^/]*.html$ index.php<br>&nbsp;<br>This means that any &quot;*.html&quot;-documents should be handled by index.php. <br>Now if is done, TYPO3 will interprete the url of the html-document like this:<br>&nbsp;[title].[id].[type].html<br>Title is optional and only usefull for the entries in the apache log-files. You may omit both [title] and [type] but if title is present, type must also be there!. <br>&nbsp;<b><br>Example:</b><br>TYPO3 will interprete this as page with uid=23 and type=1 :<br>&nbsp;Startpage.23.1.html<br>&nbsp;<br>TYPO3 will interprete this as the page with alias = &quot;start&quot; and the type is zero (default):<br>&nbsp;start.html<b><br>&nbsp;</b><b><br>Alternative option (PATH_INFO):</b><br>Instead of using the rewrite-module in apache (eg. if you&#039;re running Windows!) you can use the PATH_INFO variable from PHP.<br>It&#039;s very simple. Just set simulateStaticDocuments to &quot;PATH_INFO&quot; and you&#039;re up and running!<br>&nbsp;<br>&nbsp;<b>Also:</b> See below, .absRefPrefix<br>&nbsp;<b><br>Example (put in Setup-field of your template):</b><br>config.simulateStaticDocuments = PATH_INFO";s:7:"default";s:261:"default is defined by a configuration option in localconf.php. It&#039;s <br>$TYPO3_CONF_VARS[&quot;FE&quot;][&quot;simulateStaticDocuments&quot;] = 1;<br>This affects all sites in the database.<br>You can also set this value to the string &quot;PATH_INFO&quot;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:70;a:6:{s:8:"property";s:32:"simulateStaticDocuments_addTitle";s:8:"datatype";s:3:"int";s:11:"description";s:252:"If not zero, TYPO3 generates urls with the title in, limited to the first [simulateStaticDocuments_addTitle] number of chars.<br>&nbsp;<b><br>Example:</b><br>&nbsp;Startpage.23.1.html<br>instead of the default, &quot;23.1.html&quot;, without the title.";s:7:"default";s:16:"&nbsp;<br>&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:71;a:6:{s:8:"property";s:39:"simulateStaticDocuments_noTypeIfNoTitle";s:8:"datatype";s:7:"boolean";s:11:"description";s:420:"If set, then the type-value will not be set in the simulated filename if the type value is zero anyways. However the filename must be without a title. <br>&nbsp;<b><br>Example:</b><br>&quot;Startpage.23.0.html&quot; would <i>still </i>be &quot;Startpage.23.0.html&quot;<br>&quot;23.0.html&quot; would be &quot;23.html&quot; (that is without the zero)<br>&quot;23.1.html&quot; would <i>still</i> be &quot;23.1.html&quot; ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:72;a:6:{s:8:"property";s:39:"simulateStaticDocuments_replacementChar";s:8:"datatype";s:6:"string";s:11:"description";s:381:"Word separator for URLs generated by simulateStaticDocuments. If set to<br>hyphen, this option allows search engines to index keywords in URLs. Before TYPO3 4.0 this character was hard-coded to underscore.<br>&nbsp;<br>Depends on the compatibility mode (see Tools&gt;Install&gt;Update wizard):<br>&nbsp;&nbsp;&nbsp;underscore &quot;_&quot;<br>&nbsp;&nbsp;&nbsp;hyphen &quot;-&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:73;a:6:{s:8:"property";s:49:"simulateStaticDocuments_dontRedirectPathInfoError";s:8:"datatype";s:7:"boolean";s:11:"description";s:312:"Regarding PATH_INFO mode:<br>When a page is requested by &quot;PATH_INFO&quot; method it must be configured in order to work properly. If PATH_INFO is not configured, the index_ts.php script sends a location header to the correct page. However if you better like an error message outputted, just set this option.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:74;a:6:{s:8:"property";s:28:"simulateStaticDocuments_pEnc";s:8:"datatype";s:6:"string";s:11:"description";s:2178:"Allows you to also encode additional parameters into the simulated filename. <br>&nbsp;<b><br>Example: </b><br>You have a news-plugin. The main page has the url &quot;Page_1.228.0.html&quot; but when one clicks on a news item the url will be &quot;Page_1.228.0.html?&amp;tx_mininews_pi1[showUid]=2&amp;cHash=b8d239c224&quot; instead.<br>Now, this URL will not be indexed by external search-engines because of the query-string (everything after the &quot;?&quot; mark). This property avoids this problem by encoding the parameters. These are the options:<br>&nbsp;<b><br>Value set to &quot;base64&quot;:</b><br>This will transform the filename used to this value: &quot;Page_1.228+B6JnR4X21pbmluZXdzX3BpMVtzaG93VWlkXT0yJmNIYXNoPWI4ZDIzOWMyMjQ_.0.html&quot;. The querystring has simply been base64-encoded (and some more...) and added to the HTML-filename (so now external search-engines will find this!). The really great thing about this that the filename is self-reliant because the filename contains the parameters. The downside to it is the very very long filename.<br>&nbsp;<b><br>Value set to &quot;md5&quot;:</b><br>This will transform the filename used to this value:<br>&quot;Page_1.228+M57867201f4a.0.html&quot;. Now, what a lovely, short filename! Now all the parameters has been hashed into a 10-char string inserted into the filename. At the same time an entry has been added to a cache table in the database so when a request for this filename reaches the frontend, then the REAL parameter string is found in the database! The really great thing about this is that the filename is very short (opposite to the base64-method). The downside to this is that IF you clear the database cache table at any time, the URL here does NOT work until a page with the link has been generated again (re-inserting the parameter list into the database).<br>&nbsp;<br>&nbsp;<b>NOTICE:</b> From TYPO3 3.6.0 the encoding will work only on parameters that are manually entered in the list set by .simulateStaticDocuments_pEnc_onlyP (see right below) or those parameters that various plugins might allow in addition. This is to limit the run-away risk when many parameters gets combined.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:75;a:6:{s:8:"property";s:34:"simulateStaticDocuments_pEnc_onlyP";s:8:"datatype";s:6:"string";s:11:"description";s:561:"A list of variables that may be a part of the md5/base64 encoded part of a simulate_static_document virtual filename (see property in the row above).<br>&nbsp;<b><br>Example:</b><br>simulateStaticDocuments_pEnc_onlyP = tx_maillisttofaq_pi1[pointer], L, print<br>&nbsp;<br>-&gt; this will allow the &quot;pointer&quot; parameter for the extension &quot;maillisttofaq&quot; to be included (in addition to whatever vars the extension sets itself) and further the parameter &quot;L&quot; (could be language selection) and &quot;print&quot; (could be print-version).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:76;a:6:{s:8:"property";s:35:"content_from_pid_allowOutsideDomain";s:8:"datatype";s:7:"boolean";s:11:"description";s:204:"Using the &quot;Show content from this page instead&quot; feature allows you to insert content from the current domain only. Setting this option will allow content included from anywhere in the page tree!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:77;a:6:{s:8:"property";s:12:"absRefPrefix";s:8:"datatype";s:6:"string";s:11:"description";s:682:"If this value is set, then all relative links in TypoScript are prepended with this string. Used to convert relative paths to absolute paths.<b><br>&nbsp;</b><br>&nbsp;<b>Note:</b> This values is automatically set to the dirname of the index.php script in case simulateStaticDocuments is set to &quot;PATH_INFO&quot;.<br>If you&#039;re working on a server where you have both internal and external access, you might to yourself a favour and set the absRefPrefix to the url and path of you site, eg. http://www.typo3.com/. If you do not, you risk to render pages to cache from the internal network and thereby prefix image-references and links with a non-accesible path from outside.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:78;a:6:{s:8:"property";s:11:"noPageTitle";s:8:"datatype";s:7:"integer";s:11:"description";s:321:"If you only want to have the sitename (from the template record) in your &lt;title&gt; tag, set this to 1. If the value is 2 then the &lt;title&gt; tag is not printed at all.<br>Please take note that this tag is required for XHTML compliant output, so you should only disable this tag if you generate it manually already.";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:79;a:6:{s:8:"property";s:14:"pageTitleFirst";s:8:"datatype";s:7:"boolean";s:11:"description";s:101:"If set (and the page title is printed) then the page-title will be printed BEFORE the template title.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:80;a:6:{s:8:"property";s:17:"titleTagFunction ";s:8:"datatype";s:13:"function-name";s:11:"description";s:106:"Passes the default &lt;title&gt;-tag content to this function. No typoScript parameters are passed though.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:81;a:6:{s:8:"property";s:14:"headerComment ";s:8:"datatype";s:6:"string";s:11:"description";s:203:"The content is added before the &quot;TYPO3 Content Management Framework&quot; comment in the &lt;head&gt; section of the page. Use this to insert a note like that &quot;Programmed by My-Agency&quot; ...";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:82;a:6:{s:8:"property";s:8:"language";s:8:"datatype";s:6:"string";s:11:"description";s:897:"Language key. See stdWrap.lang for more information.<br>Select between:<br>English (default) = [empty]<br>Danish = dk<br>German = de<br>Norwegian = no<br>Italian = it<br>etc... <br>&nbsp;<br>Value must correspond with the key used for backend system language if there is one. See inside config_default.php or look at the translation page on TYPO3.org for the official 2-byte key for a given language. Notice that selecting the official key is important if you want labels in the correct language from &quot;locallang&quot; files.<br>If the language you need is not yet a system language in TYPO3 you can use an artificial string of your choice and provide values for it via the TypoScript template where the property &quot;_LOCAL_LANG&quot; for most plugins will provide a way to override/add values for labels. The keys to use must be looked up in the locallang-file used by the plugin of course.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:83;a:6:{s:8:"property";s:12:"language_alt";s:8:"datatype";s:6:"string";s:11:"description";s:468:"If &quot;config.language&quot; (above) is used, this can be set to another language key which will be used for labels if a label was not found for the main language. For instance a brazil portuguese website might specify &quot;pt&quot; as alternative language which means the portuguese label will be shown if none was available in the main language, brazil portuguese. This feature makes sense if one language is incompletely translated and close to another language.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:84;a:6:{s:8:"property";s:16:"sys_language_uid";s:8:"datatype";s:3:"int";s:11:"description";s:502:"This value points to the uid of a record from the &quot;sys_language&quot; table and if set, this means that various parts of the frontend display code will select records which are assigned to this language. See -&gt;SELECT<br>&nbsp;<br>Internally, the value is depending on whether a Alternative Page Language record can be found with that language. If not, the value will default to zero (default language) except if &quot;sys_language_mode&quot; is set to a value like &quot;content_fallback&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:85;a:6:{s:8:"property";s:17:"sys_language_mode";s:8:"datatype";s:6:"string";s:11:"description";s:1357:"Setting various modes of handling localization.<br>The syntax is &quot;[keyword] ; [value]&quot;.<br>&nbsp;<br>Possible keywords are:<br>&nbsp;<br>[default] - The system will look for a translation of the page (from &quot;Alternative Page Language&quot; table) and if it is not found it will fall back to the default language and display that.<b><br>&nbsp;</b><br>&nbsp;<b>content_fallback</b> - [ Recommended ] The system will always operate with the selected language even if the page is not translated with a page overlay record. This will keep menus etc. translated. However, the <i>content</i> on the page can still fall back to another language, defined by the value of this keyword, eg. &quot;content_fallback ; 1,0&quot; to fall back to the content of sys_language_uid 1 and if that is not present either, to default (0)<br>&nbsp;<br>&nbsp;<b>strict</b> - The system will report an error if the requested translation does not exist. Basically this means that all pages with gray background in the Web&gt;Info / Localization overview module will fail (they would otherwise fall back to default language in one or another way)<br>&nbsp;<br>&nbsp;<b>ignore</b> - The system will stay with the selected language even if the page is not translated and there&#039;s no content available in this language, so you can handle that situation on your own then.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:86;a:6:{s:8:"property";s:20:"sys_language_overlay";s:8:"datatype";s:17:"boolean / keyword";s:11:"description";s:1191:"If set, records from certain tables selected by the CONTENT cObject using the &quot;languageField&quot; setting will select the default language (0) instead of any language set by sys_language_uid / sys_language_mode. In addition the system will look for a translation of the selected record and overlay configured fields.<br>The requirements for this is that the table is configured with &quot;languageField&quot; and &quot;transOrigPointerField&quot; in the [ctrl] section of $TCA. Also, exclusion of certain fields can be done with the &quot;l10n_mode&quot; directive in the field-configuration of $TCA.<br>&nbsp;<br>For backend administration this requires that you configure the &quot;Web&gt;Page&quot; module to display content elements accordingly; That each default element is shown and next to it any translation found. This configuration can be done with Page TSconfig for a section of the website using the object path &quot;mod.web_layout.defLangBinding = 1&quot;.<br>&nbsp;<br>Keyword: <b><br>hideNonTranslated : If this keyword is used a record that has no translation will not be shown. The default is that records with no translation will show up in the default language.</b>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:87;a:6:{s:8:"property";s:32:"sys_language_softMergeIfNotBlank";s:8:"datatype";s:6:"string";s:11:"description";s:1313:"Setting additional &quot;mergeIfNotBlank&quot; fields from TypoScript.<br>&nbsp;<br>Background:<br>In TCA you can configure &quot;l10n_mode&quot; - localization mode - for each field. Two of the options affect how the frontend displays content; The values &quot;exclude&quot; and &quot;mergeIfNotBlank&quot; (see &quot;TYPO3 Core API&quot; document for details). The first (&quot;exclude&quot;) simply means that the field when found in a translation of a record will not be overlaid the default records field value. The second (&quot;mergeIfNotBlank&quot;) means that it will be overlaid <i>only</i> if it has a non-blank value.<br>Since it might be practical to set up fields for &quot;mergeIfNotBlank&quot; on a per-site basis this options allows you to override additional fields from tables.<br>&nbsp;<b><br>Syntax:</b><br>&nbsp;[table]:[field], [table]:[field], [table]:[field], ...<br>&nbsp;<b><br>Example:</b><br>config.sys_language_softMergeIfNotBlank = tt_content:image , tt_content:header<br>&nbsp;<br>This setting means that the header and image field of content elements will be used from the translation only if they had a non-blank value. For the image field this might be very practical because it means that the image(s) from the default translation will be used unless other images are inserted!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:88;a:6:{s:8:"property";s:21:"typolinkCheckRootline";s:8:"datatype";s:7:"boolean";s:11:"description";s:410:"If set, then every &quot;typolink&quot; is checked whether it&#039;s linking to a page within the current rootline of the site.<br>If not, then TYPO3 searches for the first found domain record (without redirect) in that rootline from out to in. <br>If found (another domain), then that domain is prepended the link, the external target is used instead and thus the link jumps to the page in the correct domain.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:89;a:6:{s:8:"property";s:33:"typolinkLinkAccessRestrictedPages";s:8:"datatype";s:44:"integer (page id) / keyword &quot;NONE&quot;";s:11:"description";s:908:"If set, typolinks pointing to access restricted pages will still link to the page even though the page cannot be accessed. If the value of this setting is an integer it will be interpreted as a page id to which the link will be directed. <br>If the value is &quot;NONE&quot; the original link to the page will be kept although it will generate a page-not-found situation (which can of course be picked up properly by the page-not-found handler and present a nice login form).<br>&nbsp;<br>See &quot;showAccessRestrictedPages&quot; for menu objects as well (similar feature for menus)<br>&nbsp;<b><br>Example:</b><br>config.typolinkLinkAccessRestrictedPages = 29<br>config.typolinkLinkAccessRestrictedPages_addParams = &amp;return_url=###RETURN_URL###&amp;pageId=###PAGE_ID###<br>&nbsp;<br>Will create a link to page with id 29 and add GET parameters where the return URL and original page id is a part of it.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:90;a:6:{s:8:"property";s:43:"typolinkLinkAccessRestrictedPages_addParams";s:8:"datatype";s:6:"string";s:11:"description";s:55:"See &quot;typolinkLinkAccessRestrictedPages&quot; above";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:91;a:6:{s:8:"property";s:23:"insertDmailerBoundaries";s:8:"datatype";s:7:"boolean";s:11:"description";s:238:"If set, boundary marks will be set around all records inserted on the page with cObjects CONTENT and RECORD. They are inserted as HTML-comments and do no harm.<br>Used by the Direct Mail module in TYPO3 to segmentize a page by categories.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:92;a:6:{s:8:"property";s:26:"notification_email_urlmode";s:8:"datatype";s:6:"string";s:11:"description";s:615:"This option allows you to handle URL&#039;s in plain text emails so long URLS of more than 76 chars are not broken. This option can be either empty or &quot;76&quot; or &quot;all&quot;. <br>If the string is blank, all links in plaintext emails are untouched. <br>If it&#039;s set to 76 then all links longer then 76 characters are stored in the database and a hash is sent in the GET-var ?RDCT=[md5/20] to the index.php script which finds the proper link in the database and issues a location header (redirection). <br>If the value is &quot;all&quot; then ALL &quot;http://&quot; links in the message are converted.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:93;a:6:{s:8:"property";s:27:"notification_email_encoding";s:8:"datatype";s:6:"string";s:11:"description";s:285:"This sets the encoding of plaintext emails (notification messages). The default encoding is &quot;quoted-printable&quot;. But setting this to eg. &quot;base64&quot; will encode the content with base64 encoding.<br>&nbsp;<b><br>Values possible:</b><br>base64<br>quoted-printable<br>8bit";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:94;a:6:{s:8:"property";s:26:"notification_email_charset";s:8:"datatype";s:6:"string";s:11:"description";s:47:"Alternative charset for the notification mails.";s:7:"default";s:10:"ISO-8859-1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:95;a:6:{s:8:"property";s:8:"admPanel";s:8:"datatype";s:34:"boolean / -&gt;ADMPANEL properties";s:11:"description";s:261:"If set, the admin panel appears in the bottom of pages.<br>&nbsp;<br>&nbsp;<b>NOTE:</b> In addition the panel must be enabled for the user as well, using the TSconfig for the user! See adminguide documentation.<br>&nbsp;<br>&nbsp;<b>SEE:</b> Admin Panel section";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:96;a:6:{s:8:"property";s:17:"beLoginLinkIPList";s:8:"datatype";s:11:"[IP-number]";s:11:"description";s:315:"If set and REMOTE_ADDR matches one of the listed IP-numbers (Wild-card, *, allowed) then a link to the typo3/ login scrip with redirect pointing back to the page is shown.<br>&nbsp;<br>&nbsp;<b>NOTE:</b> beLoginLinkIPList_login and/or beLoginLinkIPList_logout (see below) must be defined if the link should show up!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:97;a:6:{s:8:"property";s:23:"beLoginLinkIPList_login";s:8:"datatype";s:4:"HTML";s:11:"description";s:140:"HTML code wrapped with the login link, see &#039;beLoginLinkIPList&#039;<br>&nbsp;<b><br>Example:</b><br>&lt;HR&gt;&lt;B&gt;LOGING&lt;/B&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:98;a:6:{s:8:"property";s:24:"beLoginLinkIPList_logout";s:8:"datatype";s:4:"HTML";s:11:"description";s:49:"HTML code wrapped with the logout link, see above";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:99;a:6:{s:8:"property";s:12:"index_enable";s:8:"datatype";s:7:"boolean";s:11:"description";s:35:"Enables cached pages to be indexed.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:100;a:6:{s:8:"property";s:15:"index_externals";s:8:"datatype";s:7:"boolean";s:11:"description";s:65:"If set, external media linked to on the pages is indexed as well.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:101;a:6:{s:8:"property";s:14:"index_descrLgd";s:8:"datatype";s:3:"int";s:11:"description";s:124:"This indicates how many chars to preserve as description for an indexed page. This may be used in the search result display.";s:7:"default";s:3:"200";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:102;a:6:{s:8:"property";s:14:"xhtml_cleaning";s:8:"datatype";s:6:"string";s:11:"description";s:1764:"Tries to clean up the output to make it XHTML compliant and a bit more. THIS IS NOT COMPLETE YET, but a &quot;pilot&quot; to see if it makes sense anyways. For now this is what is done:<br>&nbsp;<b><br>What it does at this point:</b><br>- All tags (img,br,hr) is ended with &quot;/&gt;&quot; - others?<br>- Lowercase for elements and attributes<br>- All attributes in quotes<br>- Add &quot;alt&quot; attribute to img-tags if it&#039;s not there already.<br>&nbsp;<b><br>What it does NOT do (yet) according to XHTML specs.:</b><br>- Wellformedness: Nesting is NOT checked<br>- name/id attribute issue is not observed at this point.<br>- Certain nesting of elements not allowed. Most interesting, &lt;PRE&gt; cannot contain img, big,small,sub,sup ...<br>- Wrapping scripts and style element contents in CDATA - or alternatively they should have entitites converted.<br>- Setting charsets may put some special requirements on both XML declaration/ meta-http-equiv. (C.9)<br>- UTF-8 encoding is in fact expected by XML!!<br>- stylesheet element and attribute names are NOT converted to lowercase<br>- ampersands (and entities in general I think) MUST be converted to an entity reference! (&amp;amps;). This may mean further conversion of non-tag content before output to page. May be related to the charset issue as a whole.<br>- Minimized values not allowed: Must do this: selected=&quot;selected&quot;<br>&nbsp;<br>Please see the class t3lib_parsehtml for details.<br>You can enable this function by the following values:<br>&nbsp;<br>&nbsp;<b>all</b> = the content is always processed before it may be stored in cache. <br>&nbsp;<b>cached</b> = only if the page is put into the cache, <br>&nbsp;<b>output</b> = only the output code just before it&#039;s echoed out.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:103;a:6:{s:8:"property";s:18:"prefixLocalAnchors";s:8:"datatype";s:14:"string keyword";s:11:"description";s:475:"If set to one of the keywords, the content will have all local anchors in links prefixed with the path of the script. Basically this means that &lt;a href=&quot;#&quot;&gt; will be transformed to &lt;a href=&quot;path/path/script?params#&quot;&gt;. This procedure is necessary if the &lt;base&gt; tag is set in the script (eg. if &quot;realurl&quot; extension is used to produce Speaking URLs).<br>&nbsp;<br>Keywords are the same as for &quot;xhtml_cleaning&quot;, see above.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:104;a:6:{s:8:"property";s:20:"disablePrefixComment";s:8:"datatype";s:7:"boolean";s:11:"description";s:155:"If set, the stdWrap property &quot;prefixComment&quot; will be disabled, thus preventing any revealing and spaceconsuming comments in the HTML source code.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:105;a:6:{s:8:"property";s:7:"baseURL";s:8:"datatype";s:6:"string";s:11:"description";s:192:"This writes the &lt;base&gt; tag in the header of the document. Set this to the value that is expected to be the URL.<br>&nbsp;<b><br>Example:</b><br>config.baseURL = http://typo3.org/sub_dir/";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:106;a:6:{s:8:"property";s:42:"tx_[extension key with no underscores]_[*]";s:8:"datatype";s:1:"-";s:11:"description";s:31:"Configuration space for plugins";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('44', '', '61a507730523bd733941819140f8811b', '', 'tsref:constants', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:15:"<i>Array...</i>";s:8:"datatype";s:13:"<i>string</i>";s:11:"description";s:232:"Constants. <br>&nbsp;<b><br>Examples:</b><br>.EMAIL = <i>email@email.com</i><br>Now if parseFunc anywhere is configured with constants=1 then all cases of the string ###EMAIL### will be substituted in the text.<br>see -&gt;parseFunc";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('45', '', '7032add39bae490a73f4ce839844c001', '', 'tsref:(page)', 'a:1:{s:4:"rows";a:27:{i:0;a:6:{s:8:"property";s:7:"typeNum";s:8:"datatype";s:17:"<i>typeNumber</i>";s:11:"description";s:221:"This decides the the typeId of the page. The value defaults to 0 for the first <br>found PAGE object, but it MUST be set and be unique as soon you use more than one such object (watch this if you use frames on your page)!";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:10:"1,2,3,4...";s:8:"datatype";s:7:"cObject";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:42:"Wraps the content of the the cObject array";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:63:"Wraps the content of the the cObject array with stdWrap options";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:14:"bodyTagCObject";s:8:"datatype";s:7:"cObject";s:11:"description";s:74:"This is default bodytag overridden by &quot;.bodyTag&quot; if that is set.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:7:"bodyTag";s:8:"datatype";s:11:"&lt;tag&gt;";s:11:"description";s:93:"Bodytag on the page<br>&nbsp;<b><br>Example:</b><br>&lt;body bgcolor=&quot;{$bgCol}&quot;&gt;";s:7:"default";s:40:"&lt;body bgcolor=&quot;#FFFFFF&quot;&gt;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:7:"headTag";s:8:"datatype";s:11:"&lt;tag&gt;";s:11:"description";s:35:"Head-tag if alternatives are wanted";s:7:"default";s:12:"&lt;head&gt;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:14:"bodyTagMargins";s:8:"datatype";s:3:"int";s:11:"description";s:369:"margins in the bodytag. <br>&nbsp;<b><br>Property:</b><br>.useCSS = 1 (boolean) - will set a &quot;BODY {margin: ...}&quot; line in the in-document style declaration - for XHTML compliance.<br>&nbsp;<b><br>Example:</b><br>value <i>4</i><br>adds <i>leftmargin=&quot;4&quot; topmargin=&quot;4&quot; marginwidth=&quot;4&quot; marginheight=&quot;4&quot;</i> to the bodyTag.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:10:"bodyTagAdd";s:8:"datatype";s:6:"string";s:11:"description";s:48:"This content is added to the end of the bodyTag.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:5:"bgImg";s:8:"datatype";s:11:"imgResource";s:11:"description";s:74:"Background image on the page. This is automatically added to the body-tag.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:8:"frameSet";s:8:"datatype";s:13:"-&gt;FRAMESET";s:11:"description";s:76:"if any properties is set to this property, the page is made into a frameset.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:4:"meta";s:8:"datatype";s:9:"-&gt;META";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:12:"shortcutIcon";s:8:"datatype";s:8:"resource";s:11:"description";s:339:"Favicon of the page. Create a reference to an icon here!<br>Browsers that support favicons display them in the browser&#039;s address bar, next to the site&#039;s name in lists of bookmarks, and next to the page&#039;s title in a Tabbed Document Interface.<br>&nbsp;<b><br>Note:</b><br>This must be a valid &quot;.ico&quot;-file (iconfile)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:10:"headerData";s:8:"datatype";s:11:"-&gt;CARRAY";s:11:"description";s:149:"Inserts content in the header-section. Could be JavaScripts, meta-tags, other stylesheet references. <br>Is inserted after all the style-definitions.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:6:"config";s:8:"datatype";s:11:"-&gt;CONFIG";s:11:"description";s:108:"configuration for the page. Any entries override the same entries in the toplevel-object &quot;config&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:17:"includeJS.[array]";s:8:"datatype";s:8:"resource";s:11:"description";s:537:"Inserts one or more (Java)Scripts in &lt;script&gt; tags.<br>&nbsp;<br>The file definition must be a valid &quot;resource&quot; datatype, otherwise nothing is inserted.<br>&nbsp;<br>Each file has <i>optional properties</i>:<br>&nbsp;<b>.style</b> - setting the MIME type of the script (default: text/javascript)<br>&nbsp;<b><br>Example:</b><br>includeJS {<br>&nbsp;&nbsp;&nbsp;file1 = fileadmin/helloworld.js<br>&nbsp;&nbsp;&nbsp;file1.type = application/x-javascript<br>&nbsp;&nbsp;&nbsp;file2 = javascript_uploaded_to_template*.js<br>}";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:11:"includeLibs";s:8:"datatype";s:23:"<i>array of strings</i>";s:11:"description";s:902:"With this you may include php-files. This does the same as &quot;includeLibrary&quot; in -&gt;CONFIG but this can include more than one file. These files are included <i>after</i> the file of includeLibrary.<br>&nbsp;<b><br>NOTE:</b><br>The toplevel object &quot;includeLibs&quot; and the scripts defined with this property is added to each other. Script-keys (that is the &quot;array of strings&quot;-value, like below &quot;ts_address&quot;) from this property of the page overrides any scripts-keys from the toplevel &quot;includeLibs&quot; property!<br>The script-filenames are of the datatype &quot;resource&quot;.<br>&nbsp;<b><br>Example:</b><br>includeLibs.ts_address = lib_filename.php<br>includeLibs.ts_shop = lib_filename.php<br>&nbsp;<br>Please do not use the prefix shown above (&quot;ts_&quot;) as this will probably be used by the standard TYPO3 libraries that will appear in the future. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:40:"<b>&nbsp;</b><b><br>CSS Stylesheets:</b>";s:8:"datatype";N;s:11:"description";N;s:7:"default";N;s:12:"column_count";i:1;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:10:"stylesheet";s:8:"datatype";s:8:"resource";s:11:"description";s:139:"Inserts a stylesheet in the &lt;HEAD&gt;-section of the page;<i><br>&lt;link rel=&quot;stylesheet&quot; href=&quot;[resource]&quot;&gt;</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:18:"includeCSS.[array]";s:8:"datatype";s:8:"resource";s:11:"description";s:962:"Inserts a stylesheet (just like the .stylesheet property) by allows to setting up more than a single stylesheet, because you can enter files in an array.<br>&nbsp;<br>The file definition must be a valid &quot;resource&quot; datatype, otherwise nothing is inserted.<br>&nbsp;<br>Each file has <i>optional properties</i>:<br>&nbsp;<b>.media</b> - setting the media attribute of the &lt;style&gt; tag.<br>&nbsp;<b>.title</b> - setting the title of the &lt;style&gt; tag.<br>&nbsp;<b>.alternate</b> - If set (boolean) then the rel-attribute will be &quot;alternate stylesheet&quot;<br>&nbsp;<b>.import</b> - If set (boolean) then the @import way of including a stylesheet is used instead of &lt;link&gt;<br>&nbsp;<b><br>Example:</b><br>includeCSS {<br>&nbsp;&nbsp;&nbsp;file1 = fileadmin/mystylesheet1.css<br>&nbsp;&nbsp;&nbsp;file2 = stylesheet_uploaded_to_template*.css<br>&nbsp;&nbsp;&nbsp;file2.title = High contrast<br>&nbsp;&nbsp;&nbsp;file2.media = print<br>}";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:15:"CSS_inlineStyle";s:8:"datatype";s:6:"string";s:11:"description";s:95:"This value is just passed on as inline css (in-document css encapsulated in &lt;style&gt;-tags)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:20:"insertClassesFromRTE";s:8:"datatype";s:7:"boolean";s:11:"description";s:466:"If set, the classes for the Rich Text Editor configured in Page TSconfig is inserted in as the first thing in the Style-section right after the setting of the stylesheet.<br>&nbsp;<br>&nbsp;<b>.add_mainStyleOverrideDefs</b> = [* / list of tags ] - will add all the &quot;RTE.default. mainStyleOverride_add&quot; - tags configured as well.<br>&nbsp;<i><br>Might be deprecated soon. Most likely the RTE should be configured by the stylesheet instead. Stay tuned...</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:22;a:6:{s:8:"property";s:15:"noLinkUnderline";s:8:"datatype";s:7:"boolean";s:11:"description";s:111:"Disables link-underlining. Uses in-document stylesheet.<br>&nbsp;<i><br>Deprecated. Use stylesheet instead.</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:23;a:6:{s:8:"property";s:5:"hover";s:8:"datatype";s:10:"HTML-color";s:11:"description";s:147:"The color of a link when the mouse moves over it! (only MSIE). Uses in-document stylesheet.<br>&nbsp;<i><br>Deprecated. Use stylesheet instead.</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:24;a:6:{s:8:"property";s:10:"hoverStyle";s:8:"datatype";s:6:"string";s:11:"description";s:189:"Additional style information to the hover-color.<br>&nbsp;<b><br>Example:</b><br>page.hoverStyle = font: bold; text-decoration: none;<br>&nbsp;<i><br>Deprecated. Use stylesheet instead.</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:25;a:6:{s:8:"property";s:15:"smallFormFields";s:8:"datatype";s:7:"boolean";s:11:"description";s:396:"Renders formfields like textarea, input and select-boxes small with &quot;verdana size 1&quot; font. <br>Uses in-document stylesheet.<br>&nbsp;<b><br>Tip:</b><br>Use this together with the config-option &quot;compensateFieldWidth&quot; set to &quot;0.6&quot; for netscape-browsers in order to render the small form fields in the same width!<br>&nbsp;<i><br>Deprecated. Use stylesheet instead.</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:26;a:6:{s:8:"property";s:16:"adminPanelStyles";s:8:"datatype";s:7:"boolean";s:11:"description";s:44:"Will include CSS styles for the Admin Panel.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('46', '', 'abe1a9b50d108f34d9b6348126ca6a7b', '', 'tsref:FEData', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:26:"<i>array of tableNames</i>";s:8:"datatype";s:13:"-&gt;FE_TABLE";s:11:"description";s:13:"<b>&nbsp;</b>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('47', '', '885e0cbd1482e884cb0583019453c414', '', 'tsref:FEData.(tablename)/->FE_TABLE', 'a:1:{s:4:"rows";a:9:{i:0;a:6:{s:8:"property";s:15:"default.[field]";s:8:"datatype";s:6:"string";s:11:"description";s:446:"This property is in charge of which default-values is used for the table:<br>&nbsp;<b><br>Example:</b><br>This defines the default values used for new records. These values will be overridden with any value submitted instead (as long as the submitted fields are allowed due to &quot;allowNew&quot;)<br>default {<br>&nbsp;&nbsp;&nbsp;subject = This is the default subject value!<br>&nbsp;&nbsp;&nbsp;hidden = 1<br>&nbsp;&nbsp;&nbsp;parent = 0<br>}";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:16:"allowNew.[field]";s:8:"datatype";s:6:"string";s:11:"description";s:641:"This property is in charge of which fields that may be written from the frontend.<br>&nbsp;<b><br>Example:</b><br>This defines that subject is a field, that may be submitted from the frontend. If a value is not submitted, subject is filled with the default value (see above). <br>The field &quot;hidden&quot; on the other hand cannot be changed from the frontend. &quot;hidden&quot; will gain the value from the default definition (see above). If fields are set to &quot;0&quot; (zero) it&#039;s the same as if they were not defined in this array.<br>&nbsp;<br>allowNew {<br>&nbsp;&nbsp;&nbsp;subject = 1<br>&nbsp;&nbsp;&nbsp;hidden = 0<br>}";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:17:"allowEdit.[field]";s:8:"datatype";s:6:"string";s:11:"description";s:221:"Same as above (&quot;allowNew&quot;) but this controls which fields that may be written in case of an update of a record (and not a new submission)<br>Please pay attension to the property below! (&quot;overrideEdit&quot;)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:20:"overrideEdit.[field]";s:8:"datatype";s:6:"string";s:11:"description";s:479:"This works like default-values above but is values inserted after the submitted values has beed processed. This means that opposite to default-values overwritten by the submitted values, these values override the submitted values.<br>&nbsp;<b><br>Example:</b><br>In this case overrideEdit secures that if a user updates his record (if he &quot;own&quot; it) the &quot;hidden&quot;-field will be set no matter what.<br>&nbsp;<br>overrideEdit {<br>&nbsp;&nbsp;&nbsp;hidden = 1<br>}";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:12:"userIdColumn";s:8:"datatype";s:14:"string (field)";s:11:"description";s:197:"This is a string that points to the column of a record where the user-id of the current fe_user should be inserted. This fe_user-uid is inserted/updated both by &quot;new&quot; and &quot;edit&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:13:"autoInsertPID";s:8:"datatype";s:7:"boolean";s:11:"description";s:195:"Works with new records: Insert automatically the PID of the page, where the submitted data is sent to. Any &quot;pid&quot; supplied from the submitted data will override. This is for convenience.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:13:"processScript";s:8:"datatype";s:8:"resource";s:11:"description";s:567:"Include-script to be used for processing of incoming data to the table. The script is included from a function in the class tslib_fetce<br>This is the really important option, because whether or not you are going to utilize the &quot;cleaning&quot;/&quot;authorization&quot; features of the properties above depend on how you write your script to process data and put it in the database.<br>A very good example is to look at &quot;media/scripts/guest_submit.inc&quot;, included from static_template &quot;plugin.tt_guest&quot; (Used for the default guestbook feature)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:9:"separator";s:8:"datatype";s:6:"string";s:11:"description";s:94:"Separator character used when the submitted data is an array from eg. a multiple selector box.";s:7:"default";s:19:"chr(10) (linebreak)";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:15:"doublePostCheck";s:8:"datatype";s:18:"string (fieldname)";s:11:"description";s:340:"Specifies a fieldname (integer) into which an integer-hash compiled of the submitted data is inserted. If the field is set, then submissions are checked whether another record with this value already exists. If so, the record is NOT inserted, because it&#039;s expected to be a &quot;double post&quot; (posting the same data more than once)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('48', '', 'dfb38a4b542a66ea9ca4c51cc1e8c454', '', 'tsref:(page).frameSet/->FRAMESET', 'a:1:{s:4:"rows";a:4:{i:0;a:6:{s:8:"property";s:10:"1,2,3,4...";s:8:"datatype";s:8:"frameObj";s:11:"description";s:45:"Configuration of frames and nested framesets.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:4:"cols";s:8:"datatype";s:26:"&lt;frameset&gt;-data:cols";s:11:"description";s:4:"Cols";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:4:"rows";s:8:"datatype";s:26:"&lt;frameset&gt;-data:rows";s:11:"description";s:4:"Rows";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:6:"params";s:8:"datatype";s:23:"&lt;frameset&gt;-params";s:11:"description";s:93:"<b>Example:</b><br>border=&quot;0&quot; framespacing=&quot;0&quot; frameborder=&quot;NO&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('49', '', '88d7c4b86d5cebdad2b438b0538b48d3', '', 'tsref:(page).frameSet.(number)/->FRAMESET.(number)', 'a:1:{s:4:"rows";a:5:{i:0;a:6:{s:8:"property";s:3:"obj";s:8:"datatype";s:38:"<i>pointer to toplevel object-name</i>";s:11:"description";s:130:"toplevel object-name of a PAGE / FRAMESET<br>&nbsp;<b><br>Example:</b><br>&quot;left&quot;, &quot;page&quot;, &quot;frameset&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:7:"options";s:8:"datatype";s:21:"<i>url-parameters</i>";s:11:"description";s:199:"<b>Example:</b><br>print=1&amp;othervar=anotherthing<br>would add &#039;<i>&amp;print=1&amp;othervar=anotherthing</i>&#039; to the &quot;.src&quot;-content (if not &quot;.src&quot; is set manually!!)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:6:"params";s:8:"datatype";s:20:"&lt;frame&gt;-params";s:11:"description";s:81:"<b>Example:</b><br>scrolling=&quot;AUTO&quot; noresize frameborder=&quot;NO&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:4:"name";s:8:"datatype";s:23:"&lt;frame&gt;-data:name";s:11:"description";s:133:"Manually set name of frame<br>&nbsp;<br>&nbsp;<b>NOTE:</b> Is set automatically and should not be overridden under normal conditions!";s:7:"default";s:25:"value of &quot;.obj&quot;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:3:"src";s:8:"datatype";s:22:"&lt;frame&gt;-data:src";s:11:"description";s:140:"Manually set the src of the frame<br>&nbsp;<br>&nbsp;<b>NOTE:</b> Is set automatically and should not be overridden under normal conditions!";s:7:"default";s:33:"could be index.php?$id&amp;$type ";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('50', '', 'c123846d335b06bc44b284ee8c7a8ea0', '', 'tsref:->META', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:15:"<i>Array...</i>";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:495:"Metatags<br>If value is empty (after trimming) the metatag is not generated.<br>If the &quot;key&quot; (eg. &quot;REFRESH&quot; or &quot;DESCRIPTION&quot;) is &quot;REFRESH&quot; (caseinsensitive), then the &quot;http-equiv&quot;-attribute is used in the metatag instead of &quot;name&quot;.<br>&nbsp;<b><br>Examples:</b><br>.REFRESH = <i>[sec]; [url, leave blank for same page]</i><br>.DESCRIPTION = This is the description of the content in this document<br>.KEYWORDS = This is the keywords...";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('51', '', 'e8c6be7a5c4bf207221e5b5d5a6441a4', '', 'tsref:->CARRAY', 'a:1:{s:4:"rows";a:4:{i:0;a:6:{s:8:"property";s:10:"1,2,3,4...";s:8:"datatype";s:7:"cObject";s:11:"description";s:182:"This is a numerical &quot;array&quot; of content-objects (cObjects). The order by which you specific the objects is not important as the array will be sorted before it&#039;s parsed!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:29:"<b>Occational properties:</b>";s:8:"datatype";N;s:11:"description";N;s:7:"default";N;s:12:"column_count";i:1;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:23:"(stdWrap properties...)";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:474:"&nbsp;<b>NOTE:</b> This applies ONLY if &quot;CARRAY /stdWrap&quot; is set to be data type<br>If you specify any non-integer properties to a CARRAY, stdWrap will be invoked with all properties of the CARRAY.<br>&nbsp;<b><br>Example:</b><br>This will return &#039;&lt;B&gt;This will be rendered before &quot;10&quot;testing&lt;/B&gt;&#039;<br>10 = TEXT<br>10.value = testing<br>5 = HTML<br>5.value = This will be rendered before &quot;10&quot;<br>wrap = &lt;B&gt; |&lt;/B&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:10:"(TDParams)";s:8:"datatype";s:17:"&lt;TD&gt;-params";s:11:"description";s:217:"&nbsp;<b>NOTE:</b> This applies ONLY if &quot;CARRAY +TDParams&quot; is set to be data type<br>This property is used only in some cases where CARRAY is used. Please look out for a note about that in the various cases.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('52', '', '90abbeca518fabd3ec8944e62fd200b7', '', 'tsref:(cObject).HTML', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:5:"value";s:8:"datatype";s:13:"HTML /stdWrap";s:11:"description";s:14:"Raw HTML-code.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('53', '', '03fe46bb8628f60fec5859bf75fa5f75', '', 'tsref:(cObject).TEXT', 'a:1:{s:4:"rows";a:2:{i:0;a:6:{s:8:"property";s:5:"value";s:8:"datatype";s:5:"value";s:11:"description";s:34:"text, wrap with stdWrap properties";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:30:"<i>(stdWrap properties...)</i>";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('54', '', '571d18366e15bc9b1ce2cd4ef7da8ff5', '', 'tsref:(cObject).COA/(cObject).COA_INT/(cObject).COBJ_ARRAY', 'a:1:{s:4:"rows";a:5:{i:0;a:6:{s:8:"property";s:10:"1,2,3,4...";s:8:"datatype";s:7:"cObject";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:2:"if";s:8:"datatype";s:7:"-&gt;if";s:11:"description";s:55:"if &quot;if&quot; returns false the COA is NOT rendered";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:11:"includeLibs";s:8:"datatype";s:29:"&nbsp;<i>list of </i>resource";s:11:"description";s:380:"<b>(This property is used only if the object is COA_INT!, See introduction.)</b><br>This is a comma-separated list of resources that are included as PHP-scripts (with include_once() function) if this script is included.<br>This is possible to do because any include-files will be known before the scripts are included. That&#039;s not the case with the regular PHP_SCRIPT cObject.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('55', '', '3918801c03952a7fde07c4afd3faa80a', '', 'tsref:(cObject).FILE', 'a:1:{s:4:"rows";a:5:{i:0;a:6:{s:8:"property";s:4:"file";s:8:"datatype";s:8:"resource";s:11:"description";s:217:"If the resource is <b>jpg,gif,jpeg,png </b>the image is inserted as an image-tag. Al other formats is read and inserted into the HTML-code.<br>The maximum filesize of documents to be read is set to 1024 kb internally!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:8:"linkWrap";s:8:"datatype";s:8:"linkWrap";s:11:"description";s:26:"(before &quot;.wrap&quot;)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:20:"altText<br>titleText";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:165:"<b>For &lt;img&gt; output only!</b><br>&nbsp;<br>If no titltext is specified, it will use the alttext insteadIf no alttext is specified, it will use an empty alttext";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:11:"longdescURL";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:149:"<b>For &lt;img&gt; output only!</b><b><br>&nbsp;</b><br>&quot;longdesc&quot; attribute (URL pointing to document with extensive details about image).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('56', '', '45effe326c7d351875eb76178430f63f', '', 'tsref:(cObject).IMAGE', 'a:1:{s:4:"rows";a:10:{i:0;a:6:{s:8:"property";s:4:"file";s:8:"datatype";s:11:"imgResource";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"params";s:8:"datatype";s:18:"&lt;IMG&gt;-params";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:6:"border";s:8:"datatype";s:7:"integer";s:11:"description";s:59:"Value of the &quot;border&quot; attribute of the image tag.";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:43:"altText<br>titleText<br>&nbsp;<br>(alttext)";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:273:"If no titltext is specified, it will use the alttext insteadIf no alttext is specified, it will use an empty alttext<br>&nbsp;<br>(&quot;alttext&quot; is the old spelling of this attribute. It will be used only if &quot;altText&quot; does not specify a value or properties)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:11:"longdescURL";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:93:"&quot;longdesc&quot; attribute (URL pointing to document with extensive details about image).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:8:"linkWrap";s:8:"datatype";s:8:"linkWrap";s:11:"description";s:26:"(before &quot;.wrap&quot;)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:13:"imageLinkWrap";s:8:"datatype";s:30:"boolean/<br>-&gt;imageLinkWrap";s:11:"description";s:122:"&nbsp;<b>NOTE:</b> ONLY active if linkWrap is NOT set and file is NOT GIFBUILDER (as it works with the original imagefile)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:2:"if";s:8:"datatype";s:7:"-&gt;if";s:11:"description";s:55:"if &quot;if&quot; returns false the image is not shown!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('57', '', 'a2140130f94da8de59d956354896d9bf', '', 'tsref:(cObject).IMG_RESOURCE', 'a:1:{s:4:"rows";a:2:{i:0;a:6:{s:8:"property";s:4:"file";s:8:"datatype";s:11:"imgResource";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('58', '', '698298181be68b56fd0361e9da1a114f', '', 'tsref:(cObject).CLEARGIF', 'a:1:{s:4:"rows";a:3:{i:0;a:6:{s:8:"property";s:6:"height";s:8:"datatype";s:45:"&nbsp;<i>&lt;img&gt;-data:height</i> /stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:1:"1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:5:"width";s:8:"datatype";s:44:"&nbsp;<i>&lt;img&gt;-data:width</i> /stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:1:"1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:18:"&nbsp;| &lt;BR&gt;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('59', '', '0f2fee21aca2929d02f2ede163104d2b', '', 'tsref:(cObject).CONTENT', 'a:1:{s:4:"rows";a:6:{i:0;a:6:{s:8:"property";s:6:"select";s:8:"datatype";s:11:"-&gt;select";s:11:"description";s:30:"The SQL-statement is set here!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:5:"table";s:8:"datatype";s:16:"<i>tableName</i>";s:11:"description";s:296:"The table, the content should come from. <br>In standard-configurations this will be &quot;tt_content&quot;<br>&nbsp;<b>NOTE:</b> Only tables allowed are &quot;pages&quot; or tables prefixed with one of these: &quot;tt_&quot;, &quot;tx_&quot;, &quot;ttx_&quot;, &quot;fe_&quot;, &quot;user_&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:9:"renderObj";s:8:"datatype";s:7:"cObject";s:11:"description";s:6:"&nbsp;";s:7:"default";s:16:"&lt; [tablename]";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:5:"slide";s:8:"datatype";s:7:"integer";s:11:"description";s:985:"If set and no content element is found by the select command, then the rootLine will be traversed back until some content is found.<br>&nbsp;<br>Possible values are &quot;-1&quot; (slide back up to the siteroot), &quot;1&quot; (only the current level) and &quot;2&quot; (up from one level back).<br>&nbsp;<br>Use -1 in combination with collect.<br>&nbsp;<br>&nbsp;<b>.collect (integer)</b>: If set, all content elements found on current and parent pages will be collected. Otherwise, the sliding would stop after the first hit. Set this value to the amount of levels to collect on, or use &quot;-1&quot; to collect up to the siteroot.<br>&nbsp;<b>.collectFuzzy (boolean)</b>: Only useful in collect mode. If no content elements have been found for the specified depth in collect mode, traverse further until at least one match has occurred.<br>&nbsp;<b>.collectReverse (boolean)</b>: Change order of elements in collect mode. If set, elements of the current page will be on the bottom.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:31:"Wrap the whole content-story...";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('60', '', 'fda9a1413332096fac6ed5a6f0f8ce90', '', 'tsref:(cObject).RECORDS', 'a:1:{s:4:"rows";a:5:{i:0;a:6:{s:8:"property";s:6:"source";s:8:"datatype";s:34:"&nbsp;<i>records-list </i>/stdWrap";s:11:"description";s:126:"List of record-id&#039;s, optionally with appended table-names.<br>&nbsp;<b><br>Example:</b><br>tt_content_34, 45, tt_links_56";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"tables";s:8:"datatype";s:21:"<i>list of tables</i>";s:11:"description";s:456:"List of accepted tables. If any items in the &quot;.source&quot;-list is not prepended with a tablename, the first table in this list is assumed to be the table for such records.<br>Also tablenames configured in .conf is allowed.<br>&nbsp;<b><br>Example:</b><br>tables = tt_content, tt_address, tt_links<br>conf.tx_myexttable = TEXT<br>conf.tx_myexttable.value = Hello world<br>&nbsp;<br>This adds the tables tt_content, tt_address, tt_links, tx_myexttable";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:23:"conf.[<i>tablename</i>]";s:8:"datatype";s:7:"cObject";s:11:"description";s:62:"Config-array which renders records from table <i>tablename</i>";s:7:"default";s:131:"If this is NOT defined, the rendering of the records is done with the toplevel-object [tablename] - just like the cObject, CONTENT!";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:12:"dontCheckPid";s:8:"datatype";s:7:"boolean";s:11:"description";s:141:"Normally a record cannot be selected, if it&#039;s parent page (pid) is not accessible for the website user. This option disables that check.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('61', '', '58494541fb84e7f9f04a7222619963cf', '', 'tsref:(cObject).HMENU', 'a:1:{s:4:"rows";a:16:{i:0;a:6:{s:8:"property";s:16:"(1 / 2 / 3 /...)";s:8:"datatype";s:7:"menuObj";s:11:"description";s:260:"<b>Required!</b><br>Defines which menuObj that should render the menuitems on the various levels. <br>1 is the first level, 2 is the second level, 3 is the third level, 4 is ....<br>&nbsp;<b><br>Example:</b><br>temp.sidemenu = HMENU<br>temp.sidemenu.1 = GMENU ";s:7:"default";s:15:"&nbsp;(no menu)";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:10:"entryLevel";s:8:"datatype";s:3:"int";s:11:"description";s:358:"Defines at which level in the rootLine, the menu should start. <br>Default is &quot;0&quot; which gives us a menu of the very first pages on the site.<br>If the value is &lt; 0, entryLevel is chosen from &quot;behind&quot; in the rootLine. Thus &quot;-1&quot; is a menu with items from the outermost level, &quot;-2&quot; is the level before the outermost...";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:7:"special";s:8:"datatype";s:159:"<i>&quot;directory&quot; / &quot;list&quot; / &quot;updated&quot; / &quot;browse&quot; / &quot;rootline&quot; / &quot;keywords&quot; / &quot;language&quot;</i>";s:11:"description";s:26:"(See separate table below)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:13:"special.value";s:8:"datatype";s:45:"&nbsp;<i>list of page-uid&#039;s</i> /stdWrap";s:11:"description";s:9:"See above";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:8:"minItems";s:8:"datatype";s:3:"int";s:11:"description";s:360:"The minimum items in the menu. If the number of pages does not reach this level, a dummy-page with the title &quot;...&quot; and uid=[currentpage_id] is inserted.<br>&nbsp;<br>&nbsp;<b>Notice:</b> Affects all sub menus as well. To set the value for each menu level individually, set the properties in the menu objects (see &quot;Common properties&quot; table).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:8:"maxItems";s:8:"datatype";s:3:"int";s:11:"description";s:161:"The maximum items in the menu. More items will be ignored.<br>&nbsp;<br>&nbsp;<b>Notice:</b> Affects all sub menus as well. (See &quot;minItems&quot; for notice)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:5:"begin";s:8:"datatype";s:9:"int +calc";s:11:"description";s:286:"The first item in the menu. <br>&nbsp;<b><br>Example:</b><br>This results in a menu, where the first two items are skipped starting with item number 3:<br>&nbsp;&nbsp;&nbsp;begin = 3 <br>&nbsp;<br>&nbsp;<b>Notice:</b> Affects all sub menus as well. (See &quot;minItems&quot; for notice)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:14:"excludeUidList";s:8:"datatype";s:11:"list of int";s:11:"description";s:368:"This is a list of page uid&#039;s to exclude when the select statement is done. Comma-separated. You may add &quot;current&quot; to the list to exclude the current page.<br>&nbsp;<b><br>Example:</b><br>The pages with these uid-number will NOT be within the menu!! Additionally the current page is always excluded too.<br>&nbsp;&nbsp;&nbsp;excludeUidList = 34,2,current";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:15:"excludeDoktypes";s:8:"datatype";s:16:"list of integers";s:11:"description";s:189:"Enter the list of page document types (doktype) to exclude from menus. By default pages that are &quot;not in menu&quot; (5) are excluded and those marked for backend user access only (6). ";s:7:"default";s:3:"5,6";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:16:"includeNotInMenu";s:8:"datatype";s:7:"boolean";s:11:"description";s:256:"If set, pages with type &quot;Not in menu&quot; will be included in menus.<br>The number &quot;5&quot; will simply be removed from the current dok-type list (which is by default &quot;5,6&quot; but can be changed by &quot;excludeDoktypes&quot;, see above).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:19:"alwaysActivePIDlist";s:8:"datatype";s:16:"list of integers";s:11:"description";s:145:"This is a list of page UID numbers that will always be regarded as active menu items and thereby automatically opened regardless of the rootline.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:11:"protectLvar";s:8:"datatype";s:17:"boolean / keyword";s:11:"description";s:1210:"If set, then for each page in the menu it will be checked if an Alternative Page Language record for the language defined in &quot;config.sys_language_uid&quot; (typically defined via &amp;L) exists for the page. If that is not the case and the pages &quot;Localization settings&quot; have the &quot;Hide page if no translation for current language exists&quot; flag set, then the menu item will link to a non accessible page that will yield an error page to the user. Setting this option will prevent that situation by simply adding &quot;&amp;L=0&quot; for such pages, meaning that they will switch to the default language rather than keeping the current language.<br>The check is only carried out if a translation is requested (&quot;config.sys_language_uid&quot; is not zero).<br>&nbsp;<b><br>Keyword: &quot;all&quot;</b><br>When set to &quot;all&quot; the same check is carried out but it will not look if &quot;Hide page if no translation for current language exists&quot; is set - it always reverts to default language if no translation is found.<br>&nbsp;<br>For these options to make sense, they should only be used when &quot;config.sys_language_mode&quot; is not set to &quot;content_fallback&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:14:"addQueryString";s:8:"datatype";s:27:"see typolink.addQueryString";s:11:"description";s:65:"&nbsp;<b>Notice: </b>This works only for <i>special=language</i>.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:2:"if";s:8:"datatype";s:7:"-&gt;if";s:11:"description";s:58:"If &quot;if&quot; returns false, the menu is not generated";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('62', '', 'cd830eb4ea8346e958afc812a860ed75', '', 'tsref:(cObject).HMENU.special', 'a:1:{s:4:"rows";a:9:{i:0;a:6:{s:8:"property";s:9:"directory";s:8:"datatype";s:304:"This will generate a menu of all pages with pid = 35 and pid = 56.<br>&nbsp;&nbsp;&nbsp;20 = HMENU<br>&nbsp;&nbsp;&nbsp;20.special = directory<br>&nbsp;&nbsp;&nbsp;20.special.value = 35, 56<br>&nbsp;<br>If .value is not set, the default pid is the current page.<br>&nbsp;<br>Support for Mount Pages: Yes.";s:11:"description";s:6:"&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:4:"list";s:8:"datatype";s:308:"This will generate a menu with the two pages (uid=35 and uid=36) listed:<br>&nbsp;&nbsp;&nbsp;20 = HMENU<br>&nbsp;&nbsp;&nbsp;20.special = list<br>&nbsp;&nbsp;&nbsp;20.special.value = 35, 56<br>&nbsp;<br>If .value is not set, the default uid is the .entryLevel uid.<br>&nbsp;<br>Support for Mount Pages: Yes.";s:11:"description";s:6:"&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:7:"updated";s:8:"datatype";s:2737:"This will generate a menu of the most recently updated pages from the branches in the tree starting with the uid&#039;s (uid=35 and uid=36) listed. Furthermore the field &quot;tstamp&quot; is used (default is SYS_LASTCHANGED) and the treedepth is 2 levels. Also there will be shown a maximum of 8 pages and they must have been updated within the last three days (3600*24*3):<br>&nbsp;&nbsp;&nbsp;20 = HMENU<br>&nbsp;&nbsp;&nbsp;20.special = updated<br>&nbsp;&nbsp;&nbsp;20.special.value = 35, 56<br>&nbsp;&nbsp;&nbsp;20.special {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;mode = tstamp<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;depth = 2<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;maxAge = 3600*24*3<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;limit = 8<br>&nbsp;&nbsp;&nbsp;}<br>&nbsp;<br>&nbsp;<b>Ordering </b>is by default done in reverse order (desc) with the field specified by &quot;mode&quot; , but setting &quot;alternativeSortingField&quot; for the menu object (eg GMENU, see later) will override that.<br>Properties &quot;mode&quot;, &quot;depth&quot;, &quot;maxAge&quot; and &quot;limit&quot; is only used with special=&quot;updated&quot;.<br>&nbsp;<b>mode:</b> Which field in the pages-table to use. Default is &quot;SYS_LASTCHANGED&quot; (which is updated when a page is generated to the youngest tstamp of the records on the page), &quot;manual&quot; or &quot;lastUpdated&quot; will use the field &quot;lastUpdated&quot; (set manually in the page-record) and &quot;tstamp&quot; will use the &quot;tstamp&quot;-field of the pagerecord, which is set automatically when the record is changed. &quot;crdate&quot; will use &quot;crdate&quot;-field of the pagerecord. &quot;starttime&quot; will use the starttime field.<br>Fields with zero value is not selected anyway.<br>&nbsp;<b>depth:</b> By default (if the value is not an integer) the depth is 20 levels. The range is 1-20. A depth of 1 means only the start id, depth of 2 means start-id + first level. NOTE: depth is relative to beginAtLevel.<br>&nbsp;<b>beginAtLevel</b>: Integer. Determines starting level for the pagetrees generated based on .value and .depth. Zero is default and includes the start id. 1=starts with the first row of subpages, 2=starts with the second row of subpages. Depth is relative to this starting point.<br>&nbsp;<b>maxAge:</b> Seconds+calc. Pages with update-dates older than currenttime minus this number of seconds will not be shown in the menu no matter what. Default is &quot;not used&quot;. You may use +-*/ for calculations.<br>&nbsp;<b>limit:</b> Max number of items in the menu. Default is 10, max is 100.<br>&nbsp;<b>excludeNoSearchPages:</b> Boolean. If set, pages marked &quot;No search&quot; is not included into special-menus.<br>&nbsp;<br>Support for Mount Pages: Yes.";s:11:"description";s:6:"&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:8:"rootline";s:8:"datatype";s:888:"Creates a menu with pages from the &quot;rootline&quot; (see earlier in this reference)<br>&nbsp;<b>.range</b> = [begin-level] | [end-level] (same way as you reference the .entryLevel for HMENU)<br>&nbsp;<b>.target_[0-x]</b> targets<br>&nbsp;<br>This...<br>&nbsp;<br>page.2 = HMENU<br>page.2.special = rootline<br>page.2.special.range = 1|-2<br>page.2.special.targets.3 = page<br>page.2.1 = TMENU<br>page.2.1.target = _top<br>page.2.1.wrap = &lt;HR&gt; | &lt;HR&gt;<br>page.2.1.NO {<br>&nbsp;&nbsp;&nbsp;linkWrap = | &gt; <br>}<br>&nbsp;<br>... creates a menu like this:<b><br>Page level 1 &gt; Page level 2 &gt; Page level 3 &gt; Page level 4 &gt;</b><br>(The menu starts at level 1 and does NOT link to the current page (-2 is the level before). Further all pages on level 3 will have &quot;page&quot; as target and all other &quot;_top&quot;)<br>&nbsp;<br>Support for Mount Pages: Yes.";s:11:"description";s:6:"&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:6:"browse";s:8:"datatype";s:3469:"This kind of menu is built of items given by a list from the property &quot;.item&quot;. Each element in the list (sep. by &quot;|&quot;) is either a reserved itemname (see list) with a predefined function or a userdefined name which you can assign a link to any page. Note that the current page cannot be the root-page of a site.<br>&nbsp;<br>Support for Mount Pages: No!<br>&nbsp;<b>.items </b>( &quot;|&quot; separated list of &quot;itemnames&quot;)<br>&nbsp;<b>.[itemnames].target </b>(target) - optional/alternative target of the item<br>&nbsp;<b>.[itemnames].uid </b>(uid of page) - optional/alternative page-uid to link to<br>&nbsp;<b>.[itemnames].fields.[fieldname]</b> (string) - override field &quot;fieldname&quot; in pagerecord.<br>&nbsp;<b>.items.prevnextToSection (boolean)</b> - if set, the &quot;prev&quot; and &quot;next&quot; navigation will jump to the next section when it reaches the end of pages in the current section<br>&nbsp;<b>.value</b> (page-uid) - default is current page id. Seldomly you might want to override this value with another page-uid which will then act as the basepoint for the menu and the predefined items.<br>&nbsp;<b>Ordering </b>is by default done in reverse order (desc) with the field specified by &quot;mode&quot; , but setting &quot;alternativeSortingField&quot; for the menu object (eg GMENU, see later) will override that.<i><br>&nbsp;</i><i><br>Reserved itemnames:</i><br>&nbsp;<b>next</b> / <b>prev</b> : links to next page / previous page. Next and previous pages are from the same &quot;pid&quot; as the current page id (or &quot;value&quot;) - that is the next item in a menu with the current page. Also referred to as current level. <br>If &quot;.prevnextToSection&quot; is set then next/prev will link to the first page of next section / last page of previous section.<br>&nbsp;<b>nextsection</b> / <b>prevsection</b> : links to next section / previous section. A section is defined as the subpages of a page on the same level as the parent (pid) page of the current page. Will not work if parent page of current page is the root page of the site.<br>&nbsp;<b>nextsection_last</b> | <b>prevsection_last</b>: Where nextsection/prevsection links to the first page in a section, these links to the last pages. If there is only one page in the section that will be both first and last. Will not work if parent page of current page is the root page of the site.<br>&nbsp;<b>first</b> / <b>last </b>: First / Last page on current level. If there is only one page on the current level that page will be both first and last.<br>&nbsp;<b>up</b> : Links to the parent (pid) page of the current page. (up 1 level) Will always be available<br>&nbsp;<b>index </b>: Links to the parent of the parent page of the current page (up 2 levels). May not be available if that page is out of the rootline.<br>&nbsp;<b><br>&nbsp;Examples:</b><br>If id=20 is current page then:<br>21= prev and first, 19 = next, 18 = last, 17 = up, 1=index, 10 = nextsection, 11 = nextsection_last<br>prevsection and prevsection_last is not present because id=3 has no subpages! <br>&nbsp;<b><br>TypoScript (only &quot;browse&quot;-part, needs also TMENU/GMENU):</b><br>xxx = HMENU<br>xxx.special = browse<br>xxx.special {<br>&nbsp;&nbsp;&nbsp;items = index|up|next|prev <br>&nbsp;&nbsp;&nbsp;items.prevnextToSection = 1<br>&nbsp;&nbsp;&nbsp;index.target = _blank<br>&nbsp;&nbsp;&nbsp;index.fields.title = INDEX<br>&nbsp;&nbsp;&nbsp;index.uid = 8<br>}";s:11:"description";s:6:"&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:8:"keywords";s:8:"datatype";s:1721:"Makes a menu of pages with one or more keywords also found on the current page.<br>&nbsp;<b>.value </b>= page for which keywords to find similar pages.<br>&nbsp;<b>.mode:</b> Which field in the pages-table to use for sorting. Default is &quot;SYS_LASTCHANGED&quot; (which is updated when a page is generated to the youngest tstamp of the records on the page), &quot;manual&quot; or &quot;lastUpdated&quot; will use the field &quot;lastUpdated&quot; (set manually in the page-record) and &quot;tstamp&quot; will use the &quot;tstamp&quot;-field of the pagerecord, which is set automatically when the record is changed. &quot;crdate&quot; will use &quot;crdate&quot;-field of the pagerecord. &quot;starttime&quot; will use the starttime field.<br>&nbsp;<b>.entryLevel </b>= where in the rootline the search begins. Standard rootline syntax (-x to x)<br>&nbsp;<b>.depth, .limit, .excludeNoSearchPages, .beginAtLevel </b>(like &quot;updated&quot; menu)<b><br>.setKeywords (+stdWrap) = lets you define the keywords manually by defining them as a commaseparated list. If this property is defined, it overrides the default, which is the keywords of the current page.</b><br>&nbsp;<b>.keywordsField</b> = defines the field in the pages-table in which to search for the keywords. Default is the fieldname &quot;keyword&quot;. No check is done to see if the field you enter here exists, so enter an existing field, OK?!<br>&nbsp;<b>.keywordsField.sourceField</b> = defines the field from the current page from which to take the keywords being matched. The default is &quot;keyword&quot;. (Notice that &quot;.keywordsField&quot; is only setting the page-record field to <i>search in</i> !)<br>&nbsp;<br>Support for Mount Pages: Yes.";s:11:"description";s:6:"&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:8:"language";s:8:"datatype";s:2630:"Creates a language selector menu. Typically this is made as a menu with flags for each language a page is translated to and when the user clicks any element the same page id is hit but with a change to the &quot;&amp;L&quot; parameter in the URL.<br>&nbsp;<br>The &quot;language&quot; type will create menu items based on the current page record but with the language record for each language overlaid if available. The items all link to the current page id and only &quot;&amp;L&quot; is changed.<br>&nbsp;<b><br>Item states:</b><br>When &quot;TSFE-&gt;sys_language_uid&quot; matches the sys_language uid for an element the state is set to &quot;ACT&quot;, otherwise &quot;NO&quot;. However, if a page is not available due to the pages &quot;Localization settings&quot; (which can disable translations) or if no Alternative Page Language record was found (can be disabled with &quot;.normalWhenNoLanguage&quot;, see below) the state is set to &quot;USERDEF1&quot; for non-active items and &quot;USERDEF2&quot; for active items. So in total there are four states to create designs for. It is recommended to disable the link on menu items rendered with &quot;USERDEF1&quot; and &quot;USERDEF2&quot; in this case since they are disabled exactly because a page in that language does not exist and might even issue an error if tried accessed (depending on site configuration).<br>&nbsp;<br>&nbsp;<b>.value</b> = comma list of sys_language uids to construct the menu with. The number of elements in this list determines the number of menu items.<br>&nbsp;<b>.normalWhenNoLanguage</b> = boolean, which if set will render the button for a language as a non-disabled button even if no translation is found for the language.<br>&nbsp;<b><br>Example:</b><br>Creates a language menu with flags (notice that some lines break):<br>&nbsp;<br>&nbsp;<br>&nbsp;<br>&nbsp;<br>lib.langMenu = HMENU<br>lib.langMenu.special = language<br>lib.langMenu.special.value = 0,1,2<br>lib.langMenu.1 = GMENU<br>lib.langMenu.1.NO {<br>&nbsp;&nbsp;&nbsp;XY = [5.w]+4, [5.h]+4<br>&nbsp;&nbsp;&nbsp;backColor = white<br>&nbsp;&nbsp;&nbsp;5 = IMAGE<br>&nbsp;&nbsp;&nbsp;5.file = media/flags/flag_uk.gif || media/flags/flag_fr.gif || media/flags/flag_es.gif <br>&nbsp;&nbsp;&nbsp;5.offset = 2,2<br>}<br>&nbsp;<br>lib.langMenu.1.ACT &lt; lib.langMenu.1.NO<br>lib.langMenu.1.ACT=1<br>lib.langMenu.1.ACT.backColor = black<br>&nbsp;<br>lib.langMenu.1.USERDEF1 &lt; lib.langMenu.1.NO<br>lib.langMenu.1.USERDEF1=1<br>lib.langMenu.1.USERDEF1.5.file = media/flags/flag_uk_d.gif || media/flags/flag_fr_d.gif || media/flags/flag_es_d.gif <br>lib.langMenu.1.USERDEF1.noLink = 1";s:11:"description";s:6:"&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:11:"userdefined";s:8:"datatype";s:2195:"Lets you write your own little PHP-script that generates the array of menuitems.<br>&nbsp;<b>.file</b> [resource] = filename of the php-file to include. (Just like cObject PHP_SCRIPT)<br>&nbsp;<b>.[any other key]</b> = your own variables to your script. They are all accessible in the array $conf in your script<br>&nbsp;<b><br>Howto:</b><br>You must populate an array called $menuItemsArray with page-records of the menuitems you want to be in the menu.<br>It goes like this:<br>&nbsp;<br>$menuItemsArray[] = pageRow1;<br>$menuItemsArray[] = pageRow2;<br>$menuItemsArray[] = pageRow3;<br>...<br>&nbsp;<br>A &quot;pageRow&quot; is a record from the table &quot;pages&quot; with all fields selected (SELECT * FROM...)<br>If you create fake page rows, make sure to add at least &quot;title&quot; and &quot;uid&quot; field values.<br>&nbsp;<b><br>Notice:</b><br>If you work with mount-points you can set the MP param which should be set for the page by setting the internal field &quot;_MP_PARAM&quot; in the page-record (xxx-xxx).<br>&nbsp;<b><br>Overriding URLs:</b><br>You can also use the internal field &quot;_OVERRIDE_HREF&quot; to set a custom href-value (eg. &quot;http://www.typo3.org&quot;) which will in any case be used rather than a link to the page that the page otherwise might represent. If you use &quot;_OVERRIDE_HREF&quot; then &quot;_OVERRIDE_TARGET&quot; can be used to override the target value as well (See example below).<br>&nbsp;<b><br>Other reserved keys:</b><br>&quot;_ADD_GETVARS&quot; can be used to add get parameters to the URL, eg. &quot;&amp;L=xxx&quot;.<br>&quot;_SAFE&quot; can be used to protect the element to make sure it is not filtered out for any reason.<br>&nbsp;<b><br>Creating submenus:</b><br>You can create submenus for the next level easily by just adding an array of menu items in the internal field &quot;_SUB_MENU&quot; (See example below).<br>&nbsp;<b><br>Presetting element state</b><br>If you would like to preset an element to be recognized as a SPC, IFSUB, ACT, CUR or USR mode item, you can do so by specifying one of these values in the key &quot;ITEM_STATE&quot; of the page record. This setting will override the natural state-evaluation.";s:11:"description";s:6:"&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:12:"userfunction";s:8:"datatype";s:180:"Calls a user function/method in class which should (as with &quot;userdefined&quot; above) return an array with page records for the menu.<br>&nbsp;<b>.userFunc</b> = function-name";s:11:"description";s:6:"&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('63', '', '51fb0254a54165c4bb95358367ae0aec', '', 'tsref:(cObject).CTABLE', 'a:1:{s:4:"rows";a:9:{i:0;a:6:{s:8:"property";s:6:"offset";s:8:"datatype";s:3:"x,y";s:11:"description";s:29:"Offset from upper left corner";s:7:"default";s:11:"0,0 = intet";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:2:"tm";s:8:"datatype";s:21:"-&gt;CARRAY +TDParams";s:11:"description";s:7:"topMenu";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:2:"lm";s:8:"datatype";s:21:"-&gt;CARRAY +TDParams";s:11:"description";s:8:"leftMenu";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:2:"rm";s:8:"datatype";s:21:"-&gt;CARRAY +TDParams";s:11:"description";s:9:"rightMenu";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:2:"bm";s:8:"datatype";s:21:"-&gt;CARRAY +TDParams";s:11:"description";s:10:"bottomMenu";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:1:"c";s:8:"datatype";s:21:"-&gt;CARRAY +TDParams";s:11:"description";s:13:"content-cell ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:8:"cMargins";s:8:"datatype";s:7:"margins";s:11:"description";s:46:"Distance around the content-cell &quot;c&quot;";s:7:"default";s:7:"0,0,0,0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:6:"cWidth";s:8:"datatype";s:6:"pixels";s:11:"description";s:39:"Width of the content-cell &quot;c&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:11:"tableParams";s:8:"datatype";s:20:"&lt;TABLE&gt;-params";s:11:"description";s:6:"&nbsp;";s:7:"default";s:36:"border=0 cellspacing=0 cellpadding=0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('64', '', 'd15fe4c25a73d14a1233602ae5c00aeb', '', 'tsref:(cObject).OTABLE', 'a:1:{s:4:"rows";a:3:{i:0;a:6:{s:8:"property";s:6:"offset";s:8:"datatype";s:3:"x,y";s:11:"description";s:330:"Offset from upper left corner<br>&nbsp;<b><br>Note:</b><br>Actually the datatype is &quot;x,y,r,b,w,h&quot;:<br>x,y is offset from upperleft corner<br>r,b is offset (margin) to right and bottom<br>w is the required width of the content field<br>h is the required height of the content field<br>&nbsp;<br>All measures is in pixels.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:10:"1,2,3,4...";s:8:"datatype";s:7:"cObject";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:11:"tableParams";s:8:"datatype";s:20:"&lt;TABLE&gt;-params";s:11:"description";s:6:"&nbsp;";s:7:"default";s:36:"border=0 cellspacing=0 cellpadding=0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('65', '', 'ac73d41309997ef5db797e0ac823c30f', '', 'tsref:(cObject).COLUMNS', 'a:1:{s:4:"rows";a:12:{i:0;a:6:{s:8:"property";s:11:"tableParams";s:8:"datatype";s:20:"&lt;TABLE&gt;-params";s:11:"description";s:6:"&nbsp;";s:7:"default";s:36:"border=0 cellspacing=0 cellpadding=0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:8:"TDparams";s:8:"datatype";s:17:"&lt;TD&gt;-params";s:11:"description";s:6:"&nbsp;";s:7:"default";s:10:"valign=top";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:4:"rows";s:8:"datatype";s:17:"int (Range: 2-20)";s:11:"description";s:34:"The number of rows in the columns.";s:7:"default";s:1:"2";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:10:"totalWidth";s:8:"datatype";s:3:"int";s:11:"description";s:35:"The total-width of the columns+gaps";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:8:"gapWidth";s:8:"datatype";s:28:"int /stdWrap<br>+optionSplit";s:11:"description";s:48:"Width of the gap between columns. <br>0 = no gap";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:8:"gapBgCol";s:8:"datatype";s:35:"HTML-color /stdWrap<br>+optionSplit";s:11:"description";s:39:"background-color for the gap-tablecells";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:16:"gapLineThickness";s:8:"datatype";s:28:"int /stdWrap<br>+optionSplit";s:11:"description";s:72:"lineThickness of the dividerline in the gap between cells<br>0 = no line";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:10:"gapLineCol";s:8:"datatype";s:35:"HTML-color /stdWrap<br>+optionSplit";s:11:"description";s:10:"Line color";s:7:"default";s:5:"black";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:29:"[column-number]<br>1,2,3,4...";s:8:"datatype";s:7:"cObject";s:11:"description";s:44:"This is the content-object for each column!!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:5:"after";s:8:"datatype";s:7:"cObject";s:11:"description";s:50:"This is a cObject placed after the columns-table!!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:2:"if";s:8:"datatype";s:7:"-&gt;if";s:11:"description";s:61:"if &quot;if&quot; returns false the columns are not rendered!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('66', '', '735744d82b01f1ae8ee357b35a445a18', '', 'tsref:(cObject).HRULER', 'a:1:{s:4:"rows";a:6:{i:0;a:6:{s:8:"property";s:13:"lineThickness";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:11:"Range: 1-50";s:7:"default";s:1:"1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:9:"lineColor";s:8:"datatype";s:10:"HTML-color";s:11:"description";s:23:"The color of the ruler.";s:7:"default";s:5:"black";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:9:"spaceLeft";s:8:"datatype";s:6:"pixels";s:11:"description";s:35:"space before the line (to the left)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:10:"spaceRight";s:8:"datatype";s:6:"pixels";s:11:"description";s:35:"space after the line (to the right)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:10:"tableWidth";s:8:"datatype";s:6:"string";s:11:"description";s:59:"Width of the ruler (&quot;width&quot; attribute in a table)";s:7:"default";s:3:"99%";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('67', '', '99c88493b5fbff11087e84f8b0caf05e', '', 'tsref:(cObject).IMGTEXT', 'a:1:{s:4:"rows";a:37:{i:0;a:6:{s:8:"property";s:4:"text";s:8:"datatype";s:20:"-&gt;CARRAY /stdWrap";s:11:"description";s:82:"Use this to import / generate the content, that should flow around the imageblock.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:7:"textPos";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:352:"Textposition:<br>bit[0-2]: 000 = centre, 001 = right, 010 = left<br>bit[3-5]: 000 = over, 001 = under, 010 text<br>&nbsp;<br>0 - Above: Centre<br>1 - Above: Right<br>2 - Above: Left<br>8 - Below: Centre<br>9 - Below: Right<br>10 - Below: Left<br>17 - In Text: Right<br>18 - In Text: Left<br>25 - In Text: Right (no wrap)<br>26 - In Text: Left (no wrap)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:10:"textMargin";s:8:"datatype";s:15:"pixels /stdWrap";s:11:"description";s:40:"margin between the image and the content";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:20:"textMargin_outOfText";s:8:"datatype";s:7:"boolean";s:11:"description";s:337:"If set, the textMargin space will still be inserted even if the image is placed above or below the text. <br>This flag is only for a kind of backwards compatibility because this &quot;feature&quot; was recently considered a bug and thus corrected. So if anyone has depended on this way things are done, you can compensate with this flag.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:7:"imgList";s:8:"datatype";s:40:"&nbsp;<i>list of imagefiles</i> /stdWrap";s:11:"description";s:176:"list of images from &quot;.imgPath&quot;<br>&nbsp;<b><br>Example:</b><br>This imports the list of images from tt_content&#039;s image-field<br>&quot;imgList.field = image&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:7:"imgPath";s:8:"datatype";s:13:"path /stdWrap";s:11:"description";s:76:"Path to the images<br>&nbsp;<b><br>Example:</b><br>&quot;uploads/pics/&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:6:"imgMax";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:20:"max number of images";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:8:"imgStart";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:45:"start with image-number &quot;.imgStart&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:9:"imgObjNum";s:8:"datatype";s:35:"&nbsp;<i>imgObjNum</i> +optionSplit";s:11:"description";s:410:"Here you define, which IMAGE-cObjects from the array &quot;1,2,3,4...&quot; in this object that should render the images.<br>&quot;current&quot; is set to the image-filename.<br>&nbsp;<b><br>Example:</b><br>&quot;imgObjNum = 1 |*||*| 2&quot;:<br>This would render the first two images with &quot;1. ...&quot; and the last image with &quot;2. ...&quot;, provided that the &quot;.imgList&quot; contains 3 images.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:7:"1,2,3,4";s:8:"datatype";s:20:"-&gt;IMAGE (cObject)";s:11:"description";s:323:"Rendering of the images<br>The register &quot;IMAGE_NUM&quot; is set with the number of image being rendered for each rendering of a image-object. Starting with zero.<br>The image-object should not be of type GIFBUILDER!<br>&nbsp;<b><br>Important:</b><br>&quot;file.import.current = 1&quot; fetches the name of the images! ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:7:"caption";s:8:"datatype";s:20:"-&gt;CARRAY /stdWrap";s:11:"description";s:7:"Caption";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:12:"captionAlign";s:8:"datatype";s:14:"align /stdWrap";s:11:"description";s:17:"Caption alignment";s:7:"default";s:30:"default = &quot;.textPos&quot;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:12:"captionSplit";s:8:"datatype";s:7:"boolean";s:11:"description";s:378:"If this is set, the caption text is split by the character (or string) from &quot;.token&quot; , and every item is displayed under an image each in the image block.<br>.token = (string/stdWrap) Character to split the caption elements (default is chr(10))<br>.cObject = cObject, used to fetch the caption for the split<br>.stdWrap = stdWrap properties used to render the caption.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:20:"altText<br>titleText";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:215:"Default altText/titleText if no alternatives are provided by the -&gt;IMAGE cObjects <br>&nbsp;<br>If no titltext is specified, it will use the alttext insteadIf no alttext is specified, it will use an empty alttext";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:11:"longdescURL";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:186:"Default longdescURL if no alternatives are provided by the -&gt;IMAGE cObjects <br>&nbsp;<br>&quot;longdesc&quot; attribute (URL pointing to document with extensive details about image).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:6:"border";s:8:"datatype";s:17:"boolean /stdWrap ";s:11:"description";s:48:"If true, a border i generated around the images.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:9:"borderCol";s:8:"datatype";s:32:"&nbsp;<i>HTML-color</i> /stdWrap";s:11:"description";s:50:"Color of the border, if &quot;.border&quot; is set";s:7:"default";s:5:"black";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:11:"borderThick";s:8:"datatype";s:15:"pixels /stdWrap";s:11:"description";s:39:"Width of the border around the pictures";s:7:"default";s:1:"1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:4:"cols";s:8:"datatype";s:13:"int /stdWrap ";s:11:"description";s:7:"Columns";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:4:"rows";s:8:"datatype";s:13:"int /stdWrap ";s:11:"description";s:44:"Rows (higher priority thab &quot;cols&quot;)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:6:"noRows";s:8:"datatype";s:16:"boolean /stdWrap";s:11:"description";s:145:"If set, the rows are not divided by a table-rows. Thus images are more nicely shown if the height differs a lot (normally the width is the same!)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:6:"noCols";s:8:"datatype";s:16:"boolean /stdWrap";s:11:"description";s:208:"If set, the columns are not made in the table. The images are all put in one row separated by a clear giffile to space them apart.<br>If noRows is set, noCols will be unset. They cannot be set simultaneously.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:22;a:6:{s:8:"property";s:8:"colSpace";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:21:"space between columns";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:23;a:6:{s:8:"property";s:8:"rowSpace";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:18:"space between rows";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:24;a:6:{s:8:"property";s:15:"spaceBelowAbove";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:101:"Pixelsspace between content an images when position of image is above or belox text (but not in text)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:25;a:6:{s:8:"property";s:12:"tableStdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:85:"This passes the final &lt;table&gt; code for the image block to the stdWrap function.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:26;a:6:{s:8:"property";s:4:"maxW";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:195:"max width of the image-table. <br>This will scale images not in the right size! Takes the number of columns into account!<br>&nbsp;<br>&nbsp;<b>NOTE: </b>Works ONLY if IMAGE-obj is NOT GIFBUILDER";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:27;a:6:{s:8:"property";s:10:"maxWInText";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:269:"max width of the image-table, if the text is wrapped around the image-table (on the left or right side).<br>This will scale images not in the right size! Takes the number of columns into account!<br>&nbsp;<br>&nbsp;<b>NOTE: </b>Works ONLY if IMAGE-obj is NOT GIFBUILDER";s:7:"default";s:11:"50% of maxW";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:28;a:6:{s:8:"property";s:6:"equalH";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:655:"If this value is greater than zero, it will secure that images in a row has the same height. The width will be calculated.<br>If the total width of the images raise above the &quot;maxW&quot;-value of the table the height for each image will be scaled down equally so that the images still have the same height but is within the limits of the totalWidth.<br>Please note that this value will override the properties &quot;width&quot;, &quot;maxH&quot;, &quot;maxW&quot;, &quot;minW&quot;, &quot;minH&quot; of the IMAGE-objects generating the images. Furthermore it will override the &quot;noRows&quot;-property and generate a table with no columns instead!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:29;a:6:{s:8:"property";s:12:"colRelations";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:629:"This value defines the width-relations of the images in the columns of IMGTEXT. The syntax is &quot;[int] : [int] : [int] : ...&quot; for each column. If there are more imagecolumns than figures in this value, it&#039;s ignored. If the relation between two of these figures exceeds 10, this function is ignore. <br>It works only fully if all images are downscaled by their maxW-definition.<br>&nbsp;<b><br>Example:</b><br>If 6 images are placed in three columns and their width&#039;s are high enough to be forcibly scaled, this value will scale the images in the to be eg. 100, 200 and 300 pixels from left to right<br>1 : 2 : 3";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:30;a:6:{s:8:"property";s:17:"image_compression";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:996:"Image Compression:<br>0= Default<br>1= Dont change! (removes all parameters for the image_object!!)<br>(adds gif-extension and color-reduction command)<br>10= GIF/256<br>11= GIF/128<br>12= GIF/64<br>13= GIF/32<br>14= GIF/16<br>15= GIF/8<br>(adds jpg-extension and quality command)<br>20= IM: -quality 100<br>21= IM: -quality 90 &lt;=&gt; Photoshop 60 &nbsp;&nbsp;&nbsp;&nbsp;(JPG/Very High)<br>22= IM: -quality 80 &nbsp;&nbsp;&nbsp;(JPG/High)<br>23= IM: -quality 70<br>24= IM: -quality 60 &lt;=&gt; Photoshop 30 &nbsp;&nbsp;(JPG/Medium)<br>25= IM: -quality 50<br>26= IM: -quality 40 (JPG/Low)<br>27= IM: -quality 30 &lt;=&gt; Photoshop 10 <br>28= IM: -quality 20 &nbsp;&nbsp;(JPG/Very Low)<br>&nbsp;<br>The default ImageMagick quality seems to be 75. This equals Photoshop quality 45. Images compressed with ImageMagick with the same visual quality as a Photoshop-compressed image seems to be largely 50% greater in size!!<br>&nbsp;<br>&nbsp;<b>NOTE: </b>Works ONLY if IMAGE-obj is NOT GIFBUILDER";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:31;a:6:{s:8:"property";s:13:"image_effects";s:8:"datatype";s:12:"int /stdWrap";s:11:"description";s:548:"Adds these commands to the parameteres for the scaling. This function has no effect if &quot;image_compression&quot; above is set to 1!!<br>&nbsp;<br>1 =&gt; &quot;-rotate 90&quot;,<br>2 =&gt; &quot;-rotate 270&quot;,<br>3 =&gt; &quot;-rotate 180&quot;,<br>10 =&gt; &quot;-colorspace GRAY&quot;,<br>11 =&gt; &quot;-sharpen 70&quot;,<br>20 =&gt; &quot;-normalize&quot;,<br>23 =&gt; &quot;-contrast&quot;,<br>25 =&gt; &quot;-gamma 1.3&quot;,<br>26 =&gt; &quot;-gamma 0.8&quot;<br>&nbsp;<br>&nbsp;<b>NOTE: </b>Works ONLY if IMAGE-obj is NOT GIFBUILDER";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:32;a:6:{s:8:"property";s:12:"image_frames";s:8:"datatype";s:35:"Array <br>+ .key /stdWrap<br>&nbsp;";s:11:"description";s:1175:"<b>Frames:</b><br>.key points to the frame used.<br>&nbsp;<br>&quot;.image_frames.x&quot; is imgResource-mask (&quot;.m&quot;)properties which will override to the [imgResource].m properties of the imageObjects. This is used to mask the images into a frame. See how it&#039;s done in the default configuration and IMGTEXT in the static_template-table. <br>&nbsp;<b><br>Example:</b><br>1 {<br>&nbsp;&nbsp;&nbsp;mask = media/uploads/darkroom1_mask.jpg<br>&nbsp;&nbsp;&nbsp;bgImg = GIFBUILDER<br>&nbsp;&nbsp;&nbsp;bgImg {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;XY = 100,100<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;backColor = {$bgCol}<br>&nbsp;&nbsp;&nbsp;}<br>&nbsp;&nbsp;&nbsp;bottomImg = GIFBUILDER<br>&nbsp;&nbsp;&nbsp;bottomImg {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;XY = 100,100<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;backColor = black<br>&nbsp;&nbsp;&nbsp;}<br>&nbsp;&nbsp;&nbsp;bottomImg_mask = media/uploads/darkroom1_bottom.jpg<br>}<br>&nbsp;<br>&nbsp;<b>NOTE: </b>This cancels the jpg-quality settings sent as ordinary &quot;.params&quot; to the imgResource. In addition the output of this operation will always be jpg or gif!<br>&nbsp;<b>NOTE: </b>Works ONLY if IMAGE-obj is NOT GIFBUILDER";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:33;a:6:{s:8:"property";s:23:"netprintApplicationLink";s:8:"datatype";s:20:"boolean /+properties";s:11:"description";s:1415:"Set true, if you would like to enable the netprint feature. <br>&quot;Netprint&quot; is a TYPO3 application which is still in development. &#039;Netprint&#039; allows film development stores to offer online submission of Photos to a TYPO3 / Netprint server in-house from which the store offer enlargements of digital photos on eg Kodak Royal paper.<br>The application will be released under GNU/GPL sometime in 2002.<br>&#039;Netprint&#039; offers a feature to fetch images from peoples online fotoalbums. This property enables links from your site images to a Netprint server.<br>&nbsp;<b><br>Properties:</b><br>&nbsp;<b>.url</b> = Url of the Netprint site page, eg. http://netprint.photo.com/?id=999&amp;type=2<br>&nbsp;<b>.thisUrl</b> = Url of this site, eg. http://mysite.com/typo3site/ (default is calculated from HTTP_HOST)<br>&nbsp;<b>.cObject </b>= (cObject) The link content<br>&nbsp;<b>.ATagParams </b>= &lt;A&gt;-tag parameters /stdWrap<br>&nbsp;<b>.outerStdWrap </b>= (-&gt;stdWrap) stdWrap of the total linked cObject.<br>&nbsp;<b>.before </b>= (boolean) If the link code should be inserted before the image (default is after)<br>&nbsp;<b>.linkOnlyPixelsAbove </b>= (int) If set, only images with a total number of pixels greater than this number will be linked. This secures that small images will not be linked. Eg. if images above 640x480 is supposed to be linked, the limit should be approx. 300000";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:34;a:6:{s:8:"property";s:9:"editIcons";s:8:"datatype";s:6:"string";s:11:"description";s:23:"(See stdWrap.editIcons)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:35;a:6:{s:8:"property";s:23:"noStretchAndMarginCells";s:8:"datatype";s:7:"boolean";s:11:"description";s:275:"If set (1), the cells used to add left and right margins plus stretch out the table will not be added. You will loose the ability to set margins for the object if entered &quot;in text&quot;. So it&#039;s not recommended, but it has been requested by some people for reasons.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:36;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('68', '', '7831f428e4ab5909c05af00f0f34071e', '', 'tsref:(cObject).CASE', 'a:1:{s:4:"rows";a:6:{i:0;a:6:{s:8:"property";s:10:"setCurrent";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:36:"Sets the &quot;current&quot;-value. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:3:"key";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:12:"This is the ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:7:"default";s:8:"datatype";s:7:"cObject";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:15:"<i>Array...</i>";s:8:"datatype";s:7:"cObject";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:2:"if";s:8:"datatype";s:7:"-&gt;if";s:11:"description";s:51:"if &quot;if&quot; returns false nothing is returned";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('69', '', '11559da8560e5a25a5d94dc2ababdc78', '', 'tsref:(cObject).LOAD_REGISTER', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:38:"<i>Array... </i><i><br>[fieldname]</i>";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:347:"<b>Example:</b><br>(This sets &quot;contentWidth&quot;, &quot;label&quot; and &quot;head&quot;)<br>&nbsp;<br>page.27 = LOAD_REGISTER<br>page.27 {<br>&nbsp;&nbsp;&nbsp;contentWidth = 500 <br>&nbsp;<br>&nbsp;&nbsp;&nbsp;label.field = header<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;head = some text<br>&nbsp;&nbsp;&nbsp;head.wrap = &lt;B&gt; | &lt;/B&gt;<br>}";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('70', '', 'd6df84910bc06faaa29868176f91b324', '', 'tsref:(cObject).FORM', 'a:1:{s:4:"rows";a:38:{i:0;a:6:{s:8:"property";s:4:"data";s:8:"datatype";s:20:"string /-&gt;stdWrap";s:11:"description";s:102:"This is the data that sets up the form. See above.<br>&quot;||&quot; can be used instead of linebreaks";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:9:"dataArray";s:8:"datatype";s:31:"<i>[array of form elements]</i>";s:11:"description";s:2823:"This is an alternative way to define the form-fields. Instead of using the syntax with vertical separator bars suggested by the .data property, you can define the elements in regular TypoScript style arrays.<br>.dataArray is <i>added </i>to the input in .data if any.<br>Every entry in the dataArray is numeric and has three main properties, <i>label</i>, <i>type</i>, <i>value</i> and <i>required</i>. &#039;label&#039; and &#039;value&#039; has stdWrap properties. <br>There is an alternative property to .value, which is .valueArray. This is also an array in the same style with numeric entries which has properties <i>label</i>, <i>value</i> and <i>selected</i>. &#039;label&#039; has stdWrap properties.<br>&nbsp;<b><br>Example:</b><br>&nbsp;&nbsp;&nbsp;dataArray {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;10.label = Name:<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;10.type = name=input<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;10.value = [Enter name]<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;10.required = 1<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;20.label = Eyecolor<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;20.type = eyecolor=select<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;20.valueArray {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;10.label = Blue<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;10.value = 1<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;20.label = Red<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;20.value = 2<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;20.selected = 1<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;40.type = submit=submit<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;40.value = Submit<br>&nbsp;&nbsp;&nbsp;}<br>&nbsp;<br>&nbsp;<br>This is the same as this line in the .data property:<br>&nbsp;<br>Name: | *name=input | [Enter name]<br>Eyecolor: | eyecolor=select | Blue=1, *Red=2<br>| submit=submit | Submit<br>&nbsp;<br>&nbsp;<b>Why do it this way?</b> <br>Inserting an email-field after the name field would be like this:<br>&nbsp;&nbsp;&nbsp;dataArray {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;15.label = Email:<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;15.type = input<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;15.value = <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;15.specialEval = EMAIL<br>&nbsp;&nbsp;&nbsp;}<br>&nbsp;<br>&nbsp;Or translating the form to danish (setting config.language to &#039;dk&#039;):<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;dataArray {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;10.label.lang.dk = Navn:<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;10.value.lang.dk = [Indtast dit navn]<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;20.label.lang.dk = Øjenfarve<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;20.valueArray {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;10.label.lang.dk = Blå<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;20.label.lang.dk = Rød<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;40.value.lang.dk = Send<br>&nbsp;&nbsp;&nbsp;}<br>&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:9:"radioWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:33:"Wraps the labels for radiobuttons";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:4:"type";s:8:"datatype";s:3:"int";s:11:"description";s:734:"Type (action=&quot;&quot; of the form):<br>&nbsp;<br>&nbsp;<b>Integer:</b> this is regarded to be a page in TYPO3<br>&nbsp;<b>String:</b> this is regarded to be a normal url (eg. &quot;formmail.php&quot; or &quot;fe_tce_db.php&quot;)<br>&nbsp;<b>Empty;</b> the current page is chosen.<br>&nbsp;<b>NOTE:</b> If type is integer/empty the form will be submitted to a page in TYPO3 and if this page has a value for target/no_cache, then this will be used instead of the default target/no_cache below.<br>&nbsp;<br>&nbsp;<b>NOTE:</b> If the redirect-value is set, the redirect-target overriddens the target set by the action-url<br>&nbsp;<br>&nbsp;<b>NOTE:</b> May be overridden by the property override feature of the formdata (see above)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:6:"target";s:8:"datatype";s:6:"target";s:11:"description";s:28:"Default target of the form. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:6:"method";s:8:"datatype";s:11:"form-method";s:11:"description";s:23:"<b>Example: </b><br>GET";s:7:"default";s:4:"POST";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:8:"no_cache";s:8:"datatype";s:6:"string";s:11:"description";s:23:"Default no_cache-option";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:13:"noValueInsert";s:8:"datatype";s:7:"boolean";s:11:"description";s:434:"By default values that are submitted to the same page (and thereby same form, eg. at searchforms) are re-inserted in the form instead of any default-data that might be set up. <br>This, however, applies ONLY if the &quot;no_cache=1&quot; is set! (a page being cached may not include user-specific defaults in the fields of course...) <br>If you set this flag, &quot;noValueInsert&quot;, the content will always be the default content.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:20:"compensateFieldWidth";s:8:"datatype";s:6:"double";s:11:"description";s:85:"Overriding option to the config-value of the same name. See &quot;CONFIG&quot; above.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:12:"locationData";s:8:"datatype";s:16:"boolean / string";s:11:"description";s:1479:"If this value is true, then a hidden-field called &quot;locationData&quot; is added to the form. This field wil be loaded with a value like this:<br>[page id]:[current record table]:[current record id]<br>For example, if a formfield is inserted on page with uid = &quot;100&quot;, as a page-content item from the table &quot;tt_content&quot; with id &quot;120&quot;, then the value would be &quot;100:tt_content:120&quot;.<br>The value is use by eg. the cObject SEARCHRESULT. If the value $GLOBALS[&quot;HTTP_POST_VARS&quot;][&quot;locationData&quot;] is detected here, the search is done as if it was performed on this page! This is very usefull if you want a search functionality implemented on a page with the &quot;stype&quot; field set to &quot;L1&quot; which means that the search is carried out from the first level in the rootline. <br>Suppose you want the search to submit to a dedicated searchpage where ever. This page will then know - because of locationData - that the search was submittet from another place on the website.<br>If &quot;locationData&quot; is not only true but also set to &quot;HTTP_POST_VARS&quot; then the value will insert the content of $GLOBALS[&quot;HTTP_POST_VARS&quot;][&quot;locationData&quot;] instead of the true location data of the page. This should be done with search-fields as this will carry the initial searching start point with.<br>&nbsp;<b>NOTE:</b> May be overridden by the property override feature of the formdata (see above)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:8:"redirect";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:371:"url to redirect to (generates the hiddenfield &quot;redirect&quot;)<br>&nbsp;<br>&nbsp;<b>Integer:</b> this is regarded to be a page in TYPO3<br>&nbsp;<b>String:</b> this is regarded to be a normal url<br>&nbsp;<b>Empty;</b> the current page is chosen.<br>&nbsp;<br>&nbsp;<b>NOTE:</b> If this value is set the target of this overriddes the target of the &quot;type&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:9:"recipient";s:8:"datatype";s:38:"&nbsp;<i>(list of) string</i> /stdWrap";s:11:"description";s:89:"Email recipient of the formmail content (generates the hiddenfield &quot;recipient&quot;)";s:7:"default";s:8:"No email";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:8:"goodMess";s:8:"datatype";s:6:"string";s:11:"description";s:184:"Message for the formevaluation function in case of correctly filled form.<br>&nbsp;<br>&nbsp;<b>NOTE:</b> May be overridden by the property override feature of the formdata (see above)";s:7:"default";s:10:"No message";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:7:"badMess";s:8:"datatype";s:6:"string";s:11:"description";s:238:"Prefixed Message for the formevaluation in case of missing required fields. <br>This message is shown above the list of fields.<br>&nbsp;<br>&nbsp;<b>NOTE:</b> May be overridden by the property override feature of the formdata (see above)";s:7:"default";s:10:"No message";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:9:"emailMess";s:8:"datatype";s:6:"string";s:11:"description";s:180:"Message if a field evaluated to be an email adresse did not validate.<br>&nbsp;<br>&nbsp;<b>NOTE:</b> May be overridden by the property override feature of the formdata (see above)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:5:"image";s:8:"datatype";s:20:"-&gt;IMAGE (cObject)";s:11:"description";s:171:"If this is a valid image the submitbutton is rendered as this image!!<br>&nbsp;<br>&nbsp;<b>NOTE:</b> CurrentValue is set to the caption-label before generating the image.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:6:"layout";s:8:"datatype";s:6:"string";s:11:"description";s:471:"This defines how the label and the field are placed towards each other.<br>&nbsp;<b><br>Example:</b><br>This substitutes the &quot;###FIELD###&quot; with the field data and the &quot;###LABEL###&#039; with labeldata. <br>&nbsp;<br>&lt;tr&gt;&lt;td&gt;###FIELD###&lt;/td&gt;&lt;td&gt; ###LABEL###&lt;/td&gt;&lt;/tr&gt;<br>&nbsp;<br>You can also use the marker ###COMMENT### which is ALSO the label value inserted, but wrapped in .commentWrap stdWrap-properties (see below)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:9:"fieldWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:23:"Field: Wraps the fields";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:9:"labelWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:23:"Labels: Wraps the label";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:11:"commentWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:52:"Comments: Wrap for comments IF you use ###COMMENT###";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:3:"REQ";s:8:"datatype";s:7:"boolean";s:11:"description";s:58:"Defines if required-fields should be checked and marked up";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:13:"REQ.fieldWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:47:"Field: Wraps the fields, but for reuired fields";s:7:"default";s:34:"the &quot;fieldWrap&quot;-property";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:22;a:6:{s:8:"property";s:13:"REQ.labelWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:47:"Labels: Wraps the label, but for reuired fields";s:7:"default";s:34:"the &quot;labelWrap&quot;-property";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:23;a:6:{s:8:"property";s:10:"REQ.layout";s:8:"datatype";s:6:"string";s:11:"description";s:60:"The same as &quot;layout&quot; above, but for reuired fields";s:7:"default";s:31:"the &quot;layout&quot;-property";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:24;a:6:{s:8:"property";s:14:"COMMENT.layout";s:8:"datatype";s:6:"string";s:11:"description";s:32:"Alternative layout for comments.";s:7:"default";s:31:"the &quot;layout&quot;-property";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:25;a:6:{s:8:"property";s:12:"CHECK.layout";s:8:"datatype";s:6:"string";s:11:"description";s:33:"Alternative layout for checkboxes";s:7:"default";s:31:"the &quot;layout&quot;-property";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:26;a:6:{s:8:"property";s:12:"RADIO.layout";s:8:"datatype";s:6:"string";s:11:"description";s:35:"Alternative layout for radiobuttons";s:7:"default";s:31:"the &quot;layout&quot;-property";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:27;a:6:{s:8:"property";s:12:"LABEL.layout";s:8:"datatype";s:6:"string";s:11:"description";s:34:"Alternative layout for label types";s:7:"default";s:31:"the &quot;layout&quot;-property";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:28;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:46:"Wraps the hole form (before formtags is added)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:29;a:6:{s:8:"property";s:12:"hiddenFields";s:8:"datatype";s:18:"[array of cObject]";s:11:"description";s:213:"Used to set hiddenFields from TS.<br>&nbsp;<b><br>Example:</b><br>hiddenFields.pid = TEXT<br>hiddenFields.pid.value = 2<br>&nbsp;<br>This makes a hidden-field with the name &quot;pid&quot; and value &quot;2&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:30;a:6:{s:8:"property";s:6:"params";s:8:"datatype";s:27:"form-element tag parameters";s:11:"description";s:280:"Extra parameters to form elements<br>&nbsp;<b><br>Example:</b><br>params = style=&quot;width:200px;&quot;<br>params.textarea = style=&quot;width:300px;&quot;<br>params.check = <br>&nbsp;<br>This sets the default to 200 px width, but excludes check-boxes and sets textareas to 300.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:31;a:6:{s:8:"property";s:13:"wrapFieldName";s:8:"datatype";s:4:"wrap";s:11:"description";s:222:"This wraps the fieldnames before they are applied to the form-field tags.<br>&nbsp;<b><br>Example:</b><br>If value is then the fieldname &quot;email&quot; would be wrapped to this value: <i>tx_myextension[input][email]</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:32;a:6:{s:8:"property";s:10:"noWrapAttr";s:8:"datatype";s:7:"boolean";s:11:"description";s:281:"If this value is true then all wrap attributes of textarea elements are suppressed. This is needed for XHTML-compliancy.<br>&nbsp;<br>The wrap attributes can also be disabled on a per-field basis by using the special keyword &quot;disabled&quot; as the value of the wrap attribute.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:33;a:6:{s:8:"property";s:15:"arrayReturnMode";s:8:"datatype";s:7:"boolean";s:11:"description";s:217:"If set, the &lt;form&gt; tags and the form content will be returned in an array as separate elements including other pratical values. This mode is for use in extensions where the array return value can be more useful.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:34;a:6:{s:8:"property";s:13:"accessibility";s:8:"datatype";s:7:"boolean";s:11:"description";s:461:"If set, then the form will be compliant with accessibility guidelines (XHTML compliant). This includes:<br>&nbsp;<br>label string will be wrapped in &lt;label for=&quot;formname[fieldname-hash]&quot;&gt; ... &lt;/label&gt;<br>All form elements will have an id-attribute carrying the formname with the md5-hashed fieldname appended<br>&nbsp;<br>&nbsp;<b>Notice: </b>In TYPO3 4.0 and later, CSS Styled Content is configured to produce accessible forms by default.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:35;a:6:{s:8:"property";s:8:"formName";s:8:"datatype";s:6:"string";s:11:"description";s:121:"An alternative name for this form. Default will be a unique (random) hash.<br>&nbsp;<br>&lt;form name=&quot;...&quot;&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:36;a:6:{s:8:"property";s:11:"fieldPrefix";s:8:"datatype";s:6:"string";s:11:"description";s:247:"Alternative prefix for the name of the fields in this form. Otherwise, all fields are prefixed with the form name (either a unique hash or the name set in the &quot;formName&quot; property). If set to &quot;0&quot;, there will be no prefix at all.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:37;a:6:{s:8:"property";s:17:"dontMd5FieldNames";s:8:"datatype";s:7:"boolean";s:11:"description";s:272:"The IDs generated for all elements in a form are md5 hashes from the fieldname. Setting this to true will disable this behaviour and use a cleaned fieldname, prefixed with the form name as the ID, instead.<br>This can be useful to style specifically named fields with CSS.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('71', '', '06d8abccf0aba6b413150e9c100f4bd4', '', 'tsref:(cObject).SEARCHRESULT', 'a:1:{s:4:"rows";a:15:{i:0;a:6:{s:8:"property";s:11:"allowedCols";s:8:"datatype";s:6:"string";s:11:"description";s:120:"List (separated by &quot;:&quot;) of allowed table-cols.<br>&nbsp;<b><br>Example:</b><br>pages.title:tt_content.bodytext";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"layout";s:8:"datatype";s:6:"string";s:11:"description";s:368:"This defines how the search content is shown.<br>&nbsp;<b><br>Example:</b><br>This substitutes the following fields:<br>###RANGELOW###:The low result range, eg. &quot;1&quot;<br>###RANGEHIGH###:The high result range, eg. &quot;10&quot;<br>###TOTAL###:The total results<br>###RESULT###:The result itself<br>&nbsp;###NEXT###:The next-button<br>###PREV###:The prev-button";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:4:"next";s:8:"datatype";s:7:"cObject";s:11:"description";s:126:"This cObject will be wrapped by a link to the next searchresult. This is the code substituting the &quot;###NEXT###&quot;-mark";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:4:"prev";s:8:"datatype";s:7:"cObject";s:11:"description";s:126:"This cObject will be wrapped by a link to the prev searchresult. This is the code substituting the &quot;###PREV###&quot;-mark";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:6:"target";s:8:"datatype";s:6:"target";s:11:"description";s:27:"target til next/prev links!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:5:"range";s:8:"datatype";s:3:"int";s:11:"description";s:32:"The number of results at a time!";s:7:"default";s:2:"20";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:9:"renderObj";s:8:"datatype";s:7:"cObject";s:11:"description";s:325:"the cObject to render the searchresults<br>$cObj-&gt;data array is set to the resulting record from the search.<br>Please note, that in all fields are named [tablename]_[fieldnam]. Thus the pagetitle is in the field &quot;pages_title&quot;.<br>Apart from this, these fields from the pages-table are also present:<br>&nbsp;uid";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:10:"renderWrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:9:"resultObj";s:8:"datatype";s:7:"cObject";s:11:"description";s:56:"the cObject prepended in the search results returns rows";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:11:"noResultObj";s:8:"datatype";s:7:"cObject";s:11:"description";s:50:"the cObject used if the search results in no rows.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:9:"noOrderBy";s:8:"datatype";s:7:"boolean";s:11:"description";s:87:"If this is set, the result is NOT sorted after lastUpdated, tstamp for the pages-table.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:25:"Wrap the whole content...";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:25:"Wrap the whole content...";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:22:"addExtUrlsAndShortCuts";s:8:"datatype";s:7:"boolean";s:11:"description";s:408:"If set, then the doktypes 3 and 4 (External URLS and Shortcuts) are added to the doktypes being searched.<br>However at this point in time, no pages will be select if they do not have at least one tt_content record on them! That is because the pages and tt_content (or other) table is joined. So there must at least one occurance of a tt_content element on a External URL / Shortcut page for them to show up.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:25:"languageField.[2nd table]";s:8:"datatype";s:6:"string";s:11:"description";s:198:"Setting a field name to filter language on. This works like the &quot;languageField&quot; setting in -&gt;select<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>languageField.tt_content = sys_language_uid";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('72', '', '4a24c3602d0800d7feacc6759c6dbf21', '', 'tsref:(cObject).USER/(cObject).USER_INT', 'a:1:{s:4:"rows";a:2:{i:0;a:6:{s:8:"property";s:15:"<i>userFunc</i>";s:8:"datatype";s:13:"function-name";s:11:"description";s:862:"The name of the function. If you specify the name with a &#039;-&gt;&#039; in, it&#039;s intepreted as a call to a method in a class.<br>&nbsp;Two parameters are sent: A content variable (which is empty in this case, but not when used from stdWrap function .postUserFunc and .preUserFunc) and the second parameter is an array with the properties of this cObject if any.<br>&nbsp;<b><br>Example:</b><br>This TypoScript will display all content element headers of a page in reversed order. Please take a look in media/scripts/example_callfunction.php!!<br>(Also demonstrated on the testsite, page <br>&nbsp;<br>page = PAGE<br>page.typeNum=0<br>includeLibs.something = media/scripts/example_callfunction.php<br>&nbsp;<br>page.30 = USER<br>page.30 {<br>&nbsp;&nbsp;&nbsp;userFunc = user_various-&gt;listContentRecordsOnPage<br>&nbsp;&nbsp;&nbsp;reverseOrder = 1<br>}";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:11:"includeLibs";s:8:"datatype";s:29:"&nbsp;<i>list of </i>resource";s:11:"description";s:372:"<b>(This property applies only if the object is created as USER_INT)</b><br>This is a comma-separated list of resources that are included as PHP-scripts (with include_once() function) if this script is included.<br>This is possible to do because any include-files will be known before the scripts are included. That&#039;s not the case with the regular PHP_SCRIPT cObject.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('73', '', '58679d0408b0f09f69cb93e0634e69c9', '', 'tsref:(cObject).PHP_SCRIPT', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:11:"<i>file</i>";s:8:"datatype";s:8:"resource";s:11:"description";s:972:"File that will be included. This file must be valid PHP-code! It&#039;s included with &quot;include()&quot;;<br>&nbsp;<b><br>Directions:</b><br>&nbsp;<b>1) All content must be put into $content.</b> No output must be echo&#039;ed out!<br>&nbsp;<br>&nbsp;2) Call $GLOBALS[&quot;TSFE&quot;]-&gt;set_no_cache(), if you want to disable caching of the page. Set this during development! And set it, if the content you create may not be cached. <br>&nbsp;<br>&nbsp;<b>NOTE:</b> If you have a parsing error in your include script the $GLOBALS[&quot;TSFE&quot;]-&gt;set_no_cache() function is NOT executed and thereby does not disable caching. Upon a parse-error you must manually clear the page-cache after you have corrected your error!<br>&nbsp;3) the array $conf contains the configuration for the PHP_SCRIPT cObject. Try debug($conf) to see the content printed out for debugging!<i><br>See later in this manual for an introduction to writing your own PHP include-scripts.</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('74', '', '6307a490ae08c78efdc8a3ceb92bfde6', '', 'tsref:(cObject).PHP_SCRIPT_INT', 'a:1:{s:4:"rows";a:2:{i:0;a:6:{s:8:"property";s:11:"<i>file</i>";s:8:"datatype";s:8:"resource";s:11:"description";s:2097:"File that will be included. This file must be valid PHP-code! It&#039;s included with &quot;include()&quot;;<br>&nbsp;<b><br>Purpose:</b><br>&nbsp;This basically works like PHP_SCRIPT. But the vital difference is that inserting a PHP_SCRIPT<b>_INT </b>(internal opposed to external, see below) merely inserts a divider-string in the code and then serializes the current cObj and puts it in the $GLOBALS[&quot;TSFE&quot;]-&gt;config[&quot;INTincScript&quot;]-array. This array is saved with the cached page-content.<br>Now, the point is, that including a script like this lets you avoid disabling pagecaching. The reason is that the cached page contains the divider string and when a &quot;static&quot; page is fetched from cache, it&#039;s divided by that string and the dynamic content object is inserted.<br>This is the compromise option of all three PHP_SCRIPT-cObjects, because the page-data is all cached, but still the pagegen.php script is included, which initializes all the classes, objects and so. What you gain here is an environment for your script almost exactly the same as PHP_SCRIPT because your script is called from inside a class tslib_cObj object. You can work with all functions of the tslib_cObj-class. But still all the &quot;static&quot; pagecontent is only generated once, cached and only your script is dynamically rendered.<br>&nbsp;<b><br>Rules:</b><br>- calls to $GLOBALS[&quot;TSFE&quot;]-&gt;set_no_cache() and $GLOBALS[&quot;TSFE&quot;]-&gt;set_cache_timeout_default() makes no sense in this situation.<br>- parsing errors does not interfere with caching<br>- Be aware that certain global variables may not be set as usual and be available as usual when working in this mode. Most scripts should work out-of-the-box with this option though.<br>- Dependence and use of LOAD_REGISTER is fragile because the PHP_SCRIPT_INT is not rendered until <i>after</i> the cached content and due to this changed order of events, use of LOAD_REGISTER may not work.<br>- You can not nest PHP_SCRIPT_INT and PHP_SCRIPT_EXT in PHP_SCRIPT_INT. You may nest PHP_SCRIPT cObjects though.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:11:"includeLibs";s:8:"datatype";s:29:"&nbsp;<i>list of </i>resource";s:11:"description";s:296:"This is a comma-separated list of resources that are included as PHP-scripts (with include_once() function) if this script is included.<br>This is possible to do because any include-files will be known before the scripts are included. That&#039;s not the case with the regular PHP_SCRIPT cObject.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('75', '', 'dede7a11cddf475e1eaf0a9116291157', '', 'tsref:(cObject).PHP_SCRIPT_EXT', 'a:1:{s:4:"rows";a:2:{i:0;a:6:{s:8:"property";s:11:"<i>file</i>";s:8:"datatype";s:8:"resource";s:11:"description";s:1464:"File that will be included. This file must be valid PHP-code! It&#039;s included with &quot;include()&quot;;<br>&nbsp;<b><br>Purpose:</b><br>&nbsp;This works like PHP_SCRIPT_INT, because a divider string is also inserted in the content for this kind of include-script. But the difference is that the content is divided as the very last thing before it&#039;s output to the browser. <br>This basically means that PHP_SCRIPT<b>_EXT</b> (external, because it&#039;s included in the global space in index_ts.php file!!) can output data directly with echo-statements! <br>This is a very &quot;raw&quot; version of PHP_SCRIPT because it&#039;s not included from inside an object and you have only very few standard functions from TYPO3 to call.<br>This is the fastest option of all three PHP_SCRIPT-cObjects, because the page-data is all cached and your dynamic content is generated by a raw php-script<br>&nbsp;<b><br>Rules:</b><br>- All content can be either 1) echo&#039;ed out directly, or 2) returned in $content.<br>- calls to $GLOBALS[&quot;TSFE&quot;]-&gt;set_no_cache() and $GLOBALS[&quot;TSFE&quot;]-&gt;set_cache_timeout_default() makes no sense in this situation.<br>- parsing errors does not interfere with caching<br>- In the global name-space, the array $REC contains the current record when the file was &quot;inserted&quot; on the page, and $CONF-array contains the configuration for the script.<br>- Don&#039;t mess with the global vars named $EXTiS_* ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:11:"includeLibs";s:8:"datatype";s:29:"&nbsp;<i>list of </i>resource";s:11:"description";s:296:"This is a comma-separated list of resources that are included as PHP-scripts (with include_once() function) if this script is included.<br>This is possible to do because any include-files will be known before the scripts are included. That&#039;s not the case with the regular PHP_SCRIPT cObject.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('76', '', '36fc199c62fb88c0a813769e3de9adc9', '', 'tsref:(cObject).TEMPLATE', 'a:1:{s:4:"rows";a:9:{i:0;a:6:{s:8:"property";s:8:"template";s:8:"datatype";s:7:"cObject";s:11:"description";s:84:"&nbsp;This must be loaded with the template-code. If not the object returns nothing.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:8:"subparts";s:8:"datatype";s:30:"<i>Array... of </i><br>cObject";s:11:"description";s:1253:"This is an array of subpart-markers (case-sensitive).<br>A subpart is defined by two markers in the template. The markers must be wrapped by &quot;###&quot; on both sides. You may insert the subpart-markers inside HTML-comment-tags!! <br>&nbsp;<b><br>Example: </b><br>subparts {<br>&nbsp;&nbsp;&nbsp;HELLO = TEXT<br>&nbsp;&nbsp;&nbsp;HELLO.value = En subpart er blevet erstattet!!<br>}<br>&nbsp;<br>In the templates:<br>&lt;!-- start of subpart: ###HELLO### --&gt;<br>This is the HTML.code, that will be loaded in the register and replaced with the result...<br>&lt;!-- end ###HELLO### --&gt;<br>&nbsp;<b><br>NOTE:</b><br>Before the content-objects of each subpart is generated, all subparts in the array are extracted and loaded into the register so that you can load them from there later on. <br>The register-key for each subparts code is &quot;SUBPART_[theSubpartkey]&quot;.<br>In addition the current-value is loaded with the content of each subpart just before the cObject for the subpart is parsed. That makes it quite easy to load the subpart of the cObject (eg: &quot;.current=1&quot;)<br>Eg. this subpart above has the register-key &quot;SUBPART_HELLO&quot;.<i><br>This is valid ONLY if the property .nonCachedSubst is not set! (see below)</i>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:13:"relPathPrefix";s:8:"datatype";s:26:"<i>string / properties</i>";s:11:"description";s:757:"Finds all relative references (eg. to images or stylesheets) and prefixes this value.<br>If you specify properties (uppercase) these will match HTML tags and specify alternative paths for them. See example below.<br>If the property is named &quot;style&quot; it will set alternative path for the &quot;url()&quot; wrapper that may be in &lt;style&gt; sections.<br>&nbsp;<b><br>Example:</b><br>page.10 = TEMPLATEpage.10 { template = FILE template.file = fileadmin/template.html relPathPrefix = fileadmin/<br>&nbsp;&nbsp;&nbsp;relPathPrefix.IMG = fileadmin/img/}<br>&nbsp;<br>Inthis example all relative paths found are prefixed &quot;fileadmin/&quot; unless it was the src attribute of an img tag in which case the path prefixed is &quot;fileadmin/img/&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:5:"marks";s:8:"datatype";s:30:"<i>Array... of </i><br>cObject";s:11:"description";s:451:"This is an array of marks-markers (case-sensitive).<br>A mark is defined by one markers in the template. The marker must be wrapped by &quot;###&quot; on both sides. Opposite to subparts, you may NOT insert the subpart-markers inside HTML-comment-tags! (They will not be removed).<br>Marks are substituted bya str_replace-function. The subparts loaded in the register is available also to the cObjects of markers (only if .nonCachedSubst is not set!).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:5:"wraps";s:8:"datatype";s:30:"<i>Array... of </i><br>cObject";s:11:"description";s:483:"This is an array of wraps-markers (case-sensitive).<br>This is shown best by an example:<b><br>Example: </b><br>subparts {<br>&nbsp;&nbsp;&nbsp;MYLINK = TEXT<br>&nbsp;&nbsp;&nbsp;MYLINK.value = &lt;A href=&quot;#&quot;&gt; | &lt;/A&gt;<br>}<br>&nbsp;<br>In the template:<br>This is &lt;!--###MYLINK###--&gt;a link to my&lt;!--###MYLINK###--&gt; page!<br>&nbsp;<br>In this example the MYLINK subpart will be substituted by the wrap which is the content returned by the MYLINK cObject.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:13:"workOnSubpart";s:8:"datatype";s:6:"string";s:11:"description";s:204:"This is an optional definition of a subpart, that we decide to work on. In other words; if you define this value that subpart is extracted from the template and is the basis for this whole templateobject.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:10:"markerWrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:235:"This is the wrap the markers is wrapped with. The default value is ### | ### resulting in the markers to be presented as ###[marker_key]###.<br>Any whitespace around the wrap-items is stripped before they are set around the marker_key.";s:7:"default";s:9:"### | ###";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:20:"substMarksSeparately";s:8:"datatype";s:7:"boolean";s:11:"description";s:431:"If set, then marks are substituted in the content AFTER the substitution of subparts and wraps. <br>Normally marks are not substituted inside of subparts and wraps when you are using the default cached mode of the TEMPLATE cObject. That is a problem if you have marks inside of subparts! But setting this flag will make the marker-substitution a non-cached, subsequent process.<br>Another solution is to turn of caching, see below.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:14:"nonCachedSubst";s:8:"datatype";s:7:"boolean";s:11:"description";s:707:"If set, then the substitution mode of this cObject is totally different. Normally the raw template is read and divided into the sections denoted by the marks, subparts and wraps keys. The good thing is high speed, because this &quot;pre-parsed&quot; template is cached. The bad thing is that templates that depends on incremental substition (where the order of substition is important) will not work so well.<br>By setting this flag, markers are first substituted by str_replace in the template - one by one. Then the subparts are substituted one by one. And finally the wraps one by one.<br>Obviously you loose the ability to refer to other parts in the template with the register-keys as described above. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('77', '', '9e45ae1e8e57e33a34339154486c9e40', '', 'tsref:(cObject).MULTIMEDIA', 'a:1:{s:4:"rows";a:3:{i:0;a:6:{s:8:"property";s:4:"file";s:8:"datatype";s:17:"resource /stdWrap";s:11:"description";s:213:"The multimedia file. Types are:<br>txt, html, htm:Inserted directly<br>class:Java-applet<br>swf:Flash animation<br>swa, dcr:ShockWave Animation<br>wav,au:Sound<br>avi,mov,asf,mpg,wmv:Movies (AVI, QuickTime, MPEG4)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"params";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:351:"This is parameters for the multimedia-objects. Use this to enter stuff like with and height:<br>&nbsp;<b><br>Example:</b><br>width=200<br>height=300<br>&nbsp;<br>... will generate a tag like &#039;&lt;embed .... width=&quot;200&quot; height=&quot;300&quot;&gt;&#039;<br>height=<br>&nbsp;<br>An empty string will remove the parameter from the embed-tag";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('78', '', '71d45380d5c1507c11c46fa7b95d72fa', '', 'tsref:(cObject).EDITPANEL', 'a:1:{s:4:"rows";a:11:{i:0;a:6:{s:8:"property";s:5:"label";s:8:"datatype";s:6:"string";s:11:"description";s:123:"Title for the panel. You can insert the record title with %s<br>&nbsp;<b><br>Example:</b><br>Section: &lt;B&gt;%s&lt;/B&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:5:"allow";s:8:"datatype";s:6:"string";s:11:"description";s:356:"Define which functions are accessible. Further this list may be reduced, if the BE_USER does not have permission to perform the action<br>Values should be listed separated by comma. This is the options you can choose between:<br>toolbar,edit,new,delete,move,hide <br>(toolbar is a general list of icons regarding the page, so use this for pagerecords only)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:18:"newRecordFromTable";s:8:"datatype";s:6:"string";s:11:"description";s:98:"Will display a panel for creation of new element (in the top of list) on the page from that table.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:14:"newRecordInPid";s:8:"datatype";s:3:"int";s:11:"description";s:70:"Define a page ID where new records (except new pages) will be created.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:4:"line";s:8:"datatype";s:13:"boolean / int";s:11:"description";s:120:"If set, a black line will appear after the panel. This value will indicate the distance from the black line to the panel";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:18:"edit.displayRecord";s:8:"datatype";s:7:"boolean";s:11:"description";s:67:"If set, then the record edited is displayed above the editing form.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:14:"onlyCurrentPid";s:8:"datatype";s:7:"boolean";s:11:"description";s:99:"If set, only records with a pid matching the current id (TSFE-&gt;id) will be shown with the panel.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:9:"innerWrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:20:"Wraps the edit panel";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:9:"outerWrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:67:"Wraps the whole edit panel including the black line (if configured)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:13:"previewBorder";s:8:"datatype";s:14:"boolean / int ";s:11:"description";s:157:"If set, the hidden/starttime/endtime/fe_user elements which are previewed will have a border around.<br>The integer value denotes the thickness of the border";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:73:"previewBorder.innerWrap<br>previewBorder.outerWrap<br>previewBorder.color";s:8:"datatype";s:17:"wrap / HTML color";s:11:"description";s:271:"&nbsp;<b>innerWrap</b> wraps the content elements (including the icons) inside the preview border (an HTML table). <br>&nbsp;<br>&nbsp;<b>outerWrap</b> wraps the whole content element including the border. <br>&nbsp;<br>&nbsp;<b>color</b> denotes the color of the border.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('79', '', '92d229100f79be75aed1bd3d7f60373d', '', 'tsref:_GIFBUILDER.charRangeMap', 'a:1:{s:4:"rows";a:4:{i:0;a:6:{s:8:"property";s:8:"[array] ";s:8:"datatype";s:6:"string";s:11:"description";s:987:"Basename of font file to match for this configuration. Notice that only the <i>filename</i> of the font file is used - the path is stripped off. This is done to make matching easier and avoid problems when font files might move to other locations in extensions etc.<br>&nbsp;<br>So if you use the font file &quot;EXT:myext/fonts/arial.ttf&quot; or &quot;t3lib/fonts/arial.ttf&quot; both of them will match with this configuration.<br>&nbsp;<b><br>The key:</b><br>The value of the array key will be the key used when forcing the configuration into &quot;splitRendering&quot; configuration of the individual GIFBUILDER objects. In the example below the key is &quot;123&quot;. <br>Notice; If the key is already found in the local GIFBUILDER configuration the content of that key is respected and not overridden. Thus you can make local configurations which override the global setting.<br>&nbsp;<b><br>Example:</b><br>_GIFBUILDER.charRangeMap {<br>&nbsp;&nbsp;&nbsp;123 = arial.ttf<br>....";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:21:"[array].charMapConfig";s:8:"datatype";s:43:"TEXT / splitRendering.[array] configuration";s:11:"description";s:871:"splitRendering configuration to set. See GIFBUILDER TEXT object for details.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>_GIFBUILDER.charRangeMap {<br>&nbsp;&nbsp;&nbsp;123 = arial.ttf<br>&nbsp;&nbsp;&nbsp;123 {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>charMapConfig {</b><b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fontFile = t3lib/fonts/vera.ttf</b><b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value = -65</b><b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fontSize = 45</b><b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fontSizeMultiplicator = 2.3<br>&nbsp;&nbsp;&nbsp;}<br>}<br>&nbsp;<br>This example configuration shows that GIFBUILDER TEXT objects with font faces matching &quot;arial.ttf&quot; will have a splitConfiguration that uses &quot;t3lib/fonts/vera.ttf&quot; for all characters that fall below/equal to 65 in Unicode value.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:29:"[array].fontSizeMultiplicator";s:8:"datatype";s:6:"double";s:11:"description";s:185:"If set, this will take the font size of the TEXT GIFBUILDER object and multiply with this amount (xx.xx) and override the &quot;fontSize&quot; property inside &quot;charMapConfig&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:29:"[array].pixelSpaceFontSizeRef";s:8:"datatype";s:6:"double";s:11:"description";s:1365:"If set, this will multiply the four [x/y]Space[Before/After] properties of split rendering with the relationship between the fontsize and this value. <br>In other words; Since pixel space may vary depending on the font size used you can simply specify by this value at what fontsize the pixel space settings are optimized and for other fontsizes this will automatically be adjusted according to this font size.<br>&nbsp;<b><br>Example:</b><br>_GIFBUILDER.charRangeMap {<br>&nbsp;&nbsp;&nbsp;123 = arial.ttf<br>&nbsp;&nbsp;&nbsp;123 {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;charMapConfig {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fontFile = t3lib/fonts/vera.ttf<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value = 48-57<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;color = green<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>xSpaceBefore = 3</b><b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;xSpaceAfter = 3</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>pixelSpaceFontSizeRef = 24</b><br>&nbsp;&nbsp;&nbsp;}<br>}<br>&nbsp;<br>In this example xSpaceBefore and xSpaceAfter will be &quot;3&quot; when the font size is 24. If this configuration is used on a GIFBUILDER TEXT object where the font size is only 16 the spacing values will be corrected by &quot;16/24&quot;, effectively reducing the pixelspace to &quot;2&quot; in that case.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('80', '', '07c97ef7ff913a09f3d43365e693254c', '', 'tsref:->GIFBUILDER', 'a:1:{s:4:"rows";a:12:{i:0;a:6:{s:8:"property";s:10:"1,2,3,4...";s:8:"datatype";s:32:"GifBuilderObj<br>+ .if (-&gt;if)";s:11:"description";s:205:".if (-&gt;if) is a property of all gifbuilder-objects. If the property is present and NOT set, the object is NOT rendered! This corresponds to the functionallity of &quot;.if&quot; of the stdWrap-function.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:2:"XY";s:8:"datatype";s:9:"x,y +calc";s:11:"description";s:22:"Size of the gif-file. ";s:7:"default";s:6:"100,20";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:6:"format";s:8:"datatype";s:33:"&quot;gif&quot; / &quot;jpg&quot;";s:11:"description";s:61:"Output type. <br>&quot;jpg&quot;/&quot;jpeg&quot; = jpg-image";s:7:"default";s:3:"gif";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:12:"reduceColors";s:8:"datatype";s:14:"posint (1-255)";s:11:"description";s:41:"Reduce the number of colors (if gif-file)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:21:"transparentBackground";s:8:"datatype";s:7:"boolean";s:11:"description";s:287:"Set this flag to render the background transparent. TYPO3 makes the color found at position 0,0 of the image (upper left corner) transparent.<br>If you render text you should leave the niceText option OFF as the result with probably be more precise without the niceText antialiasing hack";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:16:"transparentColor";s:8:"datatype";s:31:"&nbsp;<i>HTMLColor</i> /stdWrap";s:11:"description";s:451:"Specify a color that should be transparent<br>&nbsp;<b><br>Example-values:</b><br>#ffffcc <br>red <br>255,255,127<br>&nbsp;<b><br>Option:</b><br>transparentColor.closest = 1<br>This will allow for the closest color to be matched instead. You may need this if you image is not garanteed &quot;clean&quot;.<br>&nbsp;<br>&nbsp;<b>NOTE:</b> You may experience that this doesn&#039;t work if you use reduceColors-option or render text with niceText-option.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:7:"quality";s:8:"datatype";s:15:"posint (10-100)";s:11:"description";s:47:"JPG-quality (if &quot;.format&quot; = jpg/jpeg)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:9:"backColor";s:8:"datatype";s:25:"GraphicColor <br>+stdWrap";s:11:"description";s:28:"Background color for the gif";s:7:"default";s:5:"white";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:6:"offset";s:8:"datatype";s:9:"x,y +calc";s:11:"description";s:30:"Offset all objects on the gif.";s:7:"default";s:3:"0,0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:8:"workArea";s:8:"datatype";s:14:"x,y,w,h + calc";s:11:"description";s:253:"Define the workarea on the giffile. All the GifBuilderObj&#039;s will see this as the dimensions of the gif-file regarding alignment, overlaying of images an so on. Only will TEXT-objects exceeding the boundaries of the workarea print outside this area.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:8:"maxWidth";s:8:"datatype";s:6:"pixels";s:11:"description";s:25:"Maximal width of gif-file";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:9:"maxHeight";s:8:"datatype";s:6:"pixels";s:11:"description";s:26:"Maximal heigth of gif-file";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('81', '', '39e45fa8cdd66301847431223c33177b', '', 'tsref:->GIFBUILDER.(GBObj).TEXT', 'a:1:{s:4:"rows";a:22:{i:0;a:6:{s:8:"property";s:4:"text";s:8:"datatype";s:7:"stdWrap";s:11:"description";s:220:"This is text text-string on the gif-file. The item is rendered only if this string is not empty.<br>The cObj-&gt;data-array is loaded with the page-record, if for example the GIFBUILDER-object is used by GMENU or IMGMENU";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:13:"textMaxLength";s:8:"datatype";s:3:"int";s:11:"description";s:115:"The maximum length of the text. This is just a natural break that prevents incidental rendering of very long texts!";s:7:"default";s:3:"100";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:8:"maxWidth";s:8:"datatype";s:6:"pixels";s:11:"description";s:261:"Sets the maximum width in pixels, the text must be. Reduces the fontSize if the text does not fit within this width.<br>&nbsp;<br>Does not support setting alternative fontSizes in splitRendering options.<br>&nbsp;<br>(By Rene Fritz &lt;r.fritz@colorcube.de&gt;)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:14:"doNotStripHTML";s:8:"datatype";s:7:"boolean";s:11:"description";s:104:"If set, HTML-tags in the string inserted are NOT removed. Any other way HTML-code is removed by default!";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:8:"fontSize";s:8:"datatype";s:6:"posint";s:11:"description";s:9:"Font size";s:7:"default";s:2:"12";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:9:"fontColor";s:8:"datatype";s:21:"GraphicColor /stdWrap";s:11:"description";s:10:"Font color";s:7:"default";s:5:"black";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:8:"fontFile";s:8:"datatype";s:8:"resource";s:11:"description";s:42:"Font face (truetype font you can upload!!)";s:7:"default";s:20:"Nimbus (Arial-clone)";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:5:"angle";s:8:"datatype";s:6:"degree";s:11:"description";s:116:"Rotation degrees of the text. <br>&nbsp;<br>&nbsp;<b>NOTE:</b> Angle is not available if spacing/wordSpacing is set.";s:7:"default";s:22:"0<br>Range: -90 til 90";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:5:"align";s:8:"datatype";s:5:"align";s:11:"description";s:21:"Alignment of the text";s:7:"default";s:4:"left";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:6:"offset";s:8:"datatype";s:9:"x,y +calc";s:11:"description";s:18:"Offset of the text";s:7:"default";s:3:"0,0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:9:"antiAlias";s:8:"datatype";s:7:"Boolean";s:11:"description";s:151:"FreeType antialiasing. Notice, the default mode is &quot;on&quot;!<br>&nbsp;<br>&nbsp;<b>Note:</b> This option is not available if .niceText is enabled";s:7:"default";s:1:"1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:10:"iterations";s:8:"datatype";s:6:"posint";s:11:"description";s:191:"How many times the text should be &quot;printed&quot; onto it self. This will add the effect of bold text.<br>&nbsp;<br>&nbsp;<b>Note:</b> This option is not available if .niceText is enabled";s:7:"default";s:1:"1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:7:"spacing";s:8:"datatype";s:6:"posint";s:11:"description";s:53:"Pixel-distance between letters. This may render ugly!";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:11:"wordSpacing";s:8:"datatype";s:6:"posint";s:11:"description";s:29:"Pixel-distance between words.";s:7:"default";s:24:"= &quot;.spacing&quot;*2";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:4:"hide";s:8:"datatype";s:7:"boolean";s:11:"description";s:163:"If this is true, the text is NOT printed. <br>This feature may be used if you need a shadow-object to base a shadow on the text, but do not want the text to print.";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:16:"hideButCreateMap";s:8:"datatype";s:7:"boolean";s:11:"description";s:230:"If this option is set, the text will not be rendered. Shadows and emboss will, though, so don&#039;t apply these!! But this feature is also meant only to enable a text to generate the imageMap coordinates without rendering itself.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:6:"emboss";s:8:"datatype";s:24:"GifBuilderObj-&gt;EMBOSS";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:6:"shadow";s:8:"datatype";s:24:"GifBuilderObj-&gt;SHADOW";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:7:"outline";s:8:"datatype";s:25:"GifBuilderObj-&gt;OUTLINE";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:6:"imgMap";s:8:"datatype";s:109:"-&gt;IMGMAP<br>&nbsp;<br>+ stdWrap properties for &quot;altText&quot; and &quot;titleText&quot; in this case.";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:8:"niceText";s:8:"datatype";s:7:"boolean";s:11:"description";s:1004:"This is a very popular feature that helps to render small letters much nicer than the freetype library can normally do. But it also loads the system very much!<br>The principle of this function is to create a black/white giffile in twice or more times the size of the actual gif-file and then print the text onto this is a scaled dimension. Afterwards ImageMagick (IM) scales down the mask and masks the font color down on the original gif-file through the temporary mask. <br>The fact that the font is actually rendered in the double size and scaled down adds a more homogenous shape to the lettes. Some fonts are more critical than others though. If you do not need the quality, then don&#039;t use the function.<br>&nbsp;<b><br>Some properties:</b><br>.before = IM-params before scale<br>.after = IM-params after scale<br>.sharpen = sharpen-value for the mask (after scaling), integer 0-99 (this enables you to make the text crisper if it&#039;s too blurred!)<br>.scaleFactor = scaling-factor, int 2-5";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:80:"splitRendering.compX<br>splitRendering.compY<br>splitRendering.[array]<br>&nbsp;";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:2810:"Split the rendering of a string into separate processes with individual configurations. By this method a certain range of characters can be rendered with another font face or size. This is very useful if you want to use separate fonts for strings where you have latin characters combined with eg. Japanese and there is a separate font file for each.<br>You can also render keywords in another font/size/color.<br>&nbsp;<b><br>Properties:</b><br>splitRendering.compX = <i>Additional pixelspace between parts, x direction</i><br>splitRendering.compY = <i>Additional pixelspace between parts, y direction</i><br>splitRendering.[array] = [charRange, highlightWord]<br>splitRendering.[array] {<br>&nbsp;&nbsp;&nbsp;fontFile = <i>Alternative font file for this rendering</i><br>&nbsp;&nbsp;&nbsp;fontSize = <i>Alternative font size for this rendering</i><br>&nbsp;&nbsp;&nbsp;color = <i>Alternative color for this rendering, works ONLY without &quot;niceText&quot;</i><br>&nbsp;&nbsp;&nbsp;xSpaceBefore = <i>x-Space before this part</i><br>&nbsp;&nbsp;&nbsp;xSpaceAfter = <i>x-Space after this part</i><br>&nbsp;&nbsp;&nbsp;ySpaceBefore =<i> y-Space before this part</i><br>&nbsp;&nbsp;&nbsp;ySpaceAfter = <br>}<br>&nbsp;<b><br>Keyword: charRange</b><br>splitRendering.[array].value = Commaseparated list of character ranges (eg. &quot;100-200&quot;) given as Unicode character numbers. The list accepts optional starting and ending points, eg. &quot; - 200&quot; or &quot; 200 -&quot; and single values, eg. &quot;65, 66, 67&quot;<br>&nbsp;<b><br>Keyword: highlightWord</b><br>splitRendering.[array].value = Word to highlight, makes a case sensitive search for this.<br>&nbsp;<b><br>Limitations:</b><br>The pixelcompensation values are not corrected for scale factor used with niceText. Basically this means that when niceText is used, these values will have only the half effect.<br>When word spacing is used the &quot;highlightWord&quot; mode doesn&#039;t work.<br>The color override works only without &quot;niceText&quot;.<br>&nbsp;<b><br>Example:</b><br>&nbsp;&nbsp;&nbsp;10.splitRendering.compX <b>=</b> 2<br>&nbsp;&nbsp;&nbsp;10.splitRendering.compY <b>=</b> -2<br>&nbsp;&nbsp;&nbsp;10.splitRendering.10 <b>=</b> charRange<br>&nbsp;&nbsp;&nbsp;10.splitRendering.10 <b>{</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value <b>=</b> 200-380 , 65, 66<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fontSize <b>=</b> 50<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fontFile <b>=</b> t3lib/fonts/nimbus.ttf<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;xSpaceBefore <b>=</b> 30<br>&nbsp;&nbsp;&nbsp;<b>}</b><br>&nbsp;&nbsp;&nbsp;10.splitRendering.20 <b>=</b> highlightWord<br>&nbsp;&nbsp;&nbsp;10.splitRendering.20 <b>{</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value <b>=</b> TheWord<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;color <b>=</b> red<br>&nbsp;&nbsp;&nbsp;<b>}</b>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('82', '', '5be8c3b8974e916b9d679e1daf164057', '', 'tsref:->GIFBUILDER.(GBObj).SHADOW', 'a:1:{s:4:"rows";a:6:{i:0;a:6:{s:8:"property";s:10:"textObjNum";s:8:"datatype";s:7:"pos-int";s:11:"description";s:309:"Must point to the TEXT-object if these shadow-properties are not properties to a TEXT-object directly (&quot;stand-alone-shadow&quot;). Then the shadow needs to know which TEXT-object it should be a shadow of!<br>If - on the other hand - the shadow is a property to a text-object, this property is not needed.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"offset";s:8:"datatype";s:3:"x,y";s:11:"description";s:13:"Shadow offset";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:5:"color";s:8:"datatype";s:12:"GraphicColor";s:11:"description";s:12:"Shadow color";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:4:"blur";s:8:"datatype";s:13:"posint (1-99)";s:11:"description";s:389:"Blurring of the shadow. Above 40 only values of 40,50,60,70,80,90 means something.<br>&nbsp;<br>&nbsp;<b>NOTE:</b> Unfortunately the blurring capabilities of ImageMagick is not very mature in the version 4.2.9. This is addressed in the later version 5.2.0 where a gaussian blur-function is added. BUT as we do cannot use the latest ImageMagick development yet, this is not utilized so far.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:7:"opacity";s:8:"datatype";s:14:"posint (1-100)";s:11:"description";s:97:"Opacity (transparency^-1) <br>100% opacity = 0% transparency). Only active with a value for blur.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:9:"intensity";s:8:"datatype";s:13:"posint(0-100)";s:11:"description";s:148:"How &quot;massive&quot; the shadow is. This value can - if it has a high value combined with a blurred shadow - create a kind of soft-edged outline.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('83', '', 'effa3a1bd581c80efddf4f9370a21358', '', 'tsref:->GIFBUILDER.(GBObj).EMBOSS', 'a:1:{s:4:"rows";a:7:{i:0;a:6:{s:8:"property";s:10:"textObjNum";s:8:"datatype";s:7:"pos-int";s:11:"description";s:309:"Must point to the TEXT-object if these shadow-properties are not properties to a TEXT-object directly (&quot;stand-alone-shadow&quot;). Then the shadow needs to know which TEXT-object it should be a shadow of!<br>If - on the other hand - the shadow is a property to a text-object, this property is not needed.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"offset";s:8:"datatype";s:3:"x,y";s:11:"description";s:20:"Offset of the emboss";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:9:"highColor";s:8:"datatype";s:12:"GraphicColor";s:11:"description";s:18:"Upper border-color";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:8:"lowColor";s:8:"datatype";s:12:"GraphicColor";s:11:"description";s:18:"lower border-color";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:4:"blur";s:8:"datatype";s:13:"posint (1-99)";s:11:"description";s:82:"Blurring of the shadow. Above 40 only values of 40,50,60,70,80,90 means something.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:7:"opacity";s:8:"datatype";s:14:"posint (1-100)";s:11:"description";s:97:"Opacity (transparency^-1) <br>100% opacity = 0% transparency). Only active with a value for blur.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:9:"intensity";s:8:"datatype";s:13:"posint(0-100)";s:11:"description";s:148:"How &quot;massive&quot; the emboss is. This value can - if it has a high value combined with a blurred shadow - create a kind of soft-edged outline.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('84', '', '51a763b66d4511f3e4e5216bc300f7db', '', 'tsref:->GIFBUILDER.(GBObj).OUTLINE', 'a:1:{s:4:"rows";a:3:{i:0;a:6:{s:8:"property";s:10:"textObjNum";s:8:"datatype";s:7:"pos-int";s:11:"description";s:309:"Must point to the TEXT-object if these shadow-properties are not properties to a TEXT-object directly (&quot;stand-alone-shadow&quot;). Then the shadow needs to know which TEXT-object it should be a shadow of!<br>If - on the other hand - the shadow is a property to a text-object, this property is not needed.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:9:"thickness";s:8:"datatype";s:3:"x,y";s:11:"description";s:38:"Thickness in each direction, range 1-2";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:5:"color";s:8:"datatype";s:12:"GraphicColor";s:11:"description";s:13:"Outline color";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('85', '', '8ff83c2335d4b0a2170dbe5180c449a0', '', 'tsref:->GIFBUILDER.(GBObj).BOX', 'a:1:{s:4:"rows";a:3:{i:0;a:6:{s:8:"property";s:10:"dimensions";s:8:"datatype";s:13:"x,y,w,h +calc";s:11:"description";s:164:"Dimensions of a filled box. <br>x,y &nbsp;&nbsp;&nbsp;is the offset. <br>w,h &nbsp;&nbsp;&nbsp;is the dimensions. Dimensions of 1 will result in 1-pixel wide lines!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:5:"color";s:8:"datatype";s:12:"GraphicColor";s:11:"description";s:10:"fill-color";s:7:"default";s:5:"black";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:5:"align";s:8:"datatype";s:7:"VHalign";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('86', '', '2cb1f22d527579954a79b8a61bde9821', '', 'tsref:->GIFBUILDER.(GBObj).IMAGE', 'a:1:{s:4:"rows";a:5:{i:0;a:6:{s:8:"property";s:4:"file";s:8:"datatype";s:11:"imgResource";s:11:"description";s:13:"The imagefile";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"offset";s:8:"datatype";s:9:"x,y +calc";s:11:"description";s:7:"Offset ";s:7:"default";s:3:"0,0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:4:"tile";s:8:"datatype";s:3:"x,y";s:11:"description";s:93:"tile x,y times. <br>Maximum times is 20 each direction. If you need more, use a larger image.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:5:"align";s:8:"datatype";s:7:"VHalign";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:4:"mask";s:8:"datatype";s:11:"imgResource";s:11:"description";s:38:"Optional mask-image for the imagefile.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('87', '', '929383b3d8d54785cc1039680ff99cc1', '', 'tsref:->GIFBUILDER.(GBObj).EFFECT', 'a:1:{s:4:"rows";a:16:{i:0;a:6:{s:8:"property";s:5:"gamma";s:8:"datatype";s:9:"0.5 - 3.0";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:4:"blur";s:8:"datatype";s:4:"1-99";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:7:"sharpen";s:8:"datatype";s:4:"1-99";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:8:"solarize";s:8:"datatype";s:4:"0-99";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:5:"swirl";s:8:"datatype";s:5:"0-100";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:4:"wave";s:8:"datatype";s:15:"ampli , length ";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:8:"charcoal";s:8:"datatype";s:5:"0-100";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:4:"gray";s:8:"datatype";s:1:"-";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:4:"edge";s:8:"datatype";s:4:"0-99";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:6:"emboss";s:8:"datatype";s:1:"-";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:4:"flip";s:8:"datatype";s:1:"-";s:11:"description";s:17:"Vertical flipping";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:4:"flop";s:8:"datatype";s:1:"-";s:11:"description";s:19:"Horizontal flipping";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:6:"rotate";s:8:"datatype";s:5:"0-360";s:11:"description";s:8:"Rotation";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:6:"colors";s:8:"datatype";s:5:"2-255";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:5:"shear";s:8:"datatype";s:8:"-90 - 90";s:11:"description";s:19:"Horizontal shearing";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:6:"invert";s:8:"datatype";s:1:"-";s:11:"description";s:17:"invert the colors";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('88', '', '2f2fcb9c4842398cd5db95ab70b149e1', '', 'tsref:->GIFBUILDER.(GBObj).WORKAREA', 'a:1:{s:4:"rows";a:2:{i:0;a:6:{s:8:"property";s:3:"set";s:8:"datatype";s:14:"x,y,w,h + calc";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:5:"clear";s:8:"datatype";s:7:"(isset)";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('89', '', '5508b16c314c5d90493806f1d5ca4cf3', '', 'tsref:->GIFBUILDER.(GBObj).CROP', 'a:1:{s:4:"rows";a:3:{i:0;a:6:{s:8:"property";s:9:"backColor";s:8:"datatype";s:12:"GraphicColor";s:11:"description";s:6:"&nbsp;";s:7:"default";s:22:"The original backColor";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:5:"align";s:8:"datatype";s:7:"VHalign";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:4:"crop";s:8:"datatype";s:14:"x,y,v,h + calc";s:11:"description";s:58:"x,y is offset of the crop-frame, <br>v,h is the dimensions";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('90', '', 'ba6305e366aaa4b52244519082a733b0', '', 'tsref:->GIFBUILDER.(GBObj).SCALE', 'a:1:{s:4:"rows";a:3:{i:0;a:6:{s:8:"property";s:5:"width";s:8:"datatype";s:13:"pixels + calc";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"height";s:8:"datatype";s:13:"pixels + calc";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:6:"params";s:8:"datatype";s:17:"ImageMagickParams";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('91', '', 'bf3aab4abf7599f8a3e05707afd7b9fc', '', 'tsref:->GIFBUILDER.(GBObj).ADJUST', 'a:1:{s:4:"rows";a:3:{i:0;a:6:{s:8:"property";s:11:"inputLevels";s:8:"datatype";s:8:"low,high";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:12:"outputLevels";s:8:"datatype";s:9:"low, high";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:10:"autoLevels";s:8:"datatype";s:1:"-";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('92', '', 'c647a6f7686f2a20dfc6fcea63b02c18', '', 'tsref:->IMGMAP', 'a:1:{s:4:"rows";a:6:{i:0;a:6:{s:8:"property";s:3:"url";s:8:"datatype";s:3:"url";s:11:"description";s:11:"url to link";s:7:"default";s:47:"For IMGMENU menu objects provided automatically";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"target";s:8:"datatype";s:6:"target";s:11:"description";s:15:"target for link";s:7:"default";s:47:"For IMGMENU menu objects provided automatically";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:6:"noBlur";s:8:"datatype";s:7:"Boolean";s:11:"description";s:192:"Normally graphical links are &quot;blurred&quot; if the browser is MSIE. This removes the ugly box around a link. <br>If this property is set, the link is NOT blurred with &quot;onFocus&quot;.";s:7:"default";s:47:"For IMGMENU menu objects provided automatically";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:7:"explode";s:8:"datatype";s:3:"x,y";s:11:"description";s:146:"This &quot;explodes&quot; or &quot;implodes&quot; the image-map. Useful to let the hot area cover a little more than just the letters of the text.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:7:"altText";s:8:"datatype";s:6:"atring";s:11:"description";s:121:"Value of the alt-attribute.<br>&nbsp;<br>(Used from TEXT Gifbuilding objects, this has stdWrap properties. Otherwise not)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:9:"titleText";s:8:"datatype";s:6:"string";s:11:"description";s:123:"Value of the title attribute.<br>&nbsp;<br>(Used from TEXT Gifbuilding objects, this has stdWrap properties. Otherwise not)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('93', '', '5c576ef57f313263731885ee7eb93387', '', 'tsref:(cObject).HMENU.(mObj)', 'a:1:{s:4:"rows";a:14:{i:0;a:6:{s:8:"property";s:12:"sectionIndex";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:11:"(see below)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:23:"alternativeSortingField";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:517:"Normally the menuitems are sorted by the fields &quot;sorting&quot; in the pages- and tt_content-table. Here you can enter a list of fields that is used in the SQL- &quot;ORDER BY&quot; statement instead.<br>&nbsp;<b><br>Examples (for &quot;pages&quot; table):</b><br>alternativeSortingField = title desc<br>(This will render the menu in reversed alphabetical order)<br>&nbsp;<br>&nbsp;<b>LIMITATIONS:</b> <br>This property works with normal menus, sectionsIndex menus and special-menus of type &quot;directory&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:8:"minItems";s:8:"datatype";s:3:"int";s:11:"description";s:212:"The minimum items in the menu. If the number of pages does not reach this level, a dummy-page with the title &quot;...&quot; and uid=[currentpage_id] is inserted.<br>&nbsp;<br>Takes precedence over HMENU.minItems";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:8:"maxItems";s:8:"datatype";s:3:"int";s:11:"description";s:108:"The maximum items in the menu. More items will be ignored.<br>&nbsp;<br>Takes precedence over HMENU.maxItems";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:5:"begin";s:8:"datatype";s:9:"int +calc";s:11:"description";s:230:"The first item in the menu. <br>&nbsp;<b><br>Example:</b><br>This results in a menu, where the first two items are skipped starting with item number 3:<br>&nbsp;&nbsp;&nbsp;begin = 3 <br>&nbsp;<br>Takes precedence over HMENU.begin";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:8:"JSWindow";s:8:"datatype";s:7:"boolean";s:11:"description";s:441:"If set, the links of the menu-items will open by JavaScript in a pop-up window. <br>&nbsp;<b><br>.newWindow boolean, that lets every menuitem open in its own window opposite to opening in the same window for each click.</b><br>&nbsp;<br>&nbsp;<b>.params</b> is the list of parameters sent to the JavaScript open-window function, eg: <br>width=200,height=300,status=0,menubar=0<br>&nbsp;<br>&nbsp;<b>NOTE:</b> Does not work with JSMENU&#039;s";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:13:"imgNamePrefix";s:8:"datatype";s:6:"string";s:11:"description";s:76:"prefix for the imagenames. This prefix is appended with the uid of the page.";s:7:"default";s:15:"&quot;img&quot;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:16:"imgNameNotRandom";s:8:"datatype";s:7:"boolean";s:11:"description";s:373:"If set, the image names of menuitems is not randomly assigned. Usefull switch if you&#039;re manipulating these images with some external JavaScript<br>&nbsp;<br>&nbsp;<b>NOTE:</b> Don&#039;t set this if you&#039;re working with a menu with sectionIndex! In that case you need special unique names of items based on something else than the uid of the parent page of course!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:13:"debugItemConf";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:160:"Outputs (by the debug()-function) the configuration arrays for each menuitem. Useful to debug optionSplit things and such...<br>Applies to GMENU, TMENU, IMGMENU";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:10:"overrideId";s:8:"datatype";s:17:"integer (page-id)";s:11:"description";s:393:"If set, then all links in the menu will point to this pageid. Instead the real uid of the page is sent by the parameter &quot;&amp;real_uid=[uid]&quot;.<br>This feature is smart, if you have inserted a menu from somewhere else, perhaps a shared menu, but wants the menuitems to call the same page, which then generates a proper output based on the real_uid.<br>Applies to GMENU, TMENU, IMGMENU";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:9:"addParams";s:8:"datatype";s:6:"string";s:11:"description";s:174:"Additional parameter for the menu-links. <br>&nbsp;<b><br>Example:</b><br>&quot;&amp;some_var=some%20value&quot;<br>Must be rawurlencoded.<br>Applies to GMENU, TMENU, IMGMENU";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:25:"showAccessRestrictedPages";s:8:"datatype";s:44:"integer (page id) / keyword &quot;NONE&quot;";s:11:"description";s:1170:"If set, pages in the menu will include pages with frontend user group access enabled. However the page is of course not accessible and therefore the URL in the menu will be linked to the page with the ID of this value. On that page you could put a login form or other message.<br>If the value is &quot;NONE&quot; the link will not be changed and the site will perform page-not-found handling when clicked (which can be used to capture the event and act accordingly of course).<br>&nbsp;<b><br>Properties:</b><br>.addParam = Additional parameter for the URL, which can hold two markers; ###RETURN_URL### which will be substituted with the link the page would have had if it had been accessible and ###PAGE_ID### holding the page id of the page coming from (could be used to look up which fe_groups was required for access.<br>&nbsp;<b><br>Example:</b><br>showAccessRestrictedPages = 22<br>showAccessRestrictedPages.addParams = &amp;return_url=###RETURN_URL###&amp;pageId=###PAGE_ID###<br>&nbsp;<br>The example will link access restricted menu items to page id 22 with the return URL in the GET var &quot;return_url&quot; and the page id in the GET var &quot;pageId&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:17:"itemArrayProcFunc";s:8:"datatype";s:13:"function-name";s:11:"description";s:686:"The first variable passed to this function is the &quot;menuArr&quot; array with the menuitems as they are collected based on the type of menu.<br>You&#039;re free to manipulate or add to this array as you like. Just remember to return the array again!<br>&nbsp;<b><br>Note:</b><br>.parentObj property is hardcoded to be a reference to the calling tslib_menu object. Here you&#039;ll find eg. -&gt;id to be the uid of the menu item generating a submenu and such.<br>&nbsp;<b><br>Presetting element state</b><br>You can override element states like SPC, IFSUB, ACT, CUR or USR by setting the key ITEM_STATE in the page records. See cObject HMENU/special=userdefined for more information.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:18:"submenuObjSuffixes";s:8:"datatype";s:22:"string<br>+optionSplit";s:11:"description";s:1773:"Defines a suffix for alternative sub-level menu objects. Useful to create special submenus depending on their parent menu element. See example below.<br>&nbsp;<b><br>Example:</b><br>This example will generate a menu where the menu objects for the second level will differ depending on the number of the first level item for which the submenu is rendered. The second level objects used are &quot;2&quot; (the default), &quot;2a&quot; and &quot;2b&quot; (the alternatives). Which of them is used is defined by &quot;1.submenuObjSuffixes&quot; which has the configuration &quot;a |*| |*| b&quot;. This configuration means that the first menu element will use configuration &quot;2a&quot; and the last will use &quot;2b&quot; while anything in between will use &quot;2&quot; (no suffix applied)<br>&nbsp;<br>page.200 = HMENU<br>page.200 {<br>&nbsp;&nbsp;&nbsp;1 = TMENU<br>&nbsp;&nbsp;&nbsp;1.wrap = &lt;div style=&quot;width:200px; border: 1px solid;&quot;&gt;|&lt;/div&gt;<br>&nbsp;&nbsp;&nbsp;1.expAll = 1<br>&nbsp;&nbsp;&nbsp;1.submenuObjSuffixes = a |*| |*| b<br>&nbsp;&nbsp;&nbsp;1.NO.allWrap = &lt;b&gt;|&lt;/b&gt;&lt;br/&gt;<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;2 = TMENU<br>&nbsp;&nbsp;&nbsp;2.NO.allWrap = &lt;div style=&quot;background:red;&quot;&gt;|&lt;/div&gt;<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;2a = TMENU<br>&nbsp;&nbsp;&nbsp;2a.NO.allWrap = &lt;div style=&quot;background:yellow;&quot;&gt;|&lt;/div&gt;<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;2b = TMENU<br>&nbsp;&nbsp;&nbsp;2b.NO.allWrap = &lt;div style=&quot;background:green;&quot;&gt;|&lt;/div&gt;<br>}<br>&nbsp;<br>The result can be seen in the image below (applied on the testsite package):<br>&nbsp;<br>&nbsp;<br>&nbsp;<br>Applies to GMENU, TMENU, GMENU_LAYERS, TMENU_LAYERS and GMENU_FOLDOUT on &gt;= 2nd level in a menu.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('94', '', '2c8d1fb6db707d441cd5769786710a19', '', 'tsref:(cObject).HMENU.(mObj_itemStates)', 'a:1:{s:4:"rows";a:10:{i:0;a:6:{s:8:"property";s:2:"NO";s:8:"datatype";s:18:"Boolean / (config)";s:11:"description";s:508:"The default &quot;Normal&quot; state rendering of Item. This is required for all menus.<br>If you specify properties for the &quot;NO&quot; property you do not have to set it &quot;1&quot;. Otherwise with no properties setting &quot;NO=1&quot; will render the menu anyways (for TMENU this may make sense).<br>&nbsp;<br>The simplest menu TYPO3 can generate is then:<br>&nbsp;<br>page.20 = HMENU<br>page.20.1 = TMENU<br>page.20.1.NO = 1<br>&nbsp;<br>That will be pure &lt;a&gt; tags wrapped around page titles.";s:7:"default";s:1:"1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:16:"IFSUB<br>IFSUBRO";s:8:"datatype";s:18:"Boolean / (config)";s:11:"description";s:54:"Enable/Configuration for menu items which has subpages";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:12:"ACT<br>ACTRO";s:8:"datatype";s:18:"Boolean / (config)";s:11:"description";s:67:"Enable/Configuration for menu items which are found in the rootLine";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:22:"ACTIFSUB<br>ACTIFSUBRO";s:8:"datatype";s:18:"Boolean / (config)";s:11:"description";s:84:"Enable/Configuration for menu items which are found in the rootLine and has subpages";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:12:"CUR<br>CURRO";s:8:"datatype";s:18:"Boolean / (config)";s:11:"description";s:69:"Enable/Configuration for a menu item if the item is the current page.";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:22:"CURIFSUB<br>CURIFSUBRO";s:8:"datatype";s:18:"Boolean / (config)";s:11:"description";s:86:"Enable/Configuration for a menu item if the item is the current page and has subpages.";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:12:"USR<br>USRRO";s:8:"datatype";s:18:"Boolean / (config)";s:11:"description";s:96:"Enable/Configuration for menu items which are access restricted pages that a user has access to.";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:3:"SPC";s:8:"datatype";s:18:"Boolean / (config)";s:11:"description";s:295:"Enable/Configuration for &#039;Spacer&#039; pages.<br>Spacers are pages of the doktype &quot;Spacer&quot;. These are not viewable pages but &quot;placeholders&quot; which can be used to divide menuitems.<br>&nbsp;<br>&nbsp;<b>Note:</b> Rollovers doesn&#039;t work with spacers, if you use GMENU!";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:22:"USERDEF1<br>USERDEF1RO";s:8:"datatype";s:18:"Boolean / (config)";s:11:"description";s:280:"Userdefined, see .itemArrayProcFunc for details on how to use this.<br>You can set the ITEM_STATE values USERDEF1 and USERDEF2 (+...RO) from a script/userfunction processing the menu item array. See HMENU/special=userdefined or the property .itemArrayProcFunc of the menu objects.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:22:"USERDEF2<br>USERDEF2RO";s:8:"datatype";s:18:"Boolean / (config)";s:11:"description";s:11:"(See above)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('95', '', '397a0804fc8ada0e121f0a17e8bf8dd4', '', 'tsref:(cObject).HMENU.(mObj).GMENU', 'a:1:{s:4:"rows";a:20:{i:0;a:6:{s:8:"property";s:2:"RO";s:8:"datatype";s:7:"Boolean";s:11:"description";s:159:"RollOver configuration enabled / disabled. <br>If this is true, RO becomes a GIFBUILDER-object defining the layout of the menuitem when the mouse rolls over it";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:6:"expAll";s:8:"datatype";s:7:"Boolean";s:11:"description";s:252:"If this is true, the menu will always show the menu on the level underneath the menuitem. This corresponds to a situation where a user has clicked a menuitem and the menu folds out the next level. This can enable that to happen on all items as default.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:8:"collapse";s:8:"datatype";s:7:"Boolean";s:11:"description";s:116:"If set, &quot;active&quot; menuitems that has expanded the next level on the menu will now collapse that menu again.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:9:"accessKey";s:8:"datatype";s:7:"Boolean";s:11:"description";s:44:"If set access-keys are set on the menu-links";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:6:"noBlur";s:8:"datatype";s:7:"Boolean";s:11:"description";s:222:"Normally graphical links are &quot;blurred&quot; if the browser is MSIE. Blurring removes the ugly box around a clicked link. <br>If this property is set, the link is NOT blurred (browser-default) with &quot;onFocus&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:6:"target";s:8:"datatype";s:6:"target";s:11:"description";s:23:"Target of the menulinks";s:7:"default";s:4:"self";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:14:"forceTypeValue";s:8:"datatype";s:3:"int";s:11:"description";s:151:"If set, the &amp;type parameter of the link is forced to this value regardless of target. Overrides the global equivalent in &#039;config&#039; if set.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:43:"Wraps only if there were items in the menu!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:11:"applyTotalH";s:8:"datatype";s:20:"objNumsList (offset)";s:11:"description";s:498:"This adds the total height of the previously generated menuitems to the offset of the GifBuilderObj&#039;s mentioned in this list.<br>&nbsp;<b><br>Example:</b><br>This is useful it you want to create a menu with individual items but a common background image that extends to the whole area behind the menu. Then you should setup the background image in each GIFBUILDER-object and include the object-number in this list. <br>Look at the implementation in static_template &quot;styles.gmenu.bug&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:11:"applyTotalW";s:8:"datatype";s:20:"objNumsList (offset)";s:11:"description";s:129:"This adds the total width of the previously generated menuitems to the offset of the GifBuilderObj&#039;s mentioned in this list.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:3:"min";s:8:"datatype";s:13:"x,y (calcInt)";s:11:"description";s:54:"Forces the menu as a whole to these minimum dimensions";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:3:"max";s:8:"datatype";s:13:"x,y (calcInt)";s:11:"description";s:54:"Forces the menu as a whole to these maximum dimensions";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:15:"useLargestItemX";s:8:"datatype";s:7:"boolean";s:11:"description";s:81:"If set, then the width of all menuitems will be equal to the largest of them all.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:15:"useLargestItemY";s:8:"datatype";s:7:"boolean";s:11:"description";s:82:"If set, then the height of all menuitems will be equal to the largest of them all.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:11:"distributeX";s:8:"datatype";s:4:"int+";s:11:"description";s:219:"If set, the total width of all the menuitems will be equal to this number of pixels by adding/subtracting an equal amount of pixels to each menu items width.<br>Will overrule any setting for &quot;.useLargestItemX&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:11:"distributeY";s:8:"datatype";s:4:"int+";s:11:"description";s:221:"If set, the total height of all the menuitems will be equal to this number of pixels by adding/subtracting an equal amount of pixels to each menu items height.<br>Will overrule any setting for &quot;.useLargestItemY&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:20:"removeObjectsOfDummy";s:8:"datatype";s:11:"objNumsList";s:11:"description";s:259:"If the menu is forced to a certain minimum dimension, this is a list of objects in the gifbuilder-object that is removed for this last item. This is important to do if the menuitems has elements that should only be applied if the item is actually a menuitem!!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:14:"disableAltText";s:8:"datatype";s:7:"boolean";s:11:"description";s:112:"If set, the alt-parameter of the images are not set. You can do it manually by &quot;imgParams&quot; (see below)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:9:"IProcFunc";s:8:"datatype";s:13:"function-name";s:11:"description";s:335:"The internal array &quot;I&quot; is passed to this function and expected returned as well. Subsequent to this function call the menu item is compiled by implode()&#039;ing the array $I[parts] in the passed array. Thus you may modify this if you need to.<br>See example on the testsite and in media/scripts/example_itemArrayProcFunc.php";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:73:"[Common Item States, see above]<br>+ rollover version for all, except SPC";s:8:"datatype";s:59:"-&gt;GIFBUILDER<br>+ Additional properties! See table below";s:11:"description";s:572:"This is the GIFBUILDER-options for each category of menuitem that can be generated.<br>&nbsp;<br>&nbsp;<b>NOTE:</b> For the GMENU series you can also define the RollOver configuration for the item states. This means that you define the GIFBUILDER object for the &#039;Active&#039; state by ACT and the RollOver GIFBUILDER object for the &#039;Active&#039; state by ACTRO.<br>This pattern goes for ALL the states except the SPC state.<br>&nbsp;<b><br>SPECIAL:</b><br>The -&gt;OptionSplit function is run on the whole GIFBUILDER-configuration before the items are generated.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('96', '', '1bbf6acf6082debc2080c0087b00e44b', '', 'tsref:(cObject).HMENU.(mObj).GMENU.(itemState)', 'a:1:{s:4:"rows";a:10:{i:0;a:6:{s:8:"property";s:6:"noLink";s:8:"datatype";s:7:"boolean";s:11:"description";s:31:"If set, the item is NOT linked!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:9:"imgParams";s:8:"datatype";s:6:"params";s:11:"description";s:34:"Parameters for the &lt;img&gt;-tag";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:9:"altTarget";s:8:"datatype";s:6:"string";s:11:"description";s:67:"Alternative target which overrides the target defined for the GMENU";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:14:"altImgResource";s:8:"datatype";s:10:"imgResouce";s:11:"description";s:109:"Defines an alternative image to use. If an image returns here, it will override any GIFBUILDER configuration.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:9:"ATagTitle";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:68:"which defines the title attribute of the a-tag. (See TMENUITEM also)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:10:"ATagParams";s:8:"datatype";s:6:"string";s:11:"description";s:21:"Additional parameters";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:21:"Wrap of the menu item";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:17:"allWrap /+stdWrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:20:"Wraps the whole item";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:16:"subst_elementUid";s:8:"datatype";s:7:"boolean";s:11:"description";s:66:"If set, &quot;{elementUid}&quot; is substituted with the item uid.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:10:"allStdWrap";s:8:"datatype";s:13:"/-&gt;stdWrap";s:11:"description";s:25:"stdWrap of the whole item";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('97', '', 'de8dd1a479d93f1a2b3b6339f8b3bcc6', '', 'tsref:(cObject).HMENU.(mObj).GMENU_LAYERS, (cObject).HMENU.(mObj).TMENU_LAYERS', 'a:1:{s:4:"rows";a:23:{i:0;a:6:{s:8:"property";s:10:"layerStyle";s:8:"datatype";s:22:"&lt;DIV&gt;-tag params";s:11:"description";s:176:"Parameters for the &lt;DIV&gt;-layer-tags in the HTML-document. You might probably not need change this.<br>&nbsp;<b><br>Example:</b><br>position:absolute; VISIBILITY: hidden; ";s:7:"default";s:39:"position:absolute; visibility: hidden; ";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:12:"lockPosition";s:8:"datatype";s:44:"&quot;x&quot; / &quot;y&quot; / &quot;&quot;";s:11:"description";s:438:"If this is set to &quot;x&quot; or &quot;y&quot; the menu on the layers is locked and does not follow the mouse-cursor (which it does if this is not set).<br>&quot;x&quot; or &quot;y&quot; defines respectively that the summed width (x) or height (y) is added to the x or y offset of the menu. That means that you should set this value to &quot;x&quot; if you have a horizontal GMENU_LAYERS and to &quot;y&quot; if you have a verical menu.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:15:"dontFollowMouse";s:8:"datatype";s:7:"boolean";s:11:"description";s:422:"If set and lockPosition is blank (so that the menu layer follows the mouse) then the menu will NOT follow the mouse but still it will appear where the mouse cursor hit the trigger-element. Usefull if you don&#039;t know the exact positions of elements. <br>&nbsp;<br>&nbsp;<b>Warning:</b> You should not set displayActiveOnLoad for menus with this feature enabled (because the absolute position of the layer is not known).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:19:"lockPosition_adjust";s:8:"datatype";s:3:"int";s:11:"description";s:153:"A number which is added to the width/height of the menuitems in order to compensate for eg. hspace or other things between the images in the GMENU_LAYERS";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:20:"lockPosition_addSelf";s:8:"datatype";s:7:"boolean";s:11:"description";s:308:"Normally the width and height of the items (+lockPosition_adjust) are summed up after the item has been rendered. This is good if the direction of the menulayers is right- og downwards.<br>But if you use directionLeft/directionUp, you might want to add the width of the items before.<br>If so, set this flag.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:10:"xPosOffset";s:8:"datatype";s:3:"int";s:11:"description";s:154:"The offset of the menu from the point where it&#039;s &quot;activated&quot; (if lockPosition is false) / from topleft page corner (if lockPosition is set)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:10:"yPosOffset";s:8:"datatype";s:3:"int";s:11:"description";s:34:"As above, but for the y-dimension.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:9:"topOffset";s:8:"datatype";s:3:"int";s:11:"description";s:210:"The offset of menuitems from top of browser. Should be set rather than defining it in the .layerStyle property. Must be set in order to use directionUp.<br>Used with either lockPosition=x or xPosOffset defined.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:10:"leftOffset";s:8:"datatype";s:3:"int";s:11:"description";s:220:"The offset of menuitems from left border of browser. Should be set rather than defining it in the .layerStyle property. Must be set in order to use directionLeft.<br>Used with either lockPosition=y or yPosOffset defined.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:15:"blankStrEqFalse";s:8:"datatype";s:7:"boolean";s:11:"description";s:300:"If set, then the properties topOffset,leftOffset, xPosOffset, yPosOffset are considered &quot;blank&quot; if they are really blank strings - not just &quot;zero&quot;. You should enable this if you wish to be able to work with zero offsets. This is typically the case if you use relative positioning.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:13:"directionLeft";s:8:"datatype";s:7:"boolean";s:11:"description";s:292:"Set this, if you want the items to be right-aligned (pop&#039;s out towards the left).<br>Does not work with Opera at this time because I don&#039;t know how to make Opera read the width of each layer.<br>If you set the width of the menu-layers in .layerStyles this might work no matter what.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:11:"directionUp";s:8:"datatype";s:7:"boolean";s:11:"description";s:99:"Set this, if you want the items to be bottom-aligned (pop&#039;s out upwards instead of downwards).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:13:"setFixedWidth";s:8:"datatype";s:3:"int";s:11:"description";s:922:"For GMENU_LAYERS the width and heights of the element is normally known from the graphical item. For TMENU_LAYERS this cannot be known in the same way. Therefore you can use .setFixedWidth and .setFixedHeight to set these values to a number you find reasonable. Of course this may be blasted by the browsers rendering if the font gets out of proportions etc.<br>Alternatively you may want to use the property &quot;relativeToTriggerItem&quot; which will position your menu layers relative to the item you roll over. This has some drawbacks though. A middle solution is to use a menu with lockPosition set to blank and dontFollowMouse set to true. Then you need only specify either an x or y coordinate to follow and the item will appear where the mouse hits the element.<br>&nbsp;<b>Notice:</b> Active if value is NOT a blank str. Setting this value to zero means that no width is calculated for the items in GMENU_LAYERS.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:14:"setFixedHeight";s:8:"datatype";s:3:"int";s:11:"description";s:52:"See &quot;setFixedWidth&quot;. Same, but for height.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:13:"bordersWithin";s:8:"datatype";s:11:"l,t,r,b,l,t";s:11:"description";s:172:"Keep borders of the layer within these limits in pixels. Zero is &#039;not set&#039;<br>(Syntax: List of integers, evaluated clockwise: Left, Top, Right, Bottom, Left, Top)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:19:"displayActiveOnLoad";s:8:"datatype";s:7:"boolean";s:11:"description";s:605:"If set, the submenu-layer of the active menuitem is opened at page-load. If .freezeMouseover is also set and there is RO defined for the main menu items, the menuitem belonging to the displayed submenu is also shown.<br>&nbsp;<b><br>Properties:</b><br>.onlyOnLoad (boolean)<br>If set, then the display of the active item will happen only when the page is loaded. The display will not be restored on mouseout of other items.<br>&nbsp;<b><br>Warning: If you are cascading GMENU_LAYER objects make sure that all elements before this element (for which you set this attribute) also has this attribute set!</b>";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:15:"freezeMouseover";s:8:"datatype";s:7:"boolean";s:11:"description";s:297:"If set, any mouseout effect of main menuitems is removed not on roll-out but when another element is rolled over (or the layer is hidden/default layer restored)<br>&nbsp;<b><br>Properties:</b><br>.alwaysKeep (boolean)<br>If set, the freezed element will always stay, even if the submenu is hidden.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:19:"hideMenuWhenNotOver";s:8:"datatype";s:4:"int+";s:11:"description";s:267:"If set (&gt; 1) then the menu will hide it self whenever a user moves the cursor away from the menu. The value of this parameter determines the width (pixels) of the zone around the element until the mousepointer is considered to be far enough away to hide the layer.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:13:"hideMenuTimer";s:8:"datatype";s:4:"int+";s:11:"description";s:106:"This is the number of milliseconds to wait before the submenu will disappear if hideMenuWhenNotOver is set";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:17:"dontHideOnMouseUp";s:8:"datatype";s:7:"boolean";s:11:"description";s:140:"If set, the menu will not hide it&#039;s layers when the mouse botton is clicked. Usefull if your menuitems loads the pages in another frame";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:13:"layer_menu_id";s:8:"datatype";s:6:"string";s:11:"description";s:209:"If you want to specifically name a menu on a page. Probably you don&#039;t need that!<br>&nbsp;<br>&nbsp;<b>Warning:</b> Don&#039;t use underscore and special characters in this string. Stick to alpha-numeric.";s:7:"default";s:26:"[random 6 char hashstring]";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:21:"relativeToTriggerItem";s:8:"datatype";s:7:"boolean";s:11:"description";s:1242:"This allows you to position the menu layers relative to the item that triggers it. However you should be aware of the following facts:<br>This does not work with Netscape 4 - the position of the trigger layer will be calculated to zero and thus the offset for all menu layers will be 0,0 + your values. <br>This feature will wrap the menu item in some &lt;div&gt;-tags right before the whole item is wrapped by the .wrap code (for GMENU_LAYERS) or .allWrap (for TMENU_LAYERS). The bottom line of this is: 1) If your menu is horizontal, always wrap your menu items in a table so linebreaks does not appear because of the &lt;div&gt;-tags and 2) make sure the wrapping of the table cell is done with the .wrap/.allWrap properties respectively.<br>Works only effectively on the first xMENU_LAYER in a cascade. For succeeding xMENU_LAYERS items please use &quot;relativeToParentLayer&quot;.<i><br>If set, properties xPosOffset, yPosOffset and lockPosition* are not functional (properties directionLeft, directionUp, topOffset and leftOffset are still active)</i><i><br>&nbsp;</i><b><br>Additional Properties:</b><br>&nbsp;<b>.addWidth</b> = Adds the width of the trigger element<br>&nbsp;<b>.addHeight</b> = Adds the height of the trigger element";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:22;a:6:{s:8:"property";s:21:"relativeToParentLayer";s:8:"datatype";s:7:"boolean";s:11:"description";s:556:"If set, then the layer will be positioned relative to the previous layer (parent) in a cascaded series of xMENU_LAYERS. Basically the relative position of the parent layer is just added to the offset of the current menu. <br>&nbsp;<br>&nbsp;<b>Warning:</b> This property makes sense only if there really is a previous GMENU_LAYER to get position from! So you must have a cascaded menu!<br>&nbsp;<b><br>Additional Properties:</b><br>&nbsp;<b>.addWidth</b> = Adds the width of the parent layer<br>&nbsp;<b>.addHeight</b> = Adds the height of the parent layer";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('98', '', 'cc7479b256282161af55c3137ffe98ec', '', 'tsref:(cObject).HMENU.(mObj).GMENU_FOLDOUT', 'a:1:{s:4:"rows";a:17:{i:0;a:6:{s:8:"property";s:17:"dontLinkIfSubmenu";s:8:"datatype";s:7:"boolean";s:11:"description";s:110:"If set, items that has a submenu is not linked. Items without a submenu are always linked in the regular ways.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:9:"foldTimer";s:8:"datatype";s:3:"int";s:11:"description";s:53:"The timeout in the animation, these are milliseconds.";s:7:"default";s:2:"40";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:9:"foldSpeed";s:8:"datatype";s:16:"int, range 1-100";s:11:"description";s:58:"How many steps in an animation? Choose 1 for no animation.";s:7:"default";s:1:"1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:10:"stayFolded";s:8:"datatype";s:7:"boolean";s:11:"description";s:49:"Stay open when you click a new toplink? (Level 1)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:12:"bottomHeight";s:8:"datatype";s:11:"int, pixels";s:11:"description";s:147:"Sets the height of the bottom layer. Is important if the bottomlayer contains either content or a background color: Else the layer will be clipped.";s:7:"default";s:3:"100";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:9:"menuWidth";s:8:"datatype";s:11:"int, pixels";s:11:"description";s:174:"Width of the whole menu main layer. Important to set, especially for the bottomlayer as it is clipped by this value. Always try to set this to the width in pixels of the menu";s:7:"default";s:3:"170";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:10:"menuHeight";s:8:"datatype";s:3:"int";s:11:"description";s:60:"Height of the whole menulayer. Seems to be not so important.";s:7:"default";s:3:"400";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:13:"subMenuOffset";s:8:"datatype";s:3:"x,y";s:11:"description";s:155:"Offset of the submenu for each menuitem. This is important because if you don&#039;t set this value the items will appear ontop of their &quot;parent&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:10:"menuOffset";s:8:"datatype";s:3:"x,y";s:11:"description";s:64:"Offset of the menu main layer on the page. From upperleft corner";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:13:"menuBackColor";s:8:"datatype";s:10:"HTML-color";s:11:"description";s:158:"Background color behind menu. If not set, transparent (which will not work very well in case .foldSpeed is set to something else than 1. But see for yourself)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:15:"dontWrapInTable";s:8:"datatype";s:7:"boolean";s:11:"description";s:482:"By default every menuitem on the first level is wrapped in a table:<br>&lt;TABLE cellSpacing=0 cellPadding=0 width=&quot;100%&quot; border=0&gt;&lt;TR&gt;&lt;TD&gt;<br>[menu item HTML here..]<br>&lt;/TD&gt;&lt;/TR&gt;&lt;/TABLE&gt;<br>Doing this ensures that the layers renders equally in the supported browsers. However you might need to disable that which is what you can do by setting this flag.<br>&nbsp;<b>Note:</b> Using &lt;TBODY&gt; in this tables seems to break Netscape 4+";s:7:"default";s:1:"0";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:13:"bottomContent";s:8:"datatype";s:7:"cObject";s:11:"description";s:62:"Content for the bottom layer that covers the end of the menu. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:12:"adjustItemsH";s:8:"datatype";s:3:"int";s:11:"description";s:211:"Adjusts the height calculation of the menulayers of the first level (called Top)<br>&nbsp;<b><br>Example:</b><br>-10<br>&nbsp;<br>This value will substract 10 pixels from the height of the layer in calculations.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:15:"adjustSubItemsH";s:8:"datatype";s:3:"int";s:11:"description";s:104:"Adjusts the height calculation of the menulayers of the second level (subitems, called Sub)<br>See above";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:19:"arrowNO<br>arrowACT";s:8:"datatype";s:11:"imgResource";s:11:"description";s:403:"If both arrowNO and arrowACT is defined and valid imgResources then these images are use as &quot;traditional arrows&quot; that indicates whether an item is expanded (active) or not. <br>NO is normal, ACT is expanded<br>The image is inserted just before the menuitem. If you want to change the position, put the marker ###ARROW_IMAGE### into the wrap of the item and the image will be put there instead.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:14:"arrowImgParams";s:8:"datatype";s:18:"&lt;img&gt; params";s:11:"description";s:80:"Parameters to the arrow-image.<br>&nbsp;<b><br>Example:</b><br>hspace=5 vspace=7";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:19:"displayActiveOnLoad";s:8:"datatype";s:7:"boolean";s:11:"description";s:67:"If set, then the active menu items will fold out &quot;onLoad&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('99', '', 'bec5811d03462a9bb1c8e461c032d461', '', 'tsref:(cObject).HMENU.(mObj).TMENU', 'a:1:{s:4:"rows";a:8:{i:0;a:6:{s:8:"property";s:6:"expAll";s:8:"datatype";s:7:"Boolean";s:11:"description";s:252:"If this is true, the menu will always show the menu on the level underneath the menuitem. This corresponds to a situation where a user has clicked a menuitem and the menu folds out the next level. This can enable that to happen on all items as default.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:8:"collapse";s:8:"datatype";s:7:"Boolean";s:11:"description";s:116:"If set, &quot;active&quot; menuitems that has expanded the next level on the menu will now collapse that menu again.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:6:"noBlur";s:8:"datatype";s:7:"Boolean";s:11:"description";s:212:"Normally links are &quot;blurred&quot; if the browser is MSIE. Blurring removes the ugly box around a clicked link. <br>If this property is set, the link is NOT blurred (browser-default) with &quot;onFocus&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:6:"target";s:8:"datatype";s:6:"target";s:11:"description";s:23:"Target of the menulinks";s:7:"default";s:4:"self";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:14:"forceTypeValue";s:8:"datatype";s:3:"int";s:11:"description";s:89:"If set, the &amp;type parameter of the link is forced to this value regardless of target.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:43:"Wraps only if there were items in the menu!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:9:"IProcFunc";s:8:"datatype";s:13:"function-name";s:11:"description";s:335:"The internal array &quot;I&quot; is passed to this function and expected returned as well. Subsequent to this function call the menu item is compiled by implode()&#039;ing the array $I[parts] in the passed array. Thus you may modify this if you need to.<br>See example on the testsite and in media/scripts/example_itemArrayProcFunc.php";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:31:"[Common Item States, see above]";s:8:"datatype";s:14:"-&gt;TMENUITEM";s:11:"description";s:221:"This is the TMENUITEM-options for each category of menuitem that can be generated.<br>&nbsp;<b><br>SPECIAL:</b><br>The -&gt;OptionSplit function is run on the whole GIFBUILDER-configuration before the items are generated.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('100', '', '6741d93da8500fc90e7237a7a0cf9479', '', 'tsref:(cObject).HMENU.(mObj).TMENUITEM', 'a:1:{s:4:"rows";a:22:{i:0;a:6:{s:8:"property";s:17:"allWrap /+stdWrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:20:"Wraps the whole item";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:15:"wrapItemAndSub ";s:8:"datatype";s:4:"wrap";s:11:"description";s:56:"Wraps the whole item and any submenu concatenated to it.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:16:"subst_elementUid";s:8:"datatype";s:7:"boolean";s:11:"description";s:301:"If set, all appearances of the string &#039;{elementUid}&#039; in the total element html-code (after wrapped in .allWrap} is substituted with the uid number of the menu item. <br>This is useful if you want to insert an identification code in the HTML in order to manipulate properties with JavaScript.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:12:"RO_chBgColor";s:8:"datatype";s:6:"string";s:11:"description";s:1407:"If property RO is set (see below) then you can set this property to a certain set of parameters which will allow you to change the background color of eg. the tablecell when the mouse rolls over you text-link.<br>&nbsp;<b><br>Syntax:</b><br>[over-color] | [out-color] | [id-prefix]<br>&nbsp;<b><br>Example:</b><br>page = PAGE<br>page.typeNum = 0<br>page.10 = HMENU<br>page.10.wrap = &lt;table border=1&gt;|&lt;/table&gt;<br>page.10.1 = TMENU<br>page.10.1.NO {<br>&nbsp;&nbsp;&nbsp;allWrap = &lt;tr&gt;&lt;td valign=top id=&quot;1tmenu{elementUid}&quot; style=&quot;background:#eeeeee;&quot;&gt;|&lt;/td&gt;&lt;/tr&gt;<br>&nbsp;&nbsp;&nbsp;subst_elementUid = 1<br>&nbsp;&nbsp;&nbsp;RO_chBgColor = #cccccc | #eeeeee | 1tmenu<br>&nbsp;&nbsp;&nbsp;RO = 1<br>}<br>&nbsp;<br>This example will start out with the table cells in #eeeeee and change them to #cccccc (and back) when rolled over. The &quot;1tmenu&quot; string is a unique id for the menu items. You may not need it (unless the same menu items are more than once on a page), but the important thing is that the id of the table cell has the exact same label before the {elementUid} (red marks). The other important thing is that you DO set a default background color for the cell with the style-attribute (blue marking). If you do not, Mozilla browsers will behave a little strange by not capturing the mouseout event the first time it&#039;s triggered. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:6:"before";s:8:"datatype";s:13:"HTML +stdWrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:9:"beforeImg";s:8:"datatype";s:11:"imgResource";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:18:"beforeImgTagParams";s:8:"datatype";s:18:"&lt;img&gt;-params";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:13:"beforeImgLink";s:8:"datatype";s:7:"boolean";s:11:"description";s:68:"If set, this image is linked with the same &lt;A&gt; tag as the text";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:11:"beforeROImg";s:8:"datatype";s:11:"imgResource";s:11:"description";s:99:"If set, &quot;.beforeImg&quot; and &quot;.beforeROImg&quot; is expected to create a rollOver-pair. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:10:"beforeWrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:40:"wrap around the &quot;.before&quot;-code";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:8:"linkWrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:7:"stdWrap";s:8:"datatype";s:15:"stdWrap-options";s:11:"description";s:26:"stdWrap to the link-text! ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:14:"ATagBeforeWrap";s:8:"datatype";s:7:"boolean";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:10:"ATagParams";s:8:"datatype";s:38:"&nbsp;<i>&lt;A&gt;-params</i> /stdWrap";s:11:"description";s:77:"Additional parameters<br>&nbsp;<b><br>Example:</b><br>class=&quot;board&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:9:"ATagTitle";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:280:"Allows you to specify the &quot;title&quot; attribute of the &lt;a&gt; tag around the menu item.<br>&nbsp;<b><br>Example:</b><br>ATagTitle.field = abstract // description<br>&nbsp;<br>This would use the abstract or description field for the &lt;a title=&quot;&quot;&gt; attribute.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:11:"doNotLinkIt";s:8:"datatype";s:7:"boolean";s:11:"description";s:43:"if set, the linktext are not linked at all!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:13:"doNotShowLink";s:8:"datatype";s:7:"boolean";s:11:"description";s:62:"if set, the text will not be shown at all (smart with spacers)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:8:"stdWrap2";s:8:"datatype";s:14:"wrap /+stdWrap";s:11:"description";s:123:"stdWrap to the total link-text and ATag. (Notice that the plain default value passed to stdWrap function is &quot;|&quot;.)";s:7:"default";s:8:"&nbsp;| ";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:2:"RO";s:8:"datatype";s:7:"boolean";s:11:"description";s:41:"if set, rollOver is enabled for this link";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:8:"after...";s:8:"datatype";s:7:"[mixed]";s:11:"description";s:225:"The series of &quot;before...&quot; properties are duplicated to &quot;after...&quot; properties as well. The only difference is that the output generated by the .after.... properties are placed after the link and not before.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:9:"altTarget";s:8:"datatype";s:6:"target";s:11:"description";s:70:"Alternative target overriding the target property of the TMENU if set.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:10:"allStdWrap";s:8:"datatype";s:13:"/-&gt;stdWrap";s:11:"description";s:25:"stdWrap of the whole item";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('101', '', '0ab0ced808e0b089231bd8b12ab07fca', '', 'tsref:(cObject).HMENU.(mObj).IMGMENU', 'a:1:{s:4:"rows";a:10:{i:0;a:6:{s:8:"property";s:6:"target";s:8:"datatype";s:6:"target";s:11:"description";s:23:"Target of the menulinks";s:7:"default";s:4:"self";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:14:"forceTypeValue";s:8:"datatype";s:3:"int";s:11:"description";s:89:"If set, the &amp;type parameter of the link is forced to this value regardless of target.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:6:"noBlur";s:8:"datatype";s:7:"Boolean";s:11:"description";s:222:"Normally graphical links are &quot;blurred&quot; if the browser is MSIE. Blurring removes the ugly box around a clicked link. <br>If this property is set, the link is NOT blurred (browser-default) with &quot;onFocus&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:6:"params";s:8:"datatype";s:18:"&lt;img&gt;-params";s:11:"description";s:6:"&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:4:"main";s:8:"datatype";s:15:"-&gt;GIFBUILDER";s:11:"description";s:75:"Main configuration of the image-map! This defines the &quot;underlay&quot;!";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:9:"dWorkArea";s:8:"datatype";s:13:"offset + calc";s:11:"description";s:78:"Main offset of the GIFBUILDER-items (also called the &quot;distribution&quot;)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:31:"[Common Item States, see above]";s:8:"datatype";s:30:"-&gt;IMGMENUITEM<br>+ .distrib";s:11:"description";s:1359:"This is the TMENUITEM-options for each category of menuitem that can be generated.<br>&nbsp;<b><br>SPECIAL:</b><br>The -&gt;OptionSplit function is run on the whole GIFBUILDER-configuration before the items are generated.<br>&nbsp;<br>&nbsp;<b>.distrib</b> is (x,y,v,h +calc) of the distribution of the menuitems. This provides a way to space each item from the other. The codes &quot;textX&quot; and &quot;textY&quot; can be used for the width (X) and height (Y) dimension of each link.<br>This works by adding a WORKAREA-GifBuilderObj between each of the IMGMENUITEM (&quot;subset&quot; of a GIFBUILDER-object) and this workarea defines where the text should be printed. As such the &quot;x,y&quot; defines the offset <b><i>the next item will have</b></i> (this should be the width of the previous in many cases!) and &quot;v,h&quot; defines the <b><i>dimensions of the current item</b></i>. <br>Consider this example taken from the static_template &quot;template: MM&quot;:<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;NO.distrib = textX+10, 0, textX+10, textY+5<br>In the future TypoScript may provide better ways to position GIFBUILDER-objects on the image-maps!<br>&nbsp;<br>&nbsp;<b>ImgMap</b> is automatically used on the links! (that is the &quot;.imgMap&quot; property of the text-objects in the GIFBUILDER-objects is set automatically, unless is allready set.)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:12:"imgMapExtras";s:8:"datatype";s:20:"&lt;area...&gt;-tags";s:11:"description";s:43:"Extra &lt;area...&gt;tags for the image-map";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:21:"debugRenumberedObject";s:8:"datatype";s:7:"boolean";s:11:"description";s:104:"if set, the final GIFBUILDER object configuration is output in order for you to debug your configuration";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('102', '', 'cdccc471d5b78c74bb04998ced50107c', '', 'tsref:(cObject).HMENU.(mObj).IMGMENUITEM', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:10:"1,2,3,4...";s:8:"datatype";s:18:"-&gt;GifBuilderObj";s:11:"description";s:2298:"<b>NOTE:</b><br>The way a imagemap is made is this; All IMGMENUITEMS are included in one big Gifbuilderobj (and renumbered!!). Because of this, Gifbuilderobjects on the next level will not be able to access the data of each menuitem.<br>Also the feature of using [##.w] and [##.h] with +calc is currently not supported by IMGMENUITEMs.<br>Therefore all IMAGE-objects on the first level is checked; if &quot;file&quot; or &quot;mask&quot; for any IMAGE-objects are set to &quot;GIFBUILDER&quot;, the Gifbuilder-object is parsed to see if any TEXT-objects are present and if so, the TEXT-object is &quot;checked&quot; - which means, that the stdWrap-function is called at a time where the $cObj-&gt;data-array is set to the actual menuitem.<br>In the example below, the text of each menuitem is rendered by letting the title be rendered on a mask instead of directly on the image. Please observe that the &quot;NO.10&quot;-object is present in order for the image-map coordinates to be generated!!<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;NO.6 = IMAGE<br>&nbsp;&nbsp;&nbsp;NO.6.file = masked_pencolor*.gif<br>&nbsp;&nbsp;&nbsp;NO.6.mask = GIFBUILDER<br>&nbsp;&nbsp;&nbsp;NO.6.mask {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;XY = 500, 200<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;backColor = black<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;10 = TEXT<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;10 {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;text.field = title<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fontFile = fileadmin/fonts/caflisch.ttf<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fontSize = 34<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fontColor = white<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;angle = 15<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;offset = 48,110<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;20 = EFFECT<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;20.value = blur=80<br>&nbsp;&nbsp;&nbsp;} <br>&nbsp;&nbsp;&nbsp;NO.10 = TEXT<br>&nbsp;&nbsp;&nbsp;NO.10 {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;text.field = title<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fontFile = fileadmin/fonts/caflisch.ttf<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;fontSize = 34<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;angle = 15<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;offset = 48,110<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;hideButCreateMap = 1<br>&nbsp;&nbsp;&nbsp;}";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('103', '', '2cdd9060dcb2633b93d2a58448f1323e', '', 'tsref:(cObject).HMENU.(mObj).JSMENU', 'a:1:{s:4:"rows";a:9:{i:0;a:6:{s:8:"property";s:6:"levels";s:8:"datatype";s:8:"int, 1-5";s:11:"description";s:25:"How many levels there are";s:7:"default";s:1:"1";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:8:"menuName";s:8:"datatype";s:6:"string";s:11:"description";s:111:"JavaScript menu name. <br>If you have more than one JSMENU on the page, you should set this value for each one.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:6:"target";s:8:"datatype";s:6:"target";s:11:"description";s:32:"Decides target of the menu-links";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:14:"forceTypeValue";s:8:"datatype";s:3:"int";s:11:"description";s:89:"If set, the &amp;type parameter of the link is forced to this value regardless of target.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:10:"1,2,3,4...";s:8:"datatype";s:10:"JSMENUITEM";s:11:"description";s:13:"levels-config";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:30:"wrap around the selector-boxes";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:13:"wrapAfterTags";s:8:"datatype";s:4:"wrap";s:11:"description";s:66:"wrap around the selector-boxes with wrap and form-tags og JS-code.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:17:"firstLabelGeneral";s:8:"datatype";s:6:"string";s:11:"description";s:71:"General firstlabel. May be overridden by the one set in each JSMENUITEM";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:3:"SPC";s:8:"datatype";s:7:"boolean";s:11:"description";s:46:"If set, spacer can go into the menu, else not.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('104', '', '52b4fd3e8e7b15fb48cd362b5fc056cd', '', 'tsref:(cObject).HMENU.(mObj).JSMENUITEM', 'a:1:{s:4:"rows";a:9:{i:0;a:6:{s:8:"property";s:6:"noLink";s:8:"datatype";s:7:"boolean";s:11:"description";s:407:"Normally the selection of a menu item in the selector box will update the selector on the next level (if there is a next level) and if there are no items for that selector (because there were no subpages), then the link jumps to the page of itself. <br>If this flag is set, however, no menuitems in the selector box will ever link to anything. Only update the content of the next selector box on next level.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:10:"alwaysLink";s:8:"datatype";s:7:"boolean";s:11:"description";s:100:"If set an item in the menu selector will always link. This takes precedence over &quot;noLink&quot;.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:10:"showFi rst";s:8:"datatype";s:7:"boolean";s:11:"description";s:62:"if set, the first link will be shown when the menu is updated.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:10:"showActive";s:8:"datatype";s:7:"boolean";s:11:"description";s:53:"if set, the active level will be selected, if present";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:4:"wrap";s:8:"datatype";s:4:"wrap";s:11:"description";s:21:"wraps the selectorbox";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:5:"width";s:8:"datatype";s:4:"int+";s:11:"description";s:61:"Initial width of the boxes set by a number of _ (underscores)";s:7:"default";s:2:"14";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:8:"elements";s:8:"datatype";s:4:"int+";s:11:"description";s:98:"Initial number of elements in the menu. This is of course overruled by the actual menu item texts.";s:7:"default";s:1:"5";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:16:"additionalParams";s:8:"datatype";s:6:"string";s:11:"description";s:145:"Additional parameters to the &lt;select&gt; box. Eg, you could set the width with a style-parameter like this:<br>style=&quot;width: 200px;&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:10:"firstLabel";s:8:"datatype";s:6:"string";s:11:"description";s:48:"Firt label in top of the menu (default is blank)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('105', '', 'd5d05a1da766c8752918259cd571b75f', '', 'tsref:(script).fe_adminLib', 'a:1:{s:4:"rows";a:31:{i:0;a:6:{s:8:"property";s:12:"templateFile";s:8:"datatype";s:8:"resource";s:11:"description";s:67:"The template file, see examples in media/scripts/fe_user_admin.tmpl";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:15:"templateContent";s:8:"datatype";s:6:"string";s:11:"description";s:78:"Alternatively you can set this property directly to the value of the template.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:5:"table";s:8:"datatype";s:9:"tablename";s:11:"description";s:289:"The table to edit. <br>Notice: The ultimate lsit of fields allowed to be edited for the table is defined in TCA with the key [&quot;feInterface&quot;][&quot;fe_admin_fieldList&quot;] for each table in question. For an example, see the table definition for fe_users which is a good example.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:10:"defaultCmd";s:8:"datatype";s:6:"string";s:11:"description";s:86:"Defines which action should be default (if &amp;cmd= is not set when calling the page)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:17:"clearCacheOfPages";s:8:"datatype";s:25:"<i>[list of integers]</i>";s:11:"description";s:114:"This is a list of page-ids for which to clear the cache on any successfull operation be it EDIT, CREATE og DELETE.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:5:"debug";s:8:"datatype";s:7:"boolean";s:11:"description";s:86:"If set, debug information will be output from fe_adminLib which helps to track errors.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:15:"<b>Actions:</b>";s:8:"datatype";N;s:11:"description";N;s:7:"default";N;s:12:"column_count";i:1;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:5:"edit ";s:8:"datatype";s:21:"boolean /actionObject";s:11:"description";s:1880:"If set, editing is basically allowed.<br>But you need to specify:<br>&nbsp;<br>&nbsp;<b>.fields </b>(list of fieldnames) which determines the fields allowed for editing. Every field in this list must be found as well in the [&quot;feInterface&quot;][&quot;fe_admin_fieldList&quot;] found in the TCA array which ultimately determines which fields can be edited by the fe_adminLib.<b><br>&nbsp;</b><br>&nbsp;<b>.overrideValues.[fieldname]</b> (value string) defines values for specific fields which will override ANY input from the form. Overriding values happens after the outside values has been parsed by the .parseValues-property of fe_adminLib but before the evaluation by .required and .evalValues below. For example this may be useful if you wish to hide a record which is being edited, because you want to preview it first.<b><br>&nbsp;</b><br>&nbsp;<b>.required </b>(list of fieldnames, subset of .fields) which determines which fields are required to return a true value. The valid fields entered here will have the subpart ###SUB_REQUIRED_FIELD_<i>[fieldname]</i>### removed from the templates if they evaluates to being true and thereby OK. See below for information about this subpart.<b><br>&nbsp;</b><br>&nbsp;<b>.evalValues.[fieldname]</b> (list of eval-codes) defines specific evaluation forms for the individual fiels of the form. See below.<b><br>&nbsp;</b><br>&nbsp;<b>.preview</b> (boolean) will enable the form submitted to be previewed first. This requires a template for preview to be found in the template file. See below for subpart marker names.<b><br>&nbsp;</b><br>&nbsp;<b>.menuLockPid</b> (boolean will force the menu of editable items to be locked to the .pid (edit only)<b><br>&nbsp;</b><br>&nbsp;<b>.userFunc_afterSave </b>(function-name) is called after the record is saved. The content passed is an array with the current (and previous) record in.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:7:"create ";s:8:"datatype";s:21:"boolean /actionObject";s:11:"description";s:443:"The same as .edit above except where otherwise stated.<br>Plus there is these additional properties:<b><br>&nbsp;</b><br>&nbsp;<b>.noSpecialLoginForm </b>(boolean) - if set, fe_adminLib does NOT look for the subpart marker TEMPLATE_CREATE_LOGIN but always for TEMPLATE_CREATE<b><br>&nbsp;</b><br>&nbsp;<b>.defaultValues.[fieldname]</b> (value string); Like .overrideValues but this sets the default values the first time the form is displayed.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:6:"delete";s:8:"datatype";s:7:"boolean";s:11:"description";s:214:"Whether or not records may be deleted. Still regular authentication (ownership or email authCode) is required. Setting the var &quot;preview&quot; lets you make a delete-preview before actually deleting the record.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:8:"infomail";s:8:"datatype";s:7:"boolean";s:11:"description";s:374:"Infomails are plaintext mails based on templates found in the template file. They may be used for such as sending a forgotten password to a user, but what goes into the infomail is totally up to your design of the template.<br>Normally you may have only a default infomail (infomail.default) for instance for sending the password. But you can use other keys also. See below.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:14:"infomail.[key]";s:8:"datatype";s:38:"(configuration of infomail properties)";s:11:"description";s:619:"In order to make fe_adminLib send an infomail, you must specify these vars in your GET vars or HTML-form.<br>&nbsp;<br>&nbsp;<b>fetch</b> - if integer, it searches for the uid being the value of &#039;fetch&#039;. If not, it searches for the email-field (defined by a property of fe_adminLib, see below). <br>&nbsp;<br>&nbsp;<b>key</b> - points to the infomail.[key] configuration to use<b><br>&nbsp;</b><b><br>Properties:</b><br>&nbsp;<b>.dontLockPid</b> (boolean) - selects only records from the .pid of fe_adminLib.<br>&nbsp;<b>.label </b>(string) - The suffix for the markers, see &#039;Email Markers&#039; beneath.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:8:"setfixed";s:8:"datatype";s:19:"boolean /properties";s:11:"description";s:3153:"Allows set-fixed input, probably coming from a link in an infomail or notification mail.<b><br>Syntax: </b><br>&nbsp;<br>&nbsp;<b>.[fix</b><b><i>key</b></i><b>].[</b><b><i>fieldname</b></i><b>] = </b><b><i>fieldvalue</b></i><i> </i>- is used to setup a setfixed-link insertable in the infomail by the SYS_SETFIXED_*-markers. See above (setfixed-property of fe_adminLib).<br>Special fixkey &#039;DELETE&#039; is just a boolean.<br>&nbsp;<br>&nbsp;<b>.userFunc_afterSave </b>(function-name) is called after the record is saved. The content passed is an array with the current (and previous) record in.<br>&nbsp;<b><br>Concept:</b><br>The &#039;setfixed&#039; concept is best explained by describing a typical scenario - in fact the most common situation of its use:<br>Imagine you have some users submitting information on your website. But before that information enters the database, you would like to moderate it - simply preview it and then either delete it or approve it. In the &#039;create&#039; configuration of fe_adminLib, you set up the hidden field of the record to be overridden to 1. Thus the record is hidden by default. Then you configure a setfixed-fixkey to set the hidden field to 0. This set up generates a list of parameters for use in an URL and those parameters are finally inserted by a corresponding marker in the email template. The link includes all necessary authentication to perform the change of values and thus a single click on that link is enough to change the field values. So this will - by a single click of a link in a notification mail sent to an admin - enable the record! Or of course a similar link with a cmd=delete link will delete it...<br>There is a special &quot;fieldname&quot; you can use, which is &#039;_FIELDLIST&quot; and that lets you specify a list of fields in the record to base the auth-code on. If nothing is specifyed the md5-hash is based on the whole record which means that any changes will disable the setfixed link. If on the other hand, you set _FIELDLIST = uid,pid then that record will be editable as long as the uid and pid values are intact.<b><br>Example:</b><br>This is a common configuration of the email-properties with a simple setfixed setting:<br>&nbsp;&nbsp;&nbsp;email.from = kasper@typo3.com<br>&nbsp;&nbsp;&nbsp;email.fromName = Kasper Skårhøj<br>&nbsp;&nbsp;&nbsp;email.admin = kasper@typo3.com<br>&nbsp;&nbsp;&nbsp;setfixed.approve {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;hidden = 0<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;_FIELDLIST = uid,pid<br>&nbsp;&nbsp;&nbsp;}<br>&nbsp;&nbsp;&nbsp;setfixed.DELETE = 1<br>&nbsp;&nbsp;&nbsp;setfixed.DELETE._FIELDLIST = uid<br>&nbsp;<br>Now, if you insert this marker in your email template <br>&nbsp;<br>&nbsp;&nbsp;&nbsp;###SYS_SETFIXED_approve### <br>&nbsp;<br>if will get substituted with something like these parameters:<br>&nbsp;<br>&amp;cmd=setfixed&amp;rU=9&amp;fD[hidden]=0&amp;aC=5c403d90 <br>&nbsp;<br>Now, all you need is to point that to the correct url (where fe_adminLib is invoked!), eg:<br>&nbsp;<br>###THIS_URL######FORM_URL######SYS_SETFIXED_approve###<br>&nbsp;<br>and for deletion:<br>&nbsp;<br>...###SYS_SETFIXED_DELETE###";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:13:"<b>Others</b>";s:8:"datatype";N;s:11:"description";N;s:7:"default";N;s:12:"column_count";i:1;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:15:"authcodeFields ";s:8:"datatype";s:23:"<i>[list of fields]</i>";s:11:"description";s:1340:"Comma separated list of fields to base the authCode generation on. Basically this list would include &quot;uid&quot; only in most cases. If the list includes more fields, you should be aware that the authCode will change when the value of that field changes. And then the user will have to re-send an email to himself with a new code.<br>&nbsp;<br>&nbsp;<b>.addKey </b>(string) adds the string to the md5-hash of the authCode. Just enter any random string here. Point is that people from outside doesn&#039;t know this code and therefore are not able to reconstruct the md5-hash solely based on the uid<br>&nbsp;<br>&nbsp;<b>.addDate</b> (date-config) You can use this to make the code time-disabled. Say if you enter &quot;d-m-Y&quot; here as value, the code will work until midnight and then a new code will be valid.<br>&nbsp;<br>&nbsp;<b>.codeLength</b> (int) Defines how long the authentication code should be. Default is 8 characters.<br>In any case TYPO3_CONF_VARS[SYS][encryptionKey] is prepended.<br>&nbsp;<b><br>Advice:</b><br>If you want to generate authCodes compatible with the standard authCodes (used by the direct mailer by t3lib_div::stdAuthCode()), please set TYPO3_CONF_VARS[SYS][encryptionKey] to a unique and secret key (like you should in any case) and add &quot;uid&quot; as authcodeField ONLY. This is secure enough.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:5:"email";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:558:"&nbsp;<b>.from </b>(string, email) Defines the sender email address of mails sent out<br>&nbsp;<br>&nbsp;<b>.fromName </b>(string) Defines the name of the sender. If set, this will be used on the form NAME &lt;EMAIL&gt;<br>&nbsp;<b><br>.admin</b><br>&nbsp;<br>&nbsp;<b>.field </b>(string/integer) Defines the fieldname of the record where the email address to send to is found. If the field content happens to be an integer, this is assumed to be the uid of the fe_user owning the record and the email address of that user is fetched for the purpose instead.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:3:"pid";s:8:"datatype";s:4:"int+";s:11:"description";s:42:"The pid in which to store/get the records.";s:7:"default";s:12:"Current page";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:14:"fe_userOwnSelf";s:8:"datatype";s:7:"boolean";s:11:"description";s:361:"If set, fe_users created by this module has their fe_cruser_id-field set to their own uid which means they &#039;own&#039; their own record and can thus edit their own data. <br>All other tables which has a fe_cruser_id field configured in the &#039;ctrl&#039; section of their $TCA-configuration will automatically get this field set to the current fe_user id.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:15:"fe_userEditSelf";s:8:"datatype";s:7:"boolean";s:11:"description";s:102:"If set, fe_users - regardless of whether they own themselves or not - will be allowed to edit himself.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:13:"allowedGroups";s:8:"datatype";s:18:"[list of integers]";s:11:"description";s:141:"List of fe_groups uid numbers which are allowed to edit the records through this form. Normally only the owner fe_user is allowed to do that.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:8:"evalFunc";s:8:"datatype";s:13:"function-name";s:11:"description";s:276:"Function by which you can manipulate the dataArray before it&#039;s saved. <br>The dataArray is passed to the function as $content and MUST be returned again from the function.<br>The property &quot;parentObj&quot; is a hardcoded reference to the fe_adminLib object.<br>&nbsp;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:7:"formurl";s:8:"datatype";s:13:"-&gt;typolink";s:11:"description";s:66:"Contains typolink properties for the URL (action tag) of the form.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:22;a:6:{s:8:"property";s:19:"parseValues.[field]";s:8:"datatype";s:20:"[list of parseCodes]";s:11:"description";s:1510:"<b>ParseCodes:</b><br>&nbsp;<b>int </b>- returns the integer value of the input<br>&nbsp;<b>lower</b> - returns lowercase version of the input<br>&nbsp;<b>upper </b>- returns uppercase version of the input<br>&nbsp;<b>nospace</b> - strips all space<br>&nbsp;<b>alpha, num, alphanum, alphanum_x</b> - only alphabetic (a-z) and/or numeric chars. alphanum_x also allows _ and -<br>&nbsp;<b>trim </b>- trims whitespace in the ends of the string<br>&nbsp;<b>setEmptyIfAbsent </b>- will make sure the field is set to empty if the value is not submitted. This ensures a field to be updated an is handy with checkboxes<br>&nbsp;<b>random[x]</b> - Returns a random number between 0 and x<br>&nbsp;<b>files[semicolon-list(!) of extensions, none=all][maxsize in kb, none=no limit]</b> - Defining the field to hold files. See below for details!<br>&nbsp;<b>multiple </b>- Set this, if the input comes from a multiple-selector box (remember to add ...[] to the fieldname so the values come in an array!)<br>&nbsp;<b>checkArray</b> - Set this, if you want several checkboxes to set bits in a single field. In that case you must prepend every checkbox with [x] where x is the bitnumber to set starting with zero. The default values of the checkbox form elements must be false.<br>&nbsp;<b>uniqueHashInt[semicolon-list(!) of other fields]</b> - This makes a unique hash (32 bit integer) of the content in the specified fields. The values of those fields are first converted to lowercase and only alphanum chars are preserved. ";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:23;a:6:{s:8:"property";s:20:"userFunc_updateArray";s:8:"datatype";s:13:"function-name";s:11:"description";s:148:"Points to a user function which will have the value-array passed to it before the value array is used to construct the update-JavaScript statements.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:24;a:6:{s:8:"property";s:29:"evalErrors.[field].[evalCode]";s:8:"datatype";s:6:"&nbsp;";s:11:"description";s:165:"This lets you specify the error messages inserted in the ###EVAL_ERROR_FIELD_[fieldname]### markers upon an evaluation error.<br>See description of evaluation below.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:25;a:6:{s:8:"property";s:22:"cObjects.[marker_name]";s:8:"datatype";s:7:"cObject";s:11:"description";s:389:"This is cObjects you can insert by markers in the template.<br>&nbsp;<b><br>Example:</b><br>Say, you set up a cObject like this:<br>&nbsp;<br>cObject.myHeader = TEXT<br>cObject.myHeader.value = This is my header<br>&nbsp;<br>then you can include this cObject in most of the templates through a marker named ###CE_myHeader### or ###PCE_myHeader### (see below for details on the difference).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:26;a:6:{s:8:"property";s:5:"wrap1";s:8:"datatype";s:13:"-&gt; stdWrap";s:11:"description";s:225:"Global Wrap 1. This will be splitted into the markers ###GW1B### and ###GW1E###. Don&#039;t change the input value by the settings, only wrap it in something.<br>&nbsp;<b><br>Example:</b><br>wrap1.wrap = &lt;b&gt; |&lt;/B&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:27;a:6:{s:8:"property";s:5:"wrap2";s:8:"datatype";s:13:"-&gt; stdWrap";s:11:"description";s:25:"Global Wrap 2 (see above)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:28;a:6:{s:8:"property";s:6:"color1";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:43:"Value for ###GC1### marker (Global color 1)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:29;a:6:{s:8:"property";s:6:"color2";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:43:"Value for ###GC2### marker (Global color 2)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:30;a:6:{s:8:"property";s:6:"color3";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:43:"Value for ###GC3### marker (Global color 3)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('106', '', '63743e1b082d6f7bcb449ddeb484466e', '', 'tsref:(script).fe_adminLib.evalErrors.(field).(evalCode)', 'a:1:{s:4:"rows";a:8:{i:0;a:6:{s:8:"property";s:12:"uniqueGlobal";s:8:"datatype";s:149:"This requires the value of the field to be globally unique, which means it must not exist in the same field of any other record in the current table.";s:11:"description";N;s:7:"default";N;s:12:"column_count";i:2;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:11:"uniqueLocal";s:8:"datatype";s:193:"This is like uniqueGlobal, but the value is required to be unique <i>only</i> in the PID of the record. Thus if two records has different pid values, they may have the same value of this field.";s:11:"description";N;s:7:"default";N;s:12:"column_count";i:2;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:5:"twice";s:8:"datatype";s:341:"This requires the value of the field to match the value of a secondary field name [fieldname]_again sent in the incoming formdata. THis is useful for entering password. Then if your password field is name &quot;user_pass&quot; then you simple add a second field name &quot;user_pass_again&quot; and then set the &#039;twice&#039; eval code. ";s:11:"description";N;s:7:"default";N;s:12:"column_count";i:2;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:5:"email";s:8:"datatype";s:91:"Requires the field value to be an email address at least on the form [name]@*[domain].[tld]";s:11:"description";N;s:7:"default";N;s:12:"column_count";i:2;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:8:"required";s:8:"datatype";s:70:"Just simple required (trimmed value). 0 (zero) will evaluate to false!";s:11:"description";N;s:7:"default";N;s:12:"column_count";i:2;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:17:"atLeast<br>atMost";s:8:"datatype";s:142:"Specifies a minimum / maximum of characters to enter in the fields.<br>&nbsp;<b>Example</b>, that requires at least 5 characters: atleast [5] ";s:11:"description";N;s:7:"default";N;s:12:"column_count";i:2;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:8:"inBranch";s:8:"datatype";s:320:"inBranch requires the value (typically of a pid-field) to be among a list of page-id&#039;s (pid&#039;s) specified with the inBranch parameters. The parameters are given like <i>[root_pid; depth; beginAt]</i><br>&nbsp;<b>Example</b>, which will return a list of pids one level deep from page 4 (included): inBranch [4;1]";s:11:"description";N;s:7:"default";N;s:12:"column_count";i:2;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:10:"unsetEmpty";s:8:"datatype";s:196:"This evaluation does not result in any error code. Only it simply unsets the field if the value of the field is empty. Thus it&#039;ll not override any current value if the field value is not set.";s:11:"description";N;s:7:"default";N;s:12:"column_count";i:2;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('107', '', '63839135a1a4b8831ae951b0be3e42e0', '', 'tsref:(script).tipafriend', 'a:1:{s:4:"rows";a:10:{i:0;a:6:{s:8:"property";s:12:"templateFile";s:8:"datatype";s:8:"resource";s:11:"description";s:88:"The template-file. <br>See example in &#039;media/scripts/tipafriend_template.tmpl&#039;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:4:"code";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:53:"Code to define, what the script does. Case sensitive.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:11:"defaultCode";s:8:"datatype";s:6:"string";s:11:"description";s:110:"The default code (see above) if the value is empty. By default it&#039;s not set and a help screen will appear";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:5:"wrap1";s:8:"datatype";s:13:"-&gt; stdWrap";s:11:"description";s:225:"Global Wrap 1. This will be splitted into the markers ###GW1B### and ###GW1E###. Don&#039;t change the input value by the settings, only wrap it in something.<br>&nbsp;<b><br>Example:</b><br>wrap1.wrap = &lt;B&gt; |&lt;/B&gt;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:5:"wrap2";s:8:"datatype";s:13:"-&gt; stdWrap";s:11:"description";s:25:"Global Wrap 2 (see above)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:6:"color1";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:43:"Value for ###GC1### marker (Global color 1)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:6:"color2";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:43:"Value for ###GC2### marker (Global color 2)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:6:"color3";s:8:"datatype";s:15:"string /stdWrap";s:11:"description";s:43:"Value for ###GC3### marker (Global color 3)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:8:"typolink";s:8:"datatype";s:13:"-&gt;typolink";s:11:"description";s:125:"TypoLink configuration for the TIPLINK to the TIPFORM page. .additionalParams is added the parameter &quot;&amp;tipUrl=&quot;";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:8:"htmlmail";s:8:"datatype";s:7:"boolean";s:11:"description";s:92:"If set, the page is fetched as HTML and send in HTML (a plain text version is sent as well).";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('108', '', '824b1ba31d52dfeb00b9afbcb7790c9b', '', 'tsref:(script).plaintextLib', 'a:1:{s:4:"rows";a:28:{i:0;a:6:{s:8:"property";s:7:"siteUrl";s:8:"datatype";s:3:"url";s:11:"description";s:16:"Url of the site.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:13:"defaultOutput";s:8:"datatype";s:16:"untrimmed string";s:11:"description";s:40:"Default output if CType is not rendered.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:14:"uploads.header";s:8:"datatype";s:16:"untrimmed string";s:11:"description";s:18:"Header for uploads";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:13:"images.header";s:8:"datatype";s:16:"untrimmed string";s:11:"description";s:17:"Header for images";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:20:"images.captionHeader";s:8:"datatype";s:16:"untrimmed string";s:11:"description";s:24:"Header for imagecaptions";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:17:"images.linkPrefix";s:8:"datatype";s:16:"untrimmed string";s:11:"description";s:22:"Prefix for image-links";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:14:"<b>.header</b>";s:8:"datatype";N;s:11:"description";N;s:7:"default";N;s:12:"column_count";i:1;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:11:"defaultType";s:8:"datatype";s:3:"int";s:11:"description";s:28:"Which type to use as default";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:4:"date";s:8:"datatype";s:11:"date-config";s:11:"description";s:15:"For header date";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:10:"datePrefix";s:8:"datatype";s:16:"untrimmed string";s:11:"description";s:22:"Prefix for header date";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:10:"linkPrefix";s:8:"datatype";s:16:"untrimmed string";s:11:"description";s:23:"Prefix for header links";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:16:"[1-5].preLineLen";s:8:"datatype";s:3:"int";s:11:"description";s:28:"Lenght of line before header";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:17:"[1-5].postLineLen";s:8:"datatype";s:3:"int";s:11:"description";s:27:"Lenght of line after header";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:15:"[1-5].preBlanks";s:8:"datatype";s:3:"int";s:11:"description";s:35:"Number of blank lines before header";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:16:"[1-5].postBlanks";s:8:"datatype";s:3:"int";s:11:"description";s:34:"Number of blank lines after header";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:13:"[1-5].stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:15:"for header text";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:17:"[1-5].preLineChar";s:8:"datatype";s:6:"string";s:11:"description";s:21:"Character to pre-line";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:18:"[1-5].postLineChar";s:8:"datatype";s:6:"string";s:11:"description";s:22:"Character to post-line";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:19:"[1-5].preLineBlanks";s:8:"datatype";s:3:"int";s:11:"description";s:49:"Number of blank lines between header and pre-line";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:20:"[1-5].postLineBlanks";s:8:"datatype";s:3:"int";s:11:"description";s:50:"Number of blank lines between header and post-line";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:16:"[1-5].autonumber";s:8:"datatype";s:7:"boolean";s:11:"description";s:111:"If set, a number is prepended every header. The number corresponds to the content element number in the select.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:12:"[1-5].prefix";s:8:"datatype";s:16:"untrimmed string";s:11:"description";s:20:"Header string prefix";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:22;a:6:{s:8:"property";s:23:"bulletlist.[0-3].bullet";s:8:"datatype";s:16:"untrimmed string";s:11:"description";s:36:"Bullet for bullet list, layout [0-3]";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:23;a:6:{s:8:"property";s:26:"bulletlist.[0-3].secondRow";s:8:"datatype";s:16:"untrimmed string";s:11:"description";s:65:"If set, this is used for lines on the second row of bullet-lists.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:24;a:6:{s:8:"property";s:4:"menu";s:8:"datatype";s:7:"cObject";s:11:"description";s:137:"cObject to render menu. The output is stripped for tags and the links is extracted. Further all &lt;BR&gt; chars are converted to chr(10)";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:25;a:6:{s:8:"property";s:8:"shortcut";s:8:"datatype";s:7:"cObject";s:11:"description";s:129:"cObject to render other elements. See config below which simply uses this object to render more tt_content elements as plaintext.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:26;a:6:{s:8:"property";s:16:"bodytext.stdWrap";s:8:"datatype";s:12:"-&gt;stdWrap";s:11:"description";s:48:"stdWrap for body-text. See config example below.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}i:27;a:6:{s:8:"property";s:8:"userProc";s:8:"datatype";s:13:"function-name";s:11:"description";s:195:"Lets you proces the output of each content element before it finally is returned. Property &quot;parentObj&quot; of the conf-array holds a references to the plainText object calling the function.";s:7:"default";s:6:"&nbsp;";s:12:"column_count";i:4;s:16:"is_propertyTable";i:1;}}}', '');

#
# ==== Data extracted from CoreDocs/doc_core_tstemplates_0.0.1.t3x
#

#
# ==== Data extracted from typo3_src-4.0.1/typo3/sysext/dbal/doc/manual.sxw
#

#
# ==== Data extracted from typo3_src-4.0.1/typo3/sysext/rtehtmlarea/doc/manual.sxw
#
INSERT INTO static_tsconfig_help VALUES ('109', '', '004ad0c011cac5a5fcbc294774cb0281', '', 'page:RTE', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:32:"&nbsp;classes.[<i>classname</i>]";s:8:"datatype";s:841:"Defines the classes available in the RTE. <i>classname</i> is the actual name of the style-class you&#039;re configuring. Notice you must specifically assign the classes to the various facilities also. See later.<br>&nbsp;<br>Properties:<br>&nbsp;<b>.name </b>= Label of the class<br>&nbsp;<b>.value </b>= The style for the class<br>&nbsp;<b>.noShow</b> = Boolean; if set, the style of the class is not used to render it in the pop-up selector.<br>&nbsp;<b><br>Example:</b><br># General configuration of the available classes:<br>RTE.classes {<br>&nbsp;&nbsp;&nbsp;mainBodyText {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;name = Body Text (Primary)<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value = font:bold; color:blue;<br>&nbsp;&nbsp;&nbsp;}<br>}<br># Specific configuration for the Character/Text Style menu:<br>RTE.default.classesCharacter = mainBodyText";s:11:"description";N;s:7:"default";N;s:12:"column_count";i:2;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('110', '', '004ad0c011cac5a5fcbc294774cb0281', '', 'page:RTE', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:31:"&nbsp;colors.[<i>id-string</i>]";s:8:"datatype";s:828:"Defines the colors available in the RTE.<br>&nbsp;<br>Properties:<br>&nbsp;<b>.name </b>= Label of the color in menu<br>&nbsp;<b>.value </b>= The HTML-color value<br>&nbsp;<b><br>Example:</b><br># General configuration of the available colors:<br>RTE.colors {<br>&nbsp;&nbsp;&nbsp;color1 {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;name = Background color<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value = blue<br>&nbsp;&nbsp;&nbsp;}<br>&nbsp;&nbsp;&nbsp;color2 {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;name = Another color I like!<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value = #775533<br>&nbsp;&nbsp;&nbsp;}<br>&nbsp;&nbsp;&nbsp;noColor {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;name = No color<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value = <br>&nbsp;&nbsp;&nbsp;}<br>}<br># Specific setting for the font color selector:<br>RTE.default.colors = color1, color2, noColor";s:11:"description";N;s:7:"default";N;s:12:"column_count";i:2;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('111', '', '004ad0c011cac5a5fcbc294774cb0281', '', 'page:RTE', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:30:"&nbsp;fonts.[<i>id-string</i>]";s:8:"datatype";s:814:"Defines the fonts available in the RTE.<br>&nbsp;<br>Properties:<br>&nbsp;<b>.name </b>= Label of the font in menu<br>&nbsp;<b>.value </b>= The font face value<br>&nbsp;<b><br>Example:</b><br># General configuration of the available fonts:<br>RTE.fonts {<br>&nbsp;&nbsp;&nbsp;face1 {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;name = Verdana<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value = verdana, arial<br>&nbsp;&nbsp;&nbsp;}<br>&nbsp;&nbsp;&nbsp;face2 {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;name = Comic Sans<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value = Comic Sans MS<br>&nbsp;&nbsp;&nbsp;}<br>&nbsp;&nbsp;&nbsp;noFace {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;name = No font<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;value = <br>&nbsp;&nbsp;&nbsp;}<br>}<br># Specific setting for the fontstyle selector:<br>RTE.default.fontFace = face2 , face1, noFace";s:11:"description";N;s:7:"default";N;s:12:"column_count";i:2;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('112', '', '004ad0c011cac5a5fcbc294774cb0281', '', 'page:RTE', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:133:"default.[...]<br>config.[<i>tablename</i>].[<i>field</i>].[...]<br>config.[<i>tablename</i>].[<i>field</i>].types.[<i>type</i>].[...]";s:8:"datatype";s:580:"&nbsp; This is a description of how you can customize in general and override for specific fields/types.<br>&#039;RTE.default&#039; configures the RTE for all tables/fields/types<br>&#039;RTE.config.[<i>tablename</i>].[<i>field</i>]&#039; configures a specific field. The values inherit the values from &#039;RTE.default&#039; in fact this is overriding values.<br>&#039;RTE.config.[<i>tablename</i>].[<i>field</i>].types.[<i>type</i>]&#039; configures a specific field in case the &#039;type&#039;-value of the field matches <i>type</i>. Again this overrides the former settings.";s:11:"description";N;s:7:"default";N;s:12:"column_count";i:2;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('113', '', '2d88f60bc82382f1ed40901ed9ed363a', '', 'page:RTE.default/RTE.default.FE/RTE.config.(table).(field)/RTE.config.(table).(field).types.(type)', 'a:1:{s:4:"rows";a:48:{i:0;a:6:{s:8:"property";s:8:"disabled";s:8:"datatype";s:7:"boolean";s:11:"description";s:31:"If set, the editor is disabled.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:16:"classesParagraph";s:8:"datatype";s:18:"list of id-strings";s:11:"description";s:1167:"Classes available in the Paragraph Style selector. <br>The Paragraph Style selector lets you format a block of content also known typographically as a <i>paragraph</i> (the section between two linebreaks). The content of the paragraph is wrapped in block-tags and by default you can select between &lt;Hx&gt;, &lt;P&gt; and &lt;PRE&gt; formatting (you can disable any or all of these default values by the &#039;hidePStyleItems&#039;, see later). <br>&nbsp;<b><br>Example:</b><br>This configuration would result in this Paragraph style selector (provided that the classes &#039;mainBodyText&#039; and &#039;header2&#039; are found in the RTE.classes definition, see above):<br>&nbsp;<br>RTE.default {<br>&nbsp;&nbsp;&nbsp;classesParagraph = mainBodyText, header2<br>}<br>&nbsp;<br>In the case of htmlArea RTE, the classes must be defined either in one of the occurrences of the inlineStyle property or in the CSS file specified contentCSS property.<br>&nbsp;<br>In the case of the Classic RTE, the classes defined in the &#039;classesParagraph&#039; value are prepended to the types of paragraphs options. They are inserted as &lt;DIV&gt;-tags with a class-parameter.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:17:"classesCharacter ";s:8:"datatype";s:18:"list of id-strings";s:11:"description";s:1039:"Classes available for the Text Style selector.<br>&nbsp;<br>The Character Style selector is used to format any string of text inside a paragraph, tablecell. So this formatting relates to the selected piece of text in opposition to the Paragraph Styles which always formats the current paragraph no matter the selection.<br>&nbsp;<br>In the case of htmlArea RTE, the classes must be defined either in one of the occurrences of the inlineStyle property or in the CSS file specified contentCSS property.<br>&nbsp;<br>In the case of htmlArea RTE, if the property is empty, classes associated with the span tag in either the inlineSyle properties or in the contentCSS file are used.<br>&nbsp;<br>In the case of the Classic RTE, although the Character Style selector is aimed at text-formatting, it will also apply classes to other elements, for instance tables or images if selected as well as links and table-cells. The allowed classes for these operations may be configured separately by listing the classes with the options, you find below. ";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:41:"showTagFreeClasses<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:200:"Specifies that CSS classes not associated with any tag in the contentCSS style sheet should be or should not be shown in the paragraph style and the text style selection lists.<br>&nbsp;<br>Default: 0";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:17:"disablePCexamples";s:8:"datatype";s:7:"boolean";s:11:"description";s:216:"If set, the examples of classes in Paragraph and Character selectors are disabled.<br>&nbsp;<br>Note: In the case of htmlArea RTE, the styling is removed on the options of the Paragraph and Text style selector lists.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:5;a:6:{s:8:"property";s:44:"disableTYPO3Browsers <br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:265:"If set, the TYPO3 element and image browsers are disabled.<br>&nbsp;<br>Default: 0<br>&nbsp;<br>Note: If set, the htmlArea plugin TYPO3Browsers is disabled.<br>&nbsp;<br>Note: The TYPO3Browsers plugin is not available when the editor is used in the TYPO3 front end.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:6;a:6:{s:8:"property";s:12:"classesImage";s:8:"datatype";s:18:"list of id-strings";s:11:"description";s:455:"Classes available for images.<br>&nbsp;<br>In the case of htmlArea RTE, each of the listed class must be defined either in one of the occurrences of the inlineStyle property or in the CSS file specified contentCSS property.<br>&nbsp;<br>In the case of htmlArea RTE, the same list of classes is used in the class selection list of the Insert/Modify image dialog.<br>&nbsp;<br>In the case of the Classic RTE, see description of &#039;classesCharacter&#039;.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:7;a:6:{s:8:"property";s:17:"blindImageOptions";s:8:"datatype";s:15:"list of strings";s:11:"description";s:82:"List of tab items in the image selector to remove. Keylist is magic,plain,dragdrop";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:8;a:6:{s:8:"property";s:36:"classesAnchor<br>(htmlArea RTE only)";s:8:"datatype";s:18:"list of id-strings";s:11:"description";s:392:"Classes available in the Insert/Modify link dialog.<br>&nbsp;<br>These classes must be defined by the RTE.classesAnchor property.<br>&nbsp;<br>The following property specifies the default class of the class selector of the corresponding tab:<br>.default {<br>&nbsp;page = <i>className</i><br>&nbsp;url = <i>className</i><br>&nbsp;file = <i>className</i><br>&nbsp;mail = <i>className</i><br>} ";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:9;a:6:{s:8:"property";s:13:"classesLinks ";s:8:"datatype";s:18:"list of id-strings";s:11:"description";s:154:"Classes available for links. See description of &#039;classesCharacter&#039;.<br>&nbsp;<br>In the case of htmlArea RTE, classesAnchor offers more options.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:10;a:6:{s:8:"property";s:17:"defaultLinkTarget";s:8:"datatype";s:6:"string";s:11:"description";s:54:"This sets the default target for new links in the RTE.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:11;a:6:{s:8:"property";s:16:"blindLinkOptions";s:8:"datatype";s:15:"list of strings";s:11:"description";s:84:"List of tab items in the link selector to remove. Keylist is page,file,url,mail,spec";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:12;a:6:{s:8:"property";s:13:"classesTable ";s:8:"datatype";s:18:"list of id-strings";s:11:"description";s:407:"Classes available for tables. See description of &#039;classesCharacter&#039;.<br>&nbsp;<br>In the case of htmlArea RTE, each of the listed class must be defined either in one of the occurrences of the inlineStyle property or in the CSS file specified contentCSS property.<br>&nbsp;<br>In the case of htmlArea RTE, the same list of classes is used in the class selection list of the Table Properties dialog.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:13;a:6:{s:8:"property";s:10:"classesTD ";s:8:"datatype";s:18:"list of id-strings";s:11:"description";s:410:"Classes available for tablecells. See description of &#039;classesCharacter&#039;.<br>&nbsp;<br>In the case of htmlArea RTE, each of the listed class must be defined either in one of the occurrences of the inlineStyle property or in the CSS file specified contentCSS property.<br>&nbsp;<br>In the case of htmlArea RTE, the same list of classes is used in the class selection list of the Cell Properties dialog.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:14;a:6:{s:8:"property";s:7:"colors ";s:8:"datatype";s:18:"list of id-strings";s:11:"description";s:260:"Defines the specific colors generally available in the color selectors. The id-strings must be configured in the RTE.colors array (see description earlier).<br>&nbsp;<b><br>Example:</b><br>RTE.default {<br>&nbsp;&nbsp;&nbsp;colors = color1, color2,noColor<br>}";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:15;a:6:{s:8:"property";s:18:"disableColorPicker";s:8:"datatype";s:7:"boolean";s:11:"description";s:249:"Disables the color picker matrix in all color dialogs. The color picker lets you select web-colors.<br>&nbsp;<br>Note: In the case of htmlArea RTE, this applies only when the TYPO3 configurable color selection dialog is enabled (plugin SelectColor).";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:16;a:6:{s:8:"property";s:41:"disableSelectColor<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:162:"If set, the TYPO3 configurable color selection dialog is disabled.<br>&nbsp;<br>Default: 0<br>&nbsp;<br>Note: If set, the htmlArea plugin SelectColor is disabled.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:17;a:6:{s:8:"property";s:14:"hideFontFaces ";s:8:"datatype";s:36:"list of id-numbers,<br>* removes all";s:11:"description";s:278:"Lets you disable any of the default font faces in the Font Style selector. These are the possible values you can set:<br>&nbsp;<br>1: Arial<br>2: Arial Black<br>3: Verdana<br>4: Times New Roman<br>5: Garamond<br>6: Lucida Handwriting<br>7: Courier<br>8: Webdings<br>9: Wingdings";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:18;a:6:{s:8:"property";s:9:"fontFace ";s:8:"datatype";s:18:"list of id-strings";s:11:"description";s:152:"Defines the specific fonts generally available in the font selector. The id-strings must be configured in the RTE.fonts array (see description earlier).";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:19;a:6:{s:8:"property";s:14:"hideFontSizes ";s:8:"datatype";s:38:"list of size-numbers,<br>* removes all";s:11:"description";s:112:"Lets you disable any of the default font sizes available in the Font Size selector. Values are ranging from 1-7.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:20;a:6:{s:8:"property";s:27:"showButtons<br>hideButtons ";s:8:"datatype";s:18:"list of id-strings";s:11:"description";s:1224:"Note: In the case of htmlArea RTE, available buttons are: blockstylelabel, blockstyle, textstylelabel, textstyle, fontstyle, fontsize, formatblock, bold, italic, underline, strikethrough, subscript, superscript, lefttoright, righttoleft, left, center, right, justifyfull, orderedlist, unorderedlist, outdent, indent, textcolor, bgcolor, textindicator, emoticon, insertcharacter, line, link, image, table, user, acronym, findreplace, spellcheck, chMode, inserttag, removeformat, copy, cut, paste, undo, redo, showhelp, about, toggleborders, tableproperties, rowproperties, rowinsertabove, rowinsertunder, rowdelete, rowsplit, columninsertbefore, columninsertafter, columndelete, columnsplit, cellproperties, cellinsertbefore, cellinsertafter, celldelete, cellsplit, cellmerge<br>&nbsp;<br>Note: In the case of htmlArea RTE, if extension sr_static_info is not installed, the spellcheck button is not enabled.<br>&nbsp;<br>Note:In the case of htmlArea RTE, the following elements will always be shown: undo redo, about.<br>&nbsp;<br>Note: In the case of htmlArea RTE, buttons user and acronym are never available in the front end.<br>&nbsp;<br>Note: In the case of htmlArea RTE, button Acronym is not currently available in IE.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:21;a:6:{s:8:"property";s:35:"toolbarOrder<br>(htmlArea RTE only)";s:8:"datatype";s:18:"list of id-strings";s:11:"description";s:1075:"Specifies the order and grouping of buttons in the RTE tool bar. The keywords space, bar and linebreak may be used to insert a space, a separator or a line break at the corresponding position in the tool bar.<br>&nbsp;<br>Default: blockstylelabel, blockstyle, space, textstylelabel, textstyle, bar, linebreak, fontstyle, space, fontsize, space, formatblock, bar, bold, italic, underline, bar, strikethrough, subscript, superscript, bar, lefttoright, righttoleft, bar, left, center, right, justifyfull, bar, orderedlist, unorderedlist, outdent, indent, bar, textcolor, bgcolor, textindicator, bar, emoticon, insertcharacter, line, link, image, table, user, acronym, bar, findreplace, spellcheck, bar, chMode, inserttag, removeformat, bar, copy, cut, paste, bar, undo, redo, bar, showhelp, about, linebreak, toggleborders, bar, tableproperties, bar, rowproperties, rowinsertabove, rowinsertunder, rowdelete, rowsplit, bar, columninsertbefore, columninsertafter, columndelete, columnsplit, bar, cellproperties, cellinsertbefore, cellinsertafter, celldelete, cellsplit, cellmerge";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:22;a:6:{s:8:"property";s:46:"keepButtonGroupTogether<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:335:"Specifies that all buttons of a button group are displayed on the same line of the tool bar. A button group is delimited by a linebreak or by a bar.<br>&nbsp;<br>Default: 0<br>&nbsp;<br>Note: If enabled, the setting is honored only by Mozilla/Firefox. It is ignored when the browser is Internet Explorer, Safari, Opera or Mozilla 1.3. ";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:23;a:6:{s:8:"property";s:51:"hideTableOperationsInToolbar<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:246:"Specifies that table operations buttons should be hidden in the tool bar or not.<br>&nbsp;<br>Default: 0<br>&nbsp;<br>Note: If enabled, table operations will appear only in the context menu, provided that they may be enabled in the given context.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:24;a:6:{s:8:"property";s:49:"keepToggleBordersInToolbar<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:240:"Specifies that the toggleborders button should be kept in the tool bar or not.<br>&nbsp;<br>Default: 0<br>&nbsp;<br>Note: If enabled, the toggleborders button will be kept in the tool bar even if the hideTableOperationsInToolbar is enabled.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:25;a:6:{s:8:"property";s:41:"disableContextMenu<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:162:"Specifies that the context menu should be disabled or not.<br>&nbsp;<br>Default: 0<br>&nbsp;<br>Note: This property is a synonymous of disableRightClick property.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:26;a:6:{s:8:"property";s:17:"disableRightClick";s:8:"datatype";s:7:"boolean";s:11:"description";s:62:"If set, the right click (context) menu of the RTE is disabled.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:27;a:6:{s:8:"property";s:36:"showStatusBar<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:88:"Specifies that the editor status bar should be displayed or not.<br>&nbsp;<br>Default: 0";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:28;a:6:{s:8:"property";s:18:"mainStyleOverride ";s:8:"datatype";s:6:"string";s:11:"description";s:1085:"By default the editor style section is set with the CSS-code below. However you may override this by this option.<br>&nbsp;<br>Default for Classic RTE:<br>&nbsp;<br>BODY {<br>&nbsp;&nbsp;&nbsp;border: 1px black solid; <br>&nbsp;&nbsp;&nbsp;border-top: none; <br>&nbsp;&nbsp;&nbsp;margin : 2 2 2 2; <br>&nbsp;&nbsp;&nbsp;font-family:Verdana; <br>&nbsp;&nbsp;&nbsp;font-size:10px;<br>&nbsp;&nbsp;&nbsp;color:black; <br>&nbsp;&nbsp;&nbsp;background-color:white;<br>}<br>TD {font-family:Verdana; font-size:10px;}<br>P {margin-top:0px; margin-bottom:5px;}<br>DIV {margin-top:0px; margin-bottom:5px;}<br>OL {margin: 5px 10px 5px;}<br>UL {margin: 5px 10px 5px;}<br>BLOCKQUOTE {margin-top:0px; margin-bottom:0px;}<br>&nbsp;<br>Default for htmlArea RTE:<b><br>&nbsp;</b><br>body.htmlarea-content-body {<br>&nbsp;font-family: Verdana,sans-serif; <br>&nbsp;font-size: 12px;<br>&nbsp;color: black;<br>&nbsp;background-color: white;<br>}<br>td { }<br>div { }<br>pre { }<br>ol { }<br>ul { }<br>blockquote { }<br>&nbsp;<br>Note: In the case of htmlArea RTE, see also property ignoreMainStyleOverride.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:29;a:6:{s:8:"property";s:34:"mainStyleOverride_add.[<i>key</i>]";s:8:"datatype";s:18:"string (css-style)";s:11:"description";s:316:"Allows to add style configuration to the values above (for .mainStyleOverride above)<br>Keys are:<br>.P / .DIV / .TD /.BODY / .BLOCKQUOTE /.OL / .UL / .PRE / .Hx will all take values which are prepended to the above settings.<br>&nbsp;<br>Note: In the case of htmlArea RTE, see also property ignoreMainStyleOverride.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:30;a:6:{s:8:"property";s:72:"mainStyle_font<br>mainStyle_size<br>mainStyle_color<br>mainStyle_bgcolor";s:8:"datatype";s:6:"string";s:11:"description";s:265:"Setting the default font-family (verdana) , font-size (10px), font-color (black) and background color (white)<br>The default is shown in &quot;.mainStyleOverride&quot; above.<br>&nbsp;<br>Note: In the case of htmlArea RTE, see also property ignoreMainStyleOverride.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:31;a:6:{s:8:"property";s:33:"inlineStyle.[any<i> keysting</i>]";s:8:"datatype";s:6:"string";s:11:"description";s:196:"CSS code to be included in the editor style section. This will be included <i>after </i>the default code.<br>&nbsp;<br>Note: In the case of htmlArea RTE, see also property ignoreMainStyleOverride.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:32;a:6:{s:8:"property";s:27:"skin<br>(htmlArea RTE only)";s:8:"datatype";s:8:"resource";s:11:"description";s:809:"The skin contains the CSS files and the images used to style the editor.<br>The skin is specified by specifying the location of the main CSS file to be used to style the editor. The folder containing the CSS file MUST also contain a structure of folders and files identical to the structure found in the folder of the default skin. All folder names and all file names must be identical.<br>&nbsp;<br>Default: EXT:rtehtmlarea/htmlarea/skins/default/htmlarea.css<br>&nbsp;<br>Note: Extensions sr_rtehtmlarea_bluelook and sr_rtehtmlarea_xpblue provide two additional example skins.<br>&nbsp;<br>Note: these example skins do not work in Mozilla 1.3; if the property is set to one of them, the default skin will be used when the browser is Mozilla 1.3.<br>&nbsp;<br>Note: See also property ignoreMainStyleOverride.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:33;a:6:{s:8:"property";s:33:"contentCSS<br>(htmlArea RTE only)";s:8:"datatype";s:8:"resource";s:11:"description";s:485:"The CSS file that contains the style definitions that should be applied to the edited contents.<br>The selectors defined in this file will also be used by the DynamicCSS and InlineCSS plugins in the block style and text style selection lists.<br>&nbsp;<br>Default: EXT:rtehtmlarea/htmlarea/plugins/DynamicCSS/dynamiccss.css<br>&nbsp;<br>For example, this default could be overridden with: fileadmin/styles/my_contentCSS.css<br>&nbsp;<br>Note: See also property ignoreMainStyleOverride.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:34;a:6:{s:8:"property";s:46:"ignoreMainStyleOverride<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:678:"Instruct htmlArea RTE to ignore properties mainStyleOverride and inlineStyle.<br>&nbsp;<br>Default: 0<br>&nbsp;<br>Note: In htmlArea RTE, the following style sheets apply to the contents of the editing area and are linked in the following order:<br>1. the htmlarea-edited-content.css file from the skin being used (contains selectors for use in the editor but not intended to be applied in the frontend);<br>2. a css file generated from the mainStyleOverride and inlineStyle assignments;<br>3. the css file specified by contentCSS in Page TSConfig.<br>When ignoreMainStyleOverride is enabled, the middle style sheet is ignored and only the first and third style sheets are used.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:35;a:6:{s:8:"property";s:4:"proc";s:8:"datatype";s:9:"-&gt;PROC";s:11:"description";s:104:"Customization of the server processing of the content - also called &#039;transformations&#039;.<br>See ";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:36;a:6:{s:8:"property";s:38:"enableWordClean<br>(htmlArea RTE only)";s:8:"datatype";s:27:"boolean/<br>-&gt;HTMLparser";s:11:"description";s:588:"Specifies that text pasted from external sources, presumably from Microsoft Word, should be &quot;cleaned&quot; or not.<br>&nbsp;<br>Default: 0<br>&nbsp;<br>Note:If no HTMLparser configuration is specified, a limited default cleaning operation will be performed. If a HTMLparser specification is specified, parsing will be performed on the server at the time of the paste operation.<br>&nbsp;<br>Note: The HTMLparser configuration is ignored If TYPO3HtmlParser plugin is disabled.<br>&nbsp;<br>Note: Additional cleanup may be performed by the user when the removeformat button is enabled.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:37;a:6:{s:8:"property";s:37:"removeComments<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:134:"Specifies that html comments should be removed or not by the editor on save and on toggle to HTML source mode.<br>&nbsp;<br>Default: 0";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:38;a:6:{s:8:"property";s:33:"removeTags<br>(htmlArea RTE only)";s:8:"datatype";s:12:"list of tags";s:11:"description";s:92:"List of tags that should be removed by the editor on save and on toggle to HTML source mode.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:39;a:6:{s:8:"property";s:44:"removeTagsAndContents<br>(htmlArea RTE only)";s:8:"datatype";s:12:"list of tags";s:11:"description";s:171:"List of tags that should be removed by the editor, contents included, on save and on toggle to HTML source mode. The tags and the contents inside the tags will be removed.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:40;a:6:{s:8:"property";s:29:"useCSS<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:198:"Specifies that Mozilla/Firefox should use style attributes or not. When enabled, Mozilla/Firefox use span tags with style attributes rather than tags such as b, i, font, etc.<br>&nbsp;<br>Default: 0";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:41;a:6:{s:8:"property";s:45:"disableEnterParagraphs<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:549:"Specifies that the insertion of paragraphs when hitting the Enter key in Mozilla/Firefox, Safari or Opera should be disabled.<br>&nbsp;<br>Default: 0<br>&nbsp;<br>Note: If NOT enabled, the behavior of Mozilla/Firefox, Safari and Opera is modified as follows: when the Enter key is pressed, instead of inserting a br tag, the behavior of Internet Explorer is simulated and a new paragraph is created.<br>&nbsp;<br>Note: If enabled, the behavior of Mozilla/Firefox, Safari and Opera is not modified: a br tag is inserted when the Enter key is pressed.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:42;a:6:{s:8:"property";s:39:"removeTrailingBR<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:398:"Specifies that trailing br tags should be removed from block elements.<br>&nbsp;<br>Default: 0<br>&nbsp;<br>Note: If set, any trailing br tag in a block element will be removed on save and/or change mode. However, multiple trailing br tags will be preserved.<br>&nbsp;<br>Note: In Mozilla/Firefox/Netscape, whenever some text is entered in an empty block, a trailing br tag is added by the browser.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:43;a:6:{s:8:"property";s:31:"hideTags<br>(htmlArea RTE only)";s:8:"datatype";s:12:"list of tags";s:11:"description";s:347:"List of tags that should NOT be shown by the QuickTag plugin.<br>&nbsp;<br>Note: A list of tags or values among the following: a, a (full), abbr, acronym, address, b, big, blockquote, code, div, em, fieldset, font, font (full), h1, h2, h3, h4, h5, h6, i, legend, li, ol, ul, p, pre, small, span, strong, sub, sup, table, tt, q, cite, abbr, acronym";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:44;a:6:{s:8:"property";s:233:"disableAlignmentFieldsetInTableOperations<br>disableSpacingFieldsetInTableOperations<br>disableColorFieldsetInTableOperations<br>disableLayoutFieldsetInTableOperations<br>disableBordersFieldsetInTableOperations<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:93:"Disables the corresponding fieldsets of the table operations dialogs.<br>&nbsp;<br>Default: 0";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:45;a:6:{s:8:"property";s:42:"enablePersonalDicts<br>(htmlArea RTE only)";s:8:"datatype";s:7:"boolean";s:11:"description";s:393:"Specify that personal dictionaries should be enabled or not.<br>&nbsp;<br>Default: 0<br>&nbsp;<br>Note: The SpellChecker plgin must be enabled.<br>&nbsp;<br>Note: The option is ignored if PHP safe_mode is enabled on the server.<br>&nbsp;<br>Note: The feature must also be enabled in User TSConfig.<br>&nbsp;<br>Note: Personal dictionaries are stored in subdirectories of uploads/tx_rtehtmlarea";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:46;a:6:{s:8:"property";s:16:"userElements.[#]";s:8:"datatype";s:24:"string/-&gt;userCategory";s:11:"description";s:166:"Configuration of the categories of user elements<br>The string value sets the name of the category. Value is language-splitted (by |) to allow for multiple languages.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:47;a:6:{s:8:"property";s:13:"userLinks.[#]";s:8:"datatype";s:21:"string/-&gt;userLinks";s:11:"description";s:154:"Configuration of user defined links.<br>The string value sets the name of the category. Value is language-splitted (by |) to allow for multiple languages.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('114', '', '004ad0c011cac5a5fcbc294774cb0281', '', 'page:RTE', 'a:1:{s:4:"rows";a:1:{i:0;a:6:{s:8:"property";s:55:"classesAnchor.[<i>id-string</i>]<br>(htmlArea RTE only)";s:8:"datatype";s:1489:"Attaches special properties to the classes available in the Insert/Modify link dialog.<br>&nbsp;<br>Properties:<br>&nbsp;<br>.class = CSS-class-name: the name of the CSS class to which the properties are attached<br>&nbsp;<br>.type = page, url, file, mail or spec: specifies that the class applies to anchors for internal pages, external URL&#039;s, files, email addresses or special user-defined links respectively; the class will be presented only in the corresponding tab of the TYPO3 link browser<br>&nbsp;<br>.image = URL of an icon file that will prefix the content of the anchor when the class is applied to an anchor; the TYPO3 syntax EXT:extension-key/sub-directory/image-file-name may be used<br>&nbsp;<br>.altText = the text that will be used as altText for the image when the class is applied to an anchor; may be language-splitted; the TYPO3 syntax LLL:EXT:extension-key/sub-directory/locallang.php:label-index may also be used in order for the text to be localized to the language of the content using the specified language file and label index<br>&nbsp;<br>.titleText = the text that will be used as title for the anchor when the class is applied to an anchor; may be language-splitted; the TYPO3 syntax LLL:EXT:extension-key/sub-directory/locallang.php:label-index may also be used in order for the text to be localized to the language of the content using the specified language file and label index<br>&nbsp;<br>See the Demo default configuration for a complete example.";s:11:"description";N;s:7:"default";N;s:12:"column_count";i:2;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('115', '', '6da9b57fd30da516b101104fc9ea2d0b', '', 'page:->userCategory', 'a:1:{s:4:"rows";a:4:{i:0;a:6:{s:8:"property";s:4:"load";s:8:"datatype";s:6:"string";s:11:"description";s:316:"If set, the a predefined set of user element is loaded into this category. They are always loaded in the key starting with 100 and then forward in steps of 10.<br>Current options are:<br>&quot;images_from_folder&quot;: Loads gif,jpg,jpeg,png images from the specified folder (defined by the .path property)<br>&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:5:"merge";s:8:"datatype";s:7:"Boolean";s:11:"description";s:106:"If set, then any manually configured user elements are merged onto the ones loaded by the .load operation.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:4:"path";s:8:"datatype";s:6:"String";s:11:"description";s:198:"<i>(Applies for load=images_from_folder only)</i><br>&nbsp;<br>Sets the path of the folder from which to fetch the images (gif,jpg,jpeg,png)<br>&nbsp;<b><br>Example:</b><br>.path = fileadmin/istate/";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:3:"[#]";s:8:"datatype";s:24:"string/-&gt;userElements";s:11:"description";s:1934:"Configuration of the user elements.<br>The string value is the name of the user element. Language-splitted.<br>&nbsp;<b><br>Example:</b><br>&nbsp;<br>RTE.default.userElements {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;# Category with various elements<br>&nbsp;&nbsp;&nbsp;10 = Various elements | Diverse elements<br>&nbsp;&nbsp;&nbsp;10 {<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;# An image is inserted<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1 = Logo 1 | Bomærke 1<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1.description = This is the logo number 1. | Dette er logo nummer 1<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1.content = &lt;img src=&quot;###_URL###fileadmin/istate/curro.png&quot;&gt;<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;# The text-selection is wrapped with &lt;sup&gt; tags.<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2 = Subscript<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2.description = Selected text is wrapped in &lt;sup&gt;-tags.<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2.mode = wrap<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2.content = &lt;sup&gt;|&lt;/sup&gt;<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;# This submits the selected text content to the script, rte_cleaner.php<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5 = Strip all tags<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5.description = All HTML-codes are removed from selection.<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5.mode = processor<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5.submitToScript = typo3/rte_cleaner.php<br>&nbsp;&nbsp;&nbsp;}<br>&nbsp;<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;# Category with images from the fileadmin/istate/ folder<br>&nbsp;&nbsp;&nbsp;2.load = images_from_folder<br>&nbsp;&nbsp;&nbsp;2.merge = 1<br>&nbsp;&nbsp;&nbsp;2.path = fileadmin/istate/<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;# here the logo from &quot;Various elements&quot; is included as well<br>&nbsp;&nbsp;&nbsp;2.1 &lt; .10.1<br>}<br>&nbsp;&nbsp;&nbsp;# Show the user-button, if not existing<br>RTE.default.showButtons = user<br>&nbsp;";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('116', '', 'e65752d4886a06cb12258917b801963b', '', 'page:->userElements', 'a:1:{s:4:"rows";a:5:{i:0;a:6:{s:8:"property";s:4:"mode";s:8:"datatype";s:6:"string";s:11:"description";s:585:"Which kind of object it is.<br>&nbsp;<br>Options:<br>&quot;wrap&quot;: If a wrap, then the content is exploded by &quot;|&quot; and wrapped around the current text selection.<br>&nbsp;<br>&quot;processor&quot;: The content is submitted to the php-script defined by .submitToScript. GPvar(&quot;processContent&quot;) carries the selection content of the RTE and GPvar(&quot;returnUrl&quot;) contains the return url. (The &quot;content&quot; property is not used here!)<br>&nbsp;<br>default: The content is just inserted (pasted into) at the cursor or substituting any current selection.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:11:"description";s:8:"datatype";s:6:"string";s:11:"description";s:75:"A short description shown beneath the user element title (which is in bold)";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:7:"content";s:8:"datatype";s:6:"string";s:11:"description";s:41:"The content inserted/wrapped into the RTE";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:3;a:6:{s:8:"property";s:14:"submitToScript";s:8:"datatype";s:6:"string";s:11:"description";s:353:"<i>(Applies only to mode=processor)</i><br>&nbsp;<br>PHP script to which the current text selection of the RTE is submitted. The script must be relative to the site-url or a full url starting with http://...<br>&nbsp;<b><br>Example:</b><br>.submitToScript = typo3/rte_cleaner.php<br>or <br>.submitToScript = http://www.domain.org/some_extenal_script.php";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:4;a:6:{s:8:"property";s:17:"dontInsertSiteUrl";s:8:"datatype";s:7:"boolean";s:11:"description";s:254:"If set, the marker ###_URL### in the content property&#039;s content IS NOT substituted by the current site url. Normally you wish to do this for all image-references which must be prepended with the absolute url in order to display correctly in the RTE!";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');
INSERT INTO static_tsconfig_help VALUES ('117', '', '50145cc03f5f985111bb4fe700f38bdb', '', 'page:->userLinks', 'a:1:{s:4:"rows";a:3:{i:0;a:6:{s:8:"property";s:3:"url";s:8:"datatype";s:6:"string";s:11:"description";s:120:"The url.<br>If set, the marker ###_URL### in the content property&#039;s content is substituted by the current site url.";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:1;a:6:{s:8:"property";s:11:"description";s:8:"datatype";s:6:"string";s:11:"description";s:67:"A short description shown beneath the link title (which is in bold)";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}i:2;a:6:{s:8:"property";s:6:"target";s:8:"datatype";s:6:"string";s:11:"description";s:27:"Default target (if isset())";s:7:"default";N;s:12:"column_count";i:3;s:16:"is_propertyTable";i:1;}}}', '');

#
# ==== Data extracted from typo3_src-4.0.1/typo3/sysext/css_styled_content/doc/manual.sxw
#
